#include "hint.h"
#include <bits/stdc++.h>

using namespace std;

using ll = long long;

///const ll max_op = (int)1e8 + (int)1e6;

///const int K = 1;
const int K = 100;
///const ll max_op = (int)1e8 + 1;
///const ll max_op = 0;

#define all(v) v.begin(), v.end()

const int N = 10000 + 124;;
///const int N = 1;

int dp[N + 1][N + 1];

vector<int> slow(const vector<int> &a, const vector<int> &b) {
    int n = a.size();
    int m = b.size();
    ///int dp[n + 1][m + 1];
    for (int i = 0; i <= n; ++i) {
        dp[i][0] = 0;

    }
    for (int j = 0; j <= m; ++j) {
        dp[0][j] = 0;
    }
    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            dp[i][j] = max(dp[i - 1][j], dp[i][j - 1]);
            if (a[i - 1] == b[j - 1])
                dp[i][j] = max(dp[i][j], dp[i - 1][j - 1] + 1);
        }
    }
    vector<int> ans;
    int x = n, y = m;
    while (x > 0 && y > 0) {
        if (dp[x][y] == dp[x - 1][y]) {
            --x;
            continue;
        }
        if (dp[x][y] == dp[x][y - 1]) {
            --y;
            continue;
        }
        ans.emplace_back(a[x - 1]);
        --x;
        --y;
    }
    reverse(all(ans));
    return ans;
}

void Insert(vector<bool> &h, int x, int &last) {
    for (int i = 16; i >= 0; --i) {
        if (x & (1 << i))
            h[last++] = 1;
        else
            h[last++] = 0;
    }
}

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol) {
    if (a.size() <= N && b.size() <= N)
        return vector<bool>(0);
    vector<bool> h;
    int pi = -1, pj = -1;
    vector<int> p1, p2;
    for (int k = 0; k < sol.size(); ++k) {
        int i = pi + 1;
        int j = pj + 1;
        while (a[i] != sol[k])
            ++i;
        while (b[j] != sol[k])
            ++j;
        p1.emplace_back(i);
        p2.emplace_back(j);
        pi = i;
        pj = j;
    }
    vector<int> to_add;
    for (int l = 0; l < sol.size();) {
        int r = l;
        while (r + 1 < sol.size() && p1[r + 1] - p1[l] + 1 <= K && p2[r + 1] - p2[l] + 1 <= K)
            ++r;
        to_add.emplace_back(p1[r]);
        to_add.emplace_back(p2[r]);
        ///Insert(h, p1[r]);
        ///Insert(h, p2[r]);
        l = r + 1;
    }
    h.resize(17 * to_add.size());
    int last = 0;
    for (int x : to_add) {
        Insert(h, x, last);
    }
    return h;
}

int Get(const vector<bool> &hint, int i) {
    int x = 0;
    for (int j = i; j < i + 17; ++j) {
        x <<= 1;
        if (hint[j])
            x |= 1;
    }
    return x;
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint) {
    if (a.size() <= N && b.size() <= N) {
        return slow(a, b);
    }
    if (hint.empty()) {
        return vector<int>(0);
    }
    int prev1 = -1;
    int prev2 = -1;
    vector<int> ans;
    vector<int> cur;
    for (int i = 0; i < hint.size(); i += 34) {
        int p1 = Get(hint, i);
        int p2 = Get(hint, i + 17);
        vector<int> A(a.begin() + prev1 + 1, a.begin() + p1 + 1);
        vector<int> B(b.begin() + prev2 + 1, b.begin() + p2 + 1);
        prev1 = p1;
        prev2 = p2;
        cur = slow(A, B);
        for (int x : cur)
            ans.emplace_back(x);
    }
    return ans;
}

/**signed main() {
    int type;
    cin >> type;
    if (type == 1) {
        int n, m, k;
        cin >> n >> m >> k;
        vector<int> a(n);
        vector<int> b(m);
        vector<int> c(k);
        for (int &x : a)
            cin >> x;
        for (int &x : b)
            cin >> x;
        for (int &x : c)
            cin >> x;
        vector<bool> hint = genHint(a, b, c);
        for (int i = 0; i < hint.size(); ++i) {
            cout << hint[i] << ' ';
        }
        cout << endl;
        vector<int> res = solve(a, b, hint);
        for (int x : res)
            cout << x << ' ';
    }
}**/
