#include "hint.h"
#include <iostream>
#include <vector>

using namespace std;

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol){
    int n = (a.size() > b.size() ? a.size() : b.size());
    std::vector<bool> res(n);
    if(a.size() > b.size()){
        for(int i = 0;i<b.size();i++){
            for(int z = 0;z<sol.size();z++){
                if(b[i] == sol[z]){
                    res[i] = 1;
                    break;
                }
            }
        }
    }
    else{
        for(int i = 0;i<a.size();i++){
            for(int z = 0;z<sol.size();z++){
                if(a[i] == sol[z]){
                    res[i] = 1;
                    break;
                }
            }
        }
    }
    return res;
}
std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint){
    std::vector<int> k;
    if(a.size() > b.size()){
        for(int i = 0;i<hint.size();i++){
            if(hint[i]) k.push_back(b[i]);
        }
    }
    else{
        for(int i = 0;i<hint.size();i++){
            if(hint[i]) k.push_back(a[i]);
        }
    }
    return k;
}
