#include "hint.h"
#include <bits/stdc++.h>

using namespace std;

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol){
    int n = (a.size() > b.size() ? a.size() : b.size());
    std::vector<bool> res(n);
    if(a.size() > b.size()){
        for(int i = 0;i<b.size();i++){
            for(int z = 0;z<sol.size();z++){
                if(b[i] == sol[z]){
                    res[i] = 1;
                    break;
                }
            }
        }
    }
    else{
        for(int i = 0;i<a.size();i++){
            for(int z = 0;z<sol.size();z++){
                if(a[i] == sol[z]){
                    res[i] = 1;
                    break;
                }
            }
        }
    }
    return {1};
}
std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint){
    std::vector<int> k;
    int dp[a.size()][b.size()];
    pair<int,int> pr[a.size()][b.size()];
    memset(dp,0,sizeof dp);
    for(int i = 0;i<a.size();i++){
        for(int z = 0;z<b.size();z++) pr[i][z] = make_pair(-1, -1);
    }
    for(int i = 0;i<a.size();i++){
        for(int z = 0;z<b.size();z++){
            if(a[i] == b[z]){
                if(i == 0 || z == 0) dp[i][z] = 1;
                else{
                    dp[i][z] = ((i > 0 && z > 0) ? dp[i-1][z-1]+1 : 1);
                    if(i > 0 && z > 0)
                        pr[i][z] = make_pair(i-1,z-1);
                }
            }
            else{
                if(i == 0 || z == 0) continue;
                if(dp[i-1][z] > dp[i][z-1]){
                    pr[i][z] = make_pair(i-1,z);
                }
                else{
                    pr[i][z] = make_pair(i,z-1);
                }
                dp[i][z] = max(dp[i][z-1],dp[i-1][z]);
            }
        }
    }
    for(auto it:dp){
        for(int i= 0;i<b.size();i++) cout << it[i] << " ";
        cout << endl;
    }
    int x,y;
    x = a.size()-1;
    y = b.size()-1;
    vector<int> res;
    while(1){
        if(x < 0 || y < 0) break;
        if(dp[x-1][y-1] == (dp[x][y]-1)){
            res.push_back(a[x]);
            x--;
            y--;
            continue;
        }
        int x1,y1;
        x1 = pr[x][y].first, y1 = pr[x][y].second;
        x = x1, y = y1;
    }
    reverse(res.begin(),res.end());
    return res;

}