#include <bits/stdc++.h>
#include "hint.h"
using namespace std;
typedef long long ll;
typedef pair<int,int> pi;
typedef pair<ll,ll> pl;
#define endl '\n'
#define F first
#define S second
#define fastio ios_base::sync_with_stdio(false);cin.tie(nullptr);
#define all(x) (x).begin(),(x).end()
const int N = 3e5+5;
const ll INF = 2e18;

/// run : g++ Lgrader.cpp hint.cpp


vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& sol){
    vector<bool> ret;
    return ret;
}


vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint){
    int n = a.size();
    int m = b.size();

    int i,j;
    pi dp[n+1][m+1];

    for(i=0;i<=n;i++)
        dp[i][0] = {0,-2};
    for(i=0;i<=m;i++)
        dp[0][i] = {0,-2};

    /// .second : 0 -> diagonal, 1 -> left, -1 -> up
    ///           -2 -> end

    for(i=1;i<=n;i++){
        for(j=1;j<=m;j++){
            if(a[i-1] == b[j-1]){
                dp[i][j].F = dp[i-1][j-1].F + 1;
                dp[i][j].S = 0;
            }
            else{
                if(dp[i-1][j].F > dp[i][j-1].F){
                    dp[i][j] = {dp[i-1][j].F,-1};
                }
                else{
                    dp[i][j] = {dp[i][j-1].F,1};
                }
            }
        }
    }

    vector<int> ans(dp[n][m].F,-1);
    int idx = int(ans.size())-1;

    /*
    for(auto x : ans)cout<<x<<" ";
    cout<<endl;
    cout<<idx<<endl;
    */

    i = n;
    j = m;

    while(i > 0 && j > 0){
        if(dp[i][j].S == 0){
            ans[idx] = a[i-1];
            assert(a[i-1] == b[j-1]);
            idx--;
            i--;
            j--;
        }
        else if(dp[i][j].S == -1)
            i--;
        else
            j--;
    }
    assert(idx == -1);

    return ans;
}

/*

7 6
1 2 3 4 2 3 5
4 2 3 2 3 2
4
2 3 2 3

*/

/*

4 2
1 2 3 4
5 6
0


*/
