#include <bits/stdc++.h>
//#include <hint.h>

#define ibase ios_base::sync_with_stdio(0); cin.tie(0);
#define fi first
#define se second

using namespace std;
using ll = long long;

int const inf = 1e8 + 1, bit = 20;

int gsq(int x){
    return sqrt(x) + 3;
}

vector <bool> gig(int x){
    vector <bool> b(bit, 0);
    for(int i = 0; i < bit; ++i){
        if(x & (1 << i)){
            b[i] = 1;
        }
    }
    return b;
}

vector <bool> genHint(const vector <int>& a, const vector <int>& b, const vector <int>& sol){
    int n = a.size(), m = b.size(), k = sol.size();
    int sq = gsq(n);
    vector <bool> hint(sq * bit, 0);
    int j = 0, bi = 0;
    for(int i = 0; i < sq; ++i){
        int last = 0;
        vector <int> h;
        for(int _i = i * sq; _i < min(n, (i + 1) * sq); ++_i){
            if(j < k and sol[j] == a[_i]){
                h.push_back(a[_i]);
                while(b[bi] != sol[j]){
                    ++bi;
                }
                last = bi;
                ++j;
            }
        }
//        for(auto w : h){
//            cout << w << ' ';
//        }
//        cout << endl;
        vector <bool> num = gig(last);
        for(int l = 0; l < bit; ++l){
            hint[i * bit + l] = num[l];
        }
//        cout << sq << ' ' << i << ' ' << last << endl;
    }
    return hint;
}

vector <int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint){
    int n = a.size(), m = b.size();
    vector <int> sol;
    int j = 0, sq = gsq(n);
    for(int i = 0; i < sq; ++i){
        int last = 0;
        for(int _i = 0; _i < bit; ++_i){
            if(hint[i * bit + _i]){
                last += (1 << _i);
            }
        }
        if(last < j){ continue;}
//        cout << i << ' ' << j << ' ' << last << "     ";
        int N = min(sq, n - sq*i);
        int len = last - j + 1, dp[N][len];
        for(int x = 0; x < N; ++x){
            for(int y = 0; y < len; ++y){
                dp[x][y] = 0;
                if(a[i * sq + x] == b[j + y]){
                    dp[x][y] = 1 + ((x - 1 >= 0 and y - 1 >= 0) ? dp[x - 1][y - 1] : 0);
                }
                if(x - 1 >= 0){
                    dp[x][y] = max(dp[x][y], dp[x - 1][y]);
                }
                if(y - 1 >= 0){
                    dp[x][y] = max(dp[x][y], dp[x][y - 1]);
                }
            }
        }
//        for(int x = 0; x < N; ++x){
//            for(int y = 0; y < len; ++y){
//                cout << dp[x][y] << ' ';
//            }
//            cout << endl;
//        }
//        cout << "ADADSDAD " << endl;
        vector <int> ans;
        int x = N - 1, y = len - 1;
        while(x >= 0 and y >= 0){
//            cout << x << ' ' << y << endl;
            if(x - 1 >= 0 and dp[x][y] == dp[x - 1][y]){
                --x;
            }
            else if(y - 1 >= 0 and dp[x][y] == dp[x][y - 1]){
                --y;
            }
            else{
                ans.push_back(b[j + y]);
                --x;
                --y;
            }
        }
        reverse(ans.begin(), ans.end());
//        for(auto w : ans){
//            cout << w << ' ';
//        }
//        cout << endl;
        for(auto w : ans){
            sol.push_back(w);
        }
        j = last + 1;
    }
    return sol;
}
/*

signed main(){
    int n, m, k;
    cin >> n >> m >> k;
    vector <int> a(n), b(m), sol(k);
    for(int i = 0; i < n; ++i){
        cin >> a[i];
    }
    for(int i = 0; i < m; ++i){
        cin >> b[i];
    }
    for(int i = 0; i < k; ++i){
        cin >> sol[i];
    }
    vector <bool> hint = genHint(a, b, sol);
    vector <int> _sol = solve(a, b, hint);
    for(auto w : _sol){
        cout << w << ' ';
    }
}
*/

/**
7 5 4
1 2 1 3 1 2 1
1 3 1 2 2
1 3 1 2

7 7 5
1 2 1 3 1 2 4
1 3 1 2 2 3 4
1 3 1 2 4
**/

