#include "hint.h"

#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <queue>

#define upmin(a, b) a = min(a, b)
#define upmax(a, b) a = max(a, b)
#define pr(x) cout << x << endl
#define wpr(x) cout << #x << ": " << x << endl
#define spr(x) cout << x << " "
#define wprv(x) cout << #x << ": " << endl; for(auto it : x) cout << it << " "; cout << endl;
#define wprvv(x) cout << #x << ": " << endl; for(auto it : x) { for(auto it2 : it) cout << it2 << " "; cout << endl;}
#define rep(i, s, e) for(ll i = s; i < e; i++)



using namespace std;

using ll = int;
using vll = vector<ll>;
using vvll = vector<vll>;
using vb = vector<bool>;
using vvb = vector<vb>;
using pll = pair<ll, ll>;
using vpll = vector<pll>;
using vvpll = vector<vpll>;
using vi = vector<int>;


vll get_indexes(vll a, vll sol)
{
	vll inds;
	ll p = 0;
	rep(i, 0, a.size()) {
		if (p < sol.size() && sol[p] == a[i]) {
			inds.push_back(i);
			p++;
		}
	}
	return inds;
}


std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol)
{
	vll inds;
	if (a.size() <= b.size()) {
		inds = get_indexes(a, sol);
	}
	else {
		inds = get_indexes(b, sol);
	}
	vb res;
	if (inds.size() == 0) return res; // no match
	res.resize(inds[inds.size() - 1] + 1, 0);
	rep(i, 0, inds.size()) res[inds[i]] = 1;
	return res;
}



////////////////////////////////////////////////////////////////


std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint)
{
	vi ans;
	if (a.size() <= b.size()) {
		rep(i, 0, hint.size()) {
			if (hint[i]) ans.push_back(a[i]);
		}
	}
	else {
		rep(i, 0, hint.size()) {
			if (hint[i]) ans.push_back(b[i]);
		}
	}
	return ans;
}


