#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <queue>

#define upmin(a, b) a = min(a, b)
#define upmax(a, b) a = max(a, b)
#define pr(x) cout << x << endl
#define wpr(x) cout << #x << ": " << x << endl
#define spr(x) cout << x << " "
#define wprv(x) cout << #x << ": " << endl; for(auto it : x) cout << it << " "; cout << endl;
#define wprvv(x) cout << #x << ": " << endl; for(auto it : x) { for(auto it2 : it) cout << it2 << " "; cout << endl;}
#define rep(i, s, e) for(ll i = s; i < e; i++)



using namespace std;

using ll = long long;
using vll = vector<ll>;
using vvll = vector<vll>;
using vb = vector<bool>;
using vvb = vector<vb>;
using pll = pair<ll, ll>;
using vpll = vector<pll>;
using vvpll = vector<vpll>;

/*

Solution:
Let's hope greedy solution works...
For each one find the longes segemnt he can solve.
Do it with BS.

Well, the order of them stays the same. so mabye we can BS on them.


Maybe we'll do this thing:
Let's try this anyway...
For each one find the best position he can still be ok.
Moreover, let the left neighboor try to help him.

*/

struct delivery {
	ll t, h;
	delivery(ll t, ll h) : t(t), h(h) {}
	void print()
	{
		cout << "{t: " << t << ", h: " << h << "}" << endl;
	}
};

bool comp_h(delivery d1, delivery d2)
{
	return d1.h < d2.h;
}
bool comp_t(delivery d1, delivery d2)
{
	return d1.t < d2.t;
}


bool is_ok(vector<delivery>& arr)
{
	sort(arr.begin(), arr.end(), comp_t);
	rep(i, 1, arr.size()) {
		ll distv = abs(arr[i - 1].h - arr[i].h);
		ll timev = abs(arr[i].t - arr[i-1].t);
		if (distv > timev) return false;
	}
	return true;
}


vector<delivery> dels;
ll n;
void solve()
{
	cin >> n;
	rep(i, 0, n) {
		ll tt, hh; cin >> tt >> hh;
		dels.push_back(delivery(tt, hh));
	}
	sort(dels.begin(), dels.end(), comp_t);
	/*
	for (auto it : dels) {
		it.print();
	}
	*/
	
	ll res = 0;
	vb done(n, 0);
	ll p = 0;
	while (p < n) {
		if (done[p]) {
			p++;
			continue;
		}
		res++;
		vector<delivery> cur;
		cur.push_back(dels[p]);
		done[p] = true;
		rep(i, p + 1, n) {
			if (done[i]) continue;
			cur.push_back(dels[i]);
			if (is_ok(cur)) done[i] = true;
			else cur.pop_back();
		}
	}
	pr(res);
}



int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	solve();
}

/*


6
1 1
2 3
3 2
5 4
4 1
4 3

*/