#ifndef DEBUG
#include "hint.h"
#endif // DEBUG
#include <iostream>
#include <cstdio>
#include <cstring>
#include <map>
#include <vector>

struct {
	int x , y , val ;
} dp [ 20005 ] [ 20005 ] ;

void _out ( const std::vector<int>& a , const std::vector<int>& b , std::vector<int>& out , int x , int y ) {
	if ( x >= a.size() || y >= b.size() ) return ;
	if (dp[dp[x][y].x][dp[x][y].y].val < dp[x][y].val)
		out.push_back ( a[x] ) ;
	_out (a,b,out,dp[x][y].x,dp[x][y].y);
}

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol) {
	return std::vector<bool> () ;
}

std::vector<int> solve ( const std::vector<int>& a , const std::vector<int>& b , const std::vector<bool>& hint ) {
	int N = a.size();
	int M = b.size();
	for ( int i = N - 1 ; i + 1 ; i-- ) {
		for ( int j = M - 1 ; j + 1 ; j-- ) {
			if ( dp [ i + 1 ][ j ].val > dp [ i ][ j + 1 ].val ) {
				dp [ i ][ j ].val = dp [ i + 1 ][ j ].val ;
				dp [ i ][ j ].x = i + 1 ;
				dp [ i ][ j ].y = j ;
			}else{
				dp [ i ][ j ].val = dp [ i ][ j + 1 ].val ;
				dp [ i ][ j ].x = i ;
				dp [ i ][ j ].y = j + 1 ;
			}
			if ( a [ i ] == b [ j ] ) {
				if ( dp [ i + 1 ][ j + 1 ].val + 1 > dp [ i ][ j ].val ) {
					dp [ i ][ j ].val = dp [ i + 1 ][ j + 1 ].val + 1 ;
					dp [ i ][ j ].x = i + 1 ;
					dp [ i ][ j ].y = j + 1 ;
				}
			}
		}
	}
	std::vector<int> c;
	_out ( a , b , c , 0 , 0 ) ;
	return c;
}

#ifdef DEBUG
int main ( void ) {
	std::vector<int> a = { 2 , 1 , 2 , 1 , 3 , 4 , 5 } ;
	std::vector<int> b = { 2 , 2 , 1 , 2 , 3 , 5 , 4 } ;
	std::vector<bool> h;
	std::vector<int> c = solve ( a , b , h ) ;
	for ( auto i : c ) printf ( "%d " , i ) ;
	printf ( "\n") ;
    return 0;
}
#endif // DEBUG
