//#define DEBUG
#ifndef DEBUG
#include "hint.h"
#endif // DEBUG
#include <iostream>
#include <cstdio>
#include <cstring>
#include <map>
#include <vector>
struct {
    int x , y , val ;
} dp [ 10005 ] [ 10005 ] ;

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol) {
	int off = 0 ;
	std::vector<bool> res;
    for ( int i = 0 ; i < a.size () ; i++ ) {
		if ( sol [ off ] == a [ i ] ) {
				res.push_back ( true );
				off++;
		}else{
			res.push_back ( false);
		}
    }
    return res;
}
std::vector<int> solve ( const std::vector<int>& a , const std::vector<int>& b , const std::vector<bool>& hint ) {
    std::vector<int> c;
    for ( int i = 0 ; i < hint.size () ; i++ ) {
			if ( hint [ i ]) c.push_back (a[i]);
    }
    return c;
}
#ifdef DEBUG
static int n, m, k;
static std::vector<int> a, b, sol, maybeSol;
static std::vector<bool> hint;

// 7 7 2 1 2 1 3 4 5 2 2 1 2 3 5 4 5 2 1 2 3 4

int main()
{
    scanf (" %d %d" , &n ,&m) ;

    a.resize(n);
    b.resize(m);

    for (int& num : a)
    {
        scanf ( " %d" , &num) ;
    }

    for (int& num : b)
    {
        scanf ( " %d" , &num) ;
    }

    scanf ( " %d" , &k) ;

    sol.resize(k);

    for (int& num : sol)
    {
        scanf ( " %d" , &num) ;
    }

    hint = genHint(a, b, sol);
    maybeSol = solve(a, b, hint);

    std::cout << hint.size() << std::endl;
    std::cout << maybeSol.size() << std::endl;

    for (int i = 0; i < (int) maybeSol.size(); ++i)
    {
        if (i > 0) std::cout << " ";
        std::cout << maybeSol[i];
    }
    std::cout << std::endl;

    return 0;
}
#endif // DEBUG
