//#define DEBUG
#ifndef DEBUG
#include "hint.h"
#endif // DEBUG
#include <iostream>
#include <cstdio>
#include <cstring>
#include <map>
#include <vector>
struct {
    short x , y , val ;
} dp [ 10005 ] [ 10005 ] ;
std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol) {
    return std::vector<bool> () ;
}
std::vector<int> solve ( const std::vector<int>& a , const std::vector<int>& b , const std::vector<bool>& hint ) {
    short N = a.size();
    short M = b.size();
    for ( int i = N - 1 ; i + 1 ; i-- ) {
        for ( int j = M - 1 ; j + 1 ; j-- ) {
            if ( dp [ i + 1 ][ j ].val > dp [ i ][ j + 1 ].val ) {
                dp [ i ][ j ].val = dp [ i + 1 ][ j ].val ;
                dp [ i ][ j ].x = i + 1 ;
                dp [ i ][ j ].y = j ;
            }else{
                dp [ i ][ j ].val = dp [ i ][ j + 1 ].val ;
                dp [ i ][ j ].x = i ;
                dp [ i ][ j ].y = j + 1 ;
            }
            if ( a [ i ] == b [ j ] ) {
                if ( dp [ i + 1 ][ j + 1 ].val + 1 > dp [ i ][ j ].val ) {
                    dp [ i ][ j ].val = dp [ i + 1 ][ j + 1 ].val + 1 ;
                    dp [ i ][ j ].x = i + 1 ;
                    dp [ i ][ j ].y = j + 1 ;
                }
            }
        }
    }
    std::vector<int> c;
    short x = 0 , y = 0 ;
    while ( x < N && y < M ) {
        int nx = dp [x][y].x;
        int ny = dp [x][y].y;
        if ( dp[x][y].val != dp[nx][ny].val )c.push_back(a[x]);
        x = nx; y = ny;
    }
    return c;
}
#ifdef DEBUG
static int n, m, k;
static std::vector<int> a, b, sol, maybeSol;
static std::vector<bool> hint;
// 7 7 2 1 2 1 3 4 5 2 2 1 2 3 5 4 5 2 1 2 3 4
int main()
{
    scanf (" %d %d" , &n ,&m) ;
    a.resize(n);
    b.resize(m);
    for (int& num : a)
    {
        scanf ( " %d" , &num) ;
    }
    for (int& num : b)
    {
        scanf ( " %d" , &num) ;
    }
    scanf ( " %d" , &k) ;
    sol.resize(k);
    for (int& num : sol)
    {
        scanf ( " %d" , &num) ;
    }
    hint = genHint(a, b, sol);
    maybeSol = solve(a, b, hint);
    std::cout << hint.size() << std::endl;
    std::cout << maybeSol.size() << std::endl;
    for (int i = 0; i < (int) maybeSol.size(); ++i)
    {
        if (i > 0) std::cout << " ";
        std::cout << maybeSol[i];
    }
    std::cout << std::endl;
    return 0;
}
#endif // DEBUG
