#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
using namespace std;

enum BEHAVIOUR {
	SCARED ,
	CURIOUS ,
};

int N , S , C ;
std::vector<int> M ;

void Init ( ) {
	while ( M.size ( ) < 2 * N ) {
		for ( int s = 0 ; s < S ; s++ ) M.push_back ( SCARED ) ;
		for ( int c = 0 ; c < C ; c++ ) M.push_back ( CURIOUS ) ;
	}
}

int main ( void ) {
    scanf ( " %d %d %d" , &N , &S ,&C ) ;
    Init ( ) ;

    std::vector<int> H ;
    int L = 1 , R = N ;
    while ( L <= R ) {
		if ( L == R ) {
				H.push_back ( L ) ;
				break;
		}
		switch ( M [ H.size ( ) ] ) {
			case SCARED:{
				// make it move to the left by checking the rightmost available solution
				H.push_back ( R ) ; R -= 2 ; L--;
			}break;
			case CURIOUS:{
				// make it move to the left by checking the leftmost available solution
				H.push_back ( L ) ; R--;
			}break;
		}
		L = std::max ( L , 1 ) ;
		R = std::max ( R , 1 ) ;
    }
    printf ( "%d\n" , H.size ( ) ) ;
    for ( auto m : H ) printf ( "%d " , m ) ;
    printf ( "\n" ) ;
    return 0;
}
