#include <bits/stdc++.h>

using namespace std;
#define pii pair<int, int>
#define f first
#define s second
#define pb push_back

const int N = 1e4 + 10;
vector<int> g[N];
int par[N], used[N], col = 1;

int dfs(int v) {
    used[v] = col;
    for (auto u: g[v]) {
        if (par[u] == -1) {
            par[u] = v;
            return 1;
        }
    }
    for (auto u: g[v]) {
        if (used[par[u]] != col && dfs(par[u])) {
            par[u] = v;
            return 1;
        }
    }
    return 0;
}

void solve() {
    int n;
    cin >> n;
    pii a[n];
    for (int i = 0; i < n; i++)
        cin >> a[i].f >> a[i].s;
    sort(a, a + n);
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (a[j].f - a[i].f >= abs(a[i].s - a[j].s)) {
                g[i].pb(j);
            }
        }
        random_shuffle(g[i].begin(), g[i].end());
    }
    for (int i = 0; i < n; i++) {
        par[i] = -1;
    }
    vector<int> vec;
    for (int i = 0; i < n; i++)
        vec.pb(i);
    random_shuffle(vec.begin(), vec.end());
    for (auto v: vec) {
        dfs(v);
        col++;
    }
    int kolvo = 0;
    for (int i = 0; i < n; i++) {
        if (par[i] == -1)
            kolvo++;
    }
    cout << kolvo << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
}