#ifndef LOCAL
#pragma GCC optimize("Ofast,unroll-loops,fast-math,inline,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx,popcnt")
#endif
#include <bits/stdc++.h>
using namespace std;

#define endl '\n'

typedef long long ll;
typedef long double ldb;

void check(int n, int s, int c, vector<int> ans) {
    vector<int> pos;
    pos.resize(n);
    iota(pos.begin(), pos.end(), 1);
    int cur_time = 0;
    for (int el : ans) {
        auto it = lower_bound(pos.begin(), pos.end(), el);
        if (it != pos.end() && *it == el) {
            pos.erase(it);
        } else {
            assert(false);
        }
        for (int &x : pos) {
            if (cur_time % (s + c) < s) {
                if (x < el) {
                    if (x > 1)
                        x--;
                } else if (x < n) {
                    x++;
                }
            } else {
                if (x < el) {
                    x++;
                } else {
                    x--;
                }
            }
        }
        cur_time++;
        pos.erase(unique(pos.begin(), pos.end()), pos.end());
    }
    assert(pos.empty());
}

void solve() {
    int n, s, c;
    cin >> n >> s >> c;
    vector<int> ans;
    int cur_pos = 1;
    int cur_time = 0;
    ans.push_back(cur_pos);
    deque<int> left;
    int addLeft=0;
    int max_pos = n;
    int nxt_pos = n;
    if (s == 0) {
        nxt_pos = n - 1;
    }
    while (cur_pos < nxt_pos) {
        if (cur_time % (s + c) >= s) {
            max_pos--;
            addLeft++;
            if (left.empty() || left.back() != cur_pos - addLeft)
                left.push_back(cur_pos - addLeft);
            cur_pos++;
        } else {
            addLeft--;
            if (!left.empty() && left[0] + addLeft == 0) {
                left.pop_front();
                if (left.empty() || left.front() + addLeft != 1) {
                    left.push_front(1 - addLeft);
                }
            }
            cur_pos += 2;
            max_pos++;
            max_pos = min(max_pos, n);
            cur_pos = min(cur_pos, n);
        }
        cur_time++;
        ans.push_back(cur_pos);
        if (cur_time % (s + c) >= s) {
            nxt_pos = max_pos - 1;
        } else {
            nxt_pos = min(max_pos + 1, n);
        }
    }
    if ((cur_time) % (s + c) < s) {
        addLeft--;
        if (!left.empty() && left[0] + addLeft == 0) {
            left.pop_front();
            if (left.empty() || left.front() + addLeft != 1) {
                left.push_front(1 - addLeft);
            }
        }
    } else {
        addLeft++;
        if (!left.empty() && left.back() + addLeft == n + 1) {
            left.pop_back();
            if (left.empty() || left.back() + addLeft != n) {
                left.push_back(n - addLeft);
            }
        }
    }
    for (int el : left) {
        int val = min(n, el + addLeft); 
        ans.push_back(val);
        if (val == n) {
            break;
        }
        cur_time++;
        if ((cur_time) % (s + c) < s) {
            addLeft++;
            if (!left.empty() && left.back() + addLeft == n + 1) {
                left.pop_back();
                if (left.empty() || left.back() + addLeft != n) {
                    left.push_back(n - addLeft);
                }
            }
        } else {
            addLeft--;
            if (!left.empty() && left[0] + addLeft == 0) {
                left.pop_front();
                if (left.empty() || left.front() + addLeft != 1) {
                    left.push_front(1 - addLeft);
                }
            }
        }
    }
    cout << ans.size() << endl;
    for (int el : ans) {
        cout << el << " ";
    }
    cout << endl;
#ifdef LOCAL
    cout.flush();
    check(n, s, c, ans);
    ldb t = (ldb) n * (s + c) / (s + 2 * max(s, c)) + 3 * max(s, c);
    int k = (int) ans.size();
    if (k > 2 * n) {
        cout << 0 << endl;
    } else if (k <= t) {
        cout << 1 << endl;
    } else {
        cout << 0.3 * t * t / k / k << endl;
    }
#endif
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    while (t--) {
        solve();
    }
}
