#include <iostream>
#include <vector>
#include "hint.h"

using namespace std;

static int n, m, k;

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol) {
    int j = 0;
    vector<bool> hint(a.size(), false);
    for (int i = 0; i < a.size() && j < sol.size(); ++i) {
        if (a[i] == sol[j]) {
            hint[i] = true;
            ++j;
        }
    }
    return hint;
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint) {
    vector<int> res;
    for (int i = 0; i < a.size(); ++i) {
        if (hint[i]) {
            res.push_back(a[i]);
        }
    }
    return res;
}
