#include <bits/stdc++.h>
using namespace std;

void solveStupidCases(int n, int s, int c) {
    if (s == 0 && c == 1) {
        vector<int> ans;
        int mid = n / 2;
        for (int i = 0; i < n / 2 + 2; ++i) {
            ans.push_back(mid);
        }
        cout << ans.size() << '\n';
        for (int i : ans) {
            cout << i << ' ';
        }
        cout << '\n';
        exit(0);
    }
}

vector<int> firstSolve(int n, int s, int c) {
    vector<int> ans;
    int l = 1, r = n;
    while (l < r) {
        for (int i = 0; i < s && l < r; ++i) {
            ans.push_back(r);
            r -= 2;
            r = max(1, r);
            --l;
            l = max(1, l);
        }
        for (int i = 0; i < c && l < r; ++i) {
            int mid = (l + r) / 2;
            ans.push_back(mid);
            if (l != mid) {
                ++l;
            }
            --r;
        }
    }
    ans.push_back(l);
    return ans;
}

vector<int> secondSolve(int n, int s, int c) {
    vector<int> ans;

    int mid = n / 2;
    ans.push_back(mid);
    int l1 = 1, r1 = mid - 2;
    int l2 = mid + 2, r2 = n;

    bool flag = false;
    while (r1 > l1 && l2 < r2) {
        if (flag) {
            ans.push_back(r1);
            r1 -= 2;
            ++l2;
        } else {
            ans.push_back(l2);
            l2 += 2;
            --r1;
        }
        flag = !flag;
    }
    while (r1 > l1) {
        ans.push_back(r1);
        r1 -= 2;
        ++l2;
    }
    ans.push_back(1);
    ++l2;
    while (l2 < r2) {
        ans.push_back(l2);
        l2 += 2;
    }
    ans.push_back(n);
    return ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, s, c;
    cin >> n >> s >> c;
    solveStupidCases(n, s, c);
    vector<int> ans = firstSolve(n, s, c);
    vector<int> ans2 = secondSolve(n, s, c);
    if (ans2.size() < ans.size()) {
        ans = ans2;
    }
    cout << ans.size() << '\n';
    for (int i : ans) {
        cout << i << ' ';
    }
    cout << '\n';
    return 0;
}