#include <vector>
#include "hint.h"
#include <algorithm>
#include <iostream>

std::vector<bool>  genHint(const  std::vector<int>&  a,  const  std::vector<int>&  b, 
    const std::vector<int>& sol) {
      std::vector<bool> res;
      return res;
}

int const nmax = 10000;
int dp[5 + nmax][5 + nmax] = {0};

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b,
    const std::vector<bool>& hint) {
  for(int i = 1; i <= a.size(); i++)
    for(int j = 1;j <= b.size(); j++) {
      dp[i][j] = std::max(std::max(dp[i - 1][j], dp[i][j - 1]), int(dp[i - 1][j - 1] + (a[i - 1] == b[j - 1])) );
    }
  
  int x = a.size(), y = b.size();
  std::vector<int> sol;
  while(0 < dp[x][y]) {
    if(a[x - 1] == b[y - 1] && dp[x - 1][y - 1] + 1 == dp[x][y]) {
      sol.push_back(a[x - 1]);
      x--;
      y--;
    } else if(0 < x && dp[x - 1][y] == dp[x][y])
      x--;
    else
      y--;
  }
  std::reverse(sol.begin(), sol.end());
  return sol;
}

