#include <bits/stdc++.h>
#include "hint.h"

using namespace std;

#define pb push_back

int dp[10001][10001];
vector <int> A;
vector <int> B;

int rec(int i, int j)
{
    if (i<0 or j<0)
    {
        return 0;
    }
    if (dp[i][j] != -1)
    {
        return dp[i][j];
    }
    if (A[i] == B[j])
    {
        dp[i][j] = (rec(i-1,j-1) + 1);
    }
    else
    {
        dp[i][j] = max (rec(i-1, j), rec(i, j-1));
    }
    return dp[i][j];
}

vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& sol)
{
     vector <bool> emp;
     emp.pb(1);
     return emp;
}

 vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint)
{
     int n = a.size();
     int m = b.size();
     A = a;
     B = b;
     memset(dp, -1, sizeof(dp));
     rec(n-1, m-1);
     int i = n-1, j = m-1;
     vector <int> sol;
     while (dp[i][j]>0)
     {
         if (A[i]==B[j])
         {
             sol.pb(A[i]);
             i--;
             j--;
             if (i<0 or j<0)
             {
                 break;
             }
             continue;
         }
         if (dp[i-1][j] > dp[i][j-1])
         {
             i--;
         }
         else
         {
             j--;
         }
         if (i<0 or j<0)
         {
             break;
         }
     }
     reverse(sol.begin(), sol.end());
     return sol;
}

/*

5 5
12 2 0 4 3
2 0 12 3 9
3
2 0 3

*/
