#include <iostream>
#include <vector>

using namespace std; 

vector<int> c_signf(int n, int s, int c){
    vector<int> res;
    int l = 1, r = n, ind = 0; 

    while (l < r){
        if (ind % (s + c) < s){
            res.push_back(r);
            r -= 2; 
            l = max(l-1, 1); 
            if (l >= r) res.push_back(l); 
        }
        else {
            int mid = (l + r) >> 1; 
            res.push_back(mid);
            l++;
            r--; 
            if (l >= r) res.push_back(mid); 
        }
        ind++;
    }
    return res; 
}

vector<int> s_signf(int n, int s, int c){
    vector<int> res;
    int ind = 0, bar = 1; 
    while (bar < n){
        if (ind % (s+c) < s){
            res.push_back(bar);  
            bar += 2; 
        }
        else {
            res.push_back(n); 
            bar++; 
        }
        ind++;
    }
    res.push_back(n); 
    return res; 
}

void print(vector<int> & res){
    cout << res.size() << "\n"; 
    for (int a : res) cout << a << " "; 
}

int main(){
    int n,s,c; cin >> n >> s >> c; 
    vector<int> one = c_signf(n, s, c); 
    vector<int> two = s_signf(n, s, c);
    if (one.size() < two.size()) print(one); 
    else print(two); 
}
