#include <iostream>
#include <algorithm>
#include <set>

struct coord {
	int posx, posy;
	bool operator<(const coord& nr2) const {
		return ((posx == nr2.posx) ? (posy < nr2.posy) : (posx < nr2.posx));
	}
} vec[1000005];

std::multiset <int> trk;

int main() {
	std::multiset <int>::iterator pos;
	int nrn, pos1, pos2;
	int ans;
	std::cin >> nrn;
	for (int index = 0; index < nrn; index++) {
		std::cin >> pos1 >> pos2;
		vec[index] = { pos1 + pos2, pos1 - pos2 };
	}
	std::sort(vec, vec + nrn);
	ans = 1;
	trk.insert(vec[0].posy);
	for (int index = 1; index < nrn; index++) {
		if (vec[index].posy < (*trk.begin())) {
			ans++;
		}
		else {
			pos = trk.upper_bound(vec[index].posy);
			pos--;
			trk.erase(pos);
		}
		trk.insert(vec[index].posy);
	}
	std::cout << ans;
}