#include <bits/stdc++.h>
#include "hint.h"
using namespace std;

const int bucket=200;
std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol)
{
    int n=a.size();
    int m=b.size();
    vector<bool>hint;
    int pa=0,pb=0;
    int lsta=min((int)a.size()-1,bucket);
    int lstb=min((int)b.size()-1,bucket);
    for(int i=0;i<sol.size();++i)
    {
        int vlc=sol[i];
        for(;a[pa]!=vlc;++pa);
        for(;b[pb]!=vlc;++pb);
        while(pa>lsta)
        {
            lsta=min((int)a.size()-1,lsta+bucket);
            hint.push_back(true);
        }
        while(pb>lstb)
        {
            lstb=min((int)b.size()-1,lstb+bucket);
            hint.push_back(false);
        }
    }
    return hint;
}
map<int,int>dp[200005];
//map<int,int>bst[200005];
std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint)
{
    int n=a.size(),m=b.size(),i,j;
    int a1=0,a2=min((int)a.size()-1,bucket),b1=0,b2=min((int)b.size()-1,bucket);
    int mi=0,mj=0,mx=0;
    for(int x=0;x<hint.size();++x)
    {
        for(i=a1;i<=a2;++i)
            for(j=b1;j<=b2;++j)
            {
                if(a[i]==b[j])
                {
                    dp[i+1][j+1]=1+dp[i][j];
                   // bst[i+1][j+1]=3;
                }
                else
                {
                    dp[i+1][j+1]=max(dp[i][j+1],dp[i+1][j]);
                }
                if(dp[i+1][j+1]>mx)
                {
                    mx=dp[i+1][j+1];
                    mi=i;
                    mj=j;
                }
            }
        if(hint[x]==true)
        {
            a1=a2+1;
            a2=min((int)a.size()-1,a2+bucket);
        }
        else
        {
            b1=b2+1;
            b2=min((int)b.size()-1,b2+bucket);
        }
    }
    for(i=a1;i<=a2;++i)
        for(j=b1;j<=b2;++j)
        {
            if(a[i]==b[j])
            {
                dp[i+1][j+1]=1+dp[i][j];
                // bst[i+1][j+1]=3;
            }
            else
            {
                dp[i+1][j+1]=max(dp[i][j+1],dp[i+1][j]);
            }
            if(dp[i+1][j+1]>mx)
            {
                mx=dp[i+1][j+1];
                mi=i;
                mj=j;
            }
        }
    vector<int>rz;
    while(mi>0 && mj>0)
    {
        if(a[mi-1]==b[mj-1])
        {
            rz.push_back(a[mi-1]);
            --mi;
            --mj;
            continue;
        }
        if(dp[mi-1][mj]>dp[mi][mj-1])
            --mi;
        else
            --mj;
    }
    reverse(rz.begin(),rz.end());
    return rz;
}

