#include <bits/stdc++.h> 
#include "hint.h"
using namespace std;

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pii;
typedef vector<pii> vp;
typedef vector<vp> vvp;

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b,
    const std::vector<int>& sol) {
    vi w = a;
    if (a.size() > b.size()) {
        w = b;
    }
    vector<bool> ans(w.size(),0);
    int j = 0;
    for (int i = 0; i < sol.size(); i++) {
        while (w[j] != sol[i]) {
            j++;
        }
        ans[j] = true;
        j++;
    }
    return ans;
}


std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b,
    const std::vector<bool>& hint) {
    int n = a.size();
    int m = b.size();
    vvp dp(n + 1, vp(m + 1, { 0,-1 }));
    vi hold(n + 1, -1);

    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            if (a[i - 1] == b[j - 1]) {
                hold[i - 1] = dp[i - 1][j - 1].second;
                dp[i][j] = { dp[i - 1][j - 1].first + 1 , i - 1 };
            }
            else {
                if (dp[i][j - 1].first > dp[i - 1][j].first) {
                    dp[i][j] = dp[i][j - 1];
                }
                else {
                    dp[i][j] = dp[i - 1][j];
                }
            }
        }
    }
    int size = 0;
    int index = -1;
    for (int i = 0; i <= n; i++) {
        if (size < dp[i][m].first) {
            size = dp[i][m].first;
            index = dp[i][m].second;
        }
    }
    vi ans;
    ans.push_back(a[index]);
    int next = hold[index];
    while (next != -1) {
        ans.push_back(a[next]);
        next = hold[next];
    }
    reverse(ans.begin(), ans.end());
    return ans;
    
}
