#include <bits/stdc++.h>
#include "hint.h"

using namespace std;

vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& sol){
    vector<bool> v;
    return v;
}

vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint){
    int n = a.size();
    int m = b.size();

    vector<vector<int>> dp(n, vector<int>(m));
    vector<vector<bool>> tk(n, vector<bool>(m));

    for (int i = 0; i < n; ++i){
        for (int j = 0; j < m; ++j){
            if (i != 0) dp[i][j] = max(dp[i][j], dp[i-1][j]);
            if (j != 0) dp[i][j] = max(dp[i][j], dp[i][j-1]);
            if (a[i] == b[j]){
                if (i != 0 && j != 0 && dp[i][j] > dp[i-1][j-1] + 1) continue;
                tk[i][j] = true;
                dp[i][j] = 1;
                if (i != 0 && j != 0) dp[i][j] += dp[i-1][j];
            }
        }
    }

    int res = dp[n-1][m-1];
    vector<int> ans(res);

    int i = n-1, j = m-1;
    int k = res - 1;
    while (i > 0 && j > 0){
        if (tk[i][j]) {
            ans[k--] = a[i];
            i--, j--;
        } else if (dp[i-1][j] > dp[i][j-1]) i--;
        else j--;
    }

    if (tk[i][j]) ans[k--] = a[i];
    return ans;
}
