#include <bits/stdc++.h>

using namespace std;

bool check(int n, int s, int c, vector<int> res){
    int m = res.size();

    vector<int> cur(n+1);
    for (int i = 1; i <= n; ++i) cur[i] = i;

    bool flag = false;
    if (s == 0) flag = true;
    int k = 0;

    for (int j = 0; j < m; ++j){
        for (int i = 1; i <= n; ++i){
            if (cur[i] == 0) continue;
            if (cur[i] == res[j]) cur[i] = 0;
            else if (cur[i] > res[j]){
                if (flag && cur[i] > 1) cur[i]--;
                else if (!flag && cur[i] < n) cur[i]++;
            } else{
                if (flag && cur[i] < n) cur[i]++;
                else if (!flag && cur[i] > 1) cur[i]--;
            }
        }

        k++;
        if (!flag && k == s) flag = true, k = 0;
        if (flag && k == c) flag = false, k = 0;
        if (!flag && k == s) flag = true, k = 0;
        if (flag && k == c) flag = false, k = 0;
    }

    for (int i = 1; i <= n; ++i) {
        if (cur[i] != 0) return false;
    }

    return true;
}

void solve(int n, int s, int c){
    if (s == 0){
        cout << (n+2) / 2 << "\n";
        for (int i = 0; i < (n+2) / 2; ++i) cout << (n+1) / 2 << "\n";
    } else if (c == 0){
        int m1 = (n - 1) / 3 + 1;
        int m2 = m1 + (n-1) / 3;

        cout << (m2 - m1) + 3 << "\n";
        while (m1 <= m2){
            cout << m1 << "\n";
            if (m1 != m2) cout << m2 << "\n";
            m1++;
            m2--;
        }

        cout << 1 << "\n";
        cout << n << "\n";
    } else if (s == 1 && c == 1){
        int k = 1;
        vector<int> res;
        while (k <= n) {
            res.push_back(k);
            res.push_back(n);
            k += 3;
        }

        cout << res.size() << "\n";
        for (auto a : res) cout << a << "\n";
    }
    else {
        vector<int> res;

        int x = 1;
        int y = 1;
        int k = 0;

        int lst = n;

        while (k < n - x){
            for (int i = 0; i < s && k < n-x && y <= lst; ++i) {
                res.push_back(min(y, n));
                y += 2;
            }

            if (y > lst) break;

            for (int i = 0; i < c && k < n-x; ++i) {
                res.push_back(max(1, lst - c + 1));
            }
            x += max(0, s - c) + 2*(c-1);
            y += c;

            lst -= max(0, c - s - 1);
        }

        cout << res.size() << "\n";
        for (auto a : res) cout << a << " ";
        cout << "\n";

        //if (check(n, s, c, res)) cout << "OK\n";
        //else exit(0);

    }
}

int main() {

    int n, s, c; cin >> n >> s >> c;
    solve(n, s, c);


    /*
    for (int i = 0; i < 20; ++i) {
        for (int j = 0; j < 5; ++j) {
            for (int k = 0; k < 5; ++k) {
                if (j == 0 && k == 0) continue;
                cout << i+1 << " " << j+1 << " " << k+1 << "\n";
                solve(i+1, j+1, k+1);
            }
        }
    }

    solve(1000, 23, 32);
    */

    return 0;
}
