#include <bits/stdc++.h>

using namespace std;

const int NMAX = 1e4;

vector<pair<int, int>> v;
vector<int> g[NMAX];
vector<int> rev_g[NMAX];
int nr_sons[NMAX];
int truck_taken[NMAX];

int ans = 0;

void remove_as_son(int node) {
    if(nr_sons[node] != 0) return;
    nr_sons[node] = -1;

    int has_truck = 0;
    for(auto vec : g[node]) {
        if(truck_taken[vec] == 1)
        {
            has_truck = 1;
            truck_taken[vec] = 0;
            break;
        }
    }

    if(!has_truck) {
        ans++;
    }

    for(auto vec : rev_g[node]) {
        nr_sons[vec] -= 1;
        remove_as_son(vec);
    }
}

int main() {
    int n; cin >> n;
    v.resize(n);
    for(auto &e : v)
        cin >> e.first >> e.second;

    for(int i = 0; i < n; i++) {
        for(int j = 0; j < n; j++) {
            if(i == j) continue;
            if(v[i].first < v[j].first) {
                if(v[j].first - v[i].first >= max(v[i].second - v[j].second, v[j].second - v[i].second)) {
                    g[i].push_back(j);
                    rev_g[j].push_back(i);
                    nr_sons[i] += 1;
                }
            }
        }
    }

    for(int i = 0; i < n; i++) {
        truck_taken[i] = 1;
    }

    for(int i = 0; i < n; i++) {
        remove_as_son(i);
    }

    cout << ans << endl;

    return 0;
}
