//0 points on A22_Delivery let's go?
#include <bits/stdc++.h>

using namespace std;

const int NMAX = 1e4;
vector<int> g[NMAX];

bool cmp(int a, int b) {
    return g[a].size() < g[b].size();
}

int main() {
    clock_t start = clock();
    int n; cin >> n;
    vector<pair<int, int>> v(n);
    for(auto &e : v)
        cin >> e.first >> e.second;
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < n; j++) {
            if(i == j) continue;
            if(v[i].first < v[j].first) {
                if(v[j].first - v[i].first >= max(v[i].second - v[j].second, v[j].second - v[i].second)) {
                    g[i].push_back(j);
                    g[j].push_back(i);
                }
            }
        }
    }

    vector<int> perm(n);
    iota(perm.begin(), perm.end(), 0);

    int ans = 0;
    while((1.0 * clock() - start) / CLOCKS_PER_SEC < 0.8) {
        unordered_set<int> in;
        sort(perm.begin(), perm.end(), cmp);

        for(auto e : perm)
            in.insert(e);

        for(auto e : perm) {
            if(in.find(e) != in.end()) {
                for(auto vec : g[e])
                    in.erase(vec);
            }
        }

        ans = max(ans, (int)in.size());
    }

    cout << ans << endl;
}

