#include <bits/stdc++.h>

using namespace std;

int clip(int x, int l, int r) {
    if(x < l) return l;
    if(x > r) return r;
    return x;
}

int main() {
    int n, s, c; cin >> n >> s >> c;

    vector<int> ans;

    int index = 0;

    // On curious cases, move r by 1

    int l = 1, r = n;

    while(l <= r) {
#ifdef LOCAL
        cerr << l << " " << r << endl;
#endif // LOCAL

        if(l == r) {
            ans.push_back(l); break;
        }

        if(index % (s + c) < s) {
            // Scared case, query at L
            ans.push_back(l);
            // restrict [l..r]
            l = clip(l + 2, 1, n);
            r = clip(r + 1, 1, n);
        }
        else {
            // Curious case, query at R - 1
            ans.push_back(r - 1);
            // restrict
            if(l < ans.back())
                l = clip(l + 1, 1, n);
            if(r > ans.back())
                r = clip(r - 1, 1, n);
        }


        index++;
    }

    cout << ans.size() << endl;
    for(auto e : ans)
        cout << e << " ";
    cout << endl;
}
