#include <bits/stdc++.h>

using namespace std;

int clip(int x, int l, int r) {
    if(x < l) return l;
    if(x > r) return r;
    return x;
}

const int smalln = 16;

int dp[smalln * 2 + 7][(1 << smalln)];
pair<int, int> from[smalln * 2 + 7][(1 << smalln)];

int main() {
    int n, s, c; cin >> n >> s >> c;

    vector<int> ans;

    int index = 0;

    if(n > smalln) {
        int l = 1, r = n;

        while(l <= r) {
    #ifdef LOCAL
            cerr << l << " " << r << endl;
    #endif // LOCAL

            if(l == r) {
                ans.push_back(l); break;
            }

            if(index % (s + c) < s) {
                // Scared case, query at L
                ans.push_back(l);
                // restrict [l..r]
                l = clip(l + 2, 1, n);
                r = clip(r + 1, 1, n);
            }
            else {
                // Curious case, query at R - 1
                ans.push_back(r - 1);
                // restrict
                if(l < ans.back())
                    l = clip(l + 1, 1, n);
                if(r > ans.back())
                    r = clip(r - 1, 1, n);
            }


            index++;
        }
    }
    else {
        dp[0][(1 << n) - 1] = 1;
        for(int time = 1; true; time++) {
            for(int prev_mask = 0; prev_mask < (1 << n); prev_mask++) {
                if(dp[time - 1][prev_mask] == 0) continue;

                if((time - 1) % (s + c) < s) { // Scared
                    for(int step = 0; step < n; step++) {
                        int new_mask = 0;

                        if(prev_mask & 1)
                            new_mask |= 1;
                        if(prev_mask & (1 << (n - 1)))
                            new_mask |= (1 << (n - 1));

                        for(int i = 0; i + 1 < step; i++) {
                            if(prev_mask & (1 << (i + 1)))
                                new_mask |= (1 << i);
                        }
                        for(int i = step + 2; i < n; i++) {
                            if(prev_mask & (1 << (i - 1)))
                                new_mask |= (1 << i);
                        }

                        dp[time][new_mask] = 1;
                        from[time][new_mask] = {prev_mask, step};
                    }
                }
                else { // Curious
                    for(int step = 0; step < n; step++) {
                        int new_mask = 0;

                        for(int i = 1; i <= step; i++) {
                            if(prev_mask & (1 << (i - 1)))
                                new_mask |= (1 << i);
                        }
                        for(int i = step; i + 1 < n; i++) {
                            if(prev_mask & (1 << (i + 1)))
                                new_mask |= (1 << i);
                        }

                        dp[time][new_mask] = 1;
                        from[time][new_mask] = {prev_mask, step};
                    }
                }


            }

            if(dp[time][0] == 1) {
                // Solution found!
                int cnt_mask = 0;
                while(time != 0) {
                    ans.push_back(from[time][cnt_mask].second);
                    cnt_mask = from[time][cnt_mask].first;
                    time -= 1;
                }
                reverse(ans.begin(), ans.end());
                break;
            }
        }
    }

    cout << ans.size() << endl;
    for(auto e : ans)
        cout << e << " ";
    cout << endl;
}
