#include <bits/stdc++.h>
#include "hint.h"

using namespace std;

std::vector<bool> genHint(const std::vector<int> &a, const std::vector<int> &b,
                          const std::vector<int> &sol) {
    return {};
}

std::vector<int> solve(const std::vector<int> &a, const std::vector<int> &b,
                       const std::vector<bool> &hint) {
    int dp[a.size() + 1][b.size() + 1];
    for (int i = 0; i < a.size() + 1; ++i) {
        for (int j = 0; j < b.size() + 1; ++j) {
            dp[i][j] = 0;
        }
    }
    pair<int, int> from[a.size() + 1][b.size() + 1];
    for (int k = 1; k < a.size() + 1; ++k) {
        for (int i = 1; i < b.size() + 1; ++i) {
            if (dp[k - 1][i] > dp[k][i - 1]) {
                from[k][i] = {-1, 0};
            } else {
                from[k][i] = {0, -1};
            }
            dp[k][i] = max(dp[k - 1][i], dp[k][i - 1]);
            if (a[k - 1] == b[i - 1]) {
                if (dp[k][i] < dp[k - 1][i - 1] + 1) {
                    from[k][i] = {-1, -1};
                }
                dp[k][i] = max(dp[k][i], dp[k - 1][i - 1] + 1);
            }
        }
    }
    vector<int> res;
    int l = a.size();
    int r = b.size();
    while (l != 0 && r != 0) {
        auto y = from[l][r];
        if (from[l][r] == make_pair(-1, -1)) {
            res.push_back(a[l - 1]);
        }
        l += y.first;
        r += y.second;
    }
    reverse(res.begin(), res.end());
    return res;

}
//
//signed main() {
//    int n, m;
//    cin >> n;
//    vector<int> a(n);
//    for (int i = 0; i < n; ++i) {
//        cin >> a[i];
//    }
//
//    cin >> m;
//    vector<int> b(m);
//
//    for (int j = 0; j < m; ++j) {
//        cin >> b[j];
//    }
//    vector<int> res = solve(a, b, {});
//    for (int k = 0; k < res.size(); ++k) {
//        cout << res[k] << " ";
//    }
//}