#include <bits/stdc++.h>

using namespace std;
#define int long long
const int maxn = 1e3;
bool used[maxn];
int pr[maxn];
vector<int> g[maxn];
int n;

bool try_kuhn(int v) {
    used[v] = true;
    for (int i = 0; i < g[v].size(); ++i) {
        int to = g[v][i];
        if (pr[to] == -1) {
            pr[to] = v;
            return true;
        }
    }
    for (int i = 0; i < g[v].size(); ++i) {
        int to = g[v][i];
        if (used[pr[to]])continue;
        if (try_kuhn(pr[to])) {
            pr[to] = v;
            return true;
        }
    }
    return false;
}

int parsoch() {
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            used[j] = false;
        }
        ans += try_kuhn(i);
    }
    return ans;
}

signed main() {
    cin.tie();
    cout.tie();
    ios_base::sync_with_stdio(false);
#ifdef foo
    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#endif
    cin >> n;
    for (int j = 0; j < n; ++j) {
        pr[j] = -1;
    }
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;
    }
    for (int k = 0; k < n; ++k) {
        for (int i = 0; i < n; ++i) {
            if (k == i)continue;
            if (a[k].first - a[i].first >= abs(a[k].second - a[i].second)) {
                g[i].push_back(k);
            }
        }
    }
    cout << n - parsoch() << "\n";
}