#include <bits/stdc++.h>

using namespace std;
#define int long long
const int maxn = 1e4;
bool used[maxn];
int pr[maxn];
bool has[maxn];
vector<pair<int, int>> a;
vector<int> g[maxn];
int n;

bool try_kuhn(int v) {
    used[v] = true;
    for (int i = 0; i < g[v].size(); ++i) {
        int to = g[v][i];
        if (pr[to] == -1) {
            pr[to] = v;
            return true;
        }
    }
    for (int i = 0; i < g[v].size(); ++i) {
        int to = g[v][i];
        if (used[pr[to]])continue;
        if (try_kuhn(pr[to])) {
            pr[to] = v;
            return true;
        }
    }
    return false;
}

int parsoch() {
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        if (has[i]){
            ans++;
            continue;
        }
        for (int j = 0; j < n; ++j) {
            used[j] = false;
        }
        ans += try_kuhn(i);
    }
    return ans;
}

bool comp(int o1, int o2) {
    return a[o1].first < a[o2].second;
}

signed main() {
    cin.tie();
    cout.tie();
    ios_base::sync_with_stdio(false);
#ifdef foo
    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#endif
    cin >> n;
    a.resize(n);
    for (int j = 0; j < n; ++j) {
        pr[j] = -1;
    }
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;
    }
    vector<int> el;
    for (int l = 0; l < n; ++l) {
        el.push_back(l);
    }
    sort(el.begin(), el.end(), comp);
    for (int k = 0; k < n; ++k) {
        for (int i = 0; i < n; ++i) {
            if (k == i)continue;
            if (a[k].first - a[i].first >= abs(a[k].second - a[i].second)) {
                g[i].push_back(k);
            }
        }
    }
    vector<int> pos;
    pos.push_back(el[0]);
    for (int j = 1; j < n; ++j) {
        int can = -1;
        for (int i = 0; i < pos.size(); ++i) {
            if (abs(a[pos[i]].second - a[el[j]].second) <= abs(a[pos[i]].first - a[el[j]].first)) {
                can = i;
            }
        }
        if (can == -1) {
            pos.push_back(el[j]);
        } else {
            has[pos[can]] = true;
            pr[el[j]] = pos[can];
            pos[can] = el[j];
        }
    }
    cout << n - parsoch() << "\n";
}