#include <vector>
#include <bitset>

using namespace std;

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol){
    vector<bool> ans;
    for(int i=0; i<sol.size(); i++){
        bitset<31> b=sol[i];
        for(int i=0; i<b.size(); i++){
            ans.emplace_back(b[i]);
        }
    }
    return ans;
}
std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint){
    vector<int> ans;
    for(int i=0; i<hint.size(); i+=31){
        int nr=0;
        for(long long j=i, d=0; j<i+31 && d<=31; j++,d++){
            // cout<<j<<" "<<d<<"\n";
            if(hint[j]) nr+=(1<<d);
        }
        // cout<<"\n\n";
        ans.emplace_back(nr);
    }
    return ans;
}