#include <vector>
using namespace std;

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol){
    if(a.size()<=b.size()){
        vector<bool>ans((int)a.size());
        int i=0;
        for(int j=0; j<(int) a.size() && i<sol.size(); j++){
            if(a[j]==sol[i]){
                ans[j]=true;
                i++;
            } 
        }
        return ans;
    }
    else{
        vector<bool>ans((int)b.size());
        int i=0;
        for(int j=0; j<(int) b.size(); j++){
            if(i<sol.size() && b[j]==sol[i]){
                ans[j]=true;
                i++;
            } 
        }
        return ans;
    }
}
std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint){
    if(a.size()<=b.size()){
        vector<int> ans;
        for(int i=0; i<(int) a.size(); i++){
            if(hint[i]) ans.emplace_back(a[i]);
        }
        return ans;
    }
    else{
        vector<int> ans;
        for(int i=0; i<(int) b.size(); i++){
            if(hint[i]) ans.emplace_back(b[i]);
        }
        return ans;
    }
}