#include <bits/stdc++.h>

#include "hint.h"

using namespace std;

typedef long long ll;
typedef long double ld;

// #define int ll
#define f first
#define s second
#define pii pair<int, int>
#define vi vector<int>
#define pb push_back

const int K = 900;

vector<bool> genHint(const vi&a, const vi &b, const vi &sol) {
	int l = 0, it = 0;
	vector<int> v;
	for (int i = 0; i < a.size(); ++i) {
		if (l < sol.size() && a[i] == sol[l]) {
			while (b[it] != sol[l]) {
				it++;
			}
			it++;
			l++;
		}
		if ((i + 1) % K == 0) {
			v.pb(it);
		}
	}
	vector<bool> hint;
	for (auto &i : v) {
		for (int j = 0; j < 18; ++j) {
			if ((1 << j) & i)
				hint.pb(1);
			else
				hint.pb(0);
		}
	}
	return hint;
}

vi solve(const vi& a, const vi& b, const vector<bool>& hint) {
	vector<int> v;
	for (int j = 0; j < hint.size() / 18; ++j) {
		v.pb(0);
		for (int k = 0; k < 18; ++k) {
			v.back() |= (1 << k) * hint[j * 18 + k];
		}
	}
	v.pb(b.size());
	// for (auto &i : v)
	// 	cout << i << ' ';
	// cout << endl;
	vi sol;
	for (int i = min(int(a.size()), K); i <= a.size(); i = min(int(a.size()), K + i)) {
		int start = 0;
		int end = v[(i - 1) / K];
		if (i > K)
			start = v[(i - 1) / K - 1];
		int len = end - start;
		// cout << pos << ' ' << l2 << endl;
		// cout << start << ' ' << end << endl;
		if (len == 0) {
			if (i == a.size())
				break;
			else
				continue;
		}
		int pos = (i - 1) / K * K;
		int l2 = i - pos;
		int dp[l2 + 1][len + 1];
		memset(dp, -127, sizeof(dp));
		int last[l2 + 1][len + 1];
		memset(last, -1, sizeof(last));
		for (int i = 1; i <= l2; ++i) {
			for (int j = 1; j <= len; ++j) {
				if (i == 0 || j == 0) {
					dp[i][j] = 0;
				} else {
					if (a[pos + i - 1] == b[start + j - 1]) {
						dp[i][j] = dp[i - 1][j - 1] + 1;
						last[i][j] = 1;
					}
					if (dp[i][j] < dp[i - 1][j]) {
						dp[i][j] = dp[i - 1][j];
						last[i][j] = 2;
					}
					if (dp[i][j] < dp[i][j - 1]) {
						dp[i][j] = dp[i][j - 1];
						last[i][j] = 3;
					}
				}
			}
		}
		vi loc;
		pii now = {l2, len};
		while (now.f > 0 && now.s > 0) {
			int l = last[now.f][now.s];
			if (l == 1) {
				loc.pb(a[pos + now.f - 1]);
				now.f--;
				now.s--;
			} else if (l == 2) {
				now.f--;
			} else if (l == 3) {
				now.s--;
			} else {
				break;
			}
 		}

		reverse(loc.begin(), loc.end());
		for (auto &i : loc)
			sol.pb(i);
		if (i == a.size())
			break;
	}

	return sol;
}


// signed main() {
// 	ios::sync_with_stdio(0);
// 	cin.tie(0);
// 	solve();
// }

#ifdef LOCAL

static int n, m, k;
static std::vector<int> a, b, sol, maybeSol;
static std::vector<bool> hint;

int main()
{
    std::cin >> n >> m;

    a.resize(n);
    b.resize(m);

    for (int& num : a)
    {
        std::cin >> num;
    }

    for (int& num : b)
    {
        std::cin >> num;
    }

    std::cin >> k;

    sol.resize(k);

    for (int& num : sol)
    {
        std::cin >> num;
    }

    hint = genHint(a, b, sol);
    std::cout << hint.size() << std::endl;
    maybeSol = solve(a, b, hint);

    std::cout << maybeSol.size() << std::endl;

    for (int i = 0; i < (int) maybeSol.size(); ++i)
    {
        if (i > 0) std::cout << " ";
        std::cout << maybeSol[i];
    }
    std::cout << std::endl;

    return 0;
}

#endif