#include <bits/stdc++.h>

#include "hint.h"

using namespace std;

typedef long long ll;
typedef long double ld;

// #define int ll
#define f first
#define s second
#define pii pair<int, int>
#define vi vector<int>
#define pb push_back

const int K = 1200;

vector<bool> genHint(const vi&a, const vi &b, const vi &sol) {
	int l = 0, it = 0;
	vector<int> v;
	for (int i = 0; i < b.size(); ++i) {
		if (l < sol.size() && b[i] == sol[l]) {
			while (a[it] != sol[l]) {
				it++;
			}
			it++;
			l++;
		}
		if ((i + 1) % K == 0) {
			v.pb(it);
		}
	}
	vector<bool> hint;
	int last = 0;
	for (auto &i : v) {
		int mx = -1;
		for (int k = 0; k < 20; ++k) {
			if ((1 << k) & i)
				mx = k;
		}
		mx++;
		hint.pb(0);
		for (int j = 0; j < mx - last; ++j) {
			hint.pb(1);
		}
		last = mx;
	}
	return hint;
}


short dp[K + 1][int(2e5 + 50)];
short last[K + 1][int(2e5 + 50)];

vi solve(const vi& a, const vi& b, const vector<bool>& hint) {
	vector<int> v;
	int now = 0;
	for (int i = 0; i < hint.size();) {
		int j = i + 1;
		while (j < hint.size() && hint[j] == 1) {
			now++;
			j++;
		}
		v.pb(now);
		i = j;
	}
	v.pb(19);
	vector<pii> sol;
	for (int i = 0; i < a.size(); i += K) {
		if (v[i / K] == 0)
			continue;
		int mx = (1 << v[i / K]);
		int prev = (i / K == 0 ? 0 : (1 << v[i / K - 1]) / 2);
		mx = min(mx, int(b.size()));
		int lb = mx - prev;
		int la = min(int(a.size()), i + K) - i;
		for (int i = 0; i <= la; ++i) {
			for (int j = 0; j <= lb; ++j) {
				last[i][j] = -1;
				dp[i][j] = -30000;
			}
		}
		int pos = i;
		for (int i = 0; i <= la; ++i) {
			for (int j = 0; j <= lb; ++j) {
				if (i == 0 || j == 0) {
					dp[i][j] = 0;
				} else {
					
					if (dp[i][j] < dp[i - 1][j]) {
						dp[i][j] = dp[i - 1][j];
						last[i][j] = 2;
					}
					if (dp[i][j] < dp[i - 1][j - 1] + 1 && a[pos + i - 1] == b[prev + j - 1]) {
						dp[i][j] = dp[i - 1][j - 1] + 1;
						last[i][j] = 1;
					}
					if (dp[i][j] < dp[i][j - 1]) {
						dp[i][j] = dp[i][j - 1];
						last[i][j] = 3;
					}
				}
			}
		}
		vector<pii> loc;
		pii now = {la, lb};
		while (now.f > 0 && now.s > 0) {
			int l = last[now.f][now.s];
			if (l == 1) {
				loc.pb({pos + now.f - 1, prev + now.s - 1});
				now.f--;
				now.s--;
			} else if (l == 2) {
				now.f--;
			} else if (l == 3) {
				now.s--;
			} else {
				break;
			}
 		}
 		pii best = {0, int(sol.size())};
 		int r = int(sol.size()) - 1;
 		for (int j = 0; j < loc.size(); ++j) {
 			while (r != -1 && sol[r].s > loc[j].s)
 				r--;
 			if (r + 1 + j + 1 > best.s) {
 				best = {j + 1, r + 1 + j + 1};
 			}
 		}
 		int cnt = best.s - best.f;
 		while (sol.size() > cnt)
 			sol.pop_back();
 		for (int j = best.f - 1; j >= 0; --j) {
 			sol.pb(loc[j]);
 		}
	}
	vector<int> sol2;
	for (auto &i : sol)
		sol2.pb(a[i.f]);
	return sol2;
}


// signed main() {
// 	ios::sync_with_stdio(0);
// 	cin.tie(0);
// 	solve();
// }

#ifdef LOCAL

static int n, m, k;
static std::vector<int> a, b, sol, maybeSol;
static std::vector<bool> hint;

int main()
{
	std::cin >> n >> m;

	a.resize(n);
	b.resize(m);

	for (int& num : a)
	{
		std::cin >> num;
	}

	for (int& num : b)
	{
		std::cin >> num;
	}

	std::cin >> k;

	sol.resize(k);

	for (int& num : sol)
	{
		std::cin >> num;
	}

	hint = genHint(a, b, sol);
	std::cout << hint.size() << std::endl;
	maybeSol = solve(a, b, hint);

	std::cout << maybeSol.size() << std::endl;

	for (int i = 0; i < (int) maybeSol.size(); ++i)
	{
		if (i > 0) std::cout << " ";
		std::cout << maybeSol[i];
	}
	std::cout << std::endl;

	return 0;
}

#endif