#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define int ll
#define f first
#define s second
#define pii pair<int, int>
#define vi vector<int>
#define pb push_back

mt19937 rnd(time(0));

const int maxn = 1e4 + 50;
vi r[maxn];
int f[maxn];
int used[maxn];
int t = 1;
int dfs(int v) {
	if (used[v] == t)
		return 0;
	used[v] = t;
	for (auto &u : r[v]) {
		if (f[u] == -1) {
			f[u] = v;
			return 1;
		}
	}
	for (auto &u : r[v]) {
		if (dfs(f[u])) {
			f[u] = v;
			return 1;
		}
	}
	return 0;
}

void solve() {
	memset(f, -1, sizeof(f));
	int n;
	cin >> n;
	pii a[n];
	for (int i = 0; i < n; ++i) {
		cin >> a[i].f >> a[i].s;
	}
	sort(a, a + n);
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			if ((a[j].f - a[i].f) >= abs(a[i].s - a[j].s)) {
				r[i].pb(j);
			}
		}
	}
	for (int i = 0; i < n; ++i) {
		shuffle(r[i].begin(), r[i].end()), rnd;
	}
	int ans = 0;
	for (int i = 0; i < n; ++i, ++t) {
		ans += dfs(i);
	}
	cout << n - ans << endl;
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	solve();
}