#include <bits/stdc++.h>
#ifndef LOCAL_DEBUG
    #include "hint.h"
#endif

typedef long long ll;

#define MS(x,y) memset((x), (y), sizeof((x)))
#define pb push_back
#define MN 1000000000

using namespace std;

vector<bool> genHint (const vector<int>& a2,const vector<int>& b2,const vector<int>& sol2) {
    vector<int> a = a2;
    vector<int> b = b2;
    vector<int> sol = sol2;

    if ((int)a.size() > (int)b.size()) swap(a,b);

    vector<int> idA,idB;

    int doKoj = 0;

    for (int i = 0; i<a.size(); i++) {
        if (a[i] == sol[doKoj]) {
            idA.pb(i);
            doKoj++;
        }
    }

    vector<bool> res(a.size(),0);

    for (auto it:idA) res[it] = 1;

    return res;
}

vector<int> solve (const vector<int>& a2,const vector<int>& b2,const vector<bool>& hint2) {
    vector<int> a = a2;
    vector<int> b = b2;
    vector<bool> hint = hint2;

    if ((int)a.size() > (int)b.size()) swap(a,b);

    vector<int> done;

    for (int i = 0; i<hint.size(); i++) if (hint[i]) done.pb(a[i]);

    return done;
}


#ifdef LOCAL_DEBUG
int main() {
    #ifdef LOCAL_DEBUG
        fstream cin("in.txt");
    #endif

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n,m,k;
    cin>>n>>m>>k;

    vector<int> a(n),b(m),c(k);

    for (int i = 0; i<n; i++) cin>>a[i];
    for (int i = 0; i<m; i++) cin>>b[i];
    for (int i = 0; i<k; i++) cin>>c[i];

    auto res = genHint(a,b,c);
    auto res2 = solve(a,b,res);

    cout<<res2.size()<<endl;
    for (auto it:res2) cout<<it<<" ";
}
#endif
