#include <bits/stdc++.h>

typedef long long ll;

#define MS(x,y) memset((x), (y), sizeof((x)))
#define pb push_back
#define MN 1000000000

using namespace std;

int n;
pair<int,int> deliv[1001];
vector<int> pat[1001], pat2[1001];
vector<int> red;
bool vis[1001];

void dfs1 (int pos) {
    if (vis[pos]) return;

    vis[pos] = true;

    for (auto it:pat[pos]) dfs1(it);

    red.pb(pos);
}

void dfs2 (int pos) {
    if (vis[pos]) return;

    vis[pos] = true;

    for (auto it:pat[pos]) dfs2(it);
}

int main() {
    #ifdef LOCAL_DEBUG
        fstream cin("in.txt");
    #endif

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin>>n;

    for (int i = 0; i<n; i++) cin>>deliv[i].first>>deliv[i].second;
    sort(deliv, deliv+n);

    for (int i = 0; i<n; i++) {
        for (int j = i+1; j<n; j++) {
            if (deliv[j].first-deliv[i].first >= abs(deliv[j].second-deliv[i].second)) { pat[i].pb(j); pat2[j].pb(i); }
        }
    }

    MS(vis,0);
    int res = 0;

    for (int i = 0; i<n; i++) {
        if (vis[i]) continue;

        res++;
        dfs2(i);
    }

    cout<<res<<endl;
}
