﻿// hint.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
typedef vector<bool> vb;
typedef vector<int> vi;

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b,
    const std::vector<int>& sol) {
    vb hint(a.size());
    int ind = 0;
    for (int i = 0; i < a.size(); i++) {
        if (a[i] == sol[ind]) {
            hint[i] = 1;
            ind++;
            if (ind >= sol.size())
                break;
        }
    }
    int i = a.size() - 1;
    while (hint[i] == 0 && i >= 0) {
        hint.pop_back();
        i--;
    }
    return hint;
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b,
    const std::vector<bool>& hint) {
    vi solve;
    for (int i = 0; i < hint.size(); i++) {
        if (hint[i])
            solve.push_back(a[i]);
    }
    return solve;
}


