//#include "hint.h"
#pragma GCC optimize("Ofast")
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define pii pair < int, int > 
#define sz(x) (int)x.size()
#include <bits/stdc++.h>
#define ld long double
#define ll long long 
#define _ << ' ' << 

using namespace std;
using namespace __gnu_pbds;

template <typename T>
using ordered_set = tree <T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

mt19937 gen(chrono::system_clock::now().time_since_epoch().count());

static int n, m, k;
static std::vector<int> a, b, sol, maybeSol;
static std::vector<bool> hint;

vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& sol) {
    int n = sz(a), m = sz(b);
	vector < bool > ret(min(n, m) + 1);
	if (n < m) {
		ret[0] = 0;
		int p = 0;
		for (int i = 0; i < n; i++) {
			if (p < sz(sol) && sol[p] == a[i]) {
				p++;
				ret[i + 1] = 1; 
			}
		}
	}
	else {
		ret[0] = 1;
		int p = 0;
		for (int i = 0; i < m; i++) {
			if (p < sz(sol) && sol[p] == b[i]) {
				p++;
				ret[i + 1] = 1; 
			}
		}
	}
    return ret;
}

vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint) {
    vector < int > ans;
	if (hint[0]) {
		for (int i = 0; i < m; i++) {
			if (hint[i + 1]) {
				ans.push_back(b[i]);
			}
		}
	}
	else {
		for (int i = 0; i < n; i++) {
			if (hint[i + 1]) {
				ans.push_back(a[i]);
			}
		}
	}
    return ans;
}

int32_t main()
{
    #ifdef LOCAL 
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif // LOCAL
	
    std::cin >> n >> m;

    a.resize(n);
    b.resize(m);

    for (int& num : a)
    {
        std::cin >> num;
    }

    for (int& num : b)
    {
        std::cin >> num;
    }

    std::cin >> k;

    sol.resize(k);

    for (int& num : sol)
    {
        std::cin >> num;
    }

    hint = genHint(a, b, sol);
    maybeSol = solve(a, b, hint);

    std::cout << hint.size() << std::endl;
    std::cout << maybeSol.size() << std::endl;

    for (int i = 0; i < (int) maybeSol.size(); ++i)
    {
        if (i > 0) std::cout << " ";
        std::cout << maybeSol[i];
    }
    std::cout << std::endl;

    return 0;
}
