#include "hint.h"
#pragma GCC optimize("Ofast")
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define pii pair < int, int > 
#define sz(x) (int)x.size()
#include <bits/stdc++.h>
#define ld long double
#define ll long long 
#define _ << ' ' << 

using namespace std;
using namespace __gnu_pbds;

template <typename T>
using ordered_set = tree <T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

mt19937 gen(chrono::system_clock::now().time_since_epoch().count());

static int n, m, k;
static std::vector<int> a, b, sol, maybeSol;
static std::vector<bool> hint;

const int N = 10005;

vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& sol) {
    int n = sz(a), m = sz(b);
	vector < bool > ret(min(n, m) + 1);
	if (n < m) {
		ret[0] = 0;
		int p = 0;
		for (int i = 0; i < n; i++) {
			if (p < sz(sol) && sol[p] == a[i]) {
				p++;
				ret[i + 1] = 1; 
			}
		}
	}
	else {
		ret[0] = 1;
		int p = 0;
		for (int i = 0; i < m; i++) {
			if (p < sz(sol) && sol[p] == b[i]) {
				p++;
				ret[i + 1] = 1; 
			}
		}
	}
    return ret;
}

vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint) {
    vector < int > ans;
    int n = sz(a), m = sz(b);
	
	if (n <= 10000 && m <= 10000) {
        vector < int > na = {0};
        vector < int > nb = {0};
         vector < vector < int > > dp(n + 1, vector < int > (m + 1, 0));
        for (auto x : a) na.push_back(x);
        for (auto x : b) nb.push_back(x);
		for (int i = 1; i <= n; i++) {
			for (int j = 1; j <= m; j++) {
				if (dp[i - 1][j] >= dp[i][j - 1]) {
					dp[i][j] = dp[i - 1][j];
//					pr[i][j] = { i - 1, j };
				}
				else {
					dp[i][j] = dp[i][j - 1];
//					pr[i][j] = { i, j - 1 };
				}
				if (na[i] == nb[j] && dp[i][j] < dp[i - 1][j - 1] + 1) {
					dp[i][j] = dp[i - 1][j - 1] + 1;
//					pr[i][j] = { i - 1, j - 1 };
				}
			}
		}
		
		int x = n, y = m;
		while (x && y) {
            while (x > 1 && dp[x - 1][y] == dp[x][y]) x--;
            while (y > 1 && dp[x][y - 1] == dp[x][y]) y--;
			if (dp[x][y] == dp[x - 1][y - 1] + 1) {
                ans.push_back(na[x]);
                x--; y--;
                continue;
			}
		}
		reverse(ans.begin(), ans.end());
		return ans;
	}
	
	if (hint[0]) {
		for (int i = 0; i < m; i++) {
			if (hint[i + 1]) {
				ans.push_back(b[i]);
			}
		}
	}
	else {
		for (int i = 0; i < n; i++) {
			if (hint[i + 1]) {
				ans.push_back(a[i]);
			}
		}
	}
    return ans;
}

