#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define pii pair < int, int > 
#define sz(x) (int)x.size()
#include <bits/stdc++.h>
#define ld long double
#define ll long long 
#define _ << ' ' << 

using namespace std;
using namespace __gnu_pbds;

template <typename T>
using ordered_set = tree <T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

mt19937 gen(chrono::system_clock::now().time_since_epoch().count());

const int N = 1e4 + 5;

int n;

vector < pii > v;

vector < int > g[N];

bool used[N];

void dfs(int v) {
	used[v] = true;
	for (auto to : g[v]) {
		if (!used[to]) {
			dfs(to);
		}
	}
}

int32_t main() {
	#ifdef LOCAL 
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif // LOCAL
	
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	
	cin >> n;
	v.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> v[i].first >> v[i].second;
	}
	sort(v.begin(), v.end());
					
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			if (v[j].first - v[i].first >= abs(v[j].second - v[i].second)) {
				g[i].push_back(j);
				g[j].push_back(i);
			}
		}
	}
	
	int ans = 0;
	for (int i = 1; i <= n; i++) {
		if (!used[i]) {
			dfs(i);
			ans++;
		}
	}
	
	cout << ans << '\n';
	return 0;
}
