#include "hint.h"
#include <bits/stdc++.h>
using namespace std;

using ll = long long;

const int N = 200000;

vector <int> vec[N+5];

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol){
    int j = 0;
    int n = a.size(), m = b.size();
    for(int i=0; i<m; i++) vec[i].clear();
    for(int i=0; i<m; i++) vec[b[i]].push_back(i);
    vector <bool> hint;
    int mxk = m;
    int tjm = 0;
    for(int i=0; i<n; i++){
        if(a[i] == b[j]){
            tjm++;
            j++;
            mxk = m;
            continue;
        }
        if(a[i] >= m) continue;
        int k = int(lower_bound(vec[a[i]].begin(), vec[a[i]].end(), j) - vec[a[i]].begin());
        if(k >= mxk) continue;
        if(tjm < sol.size() && a[i] == sol[tjm]){
            hint.push_back(1);
            tjm++;
            j = k + 1;
            mxk = m;
        }
        /*if(hint[tjm++]){
            tjm++;
            j = k + 1;
            mxk = m;
        }*/
        else{
            hint.push_back(0);
            mxk = min(mxk, k);
        }
    }
    return hint;
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint){
    vector <int> soln;
    int j = 0;
    int n = a.size(), m = b.size();
    for(int i=0; i<m; i++) vec[i].clear();
    for(int i=0; i<m; i++) vec[b[i]].push_back(i);
    int mxk = m;
    int tjm = 0;
    for(int i=0; i<n; i++){
        if(a[i] == b[j]){
            soln.push_back(a[i]);
            j++;
            mxk = m;
            continue;
        }
        if(a[i] >= m) continue;
        int k = lower_bound(vec[a[i]].begin(), vec[a[i]].end(), j) - vec[a[i]].begin();
        if(k >= mxk) continue;
        if(hint[tjm++]){
            soln.push_back(a[i]);
            j = k + 1;
            mxk = m;
        }
        else mxk = min(mxk, k);
    }
    return soln;
}
