#include "hint.h"

#include <iostream>
#include <vector>
using namespace std;

vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& s) {
	vector<bool> h;
	if (a.size() <= b.size()) {
		int x = 0;
		for (int i = 0; i < a.size(); i++) {
			if (a[i] == s[x]) {
				h.push_back(1);
				x++;
			}
			else h.push_back(0);
		}
	}
	else {
		int x = 0;
		for (int i = 0; i < b.size(); i++) {
			if (b[i] == s[x]) {
				h.push_back(1);
				x++;
			}
			else h.push_back(0);
		}
	}
	return h;
}

vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& h) {
	vector<int> s;
	if (a.size() <= b.size()) {
		for (int i = 0; i < a.size(); i++) {
			if (h[i]) s.push_back(a[i]);
		}
	}
	else {
		for (int i = 0; i < b.size(); i++) {
			if (h[i]) s.push_back(b[i]);
		}
	}
	return s;
}