#include "hint.h"

#include <iostream>
#include <vector>
using namespace std;

vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& s) {
	vector<bool> ha, hb;
	int x = 0;
	for (int i = 0; i < a.size(); i++) {
		if (a[i] == s[x]) {
			ha.push_back(1);
			x++;
		}
		else ha.push_back(0);
		if (x >= s.size()) break;
	}
	x = 0;
	for (int i = 0; i < b.size(); i++) {
		if (b[i] == s[x]) {
			hb.push_back(1);
			x++;
		}
		else hb.push_back(0);
		if (x >= s.size()) break;
	}
	if (ha.size() <= hb.size()) {
		ha.insert(ha.begin(), 0);
		return ha;
	}
	else {
		hb.insert(hb.begin(), 1);
		return hb;
	}
}

vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& h) {
	vector<int> s;
	if (h[0] == 0) {
		for (int i = 1; i < h.size(); i++) {
			if (h[i]) s.push_back(a[i - 1]);
		}
	}
	else {
		for (int i = 1; i < h.size(); i++) {
			if (h[i]) s.push_back(b[i - 1]);
		}
	}
	return s;
}