#include <bits/stdc++.h>
#define F first
#define S second
#define pb push_back
#define eb emplace_back
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define elif else if
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
using namespace std;
const ld eps = 1e-7;
void INPUT() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
}
#ifndef LOCAL
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#endif // LOCAL


std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol){
    srand(420);
    vector < bool > hint;
    int curr = 0;
    const int LOG = 5;
    int MAX_LEN = 1<<LOG;
    vector < pair < int, int > > pre_hint;
    vector < int > is_good(a.size());
    int p = 0;
    for(int i = 0; i < a.size(); i++){
        if(p < sol.size() and a[i] == sol[p]){
            is_good[i] = 1;
            p++;
        }
    }
    for(int i = 0; i < a.size(); i++) {
        int p1 = (rand() * rand()) % a.size(), p2 = (rand() * rand()) % a.size();
        swap(is_good[p1], is_good[p2]);
    }
    int prev = -1;
    for(int i = 0; i < a.size(); i++) {
        if(is_good[i] != prev or curr == MAX_LEN - 1){
            if(curr > 0) {
                pre_hint.pb({prev, curr});
            }
            curr = 1;
            prev = is_good[i];
        }else{
            curr++;
        }
    }
    if(curr > 0) {
        pre_hint.pb({prev, curr});
    }
    for(auto i: pre_hint) {
        vector < bool > bin(LOG);
        int pp = 1;
        for(int j = bin.size() - 1; j >= 0; j--){
            if(i.S & pp) bin[j] = 1;
            pp *= 2;
        }
        hint.pb(i.F);
        for(auto j: bin)
            hint.pb(j);
    }
    return hint;
}


std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint) {
    srand(420);
    vector < pair < int, int > > swaps;
    for(int i = 0; i < a.size(); i++) {
        int p1 = (rand() * rand()) % a.size(), p2 = (rand() * rand()) % a.size();
        swaps.eb(p1, p2);
    }
    reverse(all(swaps));
    vector < pair < int, int > > pre_hint;
    const int LOG = 5;
    int MAX_LEN = 1<<LOG;
    for(int i = 0; i < hint.size(); i += LOG + 1){
        int curr = hint[i];
        cerr << i << endl;
        i += LOG;
        int pp = 1;
        int len = 0;
        for(int j = 0; j < LOG; j++){
            len += int(hint[i]) * pp;
            pp *= 2;
            i--;
        }
        cerr << i << endl;
        pre_hint.eb(curr, len);
    }
    vector < int > is_good;
    for(auto i: pre_hint){
        for(int j = 0; j < i.S; j++){
            is_good.pb(i.F);
        }
    }
    for(auto i: swaps){
        swap(is_good[i.F], is_good[i.S]);
    }
    vector < int > ans;
    for(int i = 0; i < a.size(); i++){
        if(is_good[i]){
            ans.pb(a[i]);
        }
    }
    return ans;
}

