#include "hint.h"
#include <bits/stdc++.h>
using namespace std;
#define LL long long
#define LD long double
#define INF (1<<30L)

const int maxN = 100005;

bool vectorCompare( const vector <int> &p, const vector <int> &q ){
    if( p.size() != q.size() ) return p.size() < q.size();
    int SIZE = p.size();
    for( int i = 0 ; i < SIZE ; i++ ){
        if( p[i] == q[i] ) continue;
        return p[i] < q[i];
    }
}

vector <bool> genHint( const vector <int> &A, const vector <int> &B, const vector <int> &S ){
    
    vector <bool> rv;
    vector <int> V = ( vectorCompare(A,B) ? A : B );
    for( int i = 0, j = 0 ; i < V.size() && j < S.size() ; i++ ){
        if( V[i] == S[j] ){ rv.push_back(1); j++; }
        else rv.push_back(0);
    }

    return rv;

}

vector <int> solve( const vector <int> &A, const vector <int> &B, const vector <bool> &H ){

    vector <int> rv;
    vector <int> V = ( vectorCompare(A,B) ? A : B );

    for( int i = 0 ; i < V.size() ; i++ ){
        if( H[i] ) rv.push_back(V[i]);
    }

    return rv;

} 