#include <iostream>
#include <vector>
#include <string>
#include <iomanip>
#include <set>
#include <map>
#include <algorithm>
#include <deque>
#include <cmath>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <tuple>

using namespace std;
typedef long long ll;
#define int long long

int n;
int t[1000010];
int h[1000010];

vector <int> g[1000010];
int in[1000010];
set <pair <int, int>> s;
int from[1000010];
int ans;
int used[1000010];
int C = 1;

bool dfs(int u)
{
	if (used[u] == C) return false;
	used[u] = C;
	for (auto v : g[u])
	{
		if (!from[v])
		{
			from[v] = u;
			return true;
		}
	}

	for (auto v : g[u])
	{
		if (dfs(from[v]))
		{
			from[v] = u;
			return true;
		}
	}
	return false;
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n;
	for (int i = 1; i <= n; ++i)
	{
		cin >> t[i] >> h[i];
	}

	for (int i = 1; i <= n; ++i)
	{
		for (int j = 1; j <= n; ++j) if (i != j)
		{
			if (t[j] - t[i] >= abs(h[i] - h[j]))
			{
				g[i].push_back(j);
			}
		}

		sort(g[i].begin(), g[i].end(), [&](int u, int v) {return t[u] < t[v]; });
	}

	for (int i = 1; i <= n; ++i) for (auto j : g[i]) in[j]++;

	for (int i = 1; i <= n; ++i)
	{
		s.insert({ in[i], i });
	}

	while (s.size())
	{
		auto u = s.begin()->second;
		assert(s.begin()->first == 0);
		s.erase(s.begin());
		++C;
		auto got = dfs(u);
		if (got && !from[u]) ++ans;

		for (auto v : g[u])
		{
			s.erase({ in[v], v });
			in[v]--;
			s.insert({ in[v], v });
		}
	}

	cout << ans;
	return 0;
}