#include <bits/stdc++.h>
using namespace std;
#define x first
#define y second
#define all(x) begin(x), end(x)
#define sz(x) ((int) (x).size())
using ll = long long;
using ld = long double;

const int N = 1 << 20, TREE = 2 * N, INF = 2e9 + 10;

pair<int, int> a[N];
char used[N];

int t[TREE];

void tset(int i, int x) {
	i += N;
	t[i] = x;
	i /= 2;
	while (i) {
		t[i] = max(t[2 * i], t[2 * i + 1]);
		i /= 2;
	}
}

// at [from; N) first >= bound
int tnext(int from, int bound, int ci = 1, int cl = 0, int cr = N) {
	if (t[ci] < bound || cr <= from) {
		return N;
	}
	if (cr - cl == 1) {
		return cl;
	}
	int mid = (cl + cr) / 2;
	int ans = tnext(from, bound, 2 * ci, cl, mid);
	if (ans != N) {
		return ans;
	}
	return tnext(from, bound, 2 * ci + 1, mid, cr);
}

signed main() {
	cin.tie(0)->sync_with_stdio(0);
	int n;
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> a[i].x >> a[i].y;
		a[i] = {a[i].x + a[i].y, a[i].x - a[i].y};
	}
	sort(a, a + n);
	for (int i = 0; i < n; ++i) {
		t[i + N] = a[i].y;
	}
	for (int i = N; i--; ) {
		t[i] = max(t[2 * i], t[2 * i + 1]);
	}

	int ans = 0;
	for (int i = 0; i < n; ++i) {
		if (used[i]) {
			continue;
		}
		++ans;
		used[i] = 1;
		tset(i, -INF);
		auto where = a[i];
		int j = i;
		while (1) {
			j = tnext(j + 1, where.y);
			if (j == N) {
				break;
			}
			used[j] = 1;
			tset(j, -INF);
			where = a[j];
		}
	}
	cout << ans;
}