#include <bits/stdc++.h>
using namespace std;
const int numsz = 1;
const int SQRT = 1;
void addnum(vector<bool> &V,int num){
    for(int bit = numsz-1;bit>=0;--bit){
        V.push_back((num&(1<<bit))!=0);
    }
}
std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b,
const std::vector<int>& sol){
    vector<bool> ret;
    int ptr1 = 0,ptr2 = 0;
    int cptr = 0;

    while(cptr<sol.size()){
        int lcnt = 0,rcnt = 0;
        for(int i = ptr1;i<min(int(a.size()),ptr1+SQRT);++i)
            if (lcnt+cptr<sol.size() && sol[lcnt+cptr]==a[i])
                ++lcnt;
        for(int i = ptr2;i<min(int(b.size()),ptr2+SQRT);++i)
            if (rcnt+cptr<sol.size() && sol[rcnt+cptr]==b[i])
                ++rcnt;
        if (lcnt<rcnt){
            int pos = -1;
            rcnt = 0;
            for(int i = ptr2;i<min(int(b.size()),ptr2+SQRT);++i){
                if (rcnt+cptr<sol.size() && sol[rcnt+cptr]==b[i])
                    ++rcnt;
                if (rcnt==lcnt+1){
                    pos = i;
                    break;
                }
            }
            ret.push_back(1);
            ret.push_back(0);
            addnum(ret,pos-ptr2);
            ptr1+=SQRT;
            ptr2 = pos;
            cptr+=lcnt;
        }
        else if (lcnt>rcnt){
            int pos = -1;
            lcnt = 0;
            for(int i = ptr1;i<min(int(a.size()),ptr1+SQRT);++i){
                if (lcnt+cptr<sol.size() && sol[lcnt+cptr]==a[i])
                    ++lcnt;
                if (lcnt==rcnt+1){
                    pos = i;
                    break;
                }
            }
            ret.push_back(0);
            ret.push_back(0);
            addnum(ret,pos-ptr1);
            ptr1 = pos;
            ptr2+=SQRT;
            cptr+=rcnt;
        }
        else{
            ret.push_back(0);
            ret.push_back(1);
            ptr1+=SQRT;
            ptr2+=SQRT;
            cptr+=lcnt;
        }
        //cout<<lcnt<<' '<<rcnt<<' '<<ptr1<<' '<<ptr2<<endl;
    }
    return ret;
}
int getnum(vector<bool> &V,int pos){
    int ret = 0;
    for(int i = pos;i<pos+numsz;++i)
        ret = ret*2+V[i];
    return ret;
}
int dp[2][SQRT+20];
char P[SQRT+20][SQRT+20];
std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b,
const std::vector<bool>& hi){
    vector<int> c;
    vector<bool> hint = hi;
    int ptrl = 0,ptrr = 0;
    int hptr = 0;
    //for(int to:hint)
    //    cout<<to;
    //cout<<endl;
    while(hptr<hint.size()){
        int r1 = 0,r2 = 0;
        if (hint[hptr+1]==1){
            r1 = min(int(a.size()),ptrl+SQRT);
            r2 = min(int(b.size()),ptrr+SQRT);
            hptr+=2;
        }
        else{
            if (hint[hptr]==0){
                r1 = ptrl+getnum(hint,hptr+2);
                r2 = min(int(b.size()),ptrr+SQRT);
            }
            else{
                r2 = ptrr+getnum(hint,hptr+2);
                r1 = min(int(a.size()),ptrl+SQRT);
            }
            hptr+=2+numsz;
        }
        //cout<<r1<<' '<<r2<<endl;
        if (ptrl==r1 || ptrr==r2){
            ptrl = r1;
            ptrr = r2;
            continue;
        }

        P[0][0] = 0;
        for(int i = 0;i+ptrl<r1;++i){
            for(int j = 0;j+ptrr<r2;++j){
                dp[1][j] = 0;
                P[i][j] = 0;
                if (j>0)
                    dp[1][j] = max(dp[1][j],dp[1][j-1]);
                if (dp[1][j]<dp[0][j]){
                    dp[1][j] = dp[0][j];
                    P[i][j] = 1;
                }
                if (a[i+ptrl]==b[j+ptrr]){
                  //  cout<<ptrl<<' '<<ptrr<<' '<<dp[1][j]<<endl;
                    if (j>0 && dp[1][j]<dp[0][j-1]+1){
                        dp[1][j] = dp[0][j-1]+1;
                        P[i][j] = 2;
                    }
                    else if (dp[1][j]<1){
                        dp[1][j] = 1;
                        P[i][j] = 2;
                    }
                }

            }
            for(int j = 0;j+ptrr<r2;++j){
                dp[0][j] = dp[1][j];
            }
        }
        pair<int,int> state;
        int res = 0;
        for(int j = 0;j+ptrr<r2;++j){
            if (res<dp[0][j]){
                res = dp[0][j];
                state = {r1-ptrl-1,j};
            }
        }
        //cout<<"//////////////"<<endl;

        vector<int> to_add;
        while(state.first>=0 && state.second>=0){
         //  cout<<state.first+ptrl<<' '<<state.second+ptrr<<endl;

            if (P[state.first][state.second]==0)
                --state.second;
            else if (P[state.first][state.second]==1)
                --state.first;
            else{
               // cout<<a[state.first+ptrl]<<endl;
                to_add.push_back(a[state.first+ptrl]);
                --state.first;
                --state.second;
            }
        }
        reverse(to_add.begin(),to_add.end());
        for(int to:to_add)
            c.push_back(to);
        for(int j = 0;j+ptrr<r2;++j){
            dp[0][j] = dp[1][j] = 0;
        }
        ptrl = r1;
        ptrr = r2;
       // cout<<dp[0][3]<<' '<<res<<' '<<int(P[1][1])<<endl;
       //cout<<int(P[0][0])<<endl;

    }
    return c;
}
