#include <iostream>
#include <vector>

using namespace std;

const int NMAX = 1e3 + 1;

int N;
int T[NMAX], H[NMAX];

static inline void Read ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N;

    for(int i = 1; i <= N; ++i)
        cin >> T[i] >> H[i];

    return;
}

static inline int my_abs (int X)
{
    if(X < 0)
        return -X;

    return X;
}
static inline bool Ok (int X, int Y)
{
    if(my_abs(T[X] - T[Y]) >= my_abs(H[X] - H[Y]))
        return 1;

    return 0;
}

static inline int my_max (int a, int b)
{
    return ((a > b) ? a : b);
}

static inline void Solve ()
{
    int ans = 0;

    for(int i = 0; i < (1 << N); ++i)
    {
        vector < int > V;
        int cnt = 0;

        for(int j = 0; j < N; ++j)
            if(i & (1 << j))
                ++cnt, V.push_back(j + 1);

        bool ch = 1;

        for(int x = 0; x < (int)V.size() - 1 && ch; ++x)
            for(int y = x + 1; y < (int)V.size() && ch; ++y)
                if(Ok(V[x], V[y]))
                    ch = 0;

        if(ch)
            ans = my_max(ans, cnt);
    }

    cout << ans << '\n';

    return;
}

int main()
{
    Read();

    Solve();

    return 0;
}
