#include <iostream>
#include <vector>

using namespace std;

int N, S, C;

static inline void Read ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N >> S >> C;

    return;
}

int main()
{
    Read();

    if(S == 0 && C == 1)
    {
        int Ops = ((N >> 1) + 2);
        cout << Ops << '\n';
        for(int i = 1; i <= Ops; ++i)
        {
            cout << (N >> 1);
            if(i < Ops)
                cout << ' ';
        }
        cout << '\n';
    }
    else if(S == 1 && C == 0)
    {
        vector < int > steps;

        int left = (N / 3) + 1;
        int right = (2 * N / 3);

        while(left <= right)
        {
            if(left == right)
            {
                steps.push_back(left);

                break;
            }

            steps.push_back(left);
            steps.push_back(right);

            ++left, --right;
        }

        steps.push_back(1), steps.push_back(N);

        cout << (int)steps.size() << '\n';

        for(auto it : steps)
            cout << it << ' ';

        cout << '\n';
    }
    else
    {
        vector < int > steps;

        int p1_left = 1, p1_right = (N / 3) + 1, cnt_1 = 0;
        int p2_left = (2 * N / 3) - 1, p2_right = N, cnt_2 = 0;

        while((p1_left <= p1_right) || (p2_left <= p2_right))
        {
            if(p1_left <= p1_right)
            {
                ++cnt_1;

                if(p1_left == p1_right)
                {
                    if(cnt_1 & 1)
                        steps.push_back(p1_left);
                    else steps.push_back(p1_right);

                    ++p1_left;
                }
                else
                {
                    if(cnt_1 & 1)
                        steps.push_back(p1_left), ++p1_left;
                    else steps.push_back(p1_right), --p1_right;
                }
            }

            if(p2_left <= p2_right)
            {
                ++cnt_2;

                if(p2_left == p2_right)
                {
                    if(cnt_2 & 1)
                        steps.push_back(p2_right);
                    else steps.push_back(p2_left);

                    ++p2_left;
                }
                else
                {
                    if(cnt_2 & 1)
                        steps.push_back(p2_right), --p2_right;
                    else steps.push_back(p2_left), ++p2_left;
                }
            }
        }

        steps.push_back(N / 3), steps.push_back(2 * N / 3), steps.push_back(N);

        cout << (int)steps.size() << '\n';

        for(auto it : steps)
            cout << it << ' ';

        cout << '\n';
    }

    return 0;
}
