#include <bits/stdc++.h>
#define debug(x) cerr << #x << " " << x << "\n"
#define debugs(x) cerr << #x << " " << x << " "
#pragma GCC optimize("Ofast", "unroll-loops")
//#include "hll.h"

using namespace std;
typedef long long ll;
typedef pair <ll, ll> pii;

const ll NMAX = 1000001;
const ll INF = 1e9;
const ll CT = 3;
const ll nr_of_bits = 21;

ll aib[NMAX];
void update(ll node, ll v)
{
    for(; node < NMAX; node += node&(-node))
        aib[node] += v;
}

ll query(ll node)
{
    if(node == 0)
        return 0;
    ll v = 0;
    for(; node > 0; node -= node&(-node))
        v += aib[node];
    return v;
}

ll sum(ll l, ll r)
{
    return query(r) - query(l - 1);
}

struct pp
{
    ll first, second, third, q;
};

pp v[NMAX];
unordered_map <ll, ll> mp;

bool cmp(pp a, pp b)
{
    return a.second < b.second;
}

ll suma[NMAX];
int viz[NMAX];

int main()
{
    ll n, i;
    cin >> n;
    vector <ll> cc;
    for(i = 1; i <= n; i++)
    {
        ll x, y;
        cin >> x >> y;
        v[i].first = x;
        v[i].second = y;
        cc.push_back(v[i].first);
        cc.push_back(v[i].second);
    }
    sort(v + 1, v + n + 1, cmp);
    ll cnt = 0;
    for(i = 1; i <= n; i++)
    {
        int maxim = 0;
        for(int j = 1; j < i; j++){
            if(viz[j])
                continue;
            if(abs(v[j].second - v[i].second) >= abs(v[i].second - v[i].first))
            {
                if(maxim == 0 || (v[maxim].second > v[j].second))
                    maxim = j;
            }
        }
        viz[maxim] = 1;
        if(maxim == 0)
            cnt++;
    }
    cout << cnt;
    return 0;
}
