#include <vector>
#include "hint.h"

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol);
std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint);


std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol)
{

    int cntr=0;
    std::vector<bool> ans;
    for(int i=0;i<a.size();i++)
    {
        if(a[i]==sol[cntr]){
            ans.push_back(true);
            cntr++;
        }
        else
        {
            ans.push_back(false);
        }
    }
    return ans;
}


std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint)
{
    std::vector<int> ans;
    for(int i=0;i<a.size();i++)
    {
        if(hint[i])
            ans.push_back(a[i]);
    }
    return ans;
}
