#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#include<bits/stdc++.h>
using namespace std;
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> oset;
#define fir first
#define sec second
#define mp make_pair
#define pb push_back
#define sz size
#define ll long long
#define en "\n"
int matx[1002][1002], rev[1002][1002];
int x[10002], y[10002], d[10002];
int n;
vector<queue<int> > g(20000);
vector<vector<int> > nw(200000);
bool bfs()
{
    for (int i = 0; i <= n+1; i++)
        d[i] = 1e9;
    d[0] = 0;
    queue<int> q;
    q.push(0);
    while (q.sz() > 0)
    {
        int v = q.front();
        q.pop();
        for (int i = 0; i < nw[v].sz(); i++)
            if (d[nw[v][i]] > d[v]+1)
            {
                d[nw[v][i]] = d[v]+1;
                q.push(nw[v][i]);
            }
    }
    if (d[n+1] < 1e9)
        return true;
    return false;
}
bool build_layered_network()
{
    for (int i = 0; i <= n+1; i++)
    {
        nw[i].clear();
        while (g[i].sz() > 0)
            g[i].pop();
    }
    for (int i = 0; i <= n+1; i++)
        for (int j = i+1; j <= n+1; j++)
            if (matx[i][j] > 0)
                nw[i].pb(j);
    if (!bfs())
        return false;
    for (int i = 0; i <= n+1; i++)
        for (int j = i+1; j <= n+1; j++)
            if (matx[i][j] > 0 && d[j] == d[i]+1)
                g[i].push(j);
    return true;
}
int flow = 0;
int get_way(int v)
{
    if (v == n+1)
        return 1;
    while (g[v].sz() > 0)
    {
        int u = g[v].front();
        if (matx[v][u] > 0)
        {
            int w = get_way(u);
            if (w > 0)
            {
                matx[v][u] -= w;
                matx[u][v] += w;
                return w;
            }
            else
                g[v].pop();
        }
        else
            g[v].pop();
    }
    return 0;
}
int main()
{
    ios::sync_with_stdio(0);
    cin >> n;
    vector<pair<int, int> > a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i].fir >> a[i].sec;
    sort(a.begin(), a.end());

    int res = 0;
    for (int i = 0; i < n; i++)
    {
        for (int j = i+1; j < n; j++)
            if (a[j].fir-a[i].fir >= abs(a[i].sec-a[j].sec))
            {
                matx[i+1][j+1] = 1;
                x[i]++;
                y[j]++;
            }
    }
    for (int i = 0; i < n; i++)
        if (y[i] == 0)
            matx[0][i+1] = 10000;
    for (int i = 0; i < n; i++)
        if (x[i] == 0)
            matx[i+1][n+1] = 1;
    while (build_layered_network())
    {
        while (true)
        {
            int k = get_way(0);
            if (k == 0)
                break;
            flow += k;
        }
    }
    cout << flow << en;
}
