#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#include<bits/stdc++.h>
using namespace std;
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> oset;
#define fir first
#define sec second
#define mp make_pair
#define pb push_back
#define sz size
#define ll long long
#define en "\n"
const int mx = 20100;
vector<vector<pair<int, bool> > > matx(mx);
vector<vector<int> > p(mx);
int x[mx], y[mx], d[mx];
int n;
vector<queue<pair<int, pair<int, int> > > > g(mx);
vector<vector<int> > nw(mx);
bool bfs()
{
    for (int i = 0; i <= n+n+1; i++)
        d[i] = 1e9;
    d[0] = 0;
    queue<int> q;
    q.push(0);
    while (q.sz() > 0)
    {
        int v = q.front();
        q.pop();
        for (int i = 0; i < nw[v].sz(); i++)
            if (d[nw[v][i]] > d[v]+1)
            {
                d[nw[v][i]] = d[v]+1;
                q.push(nw[v][i]);
            }
    }
    if (d[n+n+1] < 1e9)
        return true;
    return false;
}
bool build_layered_network()
{
    for (int i = 0; i <= n+n+1; i++)
    {
        nw[i].clear();
        while (g[i].sz() > 0)
            g[i].pop();
    }
    for (int i = 0; i <= n+n+1; i++)
        for (int j = 0; j < matx[i].sz(); j++)
            if (matx[i][j].sec)
                nw[i].pb(matx[i][j].fir);
    if (!bfs())
        return false;
    for (int i = 0; i <= n+n+1; i++)
        for (int j = 0; j < matx[i].sz(); j++)
            if (matx[i][j].sec && d[matx[i][j].fir] == d[i]+1)
                g[i].push(mp(matx[i][j].fir, mp(j, p[i][j])));
    return true;
}
int flow = 0;
int get_way(int v)
{
    if (v == n+n+1)
        return 1;
    while (g[v].sz() > 0)
    {
        int u = g[v].front().fir;
        int e = g[v].front().sec.fir, z = g[v].front().sec.sec;
        if (matx[v][e].sec)
        {
            int w = get_way(u);
            if (w > 0)
            {
                matx[v][e].sec = false;
                matx[u][z].sec = true;
                return w;
            }
            else
                g[v].pop();
        }
        else
            g[v].pop();
    }
    return 0;
}
int main()
{
    ios::sync_with_stdio(0);
    cin >> n;
    vector<pair<int, int> > a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i].fir >> a[i].sec;
    int res = 0;
        vector<int> z;
        for (int j = 0; j < n; j++)
            z.pb(j);
    for (int i = 0; i < n; i++)
    {
        if (i % 100 == 0)
        random_shuffle(z.begin(), z.end());
        for (int j1 = 0; j1 < z.sz(); j1++)
        {
            int j = z[j1];
            if (i != j)
                if (a[j].fir-a[i].fir >= abs(a[i].sec-a[j].sec))
                {
                    if (matx[i].sz() > 220)
                        break;
                    matx[i+1].pb(mp(n+j+1, true));
                    matx[n+j+1].pb(mp(i+1, false));
                    p[i+1].pb(matx[n+j+1].sz()-1);
                    p[n+j+1].pb(matx[i+1].sz()-1);
                    x[i]++;
                    y[j]++;
                }
        }
    }
    for (int i = 0; i < n; i++)
    {
        matx[0].pb(mp(i+1, true));
        matx[i+1].pb(mp(0, false));
        p[0].pb(matx[i+1].sz()-1);
        p[i+1].pb(matx[0].sz()-1);
    }
    for (int i = 0; i < n; i++)
    {
        matx[n+i+1].pb(mp(n+n+1, true));
        matx[n+n+1].pb(mp(n+i+1, false));
        p[n+i+1].pb(matx[n+n+1].sz()-1);
        p[n+n+1].pb(matx[n+i+1].sz()-1);
    }
    while (build_layered_network())
    {
        while (true)
        {
            int k = get_way(0);
            if (k == 0)
                break;
            flow += k;
        }
    }
    cout << n-flow << en;
}
//5
//0 0
//100 200
//101 201
//200 200
//201 201
