#include "hint.h"

using namespace std;
#include <bits/stdc++.h>

vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& sol) {
    int n = a.size(), m = b.size(), k = sol.size(), curr = 0;
    if(k == 0) return {};
    vector <bool> h;
    vector <pair <int, int>> v(k);
    for(int i = 0; i < n; i++)
        if(curr < k && a[i] == sol[curr])
            v[curr++].first = i;
    curr = 0;
    for(int i = 0; i < m; i++)
        if(curr < k && b[i] == sol[curr])
            v[curr++].second = i;
    int currseg = 0;
    auto gc = [&](int a, int b)->long long{return 1ll * (v[b].first - v[a].first) * (v[b].second - v[a].second); };
    long long t = gc(0, curr - 1) / 17;
    vector <int> tosend = {0};
    //for(auto x : v) cout << x.first << " " << x.second << "\n";
    //cout << curr << "\n";
    for(int i = 0; i < 16 && currseg < curr - 1; i++) {
        int l = currseg + 1, r = max(curr - 16 + i, l), med, last = r;
        while(l <= r) {
            //cout << "BS " << l << " " << r << "\n";
            med = (l + r) / 2;
            long long g = gc(currseg, med);
            if(g <= t) {
                last = med;
                l = med + 1;
            } else r = med - 1;
        }
        tosend.push_back(currseg = last);
    }
    //for(int x : tosend) cout << v[x].first << " " << v[x].second << "\n";
    for(int x : tosend) {
        for(int i = 17; i >= 0; i--)
            h.push_back(v[x].first & (1 << i));
        for(int i = 17; i >= 0; i--)
            h.push_back(v[x].second & (1 << i));
    }
    return h;
}

vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint) {
    int k = hint.size() / 36;
    vector <int> sol;
    if(k < 17) {
        for(int i = 0; i < 2 * k; i++) {
            int nr = 0;
            for(int j = 17; j >= 0; j--)
                nr |= hint[i * 18 + 17 - j] << j;
            if(i & 1) sol.push_back(b[nr]);
        }
    } else {
        vector <pair <int, int>> num(k);
        for(int i = 0; i < 2 * k; i++) {
            int nr = 0;
            for(int j = 17; j >= 0; j--)
                nr |= hint[i * 18 + 17 - j] << j;
            if(i % 2 == 0) num[i / 2].first = nr;
            else num[i / 2].second = nr;
        }
        long long t = 1ll * (num[k - 1].first - num[0].first) * (num[k - 1].second - num[0].second) / 17;
        //for(auto x : num) cout << x.first << " " << x.second << "\n";
        for(int ii = 0; ii < k; ii++) {
            //cout << ii << "\n";
            sol.push_back(a[num[ii].first]);
            if(ii == k - 1) break;
            int h = num[ii + 1].first - num[ii].first - 1, w = num[ii + 1].second - num[ii].second - 1;
            //cout << h << " " << w << "\n";
            if(1ll * h * w > t) continue;
            vector <vector <int>> dp(h + 1);
            for(int i = 0; i <= h; i++) dp[i].resize(w + 1, 0);
            int sti = num[ii].first, stj = num[ii].second;
            for(int i = 1; i <= h; i++)
                for(int j = 1; j <= w; j++) {
                    if(a[i + sti] == b[j + stj]) dp[i][j] = dp[i - 1][j - 1] + 1;
                    if(i > 0) dp[i][j] = max(dp[i][j], dp[i - 1][j]);
                    if(j > 0) dp[i][j] = max(dp[i][j], dp[i][j - 1]);
                }
            //cout << dp[h][w] << " " << h << " " << w << "\n";
            stack <int> st;
            for(int x = h, y = w; dp[x][y] != 0;) {
                if(a[x + sti] == b[y + stj]) {
                    st.push(a[x + sti]);
                    x--; y--;
                } else if(dp[x - 1][y] < dp[x][y - 1]) y--;
                else x--;
            }
            while(!st.empty()) {
                sol.push_back(st.top());
                st.pop();
            }
            dp.clear();
        }
    }
    return sol;
}