#include <bits/stdc++.h>
#include "hint.h"
using namespace std;

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol){

    vector <bool> v;
    v.resize(1,0);
    return v;
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint){

    int n = a.size(), m = b.size(),i,j;

    int dp[n][m];
    for (i=0;i<n;i++)
        for (j=0;j<m;j++)
            dp[i][j] = 0;

    for (i=0;i<n;i++)
        for (j=0;j<m;j++){

            if (!i && !j){
                dp[i][j] = (a[i] == b[j]);
                continue;
            }

            if (i)
                dp[i][j] = dp[i-1][j];
            if (j)
                dp[i][j] = max (dp[i][j], dp[i][j-1]);

            if (i && j && a[i] == b[j])
                dp[i][j] = max (dp[i][j], dp[i-1][j-1]+1);

        }

    i = n-1, j = m-1;
    vector <int> sol;
    while (i >= 0 && j >= 0){

        if (a[i] == b[j]){
            sol.push_back(a[i]);
            i--;
            j--;
        } else {
            if (dp[i-1][j] > dp[i][j-1])
                i--;
            else j--;
        }

    }
    reverse (sol.begin(),sol.end());
    return sol;
}