#include <bits/stdc++.h>
#include "hint.h"
using namespace std;

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol){

    vector <bool> v;

    int n = a.size(), m = b.size(),k = sol.size(), i = 0, j = 0;

    if (n < m){
        v.resize(n,false);

        while (i < n && j < k){
            if (a[i] == sol[j]){
                v[i] = 1;
                i++, j++;
            } else i++;
        }
    } else {

        v.resize(m,false);

        while (i < m && j < k){
            if (b[i] == sol[j]){
                v[i] = 1;
                i++, j++;
            } else i++;
        }

    }

    return v;
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint){

    int n = a.size(),m = b.size(),i;

    vector <int> sol;

    if (n < m){
        for (i=0;i<n;i++)
            if (hint[i] == 1)
                sol.push_back(a[i]);
    } else {
        for (i=0;i<m;i++)
            if (hint[i] == 1)
                sol.push_back(b[i]);
    }

    return sol;
}