#include <bits/stdc++.h>
#include "hint.h"

using namespace std;
typedef long long ll;

const int S=2900;
bool dp[S+1][S+1];

vector<bool> genHint(const vector<int> &a,const vector<int> &b,const vector<int> &sol)
{
    int n=a.size();
    int m=b.size();
    int x=0,y=0;
    vector<bool> hint;
    int sz=1;
    auto add=[&](int t)
    {
        t++;
        int len=0;
        int z=t;
        while(z)
        {
            len++;
            z/=2;
        }
        while(len>sz)
        {
            hint.push_back(0);
            sz++;
        }
        hint.push_back(1);
        for(int i=0;i<sz;i++)
        {
            hint.push_back(t&1);
            t/=2;
        }
    };
    vector<int> one;
    for(int t:sol)
    {
        while(x<n&&a[x]!=t) x++;
        one.push_back(x++);
    }
    vector<int> two;
    for(int t:sol)
    {
        while(y<m&&b[y]!=t) y++;
        two.push_back(y++);
    }
    x=0;
    int len=sol.size();
    while(x<len)
    {
        y=x;
        while(y+1<len&&max(one[y+1]-one[x]+1,two[y+1]-two[x]+1)<=S) y++;
        add(one[x]);
        add(two[x]);
        x=y+1;
    }
    return hint;
}

vector<int> lcs(vector<int> &a,vector<int> &b)
{
    int n=a.size();
    int m=b.size();
    vector<int> now(m+1,0);
    for(int i=1;i<=n;i++)
    {
        vector<int> nxt(m+1,0);
        for(int j=1;j<=m;j++)
        {
            nxt[j]=max(nxt[j-1],now[j]);
            dp[i][j]=(nxt[j]==nxt[j-1]);
            if(a[i-1]==b[j-1]) nxt[j]=now[j-1]+1;
        }
        now=nxt;
    }
    vector<int> c;
    int i=n,j=m;
    while(min(i,j)>0)
    {
        if(a[i-1]==b[j-1])
        {
            c.push_back(a[i-1]);
            i--; j--;
        }
        else if(!dp[i][j]) i--;
        else j--;
    }
    reverse(c.begin(),c.end());
    return c;
}

vector<int> solve(const vector<int> &a,const vector<int> &b,const vector<bool> &hint)
{
    int n=a.size();
    int m=b.size();
    int idx=0;
    int sz_now=1;
    auto get_r=[&]()->int
    {
        while(hint[idx]==0)
        {
            sz_now++;
            idx++;
        }
        idx++;
        int r=0;
        for(int i=0;i<sz_now;i++) r+=((1<<i)*hint[idx++]);
        return r-1;
    };
    int sz=hint.size();
    vector<int> breakers;
    while(idx<sz) breakers.push_back(get_r());
    breakers.push_back(n);
    breakers.push_back(m);
    int len=breakers.size();
    vector<int> res;
    for(int i=0;i+3<len;i+=2)
    {
        int x=breakers[i];
        int y=breakers[i+1];
        int limx=breakers[i+2];
        int limy=breakers[i+3];
        vector<int> one;
        for(int j=x;j<min(limx,x+S);j++) one.push_back(a[j]);
        vector<int> two;
        for(int j=y;j<min(limy,y+S);j++) two.push_back(b[j]);
        vector<int> t=lcs(one,two);
        for(int e:t) res.push_back(e);
    }
    return res;
}

//int main()
//{
//    ios::sync_with_stdio(0);
//    cin.tie(0);
//    mt19937 gen(chrono::steady_clock::now().time_since_epoch().count());
//    auto rng=[&](int l,int r)->int{return uniform_int_distribution<int>(l,r)(gen);};
//    while(1)
//    {
//        int n=rng(1,10);
//        int m=rng(1,10);
//        vector<int> a(n);
//        for(int i=0;i<n;i++) a[i]=rng(1,min(n,m));
//        vector<int> b(m);
//        for(int i=0;i<m;i++) b[i]=rng(1,min(n,m));
//        vector<int> opt=lcs(a,b);
//        int len=opt.size();
//        vector<bool> hint=genHint(a,b,opt);
//        vector<int> res=solve(a,b,hint);
//        bool ok=1;
//        int x=0;
//        for(int t:res)
//        {
//            while(x<n&&a[x]!=t) x++;
//            ok&=(x<n);
//            x++;
//        }
//        int y=0;
//        for(int t:res)
//        {
//            while(y<m&&b[y]!=t) y++;
//            ok&=(y<m);
//            y++;
//        }
//        ok&=(len==(int)res.size());
//        if(ok) cout << "OK" << endl;
//        else
//        {
//            cout << n << " " << m << "\n";
//            for(int i=0;i<n;i++) cout << a[i] << " \n"[i==n-1];
//            for(int i=0;i<m;i++) cout << b[i] << " \n"[i==m-1];
//            cout << "opt: ";
//            for(int i=0;i<len;i++) cout << opt[i] << " \n"[i==len-1];
//            cout << "res: ";
//            int rsz=res.size();
//            for(int i=0;i<rsz;i++) cout << res[i] << " \n"[i==rsz-1];
//            break;
//        }
//    }
//    return 0;
//}
