#include "hint.h"
#include <bits/stdc++.h>

using namespace std;

const int RAD = 1000;
const int MAX_N = 2e5;
const int LG = 18;
std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol) {
    int N = a.size(), M = b.size(), SZ = sol.size();
    int i = 0, j = 0;
    vector <int> ai, bj;
    for (int k = 0; k < SZ; k++) {
        while (a[i] != sol[k])
            i++;
        while (b[j] != sol[k])
            j++;
        ai.push_back(i);
        bj.push_back(j);
        i++, j++;
    }
    j = 0;
    vector <int> to; /// to what index in b we go if we do the ith rad part
    for (int i = 0; i < N; i += RAD) {
        while (j < SZ && ai[j] < i + RAD)
            j++;
        if (j == 0)
            to.push_back(-1);
        else
            to.push_back(bj[j - 1]);
    }
    /// codif the vector t
    vector <bool> hint;
    int lst = -1;
    for (int x : to) {
        int rem = N - lst + 1;
        for (int bit = 0; (1 << bit) <= rem ; bit++)
            if (x & (1 << bit))
                hint.push_back(1);
            else
                hint.push_back(0);
        lst = x;
    }
  /*  for (int i = 0; i < hint.size(); i++)
        cout << hint[i];
    cout << "\n"; */
    return hint;
}

short dp[1 + RAD][1 + MAX_N];
char from[1 + RAD][1 + MAX_N];
/**
5 5
0 1 1 2 3
1 2 3 4 5
3
1 2 3
**/
void solve_lcs(int aL, int aR, int bL, int bR, const vector <int> &a, const vector <int> &b, vector <int> &sol) {
    int sza = aR - aL + 1, szb = bR - bL + 1;
    for (int i = 1; i <= sza; i++)
        for (int j = 1; j <= szb; j++) {
            dp[i][j] = -1;
            if (a[i + aL - 1] == b[j + bL - 1]) {
                if (dp[i][j] < dp[i - 1][j - 1] + 1) {
                    dp[i][j] = dp[i - 1][j - 1] + 1;
                    from[i][j] = 2; /// from both
                }
            }
            if (dp[i][j] < dp[i - 1][j]) {
                dp[i][j] = dp[i - 1][j];
                from[i][j] = 0; /// from i - 1
            }
            if (dp[i][j] < dp[i][j - 1]) {
                dp[i][j] = dp[i][j - 1];
                from[i][j] = 1; /// from j - 1
            }
        }
    int i = sza, j = szb;
    vector <int> v;
    while (i > 0 && j > 0) {
        if (from[i][j] == 2) {
            v.push_back(a[i + aL - 1]);
            i--;
            j--;
        }
        else if (from[i][j] == 0)
            i--;
        else
            j--;
    }
    while (v.size()) {
        sol.push_back(v.back());
        v.pop_back();
    }
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint) {
    vector <int> sol;
    int N = a.size();
    int lst = -1;
    int bucket = 0;
    int nr = 0;
    for (int i = 0; i < N; i += RAD) {
        int val = 0;
        /// get val by decodif
        int rem = N - lst + 1;
        for (int bit = 0; (1 << bit) <= rem; bit++)
            val += (1 << bit) * hint[nr++];
     //   cout << lst + 1 << " " << val << "\n";
        solve_lcs(i, min(N - 1, i + RAD - 1), lst + 1, val, a, b, sol);
        lst = val;
        bucket++;
    }
  //  cout << 200000 / 36 << "\n";
    return sol;
}

