#include <bits/stdc++.h>
#include "hint.h"
using namespace std;

vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& sol) {
	return {};
}

vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint) {
	int n = (int)a.size(), m = (int)b.size();
	vector<vector<int>> dp(n, vector<int>(m));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (a[i] == b[j]) {
				if (i == 0 || j == 0) {
					dp[i][j] = 1;
				} else {
					dp[i][j] = dp[i - 1][j - 1] + 1;
				}
			}
			if (i > 0) {
				dp[i][j] = max(dp[i][j], dp[i - 1][j]);
			}
			if (j > 0) {
				dp[i][j] = max(dp[i][j], dp[i][j - 1]);
			}
		}
	}
	vector<int> answer;
	int i = n - 1, j = m - 1;
	while (true) {
		if (a[i] == b[j]) {
			answer.push_back(a[i]);
		}
		if (i == 0 || j == 0) {
			break;
		}
		if (dp[i][j] == dp[i - 1][j - 1] + 1) {
			--i, --j;
		} else if (dp[i][j] == dp[i - 1][j]) {
			--i;
		} else if (dp[i][j] == dp[i][j - 1]) {
			--j;
		} else {
			assert(false);
		}
	}
	reverse(answer.begin(), answer.end());
	return answer;
}
