#include <bits/stdc++.h>
#include "hint.h"
#define pb push_back

using namespace std;

std::vector<bool> genHint(vector<int>& a, vector<int>& b, vector<int>& sol)
{
    int n = (int)a.size();
    int m = (int)b.size();

    if (n < m)
    {
        vector < bool > ok(n);
        for (int i = 0; i < n; i++)
            ok[i] = 0;
        int l = 0;
        for (int i = 0; i < n; i++)
        {
            if (l < (int)sol.size() && a[i] == sol[l])
            {
                ok[i] = 1;
                l++;
            }
        }

        return ok;
    }
    else
    {
        vector < bool > ok(m);
        for (int i = 0; i < m; i++)
            ok[i] = 0;
        int l = 0;
        for (int i = 0; i < m; i++)
        {
            if (l < (int)sol.size() && b[i] == sol[l])
            {
                ok[i] = 1;
                l++;
            }
        }

        return ok;
    }
}


std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint)
{
    vector < int > c;
    int n = (int)a.size();
    int m = (int)b.size();

    if (n > m)
    {
        for (int i = 0; i < n; i++)
        {
            if (hint[i] == 1)
                c.pb(a[i]);
        }
    }
    else
    {
        for (int i = 0; i < m; i++)
        {
            if (hint[i] == 1)
                c.pb(b[i]);
        }
    }

    return c;
}
