#include <bits/stdc++.h>
using namespace std;

vector<int> case_c(int n, int s, int c) {
    vector<int> ans;
    int l = 1, r = n, i = 0;
    while (l <= r) {
        // cout << i << " -> " << l << " " << r << endl;
        assert(1 <= l && r <= n);
        if (i < s) {
            ans.push_back(l);
            l++; r++;
            if (r > n) r = n;
        } else {
            if (l == r) {
                ans.push_back(l);
                break;
            } else {
                ans.push_back(r-1);
                r--;
                l = min(l+1, r);
            }
        }
        i = (i + 1) % (s + c);
    }

    return ans;
}

vector<int> case_s(int n, int s, int c) {
    vector<int> ans;

    int a = n / 2, b = n / 2;
    int i = 0;

    while (a > 0 || b > 0) {
        if (i < s) {
            if (a >= b) {
                ans.push_back(a);
                if (a <= 2) a--;
                else a -= 2;
                if (b != 0) b = max(b-1, 1);
            } else {
                ans.push_back(n-b+1);
                if (b <= 2) b--;
                else b -= 2;
                if (a != 0) a = max(a-1, 1);
            }
        } else {
            if (i & 1) {
                b++;
                a--;
                ans.push_back(1);
            } else {
                a++;
                b--;
                ans.push_back(n);
            }
        }

        i = (i + 1) % (s + c);
    }

    return ans;
}

bool check(int n, int s, int c, vector<int> ans) {
    for (int& x : ans) x--;

    vector<char> w(n, true);

    int i = 0;
    for (int x : ans) {
        cout << " move=" << x+1 << endl;
        w[x] = false;
        vector<char> nw(n, false);
        for (int j = 0; j < n; ++j) {
            if (!w[j]) continue;
            if (i < s) {
                if (j < x) nw[max(0, j-1)] = true;
                if (j > x) nw[min(n-1, j+1)] = true;
            } else {
                if (j < x) nw[j+1] = true;
                if (j > x) nw[j-1] = true;
            }
        }

        w.swap(nw);

        i = (i + 1) % (s + c);

        for (char x : w) cout << (x ? "#" : ".");
        cout << endl;
    }

    for (int x : w) if (x) return false;
    return true;
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    int n, s, c; cin >> n >> s >> c;

    auto ans = c > s || c == 1 && s == 1 ? case_c(n, s, c) : case_s(n, s, c);

    cout << ans.size() << endl;
    for (int x : ans) cout << x << ' ';
    cout << endl;

/*
    bool ok = check(n, s, c, ans);
    cerr << (ok ? "OK" : "WA") << endl;
    cerr << "cnt = " << ans.size() << endl;
//*/
}

/*

1 2 3 4 5 6 7 8 9 0 1 2
# # # # # # # # # # # # 6
# # # # . . . # # # # # 8
# # # . . . . . . # # # 12
. # # # . . . . . . # # 4
# # . . . . . . . . . # 12
# . . . . . . . . . . . 1
. . . . . . . . . . . .

*/