#include <bits/stdc++.h>

//#pragma GCC optimize ("Ofast", "O3", "-O3", "fast-math")

using namespace std;

#define int long long
#define pii pair<int, int>
#define null NULL

const int inf = 1e12;
const int mod = 1e9 + 7;
const int near = 1e2;

static minstd_rand gen;


signed main() {
    int n;
    cin >> n;
    map<int, vector<int>> schedule;
    for (int i = 0; i < n; ++i) {
        int t, s;
        cin >> t >> s;
        if (!schedule.count(t)) {
            vector<int> buf;
            schedule[t] = buf;
        }
        schedule[t].push_back(s);
    }
    for (auto time: schedule)
        sort(time.second.begin(), time.second.end());

    set<pii > cars;
    for (auto time: schedule) {
        vector<int> add;

        for (auto house: time.second) {
            pii bestCar = {-inf, -inf};
            int minDist = inf;
            for (auto car: cars) {
                int d = time.first - car.second;
                if (car.first - d <= house && house <= car.first + d){
                    if (car.first - d < minDist){
                        minDist = car.first - d;
                        bestCar = car;
                    }
                }
            }
            if (bestCar.first != -inf)
                cars.erase(bestCar);
            add.push_back(house);
        }

        for (auto car: add)
            cars.insert({car, time.first});
    }

    cout << cars.size();
}