#include <bits/stdc++.h>

//#pragma GCC optimize ("Ofast", "O3", "-O3", "fast-math")

using namespace std;

#define int long long
#define pii pair<int, int>
#define null NULL

const int inf = 2e9;
const int mod = 1e9 + 7;
const int costC = 60, costS = 90;

int n, l, r;
vector<int> ans;

int clamp(int a, int mn, int mx) {
    return max(mn, min(a, mx));
}

int add(int a, int x) {
    return clamp(a + x, 0, n - 1);
}

void check(int x, bool scary = false) {
    if (scary) {
        l = min(add(l, -1), max(0ll, x - 2));
        r = max(add(r, 1), min(n - 1, x + 2));
    } else {
        if (x < l) l--, r--;
        else if (x > r) l++, r++;
        else l++, r--;
    }
    ans.push_back(x + 1);
}

signed main() {
    int s, c;
    cin >> n >> s >> c;
    if (s == 0) {
        int cnt = (n + 2) / 2;
        for (int i = 0; i < cnt; ++i)
            ans.push_back(cnt);
    } else if (c == 0) {
        l = n / 2;
        r = n / 2;
        bool order = false;
        bool left = false, right = false;
        do {
            if (l == 0 && !left) {
                ans.push_back(1);
                left = true;
                r = min(n - 1, r + 1);
                if (l == n - 1)
                    right = true;
            } else if (r == n - 1 && !right) {
                ans.push_back(n);
                right = true;
                l = max(0ll, l - 1);
                if (r == 0)
                    left = true;
            } else {
                ans.push_back((order ? l : r) + 1);
                if (l == r) {
                    l = max(0ll, l - 2), r = min(n - 1, r + 2);
                } else {
                    if (order)
                        l = max(0ll, l - 2), r = min(n - 1, r + 1);
                    else
                        l = max(0ll, l - 1), r = min(n - 1, r + 2);
                }
                order = !order;
                if ((order && left) || (!order && right))
                    order = !order;
            }
        } while (!left || !right);
    } else {
        if (s * costS > c * costC || (s == 1 && c == 1)) {
            l = n / 2;
            r = n / 2;
        } else {
            l = 0;
            r = 0;
        }
        bool inLeft = true, inRight = true;
        bool scary = true;
        int timer = s;

        while (inLeft || inRight) {
            if (l == 0 && inLeft) {
                inLeft = false;
                check(0, scary);
                if (l == n - 1)
                    inRight = false;
            } else if (r == n - 1 && inRight) {
                inRight = false;
                check(n - 1, scary);
                if (r == 0)
                    inLeft = false;
            } else {
                if (scary) {
                    if (inLeft)
                        check(l, scary);
                    else
                        check(r, scary);

                } else {
                    if (l + 1 <= n - r && inLeft) check(0);
                    else check(n - 1);
                }
            }
            timer--;
            if (timer <= 0) {
                if ((scary && c) || (!scary && s))
                    timer = (scary ? c : s), scary = !scary;
            }
        }
    }
    cout << ans.size() << endl;
    for (auto x: ans)
        cout << x << " ";
}