#include <bits/stdc++.h>
using namespace std;

#define INF 1000000009

unordered_map<int, int> mp;
vector<pair<int, int>> v;
int nrp;

#define mid ((l+r)/2)
struct segmentTree{
	segmentTree *ls=nullptr, *rs=nullptr;
	int val=INF, poz=-1;

	void push(){
		if(ls==nullptr) ls=new segmentTree;
		if(rs==nullptr) rs=new segmentTree;
	}
	
	void update(int upoz, int x, int l=1, int r=10, int cr=1){
		if(l==r){
			val=x;
			poz=upoz;
			return;
		}
		push();
		if(upoz<=mid) ls->update(upoz, x, l, mid, cr*2);
		if(mid<upoz) rs->update(upoz, x, mid+1, r, cr*2+1);
		if(ls->val<rs->val) val=ls->val, poz=ls->poz;
		else val=rs->val, poz=rs->poz;
	}

	pair<int, int> query(int ql, int qr, int l=1, int r=10, int cr=1){
		if(ql==l&&qr==r) return {val, poz};
		push();
		if(qr<=mid) return ls->query(ql, qr, l, mid, cr*2);
		if(mid<ql) return rs->query(ql, qr, mid+1, r, cr*2+1);
		return min(ls->query(ql, mid, l, mid, cr*2), rs->query(mid+1, qr, mid+1, r, cr*2+1));
	}

};
#undef mid
segmentTree *root=nullptr;

void solve(int l, int r, int lh, int rh){
	//cout<<l<<" "<<r<<" "<<lh<<" "<<rh<<"\n";
	if((r-1)<(l+1)||(r-1)==0||(l+1)==10) return;
	int mini, poz;
	tie(mini, poz) = root->query(max(l+1, 1), min((int)10,r-1));
	//cout<<mini<<" "<<poz<<"**"<<endl;
	if(mini==INF) return;
	if((abs(lh-mini)<=abs(l-poz))&&(abs(rh-mini)<=abs(r-poz))){
		nrp++;
		int x=mp[poz];
		if(((x+1)==v.size())||(v[x+1].first!=v[x].first)){
			root->update(poz, INF);
		}
		else{
			root->update(poz, v[x+1].second);
			mp[poz]++;
		}
		solve(l, poz, lh, mini);
		solve(poz, r, mini, rh);
	}
}

int main(){
	int n;
	cin>>n;
	v.resize(n+1);
	root=new segmentTree;
	for(int i=1;i<=n;++i){
		cin>>v[i].first>>v[i].second;
	}
	sort(v.begin()+1, v.end());
	for(int i=1;i<=n;++i){
		if(v[i].first!=v[i-1].first) mp[v[i].first]=i;	
	}
	for(auto it:mp){
		//cout<<it.first<<" "<<v[it.second].second<<endl;
		root->update(it.first, v[it.second].second);
	}
	int sol=0;
	while(nrp<n){
		sol++;
		solve(-1e9, 2e9, 0, 0);
	}
	cout<<sol<<"\n";
}



