#include <bits/stdc++.h>
#include "hint.h"

using namespace std;

vector <bool> genHint (const vector <int> &a, const vector <int> &b, const vector <int> &sol) {
    if ((int) a.size() <= (int) b.size()) {
        vector <bool> hint ((int) a.size(), false);
        for (int i = 0, j = 0; i < (int) a.size() && j < (int) sol.size(); i++) {
            if (a[i] == sol[j]) {
                hint[i] = true;
                j++;
            }
        }
        return hint;
    } else {
        vector <bool> hint ((int) b.size(), false);
        for (int i = 0, j = 0; i < (int) b.size() && j < (int) sol.size(); i++) {
            if (b[i] == sol[j]) {
                hint[i] = true;
                j++;
            }
        }
        return hint;
    }
}

vector <int> solve (const vector <int> &a, const vector <int> &b, const vector <bool> &hint) {
    if ((int) a.size() <= (int) b.size()) {
        vector <int> sol;
        for (int i = 0; i < (int) a.size(); i++) {
            if (hint[i] == true) {
                sol.push_back(a[i]);
            }
        }
        return sol;
    } else {
        vector <int> sol;
        for (int i = 0; i < (int) b.size(); i++) {
            if (hint[i] == true) {
                sol.push_back(b[i]);
            }
        }
        return sol;
    }
}