#include <bits/stdc++.h>
#include "hint.h"

using namespace std;

vector <bool> genHint (const vector <int> &a, const vector <int> &b, const vector <int> &sol) {
    vector <bool> hint;
    int bits = 0;
    while ((1 << bits) < min((int) a.size(), (int) b.size())) {
        bits++;
    }
    if (bits * (int) sol.size() < min((int) a.size(), (int) b.size())) {
        for (int val : sol) {
            for (int bit = 0; bit < bits; bit++) {
                hint.push_back((val >> bit) & 1);
            }
        }
        hint.push_back(0);
    }
    else if ((int) a.size() <= (int) b.size()) {
        for (int i = 0, j = 0; i < (int) a.size() && j < (int) sol.size(); i++) {
            if (a[i] == sol[j]) {
                hint.push_back(true);
                j++;
            } else {
                hint.push_back(false);
            }
        }
        hint.push_back(1);
    } else {
        for (int i = 0, j = 0; i < (int) b.size() && j < (int) sol.size(); i++) {
            if (b[i] == sol[j]) {
                hint.push_back(true);
                j++;
            } else {
                hint.push_back(false);
            }
        }
        hint.push_back(1);
    }
    return hint;
}

vector <int> solve (const vector <int> &a, const vector <int> &b, const vector <bool> &hint) {
    vector <int> sol;
    int bits = 0;
    while ((1 << bits) < min((int) a.size(), (int) b.size())) {
        bits++;
    }
    if (hint.back() == 0) {
        int len = ((int) hint.size() - 1) / bits;
        for (int i = 0; i < len; i++) {
            int val = 0;
            for (int bit = 0; bit < bits; bit++) {
                val |= (hint[i * bits + bit] << bit);
            }
            sol.push_back(val);
        }
    } else if ((int) a.size() <= (int) b.size()) {
        for (int i = 0; i < (int) a.size(); i++) {
            if (hint[i] == true) {
                sol.push_back(a[i]);
            }
        }
    } else {
        for (int i = 0; i < (int) b.size(); i++) {
            if (hint[i] == true) {
                sol.push_back(b[i]);
            }
        }
    }
    return sol;
}