#include "hint.h"

#include <bits/stdc++.h>

using namespace std;

vector <bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& sol) {
    return {};
}

vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint) {
    int n = a.size();
    int m = b.size();
    vector <vector <int>> dp, par;
    dp.resize(n);
    par.resize(n);
    for (int i = 0; i < n; i ++) {
        dp[i].resize(m);
        par[i].resize(m);
    }
    for (int i = 0; i < n; i ++) {
        for (int j = 0; j < m; j ++) {
            dp[i][j] = 0;
            if (i) {
                dp[i][j] = dp[i-1][j];
                par[i][j] = 1;
            }
            if (j and dp[i][j] <= dp[i][j-1]) {
                dp[i][j] = dp[i][j-1];
                par[i][j] = 2;
            }
            if (i and j and a[i] == b[j] and dp[i][j] < dp[i-1][j-1] + 1) {
                dp[i][j] = dp[i-1][j-1] + 1;
                par[i][j] = 3;
            }
        }
    }

    vector <int> ans;
    for (int i = n - 1, j = m - 1; i + j > 0;) {
        if (par[i][j] == 3) {
            ans.push_back(a[i]);
            i --;
            j --;
        }
        if (par[i][j] == 2) {
            j --;
        }
        if (par[i][j] == 1) {
            i --;
        }
    }
    reverse(ans.begin(), ans.end());
    return ans;
}
