#include <bits/stdc++.h>

using namespace std;

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	int n, s, c;
	cin >> n >> s >> c;

	if (s == 0) {
		vector<int> ans;
		for (int i = 1; i <= (n + 1) / 2; ++i) {
			ans.push_back(i);
		}
		ans.push_back((n + 1) / 2);
		cout << ans.size() << "\n";
		for (int i : ans) {
			cout << i << " ";
		}
		cout << "\n";
		return 0;
	}
	
	vector<int> rabbits(n);
	for (int i = 0; i < n; ++i) {
		rabbits[i] = 1;
	}

	auto sum = [&](vector<int> a) {
		int res = 0;
		for (int x : a) {
			res += x;
		}
		return res;
	};

	vector<int> ans;
	for (int it = 0; sum(rabbits) > 0; ++it) {
		auto step = [&](int pos) {
			vector<int> nrabbits(n, 0);
			for (int i = 0; i < n; ++i) {
				if (i == pos) {
					continue;
				}
				if (it % (s + c) < s) {
					// scary
					if (i == 0 || i == n - 1) {
						nrabbits[i] += rabbits[i]; 
					} else {
						if (i < pos) {
							nrabbits[i - 1] += rabbits[i];
						} else {
							nrabbits[i + 1] += rabbits[i];
						}
					}
				} else {
					// curious
					if (i < pos) {
						nrabbits[i + 1] += rabbits[i];
					} else {
						nrabbits[i - 1] += rabbits[i];
					}
				}
			}
			return nrabbits;
		};
		int best = 0;
		for (int i = 0; i < n; ++i) {
			if (sum(step(i)) < sum(step(best))) {
				best = i;
			}
		}
		ans.push_back(best + 1);
		rabbits = step(best);
	}

	cout << ans.size() << "\n";
	for (int i : ans) {
		cout << i + 1 << " ";
	}
	cout << "\n";
	return 0;
}
