#include <bits/stdc++.h>

using namespace std;

bool check(int n, int s, int c, const vector<int> &ans) {
	int k = ans.size();
	
	vector<int> a(n, 1);

	for (int t = 0; t < k; ++t) {
		int p = ans[t] - 1;

		vector<int> na(n, 0);
		for (int i = 0; i < n; ++i) {
			if (i == p) {
				continue;
			}
	
			if (t % (s + c) < s) {
				if (i == 0 || i == n - 1) {
					na[i] += a[i];
				} else {
					if (i < p) {
						na[i - 1] += a[i];
					} else {
						na[i + 1] += a[i];
					}
				}
			} else {
				if (i < p) {
					na[i + 1] += a[i];
				} else {
					na[i - 1] += a[i];
				}
			}
		}
		a = na;
	}

	for (int i = 0; i < n; ++i) {
		if (a[i]) {
			return false;
		}
	}
	return true;
}

vector<int> solve(int n, int s, int c) {
	if (s == 0) {
		vector<int> ans;
		for (int i = 1; i <= (n + 1) / 2; ++i) {
			ans.push_back(i);
		}
		ans.push_back((n + 1) / 2);
		return ans;
	}

	if (c == 0) {
		vector<int> ans;
		ans.push_back((n + 1) / 2);
		int pref = (n + 1) / 2 - 2;
		int suf = n - (n + 1) / 2 - 1;
		while (pref > 1 && suf > 1) {
			if (pref > suf) {
				ans.push_back(pref);
				pref = max(1, pref - 2);
				suf = max(1, suf - 1);
			} else {
				ans.push_back(n - suf + 1);
				pref = max(1, pref - 1);
				suf = max(1, suf - 2);
			}
		}
		while (pref > 1) {
			ans.push_back(pref);
			pref = max(1, pref - 2);
		}
		while (suf > 1) {
			ans.push_back(n - suf + 1);
			suf = max(1, suf - 2);
		}
		if (pref == 1) {
			ans.push_back(1);
		}
		if (suf == 1) {
			ans.push_back(n);
		}
		return ans;
	}

	return {};
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);

	int n, s, c;
	cin >> n >> s >> c;

	auto ans = solve(n, s, c);

	cout << ans.size() << "\n";
	for (int i : ans) {
		cout << i << " ";
	}
	cout << "\n";
#ifdef LOCAL
	if (check(n, s, c, ans)) {
		cout << "OK\n";
	} else {
		cout << "WA\n";
	}
#endif

	return 0;
}
