#include <iostream>
#include <vector>
#include <set>
#include <cmath>
#include <algorithm>
#include <map>
using namespace std;
typedef long long ll;
int main(){
    
    int n;
    cin >> n;
    vector <ll> h(n);
    vector <ll> t(n);
    
    for (int i = 0; i < n; i++)
        cin >> t[i] >> h[i];
    
    vector <pair<ll,ll> > parovi(n);
    
    for (int i = 0; i < n; i++)
        parovi[i].first = t[i], parovi[i].second = h[i];
    
    sort(parovi.begin(), parovi.end());
    
    ll l = 1, r = n;
    while (l < r){
        
        ll mid = (l+r)/2;
        
        vector <pair <ll, ll> > kraj(mid, {-1,-1});
        
        bool moguce = true;
        
        for (int  i = 0; i < n; i++){
            
            ll trent = parovi[i].first, trenp = parovi[i].second;
            bool nasao = false;
            for (int j = 0; j < mid; j++)
                if (kraj[j].first == -1 || trent - kraj[j].first >= abs(trenp - kraj[j].second)){
                    kraj[j].first = trent, kraj[j].second = trenp;
                    nasao = true;
                    break;
                }
            if (!nasao){
                moguce = false;
                break;
            }
            
        }
        
        if (!moguce)
            l = mid + 1;
        else
            r = mid;
        
        
    }
    
    cout << l;
    
}
