#include <iostream>
#include <vector>
#include <set>
#include <cmath>
#include <algorithm>
#include <map>
using namespace std;
typedef long long ll;
int main(){
    
    int n;
    cin >> n;
    vector <ll> h(n);
    vector <ll> t(n);
    
    for (int i = 0; i < n; i++)
        cin >> t[i] >> h[i];
    
    vector <pair<ll,ll> > parovi(n);
    
    for (int i = 0; i < n; i++)
        parovi[i].first = t[i], parovi[i].second = h[i];
    
    sort(parovi.begin(), parovi.end());
    
    ll l = 1, r = n;
    
    while (l < r){
        
        ll mid = (l+r)/2;
        
        bool moguce = true;
    
        vector <bool> vis(n, false);
        ll preth = -1;
        
        for (int  i = 0; i < mid; i++){
            for (int j = 0; j < n; j++){
                
                if (vis[j])
                    continue;
                if (preth == -1){
                    preth = j;
                    vis[j] = true;
                    continue;
                }
                
                if (parovi[j].first - parovi[preth].first >= abs(parovi[j].second - parovi[preth].second))
                    vis[j] = true, preth = j;
            
                
            }
            
            preth = -1;
            
        }
        
        for (int i = 0; i < n; i++)
            if (!vis[i])
                moguce = false;
        
        if (!moguce)
            l = mid + 1;
        else
            r = mid;
        
        
    }
    
    cout << l;
    
}
