#include "hint.h"
#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

typedef long long ll;

vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& sol){
	vector<bool> hint(a.size(), false);
	ll ind = 0;
	for (ll i = 0; i < a.size(); i++)
	{
		if (sol[ind] == a[i])
			hint[i] = true, ind++;
	}
	return hint;
}

vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint){
	vector<int> ans;
	for (ll i = 0; i < hint.size(); i++)
		if (hint[i])
			ans.push_back(a[i]);
	return ans;
}
