#include <vector>
#include <iomanip>
#include <iostream>
#include <algorithm>

using namespace std;

int main() {
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

  int n, s, c;
  cin >> n >> s >> c;
  int r = n - 1;
  vector<int> ans;
  int cur = 0;
  while (r >= 0) {
    if (cur % (s + c) < s) {
      ans.emplace_back(r);
      r -= 2;
      if (r == -1)
        ++r;
    } else {
      ans.emplace_back(0);
      r -= 1;
    }
    ++cur;
  }
  cout << ans.size() << '\n';
  for (int x : ans)
    cout << x + 1 << '\n';
  return 0;
}