#include<bits/stdc++.h>
using namespace std;

const int inf = 2e9 + 6;
const int N = 1e6 + 4;

struct P {
    int t, h;
    P() {}
    P(int t, int h) : t(t), h(h) {}
};

int n;
P a[N];
int res[N];

int f(P a) { return a.t - a.h; }
int g(P a) { return a.t + a.h; }

void run() {
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i].t >> a[i].h;
    }
    sort(a, a + n, [](auto v1, auto v2) { 
        if (f(v1) == f(v2)) return g(v1) < g(v2);
        return f(v1) < f(v2);
    });

    fill(res, res + n + 1, -1);
    res[0] = inf;
    int sz = 1;

    for (int i = 0; i < n; ++i) {
        int l = -1, r = sz;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            if (res[mid] > g(a[i])) l = mid;
            else r = mid;
        }
        if (res[l + 1] < g(a[i])) {
            res[l + 1] = g(a[i]);
            if (l + 1 >= sz) ++sz;
        }
    }
    cout << sz - 1 << endl;
}

signed main() {
    cin.tie(0), cout.tie(0), ios_base::sync_with_stdio(0);
    run();
}