#include "bits/stdc++.h"
#include "hint.h"

using namespace std;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

#define sz(a)(int)a.size()
#define all(a)a.begin(),a.end()
//#define int long long

vector<bool> genHint(const vector<int> &a, const vector<int> &b, const vector<int> &sol) {
    int n = a.size();
    vector<bool> res(n);
    int pnta = 0, pntsol = 0;
    while (pnta < n && pntsol < sz(sol)) {
        if (a[pnta] == sol[pntsol]) {
            res[pnta] = true;
            ++pntsol;
        }
        ++pnta;
    }
    return res;
};

vector<int> solve(const vector<int> &a, const vector<int> &b, const vector<bool> &hint) {
    vector<int> ans;
    for (int i = 0; i < sz(hint); ++i)
        if (hint[i])
            ans.push_back(a[i]);
    return ans;
}

//void solve() {
//   cout<<pow((640.0/100000.0),0.3);
//}
//
//signed main() {
//    ios_base::sync_with_stdio(0), cin.tie(0);
//    solve();
//    return 0;
//}