#include "bits/stdc++.h"

using namespace std;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
#define sz(a)(int)a.size()
#define all(a)a.begin(),a.end()
#define int long long

void solve() {
    int N, S, C;
    cin >> N >> S >> C;
    vector<int> ans;
    if (C == 0) {
        int cur = (N + 1) / 2;
        int r = cur + 1;
        ans.push_back(cur);
        while (cur > 0) {
            r = min(N, r + 1);
            cur -= 2;
            ans.push_back(cur);
        }
        cur = r;
        ans.push_back(cur);
        while (cur <= N) {
            cur += 2;
            ans.push_back(cur);
        }
    } else {
        int l = 2;
        int r = N + 1;
        ans.push_back(1);
        int cur = 1;
        while (l <= r) {
            for (int i = 0; i < S && l <= r; ++i) {
                if (cur < l) {
                    cur = l + 1;
                    l += 2;
                    r = min(N, r + 1);
                } else {
                    cur = r - 1;
                    l = max(1LL, l - 1);
                    r -= 2;
                }
                ans.push_back(cur);
            }
            for (int i = 0; i < C && l <= r; ++i) {
                if (cur < l) {
                    cur = r - 1;
                    l = max(1LL, l - 1);
                    r -= 2;
                } else {
                    cur = l + 1;
                    l += 2;
                    r = min(N, r + 1);
                }
                ans.push_back(cur);
            }
        }
    }
    cout << sz(ans) << "\n";
    for (auto x:ans) {
        x = max(x, 1LL);
        x = min(N, x);
        cout << x << " ";
    }
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    solve();
    return 0;
}