#include <bits/stdc++.h>
#include "hint.h"
//#define int long long
using namespace std;

vector<int> Clear(const vector<int> &a, const vector<int> &b) {
    set<int> s;
    for (int i = 0; i < b.size(); i++)
        s.insert(b[i]);
    vector<int> ra;
    for (int i = 0; i < a.size(); i++) {
        if (s.count(a[i]))
            ra.push_back(a[i]);
    }
    return ra;
}

std::vector<bool> genHint(const std::vector<int> &a, const std::vector<int> &b, const std::vector<int> &sol) {
    vector<int> A = Clear(a, b), B = Clear(b, a);
    if (A.size() > B.size())
        swap(A, B);
    vector<bool> Ans(A.size());
    int pos = 0;
    for (int i = 0; i < A.size(); i++) {
        if (pos < sol.size() && A[i] == sol[pos]) {
            Ans[i] = 1;
            pos++;
        } else Ans[i] = 0;
    }
    return Ans;
}

std::vector<int> solve(const std::vector<int> &a, const std::vector<int> &b, const std::vector<bool> &hint) {
    vector<int> A = Clear(a, b), B = Clear(a, b);
    if (A.size() > B.size())
        swap(A, B);
    vector<int> ans;
    for (int i = 0; i < A.size(); i++)
        if (hint[i])
            ans.push_back(A[i]);
    return ans;
}