#include <bits/stdc++.h>
#include "hint.h"

#define fr(i, a, b) for(int i = (a); i <= (b); ++i)
#define rf(i, a, b) for(int i = (a); i >= (b); --i)
#define fe(x, y) for(auto& x : y)

#define fi first
#define se second
#define pb push_back
#define mt make_tuple
#define mp make_pair

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define pw(x) (1LL << (x))

using namespace std;

mt19937_64 rng(chrono::system_clock::now().time_since_epoch().count());

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template<typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order
#define ook order_of_key

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
template<typename T>
using ve = vector<T>;

ve<bool> genHint(const ve<int>& a, const ve<int>& b, const ve<int>& sol) {
    ve<bool> hint(sz(a));
    int ptr = 0;

    fr(i, 0, sz(a) - 1) {
        if(ptr < sz(sol) && a[i] == sol[ptr]) {
            hint[i] = 1;
            ptr++;
        }
    }
    return hint;
}

ve<int> solve(const ve<int>& a, const ve<int>& b, const ve<bool>& hint) {
    ve<int> ans;
    fr(i, 0, sz(a) - 1) {
        if(hint[i]) {
            ans.pb(a[i]);
        }
    }
    return ans;
}

/*
5 3
1 2 3 2 3
3 2 1
2
3 2
*/

