#include <bits/stdc++.h>
#include "hint.h"

#define fr(i, a, b) for(int i = (a); i <= (b); ++i)
#define rf(i, a, b) for(int i = (a); i >= (b); --i)
#define fe(x, y) for(auto& x : y)

#define fi first
#define se second
#define pb push_back
#define mt make_tuple
#define mp make_pair

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define pw(x) (1LL << (x))

using namespace std;

mt19937_64 rng(chrono::system_clock::now().time_since_epoch().count());

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template<typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order
#define ook order_of_key

template<typename T>
bool umn(T& a, T b) { return (a > b ? (a = b, 1) : 0); }
template<typename T>
bool umx(T& a, T b) { return (a < b ? (a = b, 1) : 0); }

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
template<typename T>
using ve = vector<T>;

const int N = 10005;

int dp[N][N];
char par[N][N];

ve<int> solve(const ve<int>& a, const ve<int>& b) {
//    cout << "a: ";
//    fe(x, a) cout << x << " ";
//    cout << "\n";
//    cout << "b: ";
//    fe(x, b) cout << x << " ";
//    cout << "\n";

    fr(i, 0, sz(a)) {
        fr(j, 0, sz(b)) {
            dp[i][j] = -1e9;
            par[i][j] = -1;
        }
    }
    dp[0][0] = 0;
    fr(i, 0, sz(a)) {
        fr(j, 0, sz(b)) {
            if(i + 1 <= sz(a)) {
                if(umx(dp[i + 1][j], dp[i][j])) {
                    par[i + 1][j] = 0;
                }
            }
            if(j + 1 <= sz(b)) {
                if(umx(dp[i][j + 1], dp[i][j])) {
                    par[i][j + 1] = 1;
                }
            }
            if(i + 1 < sz(a) && j + 1 < sz(b) && a[i] == b[j]) {
                if(umx(dp[i + 1][j + 1], dp[i][j] + 1)) {
                    par[i + 1][j + 1] = 2;
                }
            }
        }
    }
    int x = sz(a);
    int y = sz(b);
    ve<int> ans;

    while(1) {
        if(par[x][y] == -1) break;

//        cout << "go " << x << " " << y << "\n";

        if(par[x][y] == 0) {
            x--;
            continue;
        }
        if(par[x][y] == 1) {
            y--;
            continue;
        }
        if(par[x][y] == 2) {
            x--;
            y--;
            ans.pb(a[x]);
            continue;
        }
    }
    reverse(all(ans));
    return ans;
}

ve<bool> genHint(const ve<int>& a, const ve<int>& b, const ve<int>& sol) {
    if(sz(a) <= 10000 && sz(b) <= 10000) return ve<bool>(0);

    ve<bool> hint(sz(a));

    int ptr = 0;

    fr(i, 0, sz(a) - 1) {
        if(ptr < sz(sol) && a[i] == sol[ptr]) {
            hint[i] = 1;
            ptr++;
        }
    }
    return hint;
}

ve<int> solve(const ve<int>& a, const ve<int>& b, const ve<bool>& hint) {
    if(sz(a) <= 10000 && sz(b) <= 10000) {
        return solve(a, b);
    }

    ve<int> ans;
    fr(i, 0, sz(a) - 1) {
        if(hint[i]) {
            ans.pb(a[i]);
        }
    }
    return ans;
}

/*
5 3
1 2 3 2 3
3 2 1
2
3 2
*/

