#include <bits/stdc++.h>

#define fr(i, a, b) for(int i = (a); i <= (b); ++i)
#define rf(i, a, b) for(int i = (a); i >= (b); --i)
#define fe(x, y) for(auto& x : y)

#define fi first
#define se second
#define pb push_back
#define mt make_tuple
#define mp make_pair

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define pw(x) (1LL << (x))

using namespace std;

mt19937_64 rng(chrono::system_clock::now().time_since_epoch().count());

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template<typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order
#define ook order_of_key

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
template<typename T>
using ve = vector<T>;

const int N = 1e6 + 5;

int n;
pii a[N];
ve<pii> edge;

ve<int> g[N];
bool used[N];
int match[N];

bool kuhn(int v) {
    if(used[v]) {
        return 0;
    }
    used[v] = 1;
    fr(to, v + 1, n - 1) {
        if(a[to].fi - a[v].fi >= abs(a[to].se - a[v].se)) {
            if(match[to] == -1 || kuhn(match[to])) {
                match[to] = v;
                return 1;
            }
        }
    }
    return 0;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
//    ios::sync_with_stdio(0);
//    cin.tie(0);
#else
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    cin >> n;
//    assert(n <= 1000);

    fr(i, 0, n - 1) {
        cin >> a[i].fi >> a[i].se;
    }
    sort(a, a + n);
//
//    fr(i, 0, n - 1) {
//        cout << a[i].fi << " " << a[i].se << "\n";
//    }

//    fr(i, 0, n - 1) {
//        fr(j, i + 1, n - 1) {
//            if(a[j].fi - a[i].fi >= abs(a[j].se - a[i].se)) {
//                g[i].pb(j);
////                cout << a[j].fi << " " << a[i].fi << "\n";
////                cout << "edge " << i + 1 << " " << j + 1 << "\n";
//            }
//        }
//    }

    fr(i, 0, n - 1) match[i] = -1;

    fr(i, 0, n - 1) {
        if(kuhn(i)) {
            fill(used, used + n, 0);
        }
    }
    int ans = 0;
    fr(i, 0, n - 1) {
        if(match[i] != -1) {
            ans++;
        }
    }

    cout << n - ans << "\n";

    return 0;
}
