#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

void solve(int L, int R, vector<int>& ask, vector<bool>& scared, int& sz){
      while(L != R){
            int j = ask.size();
            if(!scared[j % sz]){
                  ask.push_back(R);
                  ++ L;
            }else{
                  break;
            }
      }
      if(L == R){
            ask.push_back(L);
            return;
      }
      int mid = (L + R) / 2;
      int l1 = L, r1 = mid, l2 = mid, r2 = R;
      while(l2 != r2){
            int j = ask.size();
            if(scared[j % sz]){
                  ask.push_back(mid);
                  r1 = max(L, r1 - 1);
                  l1 = max(L, l1 - 1);
                  l2 = min(R, l2 + 1);
                  r2 = min(R, r2 + 1);
            }else{
                  ask.push_back(R);
                  r1 = min(R, r1 + 1);
                  l1 = min(R, l1 + 1);
                  l2 = min(R, l2 + 1);
                  r2 = min(R, r2 + 1);
                  ++ l2;
                  ++ r1;
            }
      }
      int j = ask.size();
      if(!scared[j % sz]){
            r1 = min(R, r1 + 1);
            l1 = min(R, l1 + 1);
      }else{
            r1 = max(L, r1 - 1);
            l1 = max(L, l1 - 1);
      }
      ask.push_back(R);
      solve(l1, r1, ask, scared, sz);
}
int main(){
      ios_base :: sync_with_stdio(0);
      cin.tie(0); cout.tie(0);
      int n, s, c;
      cin >> n >> s >> c;
      vector<int> ask;
      if(s > c){
            vector<bool> scared;
            for(int i = 0; i < s; i ++)
                  scared.push_back(1);
            for(int i = 0; i < c; i ++)
                  scared.push_back(0);
            int sz = scared.size();
            solve(1, n, ask, scared, sz);
      }
      cout << ask.size() << "\n";
      for(int x : ask)
            cout << x << " ";
}
