#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

void solve(int L, int R, vector<int>& ask, vector<bool>& scared, int& sz, int& n){
      while(L != R){
            int j = ask.size();
            if(!scared[j % sz]){
                  ask.push_back(R);
                  L = min(L + 1, R);
            }else{
                  break;
            }
      }
      if(L == R){
            ask.push_back(L);
            return;
      }
      int mid = (L + R) / 2;
      int l1 = L, r1 = mid, l2 = mid, r2 = R;
      while(l2 != r2){
            mid = l2;
            int j = ask.size();
            if(scared[j % sz]){
                  ask.push_back(mid);
                  l1 = max(1, min(mid - 2, l1 - 1));
                  r1 = max(l1, min(mid - 2, r1 - 1));
                  r2 = min(n, max(mid + 2, r2 + 1));
                  l2 = min(r2, max(mid + 2, l2 + 1));
            }else{
                  ask.push_back(R);
                  r1 = min(n, r1 + 1);
                  l1 = min(r1, l1 + 1);
                  r2 = min(n, r2 + 1);
                  l2 = min(r2, l2 + 1);
            }
      }
      int j = ask.size();
      if(!scared[j % sz]){
            r1 = min(n, r1 + 1);
            l1 = min(r1, l1 + 1);
      }else{
            l1 = max(1, l1 - 1);
            r1 = max(l1, r1 - 1);
      }
      ask.push_back(R);
      solve(l1, r1, ask, scared, sz, n);
}

void solve2(int L, int R, vector<int>& ask, vector<bool>& scared, int& sz){
      while(L != R){
            int j = ask.size();
            if(scared[j % sz]){
                  ask.push_back(R);
                  L = max(1, L - 1);
                  R = max(L, R - 2);
            }else{
                  int mid = (L + R) / 2;
                  ask.push_back(mid);
                  L = min(L + 1, mid);
                  R = max(R - 1, mid);
            }
      }
      ask.push_back(L);
}

int main(){
      ios_base :: sync_with_stdio(0);
      cin.tie(0); cout.tie(0);
      int n, s, c;
      cin >> n >> s >> c;
      vector<int> ask;
      vector<bool> scared;
      for(int i = 0; i < s; i ++)
            scared.push_back(1);
      for(int i = 0; i < c; i ++)
            scared.push_back(0);
      int sz = scared.size();
      if(s > c){
            solve(1, n, ask, scared, sz, n);
      }else{
            solve2(1, n, ask, scared, sz);
      }
      cout << ask.size() << "\n";
      for(int x : ask){
            assert(x >= 1);
            assert(x <= n);
            cout << x << " ";
      }
}
