#include <bits/stdc++.h>
#include "hint.h"
using namespace std;

#define ll long long

const int N = 1e5;
const int inf = 1e9 + 7;

vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& sol) {
    vector<bool> ret;
    if (a.size() != sol.size())
        for (int i = 0; i < a.size(); i++) {
            if (sol[i] != a[i]) {
                for (int j = 1; j <= a[i]; j++)
                    ret.push_back(true);
                break;
            }
        }
        ret.push_back(false);
    }
    int q = 0;
    for (auto& it: a) {
        if (sol[q] == it) {
            ret.push_back(true);
            q++;
        } else {
            ret.push_back(false);
        }   
    }

    return ret;
}

vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint) {
    vector<int> ret;

    if (hint.size() == a.size()) {
        for (int i = 0; i < hint.size(); i++) {
            if (hint[i]) {
                ret.push_back(a[i]);
            }
        }
    } else if (hint.size() == b.size()) {
        for (int i = 0; i < hint.size(); i++) {
            if (hint[i]) {
                ret.push_back(b[i]);
            }
        }        
    } else {
        int q = 0;
        int num = 0;
        while(hint[q]) {
            num++;
            q++;
        }
        
        bool ara = true;
        for (int i = 0; i < min(a.size(), b.size()); i++) {
            if (a[i] != b[i]) {
                if (b[i] == num)
                    ara = false;
            } 
        }

        if (ara) {
            for (int i = q + 1; i < hint.size(); i++) {
                if (hint[i]) {
                    ret.push_back(a[i - q]);
                }
            }
        } else {
            for (int i = q + 1; i < hint.size(); i++) {
                if (hint[i]) {
                    ret.push_back(b[i - q]);
                }
            }            
        }
    }

    return ret;
}