#include <bits/stdc++.h>
#define fr(i, n, m) for(int i = (n); i < (m); i++)
#define pb push_back
#define st first
#define nd second
#define pq priority_queue
#define all(x) begin(x), end(x)

using namespace std;
typedef long long ll;
typedef pair<int,int> pii;

const int mxn = 2e5+1;
const int k = 500;
int link[mxn];

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol){
	int n = a.size();
	int m = b.size();
	int lcs = sol.size();
	
	int p = 0;
	vector<int> apos;
	fr(i, 0, n){
		if(p >= lcs) break;
		if(a[i] == sol[p]){
			++p;
			apos.pb(i);
		}
	}
	
	p = 0;
	vector<int> bpos;
	fr(i, 0, m){
		if(p >= lcs) break;
		if(b[i] == sol[p]){
			++p;
			bpos.pb(i);
		}
	}
	
	vector<int> akpos;
	vector<int> bkpos;
	fr(i, 0, lcs){
		akpos.pb(apos[i]);
		bkpos.pb(bpos[i]/k + 1);
	}
	int mxbk = 0;
	fr(i, 0, lcs){
		link[bkpos[i]] = max(link[bkpos[i]], akpos[i]);
		mxbk = max(mxbk, bkpos[i]);
	}
	vector<bool> h;
	fr(i, 1, mxbk+1){
		int x = link[i];
		for(int j = 16; j >= 0; j --){
			if(x&(1<<j)){
				h.pb(true);
			}
			else{
				h.pb(false);
			}
		}
	}
	
	return h;
}



vector<int> A;
vector<int> B;
int N, M;

int la, ra, lb, rb;

int dp[mxn][1000];
int me[mxn][1000];

int f(int x, int y){
	if(x < la || y < lb) return 0;
	
	if(dp[x-la][y-lb] != -1) return dp[x-la][y-lb];
	
	int ans1 = f(x-1, y);
	int ans2 = f(x, y-1);
	int ans3 = f(x-1, y-1) + (int)(A[x] == B[y]);
	
	int mx = max({ans1, ans2, ans3});
	dp[x-la][y-lb] = mx;
	if(ans1 == mx) me[x-la][y-lb] = 0;
	else if(ans2 == mx) me[x-la][y-lb] = 1;
	else me[x-la][y-lb] = 2;

	return mx;
}
vector<int> add;
void reconstruct(int x, int y){
	if(x < la || y < lb) return;
	
	if(me[x-la][y-lb] == 0){
		reconstruct(x-1, y);
	}
	else if(me[x-la][y-lb] == 1){
		reconstruct(x, y-1);
	}
	else{
		reconstruct(x-1, y-1);
		add.pb(x);
	}
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint){
	N = (int)a.size();
	M = (int)b.size();
	A = a;
	B = b;
	
	int hlen = (int)hint.size();
	
	vector<int> v;
	int bit;
	fr(i, 0, hlen){
		if(i % 17 == 0){
			v.pb(0);
			bit = 16;
		}
		if(hint[i]){
			v.back() |= (1<<bit);
		}
		--bit;
	}
	int bblocks = (int)v.size();
	
	
	int pr = 0;
	
	fr(i, 0, bblocks){
		if(v[i] == 0) continue;
		
		lb = i*k;
		rb = min(M-1, (i+1)*k - 1);
		
		la = pr;
		ra = v[i];
		
		
		
		fr(x, 0, ra-la+1){
			fr(y, 0, rb-lb+1){
				dp[x][y] = -1;
			} 
		}
		f(ra, rb);
		reconstruct(ra, rb);
		/*if(add.empty()){
			cout<<"ERROR"<<endl;
			continue;
		}*/
		pr = add.back() + 1;
	}
	
	
	vector<int> ans = add;
	fr(i, 0, (int)ans.size()){
		ans[i] = A[add[i]];
	}
	
	
	
	
	return ans;
}
/*
int main(){
	int n, m, l;
	cin >> n;
	vector<int> a(n);
	fr(i, 0, n) cin >> a[i];
	cin >> m;
	vector<int> b(m);
	fr(i, 0, m) cin >> b[i];
	cin >> l;
	vector<int> sol(l);
	
	fr(i, 0, l) cin >> sol[i];
	
	vector<bool> hint = genHint(a, b, sol);
	sol = solve(a, b, hint);
	for(auto u : sol) cout<<u<<' ';
	cout<<endl;
	

}*/

/*10
0 1 2 3 4 5 6 7 8 9
10
10 1 10 4 6 10 10 7 8 9
6
1 4 6 7 8 9


200
130 129 162 98 96 136 185 152 188 102 193 124 32 199 71 150 91 108 94 17 175 47 64 66 65 7 131 76 138 99 77 81 192 155 56 39 25 3 151 101 61 68 172 167 24 160 97 19 179 180 198 33 21 183 197 15 120 196 194 44 83 38 46 103 84 95 57 22 170 23 70 149 163 148 121 186 161 189 100 42 191 52 72 53 67 190 132 139 144 146 45 181 93 147 153 80 116 114 49 4 88 16 90 127 20 143 85 55 178 123 157 10 13 105 177 58 0 60 109 34 50 141 115 156 134 28 176 118 48 1 12 6 187 119 165 128 27 166 5 43 137 73 106 171 74 125 69 111 79 184 51 87 173 135 168 158 117 92 35 182 107 11 126 31 2 62 133 195 18 54 174 8 159 82 37 113 9 63 41 104 59 26 14 145 89 122 110 142 86 164 29 30 169 154 36 112 140 78 75 40
200
153 131 28 23 181 140 129 62 165 14 156 98 16 196 32 46 152 188 88 143 174 21 94 142 80 106 77 127 41 11 146 172 24 117 17 134 157 61 67 66 122 138 53 26 189 160 63 47 113 109 10 145 8 187 99 161 84 175 155 57 73 52 159 33 6 4 126 100 133 75 76 85 193 91 49 50 119 123 29 107 34 0 9 78 38 150 154 112 176 169 74 139 151 86 39 149 191 199 114 64 90 72 55 92 186 83 103 65 89 137 120 1 81 58 163 68 124 45 164 44 116 182 179 60 198 177 2 30 105 40 5 15 82 22 96 93 135 185 115 59 19 158 43 51 70 141 190 110 12 118 121 37 197 183 79 167 162 56 48 97 95 108 144 71 7 3 31 195 125 87 36 128 69 111 166 35 42 180 178 20 102 147 130 170 25 27 173 101 54 148 136 192 194 171 18 104 184 132 13 168
28
129 98 152 188 94 17 66 138 99 155 33 38 149 191 114 90 55 58 60 141 118 48 128 69 111 173 18 104
*/

