#include "hint.h"
#include <iostream>
#include <vector>

using namespace std;

vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol)
{
	vector<bool> ans(a.size());
	int l = 0;
	for (int i = 0; i < sol.size(); ++i)
	{
		while (a[l] != sol[i]) ++l;
		ans[l] = 1;
		++l;
	}
	return ans;
}

vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint)
{
	vector<int> res;
	for (int i = 0; i < hint.size(); ++i)
	{
		if (hint[i] == 1) res.push_back(a[i]);
	}
	return res;
}