#include <iostream>
#include <vector>

using namespace std;


void p(vector<int>& a)
{
    cout << a.size() << '\n';
    for (auto& i : a) cout << i << " ";
    cout << '\n';
}

void test(vector<int> & ans, int n, int r, int s)
{
    vector<int> k(n);
    vector<int> c(n);

    for (int i = 0; i < k.size(); ++i) k[i] = i + 1;
    for(int i = 0; i < ans.size(); ++i)
    {
        if (i % (r + s) < s)
        {
            for (int j = 0; j < k.size(); ++j)
            {
                if (k[j] == ans[i]) c[j] = 1;
                if (k[j] < ans[i]) k[j] = max(1, k[j] - 1);
                else k[j] = min(n, k[j] + 1);
            }
        }
        else
        {
            for (int j = 0; j < k.size(); ++j)
            {
                if (k[j] == ans[i]) c[j] = 1;
                if (k[j] < ans[i]) k[j]++;
                else k[j]--;
            }
        }
    }
    p(k);
    p(c);
}

int main()
{
    int n, c, s;
    vector<int> ans, ans2, ans3;
    cin >> n >> s >> c;
    if (c == 0)
    {
        ans.push_back(n / 3 + 1);
        while (ans[ans.size() - 1] + 2 <= n) ans.push_back(ans[ans.size() - 1] + 2);
        ans.push_back(1);
        ans.push_back(n);
        p(ans);
    }
    else if (s == 0)
    {
        for (int i = 0; i < (n + 1) / 2 + 1; ++i) ans.push_back(n / 2);
        p(ans);
    }
    else
    {
        int last = 1;   
        for (int i = 0; i <= (n / (c + 2 * s) + 1); ++i)
        {
            for (int j = 0; j < s; ++j)
            {
                ans.push_back(min(last, n));
                last += 2;
            }
            
            for(int j = 0; j < c; ++j)
                ans.push_back(n);
            last += c;
        }
        int l = 1, r = n, parn = 1;
        while (r >= l)
        {
            if (parn & 1)
            {
                for (int j = 0; j < s; ++j)
                {
                    ans2.push_back(min(n,max(1, l + s - 2 * j)));
                }
                l += 3 * s - 1;
                r = min(r + s, n);
            }
            else
            {
                for (int j = 0; j < c; ++j)
                {
                    ans2.push_back(max(1, r - c + 1));
                }
                l += c;
                r -= c - 1;
            }
            parn = 1 - parn;
        }
        vector<int> pos(n);
        for (int i = 0; i < n; ++i) pos[i] = i + 1;
        int bk = 0, count = 0, bl = 0;
        while (bk + bl < n)
        {
            if (count % (c + s) < s)
            {
                ans3.push_back(pos[bk]);
                //cout << bk << pos[bk];
                bk++;
                for (int i = bk; i < n; ++i)
                {
                    if (pos[i] == pos[bk - 1]) ++bk;
                    pos[i] = min(pos[i] + 1, n);
                }
            }
            else
            {
                ans3.push_back(n);
                for (int i = bl; i < n; ++i)
                {
                    if (pos[n - 1 - i] == n) ++bl;
                    pos[i] = min(pos[i] + 1, n);
                }
            }
            ++count;
        }
        ans3.push_back(n);
        p(ans3);
        //if (ans2.size() > ans3.size()) ;
        //else p(ans2);
        //test(ans3, n, c, s);
    }
    return 0;
}