#include "hint.h"
#include <bits/stdc++.h>
using namespace std;
std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol) {
    if (max((int) a.size(), (int) b.size()) > (int) 1e4) {
        if ((int) a.size() <= (int) b.size()) {
            vector<bool> res((int) a.size(), false);
            int cnt = 0;
            for (int i = 0; i < (int) a.size(); ++i) {
                if (a[i] == sol[cnt]) {
                    ++cnt;
                    res[i] = true;
                }
            }
            return res;
        } else {
            vector<bool> res((int) b.size(), false);
            int cnt = 0;
            for (int i = 0; i < (int) b.size(); ++i) {
                if (b[i] == sol[cnt]) {
                    ++cnt;
                    res[i] = true;
                }
            }
            return res;
        }
    }
    vector<bool> res;
    return res;
}
std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint) {
    if (max((int) a.size(), (int) b.size()) > (int) 1e4) {
        if ((int) a.size() <= (int) b.size()) {
            vector<int> ans;
            for (int i = 0; i < (int) a.size(); ++i) {
                if (hint[i] == true) {
                    ans.push_back(a[i]);
                }
            }
            return ans;
        } else {
            vector<int> ans;
            for (int i = 0; i < (int) b.size(); ++i) {
                if (hint[i] == true) {
                    ans.push_back(b[i]);
                }
            }
            return ans;
        }
    }
    int n = (int) a.size();
    int m = (int) b.size();
    vector<vector<int>> dp(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (!i && !j) {
                dp[i][j] = (a[i] == b[j]);
            } else if (!i) {
                if (a[i] == b[j]) {
                    dp[i][j] = 1;
                } else {
                    dp[i][j] = dp[i][j - 1];
                }
            } else if (!j) {
                if (a[i] == b[j]) {
                    dp[i][j] = 1;
                } else {
                    dp[i][j] = dp[i - 1][j];
                }
            } else {
                if (a[i] == b[j]) {
                    dp[i][j] = dp[i - 1][j - 1] + 1;
                } else {
                    dp[i][j] = max(dp[i - 1][j], dp[i][j - 1]);
                }
            }
        }
    }
    // cerr << "HELLO\n";
    int x = n - 1, y = m - 1;
    vector<int> ans;
    while (true) {
        // cerr << y << ' ' << x << '\n';
        if (!x || !y) {
            if (a[x] == b[y]) {
                ans.push_back(a[x]);
                break;
            } else {
                #define i x
                #define j y
                if (!i && !j) break;
                else if (!i) --j;
                else --i;
                continue;
            }
        }
        int left = dp[x][y - 1];
        int up = dp[x - 1][y];
        int me = dp[x][y];
        if (a[x] == b[y]) {
            ans.push_back(a[x]);
            x -= 1;
            y -= 1;
        } else if (left >= up) {
            y -= 1;
        } else {
            x -= 1;
        }
    }
    reverse(ans.begin(), ans.end());
    return ans;
}
