#include "hint.h"
#include <algorithm>

const int N = 1e4 + 5;

int dp[N][N];

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b,
                          const std::vector<int>& sol) {
  return {};
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b,
                       const std::vector<bool>& hint) {
  for (int i = 0; i < a.size(); ++i)
    for (int j = 0; j < b.size(); ++j) {
      int ii = i + 1, jj = j + 1;
      dp[ii][jj] = std::max(dp[ii][jj - 1], dp[ii - 1][jj - 1] + (a[i] == b[j]));
      dp[ii][jj] = std::max(dp[ii][jj], dp[ii - 1][jj]);
    }
  int l = dp[a.size()][b.size()];
  std::vector<int> sol;
  int ii = a.size();
  for (int jj = b.size(); jj >= 0; --jj)
    if (dp[ii][jj] == l - 1) {
      sol.push_back(b[jj]);
      --l;
      --ii;
    }
  reverse(sol.begin(), sol.end());
  return sol;
}