#include <iostream>
#include <vector>

using namespace std;

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr), cout.tie(nullptr);
  int n, s, c;
  cin >> n >> s >> c;
  if (n == 2) {
    cout << "2\n1 2\n";
    return 0;
  }
  if (s == 0) {
    int m = n / 2 + 1;
    cout << n / 2 + 2 << "\n";
    for (int i = 0; i < n / 2 + 2; ++i)
      cout << m << " ";
  } else if (c == 0) {
    if (n == 2) {
      cout << "2\n1 2\n";
      return 0;
    }
    vector<int> ans;
    int poz = n / 2 + 1;
    ans.push_back(poz);
    for (int i = 0; i < n / 2; ++i) {
      int a = poz - 3 * i - 2;
      int b = poz + 3 * i + 3;
      if (a > 0) ans.push_back(a);
      if (b <= n) ans.push_back(b);
    }
    ans.push_back(1), ans.push_back(n);
    cout << ans.size() << "\n";
    for (auto i : ans)
      cout << i << " ";
  } else {
    int plus = 1, minus = n - 1, a, b;
    vector<int> ans;
    a = s, b = 0;
    while (plus <= minus) {
      if (a > 0) {
        ans.push_back(plus);
        plus += 2;
        --a;
        minus = min(minus + 1, n);
        if (a == 0)
          b = c;
      } else {
        ans.push_back(minus);
        ++plus;
        --b;
        --minus;
        if (b == 0)
          a = s;
      }
    }
    ans.push_back(minus);
    cout << ans.size() << "\n";
    for (auto i : ans)
      cout << i << " ";
  }
  return 0;
}