// Hint.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol)
{
	int j = 0;
	//if (a.size() < b.size()) swap(a, b);
	if (b.size() <= a.size())
	{
		vector<bool> hint(b.size(), false);
		for (int i : sol)
		{
			while (b[j] != i) j++;
			hint[j] = true;
		}
		return hint;
	}
	else
	{
		vector<bool> hint(a.size(), false);
		for (int i : sol)
		{
			while (a[j] != i) j++;
			hint[j] = true;
		}
		return hint;
	}
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint)
{
	vector<int> sol;
	if (b.size() <= a.size())
	{
		for (int i = 0; i < hint.size(); i++)
		{
			if (hint[i]) sol.push_back(b[i]);
		}
	}
	else
	{
		for (int i = 0; i < hint.size(); i++)
		{
			if (hint[i]) sol.push_back(a[i]);
		}
	}
	return sol;
}
