// Hint.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <stack>

using namespace std;

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol)
{
    int j = 0;
    vector<int> c;
    for (int i : a)
    {
        if (find(b.begin(), b.end(), i) != b.end()) c.push_back(i);
    }
    vector<bool> hint(c.size(), false);
    for (int i : sol)
    {
        while (c[j] != i) j++;
        hint[j] = true;
        j++;
    }
    return hint;
}


std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint)
{
    vector<int> sol;
    vector<int> c;
    for (int i : a)
    {
        if (find(b.begin(), b.end(), i) != b.end()) c.push_back(i);
    }
    for (int i = 0; i < hint.size(); i++)
    {
        if (hint[i]) sol.push_back(c[i]);
    }
    return sol;
}