#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n, s, c; cin >> n >> s >> c;
   vector<int> game;
    n >> s >> c;
    for (int i = 0; i < s; i++) game.push_back(1);
    int l = s+1, r = n;
    while (r - l + 1 > 2*c+1)
    {
        int m = l + c;
        for (int i = 0; i < c; i++)
        {
            game.push_back(m);
            l++; r--;
        }
        for (int i = 0; i < s; i++)
        {
            game.push_back(1);
            l++; r = min(r + 1, n);
            if (l == r) break;
        }
    }
    while (l+1 < r-1)
    {
        int m = (l + r) / 2;
        game.push_back(m);
        l = min(l + 1, m); r = max(r - 1, m);
    }
    game.push_back(l+1);
    if (game.size() < n)
    {
        cout << game.size() << endl;
        for (int i : game) cout << i << endl;
    }
    else
    {
        cout << n << endl;
        for (int i = 0; i < n - 1; i++)
        {
            if (i % ((long long)s + c) < s) cout << 1 << endl;
            else cout << n << endl;
        }
        cout << n << endl;
    }
}
