#include "hint.h"


using namespace std;

std::vector<bool> genHint(const std::vector<int> &a, const std::vector<int> &b,
                          const std::vector<int> &sol) {
    vector<bool> res(a.size());
    int p1 = 0, p2 = 0;
    while (p1 < a.size()) {
        if (a[p1] == sol[p2]) {
            p2++;
            res[p1] = true;
        }
        p1++;
    }
    return res;
}

std::vector<int> solve(const std::vector<int> &a, const std::vector<int> &b, const std::vector<bool> &hint) {
    vector<int> res;
    for (int i = 0; i < a.size(); ++i) {
        if (hint[i])
            res.push_back(a[i]);
    }
    return res;
}
