#include "hint.h"


using namespace std;

std::vector<bool> genHint(const std::vector<int> &a, const std::vector<int> &b,
                          const std::vector<int> &sol) {
    vector<int> ca = a, cb = b;
    if (a.size() > b.size()) swap(ca, cb);
    vector<bool> res(ca.size());
    int p1 = 0, p2 = 0;
    while (p1 < ca.size() && p2 < sol.size()) {
        if (ca[p1] == sol[p2]) {
            p2++;
            res[p1] = true;
        }
        p1++;
    }
    return res;
}

std::vector<int> solve(const std::vector<int> &a, const std::vector<int> &b, const std::vector<bool> &hint) {
    vector<int> ca = a, cb = b;
    if (a.size() > b.size()) swap(ca, cb);
    vector<int> res;
    for (int i = 0; i < ca.size(); ++i) {
        if (hint[i])
            res.push_back(ca[i]);
    }
    return res;
}
