#include "iostream"
#include "vector"
#include <algorithm>
#include <set>
#include <map>
#include <numeric>
//#include <bits/stdc++.h>

//#define int long long

using namespace std;

const int MAXN = 1e6 + 10;

vector<int> gr[MAXN];
int was[MAXN];
int mt[MAXN];
int flag = 1;

bool khun(int v) {
    if (was[v] == flag) return false;
    was[v] = flag;
    for (int u: gr[v]) {
        if (mt[u] == -1) {
            mt[u] = v;
            return true;
        }
    }
    for (int u: gr[v]) {
        if (khun(mt[u])) {
            mt[u] = v;
            return true;
        }
    }
    return false;
}

int t[MAXN];
int h[MAXN];


signed main() {
    cin.tie(0);
    ios::sync_with_stdio(false);
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> t[i] >> h[i];
    }
    vector<int> o(n);
    iota(o.begin(), o.end(), 0);
    auto comp = [&](int i, int j) -> bool {
        return t[i] < t[j];
    };
    sort(o.begin(), o.end(), comp);
    for (int _i = 0; _i < n; ++_i) {
        for (int _j = _i + 1; _j < n; ++_j) {
            int i = o[_i], j = o[_j];
            if (t[j] - t[i] >= abs(h[j] - h[i])) {
                gr[i].push_back(j);
            }
        }
    }
    int res = 0;
    fill(mt, mt + n, -1);
    bool a = true;
    for (int i = 0; i < n; ++i) {
        flag++;
        a = khun(i);
        res += a;
    }
    cout << n - res;
}