#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <iterator>
#include <array>
#include "hint.h"
using namespace std;
std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol){
    if(sol.size()==b.size()) return {};
    if(sol.size()==a.size()) return {};
    vector<bool> hint1, hint2;
    vector<int> a1, b1;
    for(auto i: a) a1.push_back(i);
    for(auto i: b) b1.push_back(i);
    sort(a1.begin(), a1.end());
    sort(b1.begin(), b1.end());
    int t = 0;
    for(auto i: a1){
        if(i==sol[t]){
            hint1.push_back(true);
            t++;
            if(t==sol.size()) break;
        }
        else hint1.push_back(false);
    }
    t = 0;
    for(auto i: b1){
        if(i==sol[t]){
            hint2.push_back(true);
            t++;
            if(t==sol.size()) break;
        }
        else hint2.push_back(false);
    }
    if(hint1.size()<hint2.size()){
        hint1.push_back(true);
        return hint1;
    }
    hint2.push_back(false);
    return hint2;
}
std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint){
    int n = hint.size();
    if(n==0){
        if(a.size()<b.size()) return a;
        return b;
    }
    vector<int> a1, b1;
    for(auto i: a) a1.push_back(i);
    for(auto i: b) b1.push_back(i);
    sort(a1.begin(), a1.end());
    sort(b1.begin(), b1.end());
    vector<int> sol;
    if(hint[n-1]){
        for(int i=0; i<n-1; i++){
            if(hint[i]) sol.push_back(a1[i]);
        }
        return sol;
    }
    for(int i=0; i<n-1; i++){
        if(hint[i]) sol.push_back(b1[i]);
    }
    return sol;
}
