#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <stack>
#include <queue>
#include <string>
#include "hint.h"
using namespace std;

vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol){
    // vector<int> hint(2, 0);
    int K = sol.size();
    int N = a.size();
    int M = b.size();
    // hint[0] = K;
    // int result = 0;
    int N2 = min(N, M);
    // for(int i=0; i<K; i++){
    //     result += sol[i]*pow(N2, K-i-1);
    // }
    // hint[1] = result;
    // return hint;
    int j=0;
    vector<bool> hint(K, false);
    if(N<=M){
        for(int i=0; i<K; i++){
            while(a[j] != sol[i]){
                j++;
            }
            hint[j] = true;
            j++;
        }
        
    }
    else{
        for(int i=0; i<K; i++){
            while(b[j] != sol[i]){
                j++;
            }
            hint[j] = true;
            j++;
        }
    }

    return hint;

}
vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint){
    vector<int> sol;
    int K = hint.size();
    int N = a.size();
    int M = b.size();
    int j=0;
    if(N<=M){
        for(int i=0; i<K; i++){
            while(!hint[j]){
                j++;
            }
            sol.push_back(a[j]);
            j++;
        }
        
    }
    else{
        for(int i=0; i<K; i++){
            while(!hint[j]){
                j++;
            }
            sol.push_back(b[j]);
            j++;
        }
    }


    return sol;



}



// static int n, m, k;
// static std::vector<int> a, b, sol, maybeSol;
// static std::vector<bool> hint;

// int main()
// {
//     std::cin >> n >> m;

//     a.resize(n);
//     b.resize(m);

//     for (int& num : a)
//     {
//         std::cin >> num;
//     }

//     for (int& num : b)
//     {
//         std::cin >> num;
//     }

//     std::cin >> k;

//     sol.resize(k);

//     for (int& num : sol)
//     {
//         std::cin >> num;
//     }

//     hint = genHint(a, b, sol);
//     maybeSol = solve(a, b, hint);

//     std::cout << hint.size() << std::endl;
//     std::cout << maybeSol.size() << std::endl;

//     for (int i = 0; i < (int) maybeSol.size(); ++i)
//     {
//         if (i > 0) std::cout << " ";
//         std::cout << maybeSol[i];
//     }
//     std::cout << std::endl;

//     return 0;
// }
