#include "hint.h"
#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define pb push_back
#define all(a) a.begin(),a.end()

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol){
    int n = a.size(), m = b.size(), k = sol.size();
    int j = 0;
    vector<bool> h;

    if(n <= m){
        for(int i = 0;i < n; ++i){
            if(j < k && a[i] == sol[j]){
                h.pb(1);
                ++j;
            }else h.pb(0);
        }
    }else{
        for(int i = 0;i < m; ++i){
            if(j < k && b[i] == sol[j]){
                h.pb(1);
                ++j;
            }else h.pb(0);
        }
    }
    return h;
}
std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint){
    int n = a.size(), m = b.size(), k = hint.size();
    vector<int> ans;
    if(n == k){
        for(int i = 0;i < n; ++i){
            if(hint[i] == 1)ans.pb(a[i]);
        }
    }else{
        for(int i = 0;i < m; ++i){
            if(hint[i] == 1)ans.pb(b[i]);
        }
    }
    return ans;
}

/*
int main()
{
    int n, m, k;
    std::cin >> n >> m;
    vector<int>a, b, sol, maybeSol;
    vector<bool> hint;
    a.resize(n);
    b.resize(m);

    for (int& num : a)
    {
        std::cin >> num;
    }

    for (int& num : b)
    {
        std::cin >> num;
    }

    std::cin >> k;

    sol.resize(k);

    for (int& num : sol)
    {
        std::cin >> num;
    }

    hint = genHint(a, b, sol);
    maybeSol = solve(a, b, hint);

    std::cout << hint.size() << std::endl;
    std::cout << maybeSol.size() << std::endl;

    for (int i = 0; i < (int) maybeSol.size(); ++i)
    {
        if (i > 0) std::cout << " ";
        std::cout << maybeSol[i];
    }
    std::cout << std::endl;

    return 0;
}
*/
