//#include "hint.h"
#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define pb push_back
#define all(a) a.begin(),a.end()
#define sz(a) (int)a.size()

#define int long long
const int N = 2e5 + 10;
vector<int> adj[N];
int dist(int x, int y){
    return abs(x - y);
}
bool vis[N];
int s[N];
vector<int> order;
void topo(int u){
    vis[u] = true;
    for(int v: adj[u]){
        if(!vis[v])topo(v);
    }
    order.pb(u);
}
vector<int> pos;
bool cmp(int a, int b){
    return pos[a] < pos[b];
}
void dfs(int u){
    vis[u] = true;
    for(int v: adj[u]){
        if(!vis[v]){
            dfs(v);
            return;
        }
    }
}
void solve(){
    int n;
    cin >> n;
    vector<pair<int,int>> a(n);
    for(int i = 0;i < n; ++i){
        cin >> a[i].first >> a[i].second;
    }
    //make directed graph? is it acyclic? should be
    sort(all(a));
    for(int i = 0;i < n; ++i){
        for(int j = i + 1;j < n; ++j){
            if(a[i].first + dist(a[i].second, a[j].second) <= a[j].first){
                adj[i].pb(j);
            }
        }
    }
    for(int i = 0;i < n; ++i){
        if(!vis[i])topo(i);
    }
    reverse(all(order));
    pos.resize(n);
    for(int i = 0;i < n; ++i){
        vis[i] = false;
        pos[order[i]] = i;
    }
    for(int i = 0;i < n; ++i){
        if(sz(adj[i]))sort(all(adj[i]), cmp);
    }
    int ans = 0;
    for(int i: order){
        if(!vis[i]){
            ++ans;
            dfs(i);
        }
    }
    cout << ans << "\n";
}
int32_t main(){
    solve();
}
