#include <bits/stdc++.h>
#include "hint.h"
#define ll long long
#define ld long double
#define fi first
#define se second
#define all(x) (x).begin(),(x).end()
using namespace std;
const int MX = 1e4;

vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& sol) {

    int n = a.size(), m = b.size();
    if (n <= MX && m <= MX) {
        vector <bool> hint{0};
        return hint;
    }

    vector <bool> hint;
    vector <pair<int, int>> ar;

    int ptr = 0;
    for (int i = 0; i < n; ++i) {
        if (ptr == sol.size()) break;

        int cur = (a[i] == sol[ptr]);
        if (cur) ++ptr;

        if (ar.empty() || ar.back().fi != cur) ar.push_back({cur, 1});
        else ++ar.back().se;
    }

    for (int i = 0; i < ar.size(); ++i) {
        if (ar[i].first == 1) {
            for (int j = 0; j < ar[i].se; ++j) {
                hint.push_back(1);
            }
        }
        else {
            hint.push_back(0);

            if (ar[i].se < 18) hint.push_back(1);
            else hint.push_back(0);

            if (ar[i].se < 18) {
                for (int j = 0; j < ar[i].se; ++j) {
                    hint.push_back(0);
                }
            }
            else {
                for (int j = 0; j <= 18; ++j) {
                    hint.push_back((ar[i].se >> j) & 1);
                }
            }
        }
    }
    return hint;
}
template<typename T>
inline bool chmax(T& a, T b) {
    if (a < b) { a = b; return 1; }
    return 0;
}
#define pii pair<short,short>
vector <int> solve(const vector <int> &a, const vector <int> &b, const vector <bool> &hint) {
    if (hint.size() == 1 && hint[0] == 0) {
        int n = a.size(), m = b.size();
        vector < vector <short> > dp(n + 1, vector <short> (m + 1));
        vector < vector <pii> > p(n + 1, vector <pii> (m + 1));
        for (int i = 1; i <= n; ++i) {
            for (int j = 1; j <= m; ++j) {
                if (a[i - 1] == b[j - 1]) {
                    if (chmax(dp[i][j], (short)((short)dp[i - 1][j - 1] + (short)1))) {
                        p[i][j] = {i - 1, j - 1};
                    }
                }
                else {
                    if (chmax(dp[i][j], dp[i - 1][j])) p[i][j] = {i - 1, j};
                    if (chmax(dp[i][j], dp[i][j - 1])) p[i][j] = {i, j - 1};
                }
            }
        }
        int x = n, y = m;
        vector <int> ans;
        while (x && y) {
            int xx, yy;
            tie(xx, yy) = p[x][y];
            if (xx == x - 1 && yy == y - 1) {
                ans.push_back(a[xx]);
            }
            tie(x, y) = p[x][y];
        }
        reverse(all(ans));
        return ans;
    }
    else {
        vector <int> f;
        for (int i = 0; i < hint.size(); ) {
            if (hint[i] == 1) f.push_back(1), ++i;
            else {
                int j = i + 2;
                if (hint[i + 1] == 1)
                    while (j < hint.size() && !hint[j]) ++j;
                else j = i + 2 + 19;

                if (j > hint.size()) {
                    cout << "sdflkjsdflj";
                    exit(0);
                }

                if (hint[i + 1] == 1) {
                    for (int k = i + 2; k < j; ++k){
                        f.push_back(0);
                    }
                }
                else {
                    int cnt = 0, pw = 1;
                    for (int k = i + 2; k < j; ++k) {
                        cnt += hint[k] * pw;
                        pw <<= 1;
                    }
//                    cout << "!" << cnt << endl;
                    for (int k = 0; k < cnt; ++k) f.push_back(0);
                }

                i = j;
            }
        }
        vector <int> ans;
        for (int i = 0; i < a.size(); ++i) {
            if (f[i]) ans.push_back(a[i]);
        }
        return ans;
    }
}
//signed main() {
//    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
//
//    int n;
//    cin >> n;
//    vector <int> a(n);
//    for (auto &i : a) cin >> i;
//
//    int m;
//    cin >> m;
//    vector <int> b(m);
//    for (auto &i : b) cin >> i;
//
//    int k;
//    cin >> k;
//    vector <int> c(k);
//    for (auto &i : c) cin >> i;
//
//    auto x = genHint(a, b, c);
//
////    for (auto i : x) cout << i << " ";
////    cout << endl;
//
//    auto ans = solve(a, b, x);
//
//    cout << ans.size() << '\n';
//    for (auto i : ans) cout << i << " ";
//}
/**
27
1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2 0 0 0 5 4 0 0
27
1 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 3 2 3 3 3 5 4 0 0
4
1 2 5 4
*/
