#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double
#define ll long long
#define ckmin(x, y) x = min(x, y)
#define ckmax(x, y) x = max(x, y)
#define int long long

using namespace std;

int n;
vector<pair<int, int>> t;
vector<vector<int>> g;
vector<int> p;
vector<vector<int>> G;
vector<bool> used;

void dfs(int v) {
    used[v] = true;
    for (int u : g[v]) {
        if (!used[u])dfs(u);
    }
}


bool kuhn(int v) {
    if (used[v])return false;
    used[v] = true;
    for (int u : G[v]) {
        if (p[u] == -1 || kuhn(p[u])) {
            p[u] = v;
            return true;
        }
    }
    return false;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    t.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> t[i].first >> t[i].second;
    }

    g.resize(n);
    sort(all(t));

    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (t[j].first - t[i].first >= abs(t[j].second - t[i].second)) {
                g[i].push_back(j);
            }
        }
    }

    vector<int> in(n);
    for (int i = 0; i < n; ++i) {
        for (int j : g[i]) {
            in[j]++;
        }
    }

    int froms = 0, tos = 0;
    vector<int> num1(n, -1), num2(n, -1);

    for (int i = 0; i < n; ++i) {
        if (in[i] == 0) {
            num1[i] = froms;
            froms++;
        }
        if (g[i].empty()) {
            num2[i] = tos;
            tos++;
        }
    }

    p.resize(tos, -1);
    G.resize(froms);

    for (int i = 0; i < n; ++i) {
        if (in[i] == 0) {
            used.clear();
            used.assign(n, false);
            dfs(i);
            for (int j = 0; j < n; ++j) {
                if (g[j].empty() && used[j]) {
                    G[num1[i]].push_back(num2[j]);
                }
            }
        }
    }

    for(int i = 0; i < 50; ++i) {
        for (int i = 0; i < froms; ++i) {
            used.clear();
            used.assign(froms, false);
            kuhn(i);
        }
    }

    int pairing = 0;
    for (int i = 0; i < tos; ++i) {
        if (p[i] != -1)pairing++;
    }

    cout << froms + tos - pairing;
}