#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double
#define ll long long
#define ckmin(x, y) x = min(x, y)
#define ckmax(x, y) x = max(x, y)


using namespace std;

vector<bool> getCan(vector<bool> &can, int step, bool closer) {
    int n = (int) can.size();
    vector<bool> new_can(n);
    for (int i = 0; i < n; ++i) {
        if (i == step)new_can[i] = false;
        else if (can[i]) {
            if (i < step) {
                if (closer) {
                    new_can[i + 1] = true;
                } else {
                    if (i > 0)new_can[i - 1] = true;
                    else new_can[i] = true;
                }
            } else {
                if (closer) {
                    new_can[i - 1] = true;
                } else {
                    if (i + 1 < n)new_can[i + 1] = true;
                    else new_can[i] = true;
                }
            }
        }
    }
    return new_can;
}

mt19937 rnd(time(0));

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, s, c;
    cin >> n >> s >> c;

    vector<bool> can(n);
    for (int i = 0; i < n; ++i) {
        can[i] = true;
    }

    vector<int> steps;
    for (int j = 0; j < n; ++j) {
        int ost = j % (s + c);
        bool closer = false;
        if (ost >= s)closer = true;

        int pos = 0;
        for (int i : can)pos += i;
        if (pos == 0) {
            cout << steps.size() << '\n';
            for (int x : steps) cout << x + 1 << " ";
            return 0;
        }
        vector<bool> best;
        int cur = 1e9, best_step = -1;
        int i = rnd() % n;

        auto nc = getCan(can, i, closer);
        int cc = 0;
        for (int k : nc)cc += k;
        if (cc < cur) {
            best_step = i;
            cur = cc;
            best = nc;
        }

        steps.push_back(best_step);
        swap(can, best);
    }
}