#include "hint.h"
#include <bits/stdc++.h>
using namespace std;

vector<bool> genHint(const vector<int> &a, const vector<int> &b, const vector<int> &sol) {
  int n = (int) a.size();
  int ptr = 0;
  vector<bool> ans_1(n, false);
  for (int i = 0; i < n; i++) {
    if (ptr < (int) sol.size() && a[i] == sol[ptr]) {
      ans_1[i] = true;
      ptr++;
    }
  }
  vector<bool> ans_2;
  int lg = ceil(log2(min(n, (int) b.size())));
  for (auto &x : sol) {
    for (int i = 0; i < lg; i++) ans_2.push_back(x & (1 << i));
  }
  return (int) ans_1.size() < (int) ans_2.size() ? ans_1 : ans_2;
}

vector<int> solve(const vector<int> &a, const vector<int> &b, const vector<bool> &hint) {
  int n = (int) a.size();
  if ((int) hint.size() == n) {
    vector<int> ans;
    for (int i = 0; i < n; i++) if (hint[i]) ans.push_back(a[i]);
    return move(ans);
  }
  vector<int> ans;
  int lg = ceil(log2(min(n, (int) b.size())));
  int pw = 0;
  for (auto x : hint) {
    if (pw == 0) ans.push_back(0);
    ans.back() += x << pw;
    pw = (pw + 1) % lg;
  }
  return move(ans);
}