#include "hint.h"

#include <bits/stdc++.h>

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol) {
    std::vector<bool> res;
    for(auto x : sol) {
        for(int i = 0; i < 18; i++)
            res.push_back(x & (1 << i));
    }
    return res;
}
std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint) {
    std::vector<int> res;
    for(int i = 0; i < hint.size(); i += 18) {
        int r = 0;
        for(int j = i; j < i + 18; j++)
            r |= hint[j] << (j - i);
        res.push_back(r);
    }
    return res;
}
