#include <iostream>
#include <algorithm>
#include <cmath>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <stack>
#include <queue>
#include <bitset>
#include <iomanip>
#include <unordered_map>
#include "hint.h"

using namespace std;

#define ll long long
#define ull unsigned long long
#define ft first
#define sc second
#define mpr make_pair
#define sz(a) (ll)a.size()
#define all(a) a.begin(), a.end()
#define add push_back
#define vi vector<int>
#define pii pair<int,int>
#define FOR(i,a,b) for(ll i = (a); i < (b); i++)
#define FORD(i,a,b) for(ll i = (a); i >= (b); i--)
#define fastio ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);


std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol)
{
    vector<bool> v1, v2;
    int j = 0;
    FOR(i,0,sz(a))
    {
        if(j == sz(sol))
        {
            break;
        }

        if(a[i] == sol[j])
        {
            v1.add(1);
            j++;
        }
        else
        {
            v1.add(0);
        }
    }
    j = 0;
    FOR(i,0,sz(b))
    {
        if(j == sz(sol))
        {
            break;
        }
        if(b[i] == sol[j])
        {
            v2.add(1);
            j++;
        }
        else
        {
            v2.add(0);
        }
    }
    v1.add(0);
    v2.add(1);
    if(sz(v1) <= sz(v2))
    {
        return v1;
    }
    else
    {
        return v2;
    }
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint)
{
    vector<int> ans;
    if(hint.back() == 0)
    {
        FOR(i,0,sz(hint)-1)
        {
            if(hint[i] == 1)
            {
                ans.add(a[i]);
            }
        }
    }
    else
    {
        FOR(i,0,sz(hint)-1)
        {
            if(hint[i] == 1)
            {
                ans.add(b[i]);
            }
        }
    }
    return ans;
}

// std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol)
// {
//     vector<bool> v1;
//     int j = 0;
//     FOR(i,0,sz(a))
//     {
//         if(j == sz(sol))
//         {
//             break;
//         }

//         if(a[i] == sol[j])
//         {
//             v1.add(1);
//             j++;
//         }
//         else
//         {
//             v1.add(0);
//         }
//     }
//     return v1;
// }

// std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint)
// {
//     vector<int> ans;
//     FOR(i,0,sz(hint))
//     {
//         if(hint[i] == 1)
//         {
//             ans.add(a[i]);
//         }
//     }
//     return ans;
// }

// std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol)
// {
//     vector<bool> v2;
//     int j = 0;
//     FOR(i,0,sz(b))
//     {
//         if(j == sz(sol))
//         {
//             break;
//         }
//         if(b[i] == sol[j])
//         {
//             v2.add(1);
//             j++;
//         }
//         else
//         {
//             v2.add(0);
//         }
//     }
//     return v2;
// }

// std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint)
// {
//     vector<int> ans;
//     FOR(i,0,sz(hint))
//     {
//         if(hint[i] == 1)
//         {
//             ans.add(b[i]);
//         }
//     }
//     return ans;
// }