#include <iostream>
#include <algorithm>
#include <cmath>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <stack>
#include <queue>
#include <bitset>
#include <iomanip>
#include <unordered_map>
#include "hint.h"

using namespace std;

#define ll long long
#define ull unsigned long long
#define ft first
#define sc second
#define mpr make_pair
#define sz(a) (ll)a.size()
#define all(a) a.begin(), a.end()
#define add push_back
#define vi vector<int>
#define pii pair<int,int>
#define FOR(i,a,b) for(ll i = (a); i < (b); i++)
#define FORD(i,a,b) for(ll i = (a); i >= (b); i--)
#define fastio ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);


std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol)
{
    vector<bool> v1, v2;
    vector<bool> v1rev, v2rev;
    int j = 0;
    FOR(i,0,sz(a))
    {
        if(j == sz(sol))
        {
            break;
        }

        if(a[i] == sol[j])
        {
            v1.add(1);
            j++;
        }
        else
        {
            v1.add(0);
        }
    }
    j = 0;
    FOR(i,0,sz(b))
    {
        if(j == sz(sol))
        {
            break;
        }
        if(b[i] == sol[j])
        {
            v2.add(1);
            j++;
        }
        else
        {
            v2.add(0);
        }
    }

    j = sz(sol)-1;
    FORD(i,sz(a)-1,0)
    {
        if(j == -1)
        {
            break;
        }
        if(a[i] == sol[j])
        {
            v1rev.add(1);
            j--;
        }
        else
        {
            v1rev.add(0);
        }
    }

    j = sz(sol)-1;
    FORD(i,sz(b)-1,0)
    {
        if(j == -1)
        {
            break;
        }
        if(b[i] == sol[j])
        {
            v2rev.add(1);
            j--;
        }
        else
        {
            v2rev.add(0);
        }
    }

    v1rev.add(1);
    v1rev.add(0);
    v2rev.add(1);
    v2rev.add(1);

    v1.add(0);
    v1.add(0);
    v2.add(0);
    v2.add(1);

    if(sz(v1) <= sz(v2) and sz(v1) <= sz(v1rev) and sz(v1) <= sz(v2rev))
    {
        return v1;
    }
    if(sz(v2) <= sz(v1) and sz(v2) <= sz(v1rev) and sz(v2) <= sz(v2rev))
    {
        return v2;
    }
    if(sz(v1rev) <= sz(v2) and sz(v1rev) <= sz(v1) and sz(v1rev) <= sz(v2rev))
    {
        return v1rev;
    }
    if(sz(v2rev) <= sz(v1) and sz(v2rev) <= sz(v1rev) and sz(v2) <= sz(v2))
    {
        return v2rev;
    }
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint)
{
    vector<int> ans;
    if(hint.back() == 0)
    {
        if(hint[sz(hint)-2] == 0)
        {
            FOR(i,0,sz(hint)-2)
            {
                if(hint[i] == 1)
                {
                    ans.add(a[i]);
                }
            }
        }
        else
        {
            FORD(i,sz(hint)-3,0)
            {
                if(hint[i] == 1)
                {
                    ans.add(a[sz(a)-1-i]);
                }
            }
        }
    }
    else
    {
        if(hint[sz(hint)-2] == 0)
        {
            FOR(i,0,sz(hint)-2)
            {
                if(hint[i] == 1)
                {
                    ans.add(b[i]);
                }
            }
        }
        else
        {
            FORD(i,sz(hint)-3,0)
            {
                if(hint[i] == 1)
                {
                    ans.add(b[sz(b)-1-i]);
                }
            }
        }
    }
    return ans;
}

// std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol)
// {
//     vector<bool> v1;
//     int j = 0;
//     FOR(i,0,sz(a))
//     {
//         if(j == sz(sol))
//         {
//             break;
//         }

//         if(a[i] == sol[j])
//         {
//             v1.add(1);
//             j++;
//         }
//         else
//         {
//             v1.add(0);
//         }
//     }
//     return v1;
// }

// std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint)
// {
//     vector<int> ans;
//     FOR(i,0,sz(hint))
//     {
//         if(hint[i] == 1)
//         {
//             ans.add(a[i]);
//         }
//     }
//     return ans;
// }

// std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol)
// {
//     vector<bool> v2;
//     int j = 0;
//     FOR(i,0,sz(b))
//     {
//         if(j == sz(sol))
//         {
//             break;
//         }
//         if(b[i] == sol[j])
//         {
//             v2.add(1);
//             j++;
//         }
//         else
//         {
//             v2.add(0);
//         }
//     }
//     return v2;
// }

// std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint)
// {
//     vector<int> ans;
//     FOR(i,0,sz(hint))
//     {
//         if(hint[i] == 1)
//         {
//             ans.add(b[i]);
//         }
//     }
//     return ans;
// }