#include <iostream>
#include <algorithm>
#include <cmath>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <stack>
#include <queue>
#include <bitset>
#include <iomanip>
#include <unordered_map>
#include "hint.h"
using namespace std;
#define ll long long
#define ull unsigned long long
#define ft first
#define sc second
#define mpr make_pair
#define sz(a) (ll)a.size()
#define all(a) a.begin(), a.end()
#define add push_back
#define vi vector<int>
#define pii pair<int,int>
#define FOR(i,a,b) for(ll i = (a); i < (b); i++)
#define FORD(i,a,b) for(ll i = (a); i >= (b); i--)
#define fastio ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol)
{
    vector<bool> v1, v2;
    int j = 0;
    FOR(i,0,sz(a))
    {
        if(j == sz(sol))
        {
            break;
        }
        if(a[i] == sol[j])
        {
            v1.add(1);
            j++;
        }
        else
        {
            v1.add(0);
        }
    }
    j = 0;
    FOR(i,0,sz(b))
    {
        if(j == sz(sol))
        {
            break;
        }
        if(b[i] == sol[j])
        {
            v2.add(1);
            j++;
        }
        else
        {
            v2.add(0);
        }
    }
    v1.add(0);
    v2.add(1);
    if(sz(v1) <= sz(v2))
    {
        return v1;
    }
    else
    {
        return v2;
    }
}
ll dp[10005][10005];
std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint)
{
    if(sz(a) > 10000 or sz(b) > 10000)
    {
        vector<int> ans;
        if(hint.back() == 0)
        {
            FOR(i,0,sz(hint)-1)
            {
                if(hint[i] == 1)
                {
                    ans.add(a[i]);
                }
            }
        }
        else
        {
            FOR(i,0,sz(hint)-1)
            {
                if(hint[i] == 1)
                {
                    ans.add(b[i]);
                }
            }
        }
        return ans;
    }
    FOR(i,0,sz(a))
    {
        FOR(j,0,sz(b))
        {
            dp[i+1][j+1] = max(dp[i][j]+(a[i] == b[j]), max(dp[i][j+1], dp[i+1][j]));
        }
    }
    int o = sz(a), k = sz(b);
    vector<int> ans;
    while(o > 1 or k > 1)
    {
        if(dp[o][k] == dp[o-1][k-1]+1)
        {
            ans.add(a[o]);
            o--;
            k--;
        }
        else if(dp[o][k] == dp[o-1][k])
        {
            o--;
        }
        else if(dp[o][k] == dp[o][k-1])
        {
            k--;
        }
        else
        {
            o--;
            k--;
        }
    }
    reverse(all(ans));
    return ans;
    
}