#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
#include <bits/stdc++.h>
#include "hint.h"

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

using namespace std;

typedef long long ll;

using vi = vector<int>;
const int LG = 18;
const int D = 3000;

const int maxN = 2e5 + 5;
int a[maxN];
int b[maxN];
int dpL[maxN], dpR[maxN];
vi ans;

void rec(int l1, int r1, int l2, int r2) {
    if (l1 + 1 == r1) {
        int x = a[l1];
        for(int j = l2; j < r2; ++j) {
            if (b[j] == x) {
                ans.push_back(x);
                break;
            }
        }
        return;
    }
    int mid = (l1 + r1) / 2;
    int mid2 = -1;
    bool needL = false, needR = false;
    {
        int m = r2 - l2;
        fill(dpL, dpL + m + 1, 0);
        for(int i = l1; i < mid; ++i) {
            for(int j = m; j >= 1; --j) {
                dpL[j] = max(dpL[j], dpL[j - 1] + int(a[i] == b[j - 1 + l2]));
            }
            for(int j = 1; j <= m; ++j) dpL[j] = max(dpL[j], dpL[j - 1]);
        }
        fill(dpR, dpR + m + 1, 0);
        for(int i = r1 - 1; i >= mid; --i) {
            for(int j = 0; j < m; ++j) {
                dpR[j] = max(dpR[j], dpR[j + 1] + int(a[i] == b[j + l2]));
            }
            for(int j = m - 1; j >= 0; --j) dpR[j] = max(dpR[j], dpR[j + 1]);
        }
        int mx = 0;
        for(int j = l2; j <= r2; ++j) {
            int x = dpL[j - l2];
            int y = dpR[j - l2];
            if (x + y > mx) {
                mx = x + y;
                mid2 = j;
                needL = needR = false;
                if (x) needL = true;
                if (y) needR = true;
            }
        }
    }
    if (mid2 == -1) return;
    if (needL) {
        rec(l1, mid, l2, mid2);
    }
    if (needR) {
        rec(mid, r1, mid2, r2);
    }
}

vector<bool> genHint(const vi &a1, const vi &b1, const vi &sol) {
    rep(i, (int)a1.size()) a[i] = a1[i];
    rep(i, (int)b1.size()) b[i] = b1[i];
    vi A, B;
    {
        int i = 0;
        for (auto &x : sol) {
            while (a[i] != x) i++;
            A.push_back(i++);
        }
    }
    {
        int i = 0;
        for (auto &x : sol) {
            while (b[i] != x) i++;
            B.push_back(i++);
        }
    }
    A.push_back((int) a1.size());
    B.push_back((int) b1.size());
    vector<int> res;
    int u = 0;
    for (int c = 0; c * D < (int) a1.size(); ++c) {
        int l = c * D;
        int r = min(l + D - 1, (int) a1.size() - 1);
        while (A[u] <= r) u++;
        res.push_back(B[u]);
        //cout << u << '\n';
    }
    //cout << "\n";
    vector<bool> bb;
    auto add = [&](int x) {
        rep(i, LG) {
            if ((1 << i) & x) {
                bb.push_back(true);
            } else {
                bb.push_back(false);
            }
        }
    };
    for (auto &e : res) {
        add(e);
    }
    return bb;
}

vi solve(const vi &a1, const vi &b1, const vector<bool> &hint) {
    rep(i, (int)a1.size()) a[i] = a1[i];
    rep(i, (int)b1.size()) b[i] = b1[i];
    vi res;
    int cur = 0;
    auto read = [&]() {
        int x = 0;
        rep(i, LG) {
            if (hint[cur]) {
                x |= (1 << i);
            }
            cur++;
        }
        return x;
    };
    while (cur < (int) hint.size()) {
        res.push_back(read());
    }
    assert(cur == (int) hint.size());
    ans.clear();
    rep(i, (int) res.size()) {
        int l1 = i * D;
        int r1 = min(l1 + D - 1, (int) a1.size() - 1);
        int l2 = 0;
        if (i != 0) l2 = res[i - 1];
        int r2 = res[i] - 1;
        rec(l1, r1 + 1, l2, r2 + 1);
        //cout << res[i] << ' ' << ans.size() << '\n';
    }
    //cout << '\n';
    return ans;
}
