#include <bits/stdc++.h>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

using namespace std;

typedef long long ll;

using vi = vector<int>;

void solve() {
    int n; cin >> n;
    vector<int> x(n), y(n);
    vi ord(n);
    iota(all(ord), 0);
    rep(i, n) {
        int t, h; cin >> t >> h;
        x[i] = t + h;
        y[i] = h - t;
    }
    sort(all(ord), [&] (const int &i, const int &j) {
        return make_pair(x[i], -y[i]) < make_pair(x[j], -y[j]);
    });
    const int INFi = 2e9 + 100;
    vi nvp(n, INFi);
    for(auto &i : ord) {
        (*lower_bound(all(nvp), y[i])) = y[i];
    }
    cout << (int)(lower_bound(all(nvp), INFi) - nvp.begin());
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int tests = 1;
    rep(_, tests) {
        solve();
    }
    return 0;
}