#include <bits/stdc++.h>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

using namespace std;

typedef long long ll;

using vi = vector<int>;

vector<int> solve1(int n, int s, int c) {
    vi ans;
    vector<pair<int, int>> cur, nxt;
    cur.push_back({1, n});
    auto add = [&](int l, int r) {
        if (!nxt.empty() && nxt.back().second + 1 >= l) {
            nxt.back().second = max(nxt.back().second, r);
            return;
        }
        nxt.emplace_back(l, r);
    };
    while (!cur.empty()) {
        rep(_, s) {
            if (cur.empty()) break;
            int d = -100;
            for (auto &[l, r] : cur) {
                if (l <= n / 2 + 1 && n / 2 + 1 <= r) {
                    d = n / 2 + 1;
                }
                if (abs(r * 2 - n) < abs(d * 2 - n)) d = r;
                if (abs(l * 2 - n) < abs(d * 2 - n)) d = l;
            }
            ans.push_back(d);
            nxt.clear();
            for (auto[l, r] : cur) {
                if (l == d && r == d) continue;
                if (l == d) {
                    l += 2;
                    r++;
                    l = min(l, n);
                    r = min(r, n);
                } else if (r == d) {
                    r -= 2;
                    l--;
                    l = max(l, 1);
                    r = max(r, 1);
                } else if (r < d) {
                    r--;
                    l--;
                    l = max(l, 1);
                    r = max(r, 1);
                } else if (l > d) {
                    l++;
                    r++;
                    r = min(r, n);
                    l = min(l, n);
                } else {
                    add(max(l - 1, 1), max(1, d - 2));
                    add(min(d + 2, n), min(n, r + 1));
                    continue;
                }
                add(l, r);
            }
            swap(nxt, cur);
        }
        rep(_, c) {
            if (cur.empty()) break;
            int d = cur.back().second;
            for (auto[l, r] : cur) {
                if (r - l >= 2) {
                    d = l + 1;
                    break;
                }
            }
            ans.push_back(d);
            nxt.clear();
            for (auto[l, r] : cur) {
                if (l == d && r == d) continue;
                if (l > d) {
                    l--;
                } else if (l < d) {
                    l++;
                }
                if (r > d) {
                    r--;
                } else if (r < d) {
                    r++;
                }
                add(l, r);
            }
            swap(nxt, cur);
        }
    }
    return ans;
}

vector<int> solve2(int n, int s, int c) {
    vi ans;
    int L = 1, R = n;
    while (L <= R) {
        rep(_, s) {
            ans.push_back(L);
            if (L == R) {
                L = R + 1;
                break;
            }
            L += 2;
            if (L == n + 1) L--;
            R++;
            R = min(R, n);
            if (L > R) break;
        }
        if (L > R) break;
        rep(_, c) {
            if (L > R) break;
            if (L == R) {
                ans.push_back(L);
                L = R + 1;
                break;
            }
            if (L + 1 == R) {
                ans.push_back(R);
                L++;
                continue;
            }
            assert(L < R - 1);
            ans.push_back(R - 1);
            L++;
            R--;
        }
    }
    return ans;
}

void solve() {
    int n, s, c;
    cin >> n >> s >> c;
    auto ans = solve1(n, s, c);
    {
        auto ans2 = solve2(n, s, c);
        if (ans2.size() < ans.size()) ans = ans2;
    }
    cout << ans.size() << '\n';
    for (auto &x : ans) cout << x << ' ';

}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int tests = 1;
    rep(_, tests) {
        solve();
    }
    return 0;
}