#include "hint.h"

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

static int n, m, k;
static std::vector<int> a, b, sol, maybeSol;
static std::vector<bool> hint;

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol) {
    return {};
}

const int NMAX = 10e4 + 5;

int dp[NMAX][NMAX];
vector < int > res;

void reconst(const std::vector<int>& a, const std::vector<int>& b,const int& i, const int& j) {
    if(i < 0 || j < 0)
        return;

    if(dp[i][j] <= 0)
        return;

    if(a[i] == b[j]) {
        res.push_back(a[i]);
        reconst(a, b, i - 1, j - 1);
    }
    
    if(i - 1 >= 0 && dp[i - 1][j] == dp[i][j])
        reconst(a, b, i - 1, j);
    else if(j - 1 >= 0) 
        reconst(a, b, i, j - 1);
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint) {
    const int n = (int)a.size();
    const int m = (int)b.size();

    for(int i = 0;i < n;++i) {
        for(int j = 0;j < m;++j) {
            if(a[i] == b[j]) {
                if(i - 1 >= 0 && j - 1 >= 0)
                    dp[i][j] = 1 + dp[i - 1][j - 1];
                else 
                    dp[i][j] = 1;
            }
            else {
                if(i - 1 >= 0)
                    dp[i][j] = max(dp[i][j], dp[i - 1][j]);
                if(j - 1 >= 0)
                    dp[i][j] = max(dp[i][j], dp[i][j - 1]);
            }
        }
    }

    res.reserve(dp[n - 1][m - 1]);
    reconst(a, b, n - 1, m - 1);
    reverse(res.begin(), res.end());

    return res;
}