std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b,
 const std::vector<int>& sol) {
	int a_sz = a.size();
	vector<bool> hint(a_sz);
	int i = 0;
	for (auto x : sol) {
		while (a[i] != x) ++i;
		hint[i] = true;
		++i;
	}
	
	return hint;
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b,
 const std::vector<bool>& hint) {
	int a_sz = a.size();
	vector<int> ans;
	for (int i = 0; i < a_sz; ++i) {
		if (hint[i]) {
			ans.pb(a[i]);
		}
	}
	
	return ans;
}