#include<bits/stdc++.h>
#define p pair<int, int>
#define endl '\n'
const int INF = 1000000001;

using namespace std;

vector<vector<int>> d;
vector<int> pa, pb;
vector<bool> was;

bool DFS(int vertex) {
    was[vertex] = true;
    for (int q : d[vertex]) {
        if (pb[q] == -1 || (!was[pb[q]] && DFS(pb[q]))) {
            pa[vertex] = q, pb[q] = vertex;
            return true;
        }
    }
    return false;
}

int Kun(int n, int m) {
    pa.assign(n, -1), pb.assign(m, -1), was.assign(n, false);
    for (int q = 0; q < n; q++) {
        if (DFS(q)) {
            was.assign(n, false);
        }
    }
    int ans = 0;
    for (int q : pa) {
        ans += (q != -1);
    }
    return ans;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    vector<p> a(n);
    for (int q = 0; q < n; q++) {
        cin >> a[q].first >> a[q].second;
    }
    sort(a.begin(), a.end());
    d.assign(n, {});
    for (int q = 0; q < n; q++) {
        for (int q1 = q+1; q1 < n; q1++) {
            if (a[q1].first-a[q].first >= abs(a[q1].second-a[q].second)) {
                d[q].push_back(q1);
            }
        }
    }
    mt19937 randint(179);
    int C = 100;
    for (int q = 0; q < n; q++) {
        if (d[q].size() > C) {
            shuffle(d[q].begin(), d[q].end(), randint);
            vector<int> is;
            int w = min(C, (int)d[q].size());
            for (int q1 = 0; q1 < w; q1++) {
                is.push_back(d[q][q1]);
            }
            d[q] = is;
        }
    }
    cout << n-Kun(n, n) << endl;
    return 0;
}
