#include<bits/stdc++.h>
#define int long long
#define p pair<int, int>
#define endl '\n'
const int INF = 1000000001;

using namespace std;

void print(vector<int> &ans) {
    cout << ans.size() << endl;
    for (int q : ans) {
        cout << q+1 << ' ';
    }
    cout << endl;
}

int n;

void if_S(p &x, int q) {
    if (x.second == q) {
        x.second--;
    }
    if (x.first == q) {
        x.first++;
    }
    if (x.second < q) {
        x.first--, x.second--;
    } else {
        x.first++, x.second++;
    }
    x.first = max(0LL, x.first), x.second = max(0LL, x.second);
    x.first = min(n-1, x.first), x.second = min(n-1, x.second);
}

void if_C(p &x, int q) {
    if (x.second == q) {
        x.second--;
    }
    if (x.first == q) {
        x.first++;
    }
    if (x.second < q) {
        x.first++, x.second++;
    } else if (x.first > q) {
        x.first--, x.second--;
    } else {
        x.first++, x.second--;
    }
    x.first = max(0LL, x.first), x.second = max(0LL, x.second);
    x.first = min(n-1, x.first), x.second = min(n-1, x.second);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int k, t;
    cin >> n >> k >> t;
    vector<int> ans;
    if (t == 0) {
        int w = 2*n/3;
        while (w > 0) {
            ans.push_back(w);
            w -= 2;
        }
        ans.push_back(0);
        ans.push_back(n-1);
    } else if (n <= 3) {
        ans.push_back(0);
        ans.push_back(n-1);
    } else if (k <= t) {
        p seg = {0, n-1};
        int q1 = 0;
        while (seg.first <= seg.second) {
            if (q1 % (k+t) < k) {
                ans.push_back(seg.second);
                if_S(seg, ans.back());
            } else {
                ans.push_back((seg.first+seg.second)/2);
                if_C(seg, ans.back());
            }
            q1++;
        }
    } else {
        ans.push_back(n/2);
        p seg1 = {0, max(0LL, n/2-2)}, seg2 = {min(n-1, n/2+2), n-1};
        int q1 = 1;
        while (seg1.first <= seg1.second || seg2.first <= seg2.second) {
            bool flag = (seg1.second-seg1.first >= seg2.second-seg2.first);
            if (q1 % (k+t) < k) {
                if (flag) {
                    ans.push_back(seg1.second);
                } else {
                    ans.push_back(seg2.first);
                }
                if_S(seg1, ans.back());
                if_S(seg2, ans.back());
            } else {
                if (flag) {
                    ans.push_back((seg1.first+seg1.second)/2);
                } else {
                    ans.push_back((seg2.first+seg2.second)/2);
                }
                if_C(seg1, ans.back());
                if_C(seg2, ans.back());
            }
            q1++;
        }
    }
    print(ans);
    return 0;
}
