#include <bits/stdc++.h>

using namespace std;

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n;
	cin >> n;

	vector<pair<int, int>> points;
	for(int i = 0; i < n; i++) {
		int t, h;
		cin >> t >> h;
		points.emplace_back(t + h, t - h);
	}

	sort(points.rbegin(), points.rend());

	multiset<int> positions;

	for(auto [x, y]: points) {
		auto it = positions.lower_bound(y);
		if(it != positions.end()) {
			positions.erase(it);
		}
		positions.insert(y);
	}

	cout << positions.size() << endl;

	return 0;
}
