#include <bits/stdc++.h>

using namespace std;


int n, s, c;

vector<int> ans;


signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	cin >> n >> s >> c;


	bitset<10000> positions{};
	for(int i = 0; i < n; i++) {
		positions[i] = true;
	}

	int cycle = 0;

	while(true) {
		// for(bool x: positions) {
		// 	cerr << (x ? '-' : 'x');
		// }
		// cerr << endl;


		int l = 0;
		vector<pair<int, int>> segments;
		while(l < positions.size()) {
			if(!positions[l]) {
				l++;
			} else {
				int r = l;
				while(r < positions.size() && positions[r]) {
					r++;
				}
				segments.emplace_back(l, r);
				l = r;
			}
		}
		if(segments.empty()) {
			break;
		}


		bool scared = cycle % (s + c) < s;

		if(scared) {
			// Find the leftmost segment
			auto& [l, r] = segments[0];
			// Bump its left part
			int move = l;

			ans.push_back(move);
			positions[move] = 0;

			// Move everything farther
			bool was = positions[0];
			for(int i = 0; i < move; i++) {
				positions[i] = positions[i + 1];
			}
			if(was) {
				positions[0] = 1;
			}
			was = positions[n - 1];
			for(int i = n - 1; i >= move + 1; i--) {
				positions[i] = positions[i - 1];
			}
			if(was) {
				positions[n - 1] = 1;
			}
		} else {
			// Find the leftmost segment
			auto& [l, r] = segments[0];
			int move;
			if(l == r) {
				// Simple, bump all of it
				move = l;
			} else {
				// Bump r-1
				move = r - 1;
			}
			positions[move] = 0;
			ans.push_back(move);

			// Move everything nearer
			if(move > 0 && positions[move - 1]) {
				positions[move] = 1;
			}
			for(int i = move - 1; i > 0; i--) {
				positions[i] = positions[i - 1];
			}
			positions[0] = 0;
			if(move + 1 < n && positions[move + 1]) {
				positions[move] = 1;
			}
			for(int i = move + 1; i < n; i++) {
				positions[i] = positions[i + 1];
			}
			positions[n - 1] = 0;
		}

		cycle++;
	}


	cout << ans.size() << endl;

	for(int i: ans) {
		cout << i + 1 << " ";
	}
	cout << endl;

	return 0;
}
