#pragma GCC optimize("Ofast")


#include <bits/stdc++.h>

using namespace std;


int n, s, c;

vector<int> ans;


void bump_nearer(bitset<10001>& state, int pos) {
	bitset<10001> pos_mask{};
	for(int i = 0; i < pos; i++) {
		pos_mask[i] = 1;
	}

	bitset<10001> prev = state;

	state = (prev & pos_mask) << 1;
	pos_mask[pos] = 1;
	state |= (prev & ~pos_mask) >> 1;
}


void bump_farther(bitset<10001>& state, int pos) {
	bitset<10001> pos_mask{};
	for(int i = 0; i < pos; i++) {
		pos_mask[i] = 1;
	}

	bitset<10001> prev = state;

	state = (prev & pos_mask) >> 1;
	if(prev[0] && 0 < pos) {
		state[0] = 1;
	}
	pos_mask[pos] = 1;
	state |= (prev & ~pos_mask) << 1;
	if(pos < n - 1 && (prev & ~pos_mask)[n - 1]) {
		state[n - 1] = 1;
	}
	state[n] = 0;
}


signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	cin >> n >> s >> c;


	bitset<10001> positions{};
	for(int i = 0; i < n; i++) {
		positions[i] = true;
	}

	int cycle = 0;

	while(true) {
		// for(int i = 0; i < n; i++) {
		// 	cerr << (positions[i] ? '-' : 'x');
		// }
		// cerr << endl;

		auto positions_rev = ~positions;

		vector<pair<int, int>> segments;
		int l = positions._Find_first();
		while(l < positions.size()) {
			int r = positions_rev._Find_next(l);
			segments.emplace_back(l, r);
			l = positions._Find_next(r - 1);
		}
		if(segments.empty()) {
			break;
		}


		bool scared = cycle % (s + c) < s;

		if(scared) {
			// Find the leftmost segment
			auto& [l, r] = segments[0];
			// Bump its left part
			int move = l;

			ans.push_back(move);

			bump_farther(positions, move);
		} else {
			// Find the leftmost segment
			auto& [l, r] = segments[0];
			int move;
			if(l == r) {
				// Simple, bump all of it
				move = l;
			} else {
				// Bump r-1
				move = r - 1;
			}

			ans.push_back(move);
			bump_nearer(positions, move);
		}

		cycle++;
	}


	cout << ans.size() << endl;

	for(int i: ans) {
		cout << i + 1 << " ";
	}
	cout << endl;

	return 0;
}
