#include <bits/stdc++.h>
#include "hint.h"
using namespace std;
#define vint vector<int>
#define pb push_back
#define fr first
#define sc second
vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& sol)
{
    vector<bool> hint;
    int mx = 0;
    for(int i = 0; i < a.size(); i++)
    {
        mx = max(mx, a[i]);
    }
    for(int i = 0; i < b.size(); i++)
    {
        mx = max(mx, b[i]);
    }
    if(a[i].size()+1 >= ceil(log2(mx))*sol.size()+sol.size())
    {
        hint.pb(true);
        int len = ceil(log2(mx)) + 1;
        for(int i = 0; i < sol.size(); i++)
        {
            int copy = sol[i];
            for(int j = 0; j < len; j++)
            {
                if(copy%2 == 1)
                {
                    hint.pb(true);
                }
                else
                {
                    hint.pb(false);
                }
                copy/=2;
            }
        }
        return hint;
    }
    hint.assign(a.size()+1, false);
    int now = 0;
    for(int i = 0; i < a.size(); i++)
    {
        if(now < sol.size() && a[i] == sol[now])
        {
            hint[i+1] = true;
            now++;
        }
    }
    return hint;
}
vint solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint)
{
    vint ans;
    int mx = 0;
    for(int i = 0; i < a.size(); i++)
    {
        mx = max(mx, a[i]);
    }
    for(int i = 0; i < b.size(); i++)
    {
        mx = max(mx, b[i]);
    }
    if(hint[0])
    {
        int len = ceil(log2(mx)) + 1;
        for(int i = 1; i < hint.size(); i+=len)
        {
            int now = 0;
            for(int j = 0; j < len; j++)
            {
                if(hint[i+j])
                {
                    now+=(1<<j);
                }
            }
            ans.pb(now);
        }
        return ans;
    }
    for(int i = 0; i < a.size(); i++)
    {
        if(hint[i+1])
        {
            ans.pb(a[i]);
        }
    }
    return ans;
}
/*
static int n, m, k;
static std::vector<int> a, b, sol, maybeSol;
static std::vector<bool> hint;

int main()
{
    std::cin >> n >> m;

    a.resize(n);
    b.resize(m);

    for (int& num : a)
    {
        std::cin >> num;
    }

    for (int& num : b)
    {
        std::cin >> num;
    }

    std::cin >> k;

    sol.resize(k);

    for (int& num : sol)
    {
        std::cin >> num;
    }

    hint = genHint(a, b, sol);
    maybeSol = solve(a, b, hint);

    std::cout << hint.size() << std::endl;
     for (int i = 0; i < (int) hint.size(); ++i)
    {
        if (i > 0) std::cout << " ";
        std::cout << hint[i];
    }
    std::cout << maybeSol.size() << std::endl;

    for (int i = 0; i < (int) maybeSol.size(); ++i)
    {
        if (i > 0) std::cout << " ";
        std::cout << maybeSol[i];
    }
    std::cout << std::endl;

    return 0;
}
*/
/*
9 3
1 2 3 4 5 6 7 8 9
5 0 6
2
5 6
*/
