#include <bits/stdc++.h>

using namespace std;

struct edge;

typedef pair<int, int> pii;

const int SIZE = 2e6 + 5;

int n, t[SIZE], h[SIZE], dp[SIZE][2];
pii th[SIZE];
vector<int> g[SIZE], ts;
bool used[SIZE];

void add_edge(int u, int v) {
    g[u].push_back(v);
}

void dfs(int x) {
    if(used[x]) return;
    used[x] = 1;

    for(auto i : g[x]) {
        dfs(i);
    }
    ts.push_back(x);
}

int main() {
//    ifstream cin("input.txt");

    cin >> n;
    for(int i = 0; i < n; i++) {
        cin >> t[i] >> h[i];
    }

    for(int i = 0; i < n; i++) {
        th[i] = {t[i], h[i]};
    }

    sort(th, th + n);

    for(int i = 0; i < n; i++) {
        for(int j = i + 1; j < n; j++) {
            if(th[j].first - th[i].first >= abs(th[i].second - th[j].second)) {
                add_edge(i, j);
            }
        }
    }

    for(int i = 0; i < n; i++) dfs(i);

    reverse(ts.begin(), ts.end());
    for(int i = 0; i < n; i++) used[i] = 0;
    int ans = 0;
    for(int i = 0; i < n; i++) {
        if(!used[i]) {
            ans++;
            dfs(i);
        }
    }

    cout << ans;


    return 0;
}
