#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <random>
#include <cassert>
#include <array>
#include <deque>
#include <map>
#include <set>


using namespace std;


#define ll long long
#define ld long double
#define flt double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back
#define emb emplace_back


const ll inf = 1e18;


int n;
vector<pair<ll, ll>> a;


int bin_find(vector<ll> &a, ll x) {
    int l = 0;
    int r = a.size();
    while (l + 1 < r) {
        int m = (l + r) / 2;
        if (a[m] > x) {
            l = m;
        } else {
            r = m;
        }
    }
    return l;
}


int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        ll t, h;
        cin >> t >> h;
        a[i] = make_pair(t - h, t + h);
    }
    sort(all(a));
    vector<ll> dp;
    dp.reserve(n + 1);
    dp.push_back(inf);
    for (int i = 0; i < n; ++i) {
        int x = bin_find(dp, a[i].second);
        if (x + 1 == dp.size()) {
            dp.push_back(0);
        }
        dp[x + 1] = a[i].second;
    }
    cout << (int)(dp.size()) - 1 << "\n";
    return 0;
}