#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <random>
#include <cassert>
#include <array>
#include <deque>
#include <map>
#include <set>
#include <bitset>


using namespace std;


#define ll long long
#define ld long double
#define flt double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back
#define emb emplace_back


mt19937 rnd(1312341);

const int iters = 100;

int n, s, c;
const int mxn = 1e4;





void solve(vector<int> &res) {
    int l1 = 0;
    int r1 = (n - 1) / 2;
    int l2 = r1 + 1;
    int r2 = n - 1;
    for (int i = 0; l1 <= r1 || l2 <= r2; ++i) {
        int x = i % (s + c);
        int ln1 = r1 - l1 + 1;
        int ln2 = r2 - l2 + 1;
        if (x < s) {
            if (ln1 > ln2) {
                res.push_back(r1);
                l1 -= 1;
                r1 -= 2;
                l2 += 1;
                r2 += 1;
            } else {
                res.push_back(l2);
                l1 -= 1;
                r1 -= 1;
                l2 += 2;
                r2 += 1;
            }
            l1 = max(l1, 0);
            r2 = min(r2, n - 1);
        } else {
            if (ln1 > ln2) {
                res.push_back((l1 + r1) / 2);
                l1 += 1;
                r1 -= 1;
                l2 -= 1;
                r2 -= 1;
            } else {
                res.push_back((l2 + r2) / 2);
                l2 += 1;
                r2 -= 1;
                l1 += 1;
                r1 += 1;
            }
        }
    }
}


int32_t main() {
    cin >> n >> s >> c;
    vector<int> res;
    if (s == 0) {
        for (int i = 0; i < (n + 2) / 2; ++i) {
            res.push_back(n / 2);
        }
    } 
    else{
        solve(res);
    }
    cout << res.size() << "\n";
    for (int i = 0; i < res.size(); ++i) {
        cout << res[i] + 1 << " ";
    }
    cout << "\n";
    return 0;
}