#include "hint.h"
#include <bits/stdc++.h>
using namespace std;
typedef vector<int> vi;
typedef vector<bool> vb;
#define pb push_back
std::vector<bool> genHint(const std::vector<int> &a, const std::vector<int> &b, const std::vector<int> &sol)
{
    vi tmp = a;
    if (a.size() < b.size())
        tmp = b;
    vb hint(tmp.size());
    int index = 0;
    for (int i = 0; i < sol.size(); i++)
    {
        while (tmp[index] != sol[i])
            index++;
        hint[index] = 1;
    }
    return hint;
}
std::vector<int> solve(const std::vector<int> &a, const std::vector<int> &b, const std::vector<bool> &hint)
{
    vi tmp = a;
    if (a.size() < b.size())
        tmp = b;
    vi result;
    for (int i = 0; i < tmp.size(); i++)
    {
        if (hint[i])
            result.pb(tmp[i]);
    }
    return result;
}

// static int n, m, k;
// static std::vector<int> a1, b1, sol, maybeSol;
// static std::vector<bool> hint;

// int main()
// {
//     std::cin >> n >> m;

//     a1.resize(n);
//     b1.resize(m);

//     for (int &num : a1)
//     {
//         std::cin >> num;
//     }

//     for (int &num : b1)
//     {
//         std::cin >> num;
//     }

//     std::cin >> k;

//     sol.resize(k);

//     for (int &num : sol)
//     {
//         std::cin >> num;
//     }

//     hint = genHint(a1, b1, sol);
//     maybeSol = solve(a1, b1, hint);

//     std::cout << hint.size() << std::endl;
//     std::cout << maybeSol.size() << std::endl;

//     for (int i = 0; i < (int)maybeSol.size(); ++i)
//     {
//         if (i > 0)
//             std::cout << " ";
//         std::cout << maybeSol[i];
//     }
//     std::cout << std::endl;

//     return 0;
// }
