#include <iostream>
#include <vector>
using namespace std;
int dp[1002][1002];
int let[1002][1002];
vector<int> res;
void in_h(vector<bool> &h, int tmp, int sz)
{
    int br = 0;
    while(tmp > 0)
    {
        h.push_back(tmp&1);
//        cout<<(tmp&1);
        tmp >>= 1;
        br++;
    }
    while(br < sz)
    {
        h.push_back(0);
        br++;
    }
//    cout<<endl;
}
int find_lcs(const std::vector<int>& a, int sa, int fa, const std::vector<int>& b, int sb, int fb)
{
    /// sa = 0
    for(int i=0; i<=fa-sa; i++)
    {
        for(int j=0; j<=fb-sb; j++)
        {
            dp[i][j] = 0;
        }
    }
    /// first - a[i+sa-1]
    for(int i=1; i<=(fa-sa); i++)
    {
        for(int j=1; j<=(fb-sb); j++)
        {
            if(a[i+sa-1] == b[j+sb-1])
            {
                dp[i][j] = 1+dp[i-1][j-1];
            }
            else
            {
                dp[i][j] = max(dp[i][j-1],dp[i-1][j]);
            }
        }
    }
    int row = (fa-sa);
    int col = (fb-sb);
    while(row > 0 && col > 0)
    {
        if(a[row-1] == b[col-1])
        {
            res.push_back(a[row-1]);
        }
        else if(dp[row][col] == dp[row-1][col])
        {
            row--;
        }
        else col--;
    }
}
std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol)
{
    vector<bool> h;
    vector<int> idx,idx_a,idx_b;
    int gap = sol.size()/18;
    int ptr = 0;
    for(int i=0; i<a.size(); i++)
    {
        if(ptr == sol.size()) break;
        if(a[i] == sol[ptr])
        {
            idx_a.push_back(i);
            ptr++;
        }
    }
    ptr = 0;
    for(int i=0; i<b.size(); i++)
    {
        if(ptr == sol.size()) break;
        if(b[i] == sol[ptr])
        {
            idx_b.push_back(i);
            ptr++;
        }
    }
    for(int idx = gap+1; idx<sol.size(); idx+=gap)
    {
        in_h(h,idx_a[idx],18);
        in_h(h,idx_b[idx],18);
    }
    return h;
}
std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint)
{
    vector<int> idx_a;
    vector<int> idx_b;
    for(int i=0; i<hint.size(); i+=36)
    {
        int tmp = 0;
        for(int j=17; j>=0; j--)
        {
            tmp <<= 1;
            tmp += hint[i+j];
        }
        idx_b.push_back(tmp);
        tmp = 0;
        for(int j=17; j>=0; j--)
        {
            tmp <<= 1;
            tmp += hint[i+j];
        }
        idx_a.push_back(tmp);
    }
    int sz = idx_a.size();
    int prev_a = 0;
    int prev_b = 0;
    for(int i=0; i<sz; i++)
    {
        find_lcs(a, prev_a, idx_a[i], b, prev_b, idx_b[i]);
        res.push_back(a[idx_a[i]]);
        prev_a  = idx_a[i];
        prev_b = idx_b[i];
    }
}
static int n, m, k;
static std::vector<int> a, b, sol, maybeSol;
static std::vector<bool> hint;
int main()
{
    std::cin >> n >> m;

    a.resize(n);
    b.resize(m);

    for (int& num : a)
    {
        std::cin >> num;
    }

    for (int& num : b)
    {
        std::cin >> num;
    }

    std::cin >> k;

    sol.resize(k);

    for (int& num : sol)
    {
        std::cin >> num;
    }

    hint = genHint(a, b, sol);
    maybeSol = solve(a, b, hint);

    std::cout << hint.size() << std::endl;
    std::cout << maybeSol.size() << std::endl;

    for (int i = 0; i < (int) maybeSol.size(); ++i)
    {
        if (i > 0) std::cout << " ";
        std::cout << maybeSol[i];
    }
    std::cout << std::endl;

    return 0;
}
/**
6 5
1 5 4 3 2 10
6 3 7 10 2
2
3 2
*/
