#include <bits/stdc++.h>
using namespace std;

const int maxn = 1e3+3;
int n;
pair <int, int> a [maxn];
int edges [maxn][maxn];
bool vis [maxn], curr_vis [maxn];
int cnt = 0;

bool dfs (int i, int st){
    vis [i] = 1;
    curr_vis [i] = 1;
    for (int j = 0; j < n; j ++){
        if (!vis [j] && edges [i][j] == 1){
            if (j == st) cnt --;
            else if (curr_vis [j]) continue;
            else dfs (j, st);
            edges [i][j] = -1;
            edges [j][i] = 1;
            curr_vis [i] = 0;
            return 1;
        }
    }
    for (int j = 0; j < n; j ++){
        if (edges [i][j] == 1){
            bool success = 0;
            if (j == st) cnt --, success = 1;
            else if (curr_vis [j]) continue;
            else success = dfs (j, st);
            if (success){
                edges [i][j] = -1;
                edges [j][i] = 1;
                curr_vis [i] = 0;
                return 1;
            }
        }
    }
    return 0;
}

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

    cin >> n;
    for (int i = 0; i < n; i ++){
        cin >> a [i].first >> a [i].second;
    }
    sort (a, a + n);
    for (int i = 0; i < n; i ++){
        for (int j = i + 1; j < n; j ++){
            if (abs (a [i].second - a [j].second) <= a [j].first - a [i].first) edges [i][j] = 1, edges [j][i] = -1;
        }
    }
    for (int i = 0; i < n; i ++){
        if (!vis [i]){
            cnt ++;
            dfs (i, i);
        }
    }
    cout << cnt << '\n';

}