#include <bits/stdc++.h>
using namespace std;
#ifndef LOCAL
#define cerr if(false) cerr
#endif
#define endl "\n"
typedef long long ll;
template<class T, class T2> inline ostream &operator <<(ostream &out, const pair<T, T2> &x) { out << x.first << " " << x.second; return out;}
template<class T, class T2> inline bool chkmax(T &x, const T2 &y) { return x < y ? x = y, 1 : 0; }
template<class T, class T2> inline bool chkmin(T &x, const T2 &y) { return x > y ? x = y, 1 : 0; }
const ll mod = 1e9 + 7;

const int MAX_N = 2e5 + 10;
const int LOG = 16;
const int BIG = 1;
const int BUCKET_CNT = 1000;
const int BUCKET_SIZE = 3000;

void decompose(int x, vector<bool> &ret) {
    for(int i = 0; i < LOG; i ++) {
        ret.push_back(x % 2);
        x /= 2;
    }
}

int get(vector<bool> &ret) {
    int ans = 0;
    for(int i = 0; i < LOG; i ++) {
        if(ret.back()) {
            ans += 1 << i;
        }
        ret.pop_back();
    }
    return ans;
}

int bucket[MAX_N];

vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& sol) {
    vector<bool> ret = {};
    int where = 0;
    for(int i = 0; i < a.size(); i ++) {
        if(a[i] == sol[where]) {
            ret.push_back(1);
            where ++;
        } else {
            ret.push_back(0);
        }
        if(where >= sol.size()) {break;}
    }
    return ret;
}

vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint1) {
    vector<int> ans = {};
    for(int i = 0; i < a.size(); i ++) {
        if(hint1[i]) {
            ans.push_back(a[i]);
        }
    }
    return ans;
}
