#include "hint.h"
std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol)
{
	std::vector<bool> hint(a.size(),false);
	int t=0;
	for(int i=0;i<a.size();i++)
		if(sol[t]==a[i])
		{
			hint[i]=true;
			t++;
		}
	return hint;
}
std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint)
{
	std::vector<int> sol;
	for(int i=0;i<hint.size();i++)
		if(hint[i])
			sol.push_back(a[i]);
	return sol;
}