#include "hint.h"
std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol)
{
	const std::vector<int> *smaller;

	if(a.size()<=b.size())smaller=&a;
	else smaller=&b;

	std::vector<bool> hint;
	int t=0;
	for(int i=0;i<smaller->size();i++)
		if(sol[t]==smaller->at(i))
		{
			hint.push_back(true);
			t++;
			if(t==sol.size())break;
		}
		else hint.push_back(false);
	return hint;
}
std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint)
{
	const std::vector<int> *smaller;

	if(a.size()<=b.size())smaller=&a;
	else smaller=&b;

	std::vector<int> sol;
	for(int i=0;i<hint.size();i++)
		if(hint[i])
			sol.push_back(smaller->at(i));
	return sol;
}