#include<bits/stdc++.h>
using namespace std;
const int MAXN=1e6+6;
struct point
{
	int x,y;
	bool operator<(point const& other)const
	{
		if(x!=other.x)return x<other.x;
		else return y<other.y;
	}
};
vector<point>v;
int n,cntx,cnty;
vector<pair<int,int> >xs,ys;
vector<point>points[MAXN];
struct BIT
{
	int tree[MAXN];
	void update(int idx,int val)
	{
		++idx;
		for(;idx<MAXN;idx+=idx&(-idx))
		{
			tree[idx]=max(tree[idx],val);
		}
	}
	int query(int idx)
	{
		++idx;
		int ret=0;
		for(;idx>0;idx-=idx&(-idx))
		{
			ret=max(tree[idx],ret);
		}
		return ret;
	}
}fen;
int maxdp;
int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	cin>>n;
	for(int i=1;i<=n;++i)
	{
		int t,h;
		cin>>t>>h;
		v.push_back({h+t,h-t});
		xs.push_back({h+t,i-1});
		ys.push_back({h-t,i-1});
	}
	sort(xs.begin(),xs.end());
	sort(ys.begin(),ys.end());
	for(int i=0;i<xs.size();++i)
	{
		if(i==0||xs[i].first!=xs[i-1].first)cntx++;
		v[xs[i].second].x=cntx;
	}
	for(int i=0;i<ys.size();++i)
	{
		if(i==0||ys[i].first!=ys[i-1].first)cnty++;
		v[ys[i].second].y=cnty;
	}
	/*cout<<"mapx:\n";
	for(auto xd:mapx)
	{
		cout<<xd.first<<" "<<xd.second<<endl;
	}
	cout<<"mapy:\n";
	for(auto xd:mapy)
	{
		cout<<xd.first<<" "<<xd.second<<endl;
	}
	cout<<endl<<endl;*/
	//sort(v.begin(),v.end());
	for(int i=0;i<v.size();++i)
	{
		//cout<<v[i].x<<" "<<v[i].y<<endl;
		points[v[i].x].push_back(v[i]);
	}
	vector<pair<int,int> >new_dps;
	for(int i=1;i<=cntx;++i)
	{
		//stable_sort(points[i].begin(),points[i].end());
		new_dps.clear();
		for(auto p:points[i])
		{
			int dp1=fen.query(p.y-1)+1;
			//cout<<p.x<<" "<<p.y<<" "<<dp1<<endl;
			new_dps.push_back({p.y,dp1});
			maxdp=max(maxdp,dp1);
		}
		for(auto xd:new_dps)
		{
			fen.update(xd.first,xd.second);
		}
	}
	cout<<maxdp<<'\n';
return 0;
}
