#include<iostream>
#include<vector>
#include<stack>
#include "hint.h"
using namespace std;

const int MAXN=1e4;

int dp[MAXN+1][MAXN+1];

vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& sol)
{
    vector<bool> res;

    if(a.size()<b.size())
    {
        res.push_back(true);

        int idx=0;
        for(int i=0; i<a.size() && idx<sol.size(); i++)
        {
            if(sol[idx]==a[i])
            {
                res.push_back(true);
                idx++;
            }
            else
            {
                res.push_back(false);
            }
        }
    }
    else
    {
        res.push_back(false);

        int idx=0;
        for(int i=0; i<b.size() && idx<sol.size(); i++)
        {
            if(sol[idx]==b[i])
            {
                res.push_back(true);
                idx++;
            }
            else
            {
                res.push_back(false);
            }
        }
    }

    return res;
}

vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint)
{
    vector<int> res;

    if(hint[0])
    {
        for(int i=1; i<hint.size(); i++)
        {
            if(hint[i])
            {
                res.push_back(a[i-1]);
            }
        }
    }
    else
    {
        for(int i=1; i<hint.size(); i++)
        {
            if(hint[i])
            {
                res.push_back(b[i-1]);
            }
        }
    }

    return res;
}
/*
5 6
1 2 9 3 3
1 9 9 7 8 3
3
1 9 3
*/


