#include<iostream>
#include<vector>
using namespace std;

vector<int> ans;

int GetType(int s, int c)
{
    int n=(ans.size())%(s+c);

    if(n>=s)
    {
        return 2;
    }

    return 1;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, s, c;
    cin >> n >> s >> c;

    int l=1, r=n;
    while(l<r)
    {
        int t=GetType(s, c);

        if(t==1)
        {
            ans.push_back(r);
            r--;
            l=max(l-1, 1);
        }
        else
        {
            int mid=l+(r-l)/2;
            ans.push_back(mid);

            if(r>mid)
            {
                r--;
            }

            if(l<mid)
            {
                l++;
            }
        }
    }

    if(l==r)
    {
        ans.push_back(l);
    }

    cout << ans.size() << "\n";
    for(int x:ans)
    {
        cout << x << " ";
    }
    cout << "\n";

    return 0;
}
