#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#define endl '\n'

using namespace std;

const int maxn = 1e3 + 3; 

int n; 
pair <int, int> a[maxn];
void read()
{
	cin >> n;
	for (int i = 1; i <= n; i++)
	cin >> a[i].first >> a[i].second;
}

bool is[maxn][maxn];
int deg[maxn];
int dist[maxn], cnt[maxn];
void solve()
{
	sort (a + 1, a + n + 1);
	for (int i = 1; i <= n; i++)
	for (int j = i + 1; j <= n; j++)
	if (a[j].first - a[i].first >= abs(a[i].second - a[j].second))
	is[i][j] = true, deg[j]++;
	
	for (int i = 1; i <= n; i++)
	for (int j = n; j >= 1; j--)
	if (is[i][j])
	for (int k = i + 1; k <= j-1; k++)
	if (is[i][k] && is[k][j])
	is[i][j] = false, deg[j]--;
	
	queue <int> q;
	for (int i = 1; i <= n; i++)
	if (deg[i] == 0)
	{
		q.push(i);
		dist[i] = 1; 
		cnt[1]++;
	}
	
	while (!q.empty())
	{
		int ver = q.front();
		q.pop();
		
		for (int i = ver + 1; i <= n; i++)
		if (!dist[i] && is[ver][i])
		{
			dist[i] = dist[ver] + 1;
			cnt[dist[i]]++;
		    q.push(i);
		}
	}
	
	//~ for (int i = 1; i <= n; i++)
	//~ cout << dist[i] << " " << i << endl;  
	
	int ans = 0;
	for (int i = 1; i <= n; i++)
	ans = max(ans, cnt[i]);
	
	cout << ans << endl; 
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	
	read();
	solve();
}
