#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#define endl '\n'

using namespace std;

const int maxn = 1e3 + 3; 

int n; 
pair <int, int> a[maxn];
void read()
{
	cin >> n;
	for (int i = 1; i <= n; i++)
	cin >> a[i].first >> a[i].second;
}

vector <int> adj[maxn];
bool used[maxn];
int r[maxn];
bool kuhn(int ver)
{
	for (auto i: adj[ver])
	{
		if (used[i])
		continue;
		
		used[i] = true; 
		if (r[i] == -1 || kuhn(r[i]))
		{
			r[i] = ver;
			return true;
		}
	}
	
	return false;
}

void solve()
{
	sort (a + 1, a + n + 1);
	for (int i = 1; i <= n; i++)
	for (int j = i + 1; j <= n; j++)
	if (a[j].first - a[i].first >= abs(a[i].second - a[j].second))
	adj[i].push_back(j);
	
	memset(r, -1, sizeof(r));
	int ans = 0;
	for (int i = 1; i <= n; i++)
	{
		memset(used, false, sizeof(used));
		ans += kuhn(i);
	}
	
	cout << n - ans << endl; 
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	
	read();
	solve();
}
