#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#define endl '\n'

using namespace std;

const int maxn = 1e4 + 3; 

int n; 
pair <int, int> a[maxn];
void read()
{
	cin >> n;
	for (int i = 1; i <= n; i++)
	cin >> a[i].first >> a[i].second;
}

int used[maxn];
int r[maxn];
bool kuhn(int ver, int idx)
{
	for (int i = ver + 1; i <= n; i++)
	if (a[i].first - a[ver].first >= abs(a[i].second - a[ver].second))
	{
		if (used[i] == idx)
		continue;
		
		used[i] = idx; 
		if (r[i] == -1 || kuhn(r[i], idx))
		{
			r[i] = ver;
			return true;
		}
	}
	
	return false;
}

void solve()
{
	sort (a + 1, a + n + 1);
	
	memset(r, -1, sizeof(r));
	int ans = 0;
	for (int i = 1; i <= n; i++)
		ans += kuhn(i, i);
	
	cout << n - ans << endl; 
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	
	read();
	solve();
}
