#include <algorithm>
#include <iostream>
#include <vector>
#include "hint.h"
#define endl '\n'
using namespace std;

const int MAXN = 10000;

vector<int> A, B, ans;
int dp[MAXN + 5][MAXN + 5];
int dir[MAXN + 5][MAXN + 5];

vector<bool> genHint(const std::vector<int>& a, const vector<int>& b, const vector<int>& sol)
{
    vector<bool> hint;
    return hint;
}

void gen(int i, int j)
{
    if (i == 0 or j == 0) return;
    if (dir[i][j] == 2)
    {
        ans.push_back(A[i - 1]);
        gen(i - 1, j - 1);
    }
    else if (dir[i][j] == 1) gen(i - 1, j);
    else gen(i, j - 1);
}

vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint)
{
    int n = a.size(), m = b.size();

    A = a;
    B = b;

    for (int j = 0; j <= m; ++ j)
    {
        dp[0][j] = 0;
    }

    for (int i = 0; i <= n; ++ i)
    {
        dp[i][0] = 0;
    }

    for (int i = 1; i <= n; ++ i)
    {
        for (int j = 1; j <= m; ++ j)
        {
            dp[i][j] = -1;
            if (a[i - 1] == b[j - 1])
            {
                dp[i][j] = dp[i - 1][j - 1] + 1;
                dir[i][j] = 2;
            }

            if (dp[i - 1][j] > dp[i][j])
            {
                dp[i][j] = dp[i - 1][j];
                dir[i][j] = 1;
            }

            if (dp[i][j - 1] > dp[i][j])
            {
                dp[i][j] = dp[i][j - 1];
                dir[i][j] = 3;
            }
        }
    }

    gen(n, m);

    reverse(ans.begin(), ans.end());
    return ans;
}
