#include <iostream>
#include <vector>
#include "hint.h"
#define endl '\n'
using namespace std;

const int MAXN = 200000;

vector<bool> genHint(const std::vector<int>& a, const vector<int>& b, const vector<int>& sol)
{
    vector<bool> hint1;
    hint1.push_back(0);
    int j = 0;
    for (int i = 0; i < sol.size(); ++ i)
    {
        while (a[j] != sol[i])
        {
            hint1.push_back(0);
            j++;
        }
        hint1.push_back(1);
        j++;
    }

    vector<bool> hint2;
    hint2.push_back(1);
    j = 0;
    for (int i = 0; i < sol.size(); ++ i)
    {
        while (b[j] != sol[i])
        {
            hint2.push_back(0);
            j++;
        }
        hint2.push_back(1);
        j++;
    }

    if (hint1.size() < hint2.size()) return hint1;
    return hint2;
}

vector<int> solve(vector<int> a, vector<int> b, const vector<bool>& hint)
{
    vector<int> sol;

    if (hint[0] == 1) swap(a, b);

    for (int i = 1; i < hint.size(); ++ i)
    {
        if (hint[i] == 1) sol.push_back(a[i - 1]);
    }

    return sol;
}
