#include <algorithm>
#include <iostream>
#include <vector>
#include "hint.h"
#define endl '\n'
using namespace std;

const int MAXN = 200000;

vector<int> A, B;

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol)
{
    vector<bool> hint00;
    hint00.push_back(0);
    hint00.push_back(0);
    int j = 0;
    for (int i = 0; i < sol.size(); ++ i)
    {
        while (a[j] != sol[i])
        {
            hint00.push_back(0);
            j++;
        }
        hint00.push_back(1);
        j++;
    }

    vector<bool> hint01;
    hint01.push_back(0);
    hint01.push_back(1);
    j = a.size() - 1;
    for (int i = sol.size() - 1; i >= 0; -- i)
    {
        while (a[j] != sol[i])
        {
            hint01.push_back(0);
            j--;
        }
        hint01.push_back(1);
        j--;
    }

    vector<bool> hint10;
    hint10.push_back(1);
    hint10.push_back(0);
    j = 0;
    for (int i = 0; i < sol.size(); ++ i)
    {
        while (b[j] != sol[i])
        {
            hint10.push_back(0);
            j++;
        }
        hint10.push_back(1);
        j++;
    }

    vector<bool> hint11;
    hint11.push_back(1);
    hint11.push_back(1);
    j = b.size() - 1;
    for (int i = sol.size() - 1; i >= 0; -- i)
    {
        while (b[j] != sol[i])
        {
            hint11.push_back(0);
            j--;
        }
        hint11.push_back(1);
        j--;
    }

    if (hint00.size() < min(hint01.size(), min(hint10.size(), hint11.size()))) return hint00;
    if (hint01.size() < min(hint00.size(), min(hint10.size(), hint11.size()))) return hint01;
    if (hint10.size() < min(hint11.size(), min(hint00.size(), hint01.size()))) return hint10;
    return hint11;
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint)
{
    vector<int> sol;

    A = a;
    B = b;

    if (hint[0]) swap(A, B);
    if (hint[1]) reverse(A.begin() + 2, A.end());

    for (int i = 2; i < hint.size(); ++ i)
    {
        if (hint[i] == 1) sol.push_back(A[i - 2]);
    }

    if (hint[1]) reverse(sol.begin(), sol.end());

    return sol;
}
