#include <algorithm>
#include <iostream>
#include <utility>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 1000000;

int lis[MAXN + 5];
pair<int, int> d[MAXN + 5];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    cin >> n;

    for (int i = 1; i <= n; ++ i)
    {
        cin >> d[i].first >> d[i].second;
    }

    sort(d + 1, d + n + 1);

    vector<int> v;
    for (int i = 1; i <= n; ++ i)
    {
        v.push_back(d[i].first - d[i].second);
    }

    reverse(v.begin(), v.end());

    int cnt = 1;
    lis[1] = v[0];
    for (int i = 1; i < n; ++ i)
    {
        if (v[i] < lis[1]) lis[1] = v[i];
        else if (v[i] > lis[cnt])
        {
            cnt++;
            lis[cnt] = v[i];
        }
        else
        {
            int p = lower_bound(lis + 1, lis + cnt + 1, v[i]) - lis;
            lis[p] = v[i];
        }
    }

    cout << cnt << endl;

    return 0;
}
