#include <algorithm>
#include <iostream>
#include <utility>
#include <vector>
#include <cmath>
#define endl '\n'
using namespace std;

const int MAXN = 1000000;

int deg[MAXN + 5];
pair<int, int> d[MAXN + 5];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    cin >> n;

    for (int i = 1; i <= n; ++ i)
    {
        cin >> d[i].first >> d[i].second;
    }

    sort(d + 1, d + n + 1);

    int cnt = 0;
    for (int i = 1; i <= n; ++ i)
    {
        if (deg[i] == 0) cnt++;
        for (int j = i + 1; j <= n; ++ j)
        {
            if (d[j].first - d[i].first >= abs(d[j].second - d[i].second)) deg[j]++;
        }
    }

    cout << cnt << endl;

    return 0;
}
