#include <iostream>
#include <vector>

#include "hint.h"

using namespace std;

vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& res) {
    int n = (int) b.size();
    int m = (int) res.size();

    vector<bool> hint(n, false);
    int k = 0;

    for (int i = 0; i < n and k < m; ++i) {
        if (b[i] == res[k]) {
            hint[i] = true;
            ++k;
        }
    }

    return hint;
}

vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint) {
    int n = (int) b.size();

    vector<int> res;
    for (int i = 0; i < n; ++i) {
        if (hint[i]) {
            res.push_back(b[i]);
        }
    }

    return res;
}