#include <iostream>
#include <vector>
#include <algorithm>

#include "hint.h"

using namespace std;

vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& res) {
    return {};
}

vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint) {
    int n = (int) a.size();
    int m = (int) b.size();

    vector<vector<int>> dp(n + 3, vector<int>(m + 3, 0));

    for (int i = 1; i <= n; ++i) {
        for (int j = 1; j <= m; ++j) {
            if (a[i - 1] == b[j - 1]) {
                dp[i][j] = dp[i - 1][j - 1] + 1;
            } else {
                dp[i][j] = max(dp[i][j - 1], dp[i - 1][j]);
            }
        }
    }
    
    vector<int> res;
    int i = n, j = m;

    while (i > 0 and j > 0) {
        if (dp[i - 1][j - 1] + 1 == dp[i][j]) {
            res.push_back(a[i - 1]);
            --i;
            --j;
        } else if (dp[i - 1][j] == dp[i][j]) {
            --i;
        } else {
            --j;
        }
    }

    reverse(res.begin(), res.end());

    return res;
}