#include<bits/stdc++.h>
using namespace std;

const int nmax=1e4+42;

int n,s,c;

vector< pair<int/*left*/,int/*right*/> > active,help;

vector<int> outp;

int eval(int n,int s,int c)
{
    return n*(s+c)/(s+2*max(s,c))+3*max(s,c);
}

int get_at(int pos)
{
    for(auto w:active)
    {
        int SZ=w.second-w.first+1;

        //cout<<"pos= "<<pos<<" "<<SZ<<endl;

        if(pos>SZ)pos=pos-SZ;
        else
        {
            if(s==c)return w.first;

            int l=w.first;
            int av=(w.first+w.second)/2;
            int r=w.second;

            int actual=w.first+pos-1;

            int dist_l=abs(l-actual);
            int dist_av=abs(av-actual);
            int dist_r=abs(r-actual);

            if(dist_l<=dist_av&&dist_l<=dist_r)return l;
            if(dist_av<=dist_l&&dist_av<=dist_r)return av;
            return r;
        }
    }

    return -1;
}

pair<int,int> add(pair<int,int> cur)
{
    cur.first=min(cur.first+1,n);
    cur.second=min(cur.second+1,n);

    return cur;
}

pair<int,int> sub(pair<int,int> cur)
{
    cur.first=max(cur.first-1,1);
    cur.second=max(cur.second-1,1);

    return cur;
}

void apply_left(pair<int,int> w,int type_day)
{
    if(w.first>w.second)return;

    if(type_day==1)w=sub(w);
    else w=add(w);

    if(help.size()&&help.back().second+1>=w.first)help.back().second=w.second;
    else help.push_back(w);
}

void apply_right(pair<int,int> w,int type_day)
{
    if(w.first>w.second)return;

    if(type_day==1)w=add(w);
    else w=sub(w);

    if(help.size()&&help.back().second+1>=w.first)help.back().second=w.second;
    else help.push_back(w);
}


void apply(int add,int type_day)
{
    help={};

    outp.push_back(add);

    for(auto w:active)
    {
        int l=w.first;
        int r=w.second;

        if(r<add)
        {
            apply_left(w,type_day);
        }

        else if(add<l)
        {
            apply_right(w,type_day);
        }
        else
        {
            //add is in [l, r]
            apply_left({w.first,add-1},type_day);
            apply_right({add+1,w.second},type_day);
        }
    }

    active=help;

    //cout<<"added "<<add<<" -> ";for(auto w:active)cout<<w.first<<" "<<w.second<<"\t";cout<<endl;
}

int main()
{
    scanf("%i%i%i",&n,&s,&c);

    active.push_back({1,n});

    for(int day=1;active.size();day++)
    {
        //cout<<"day= "<<day<<" active= ";for(auto w:active)cout<<w<<" ";cout<<endl;

        int remain=0;
        for(auto w:active)remain+=w.second-w.first+1;

        int add=get_at((remain+1)/2);

        //cout<<"remain= "<<remain<<" add= "<<add<<endl;

        int type_day=1;

        if(c>0&&(day-1)%(s+c)>=s)type_day=0;

        if(type_day==0)
        {
            for(auto w:active)
                if(w.first<w.second)
                {
                    add=w.first+1;
                    break;
                }
        }

        apply(add,type_day);
    }

    printf("%i\n",outp.size());
    for(auto w:outp)printf("%i ",w);
    printf("\n");

    //cout<<eval(n,s,c)<<endl;

    return 0;
}
