#include "hint.h"
#include<bits/stdc++.h>
#pragma GCC optimize ("Ofast")
#pragma GCC target ("avx2")
#define endl "\n"

using namespace std;

//const int N = 200010;

std::vector<bool> to_bin(int n)
{
    std::vector<bool> v, k;
    while(n)
    {
        v.push_back(n % 2);
        n /= 2;
    }
    for(int i = (int)v.size(); i <= 19; ++i) k.push_back(0);
    for(int i = 0; i < (int)k.size(); ++i) v.push_back(k[i]);
    return v;
}

int to_dec(std::vector<int> v)
{
    int d = 0;
    for(int i = 0, j = 18; i < 19; ++i, --j)
    {
        if(v[i]) d += (1 << i);
    }
    return d;
}

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol)
{
    std::vector<bool> h, p;
    for(int i = 0; i < (int)sol.size(); ++i)
    {
        p = to_bin(sol[i]);
        for(int j = 0; j < 19; ++j) h.push_back(p[j]);
    }
    return h;
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint)
{
    std::vector<int> d, v;
    for(int i = 0; i < (int)hint.size(); i += 19)
    {
        d.clear();
        for(int j = i; j < i + 19; ++j) d.push_back(hint[j]);
        v.push_back(to_dec(d));
    }
    return v;
}

