#include <iostream>
#include <cstdio>
#include <algorithm>
#include <limits.h>
#include <vector>
using namespace std;
vector<pair<int,int> > queries;
vector<pair<int,int> > trucks;
int N;

int R(int index/*,vector<pair<int,int> > trucks*/)//first-timestamp second-pos
{
	if(index==queries.size())return trucks.size();
	bool available=false;
	int mintrucks=INT_MAX;
	for(int i=0;i<trucks.size();i++)
	{
		if(queries[index].first-trucks[i].first>=abs(queries[index].second-trucks[i].second))
		{
			available=true;
			pair<int,int> temp=trucks[i];
			trucks[i]=queries[index];
			mintrucks=min(R(index+1),mintrucks);
			trucks[i]=temp;
		}
	}
	if(!available)
	{
		trucks.push_back(queries[index]);
		mintrucks=min(R(index+1),mintrucks);	
	}
	return mintrucks;
}

int solve()
{
	return R(0);
}

void init()
{
	pair<int,int> temp;
	scanf("%d",&N);
	for(int i=0;i<N;i++)
	{
		scanf("%d%d",&temp.first,&temp.second);
		queries.push_back(temp);
	}
	sort(queries.begin(),queries.end());
}

int main()
{
	init();
	cout<<solve()<<endl;
}