#include <iostream>
#include <cstdio>
#include <algorithm>
#include <limits.h>
#include <vector>
using namespace std;
vector<pair<int,int> > queries;
vector<pair<int,int> > trucks;
int N;
int MIN=INT_MAX;

void Print(int index)
{
	cout<<endl<<endl;
	cout<<"------"<<queries[index].first<<"  "<<queries[index].second<<"-------"<<endl;
	for(int i=0;i<trucks.size();i++)
		cout<<trucks[index].first<<"  "<<trucks[index].second<<endl;
}

int R(int index/*,vector<pair<int,int> > trucks*/)//first-timestamp second-pos
{
//	Print(index);	
	if(index==queries.size())
	{
		MIN=trucks.size();
		return trucks.size();
	}
	if(trucks.size()>=MIN)return MIN;
	bool available=false;
	int mintrucks=INT_MAX;
	for(int i=0;i<trucks.size();i++)
	{
		if(queries[index].first-trucks[i].first>=abs(queries[index].second-trucks[i].second))
		{
			available=true;
			pair<int,int> temp=trucks[i];
			trucks[i]=queries[index];
			if(trucks.size()>=MIN)return MIN;
			int calc=R(index+1);
			if(calc==trucks.size())return trucks.size();
			mintrucks=min(calc,mintrucks);
			trucks[i]=temp;
		}
	}
	if(!available)
	{
		if(trucks.size()>=MIN)return MIN;
	
		int pos=trucks.size();
		trucks.push_back(queries[index]);
		mintrucks=min(R(index+1),mintrucks);	
		trucks.erase(trucks.begin()+pos);
	}
	return mintrucks;
}

int solve()
{
	return R(0);
}

void init()
{
	pair<int,int> temp;
	scanf("%d",&N);
	for(int i=0;i<N;i++)
	{
		scanf("%d%d",&temp.first,&temp.second);
		queries.push_back(temp);
	}
	sort(queries.begin(),queries.end());
}

int main()
{
	init();
	cout<<solve()<<endl;
}