#include <bits/stdc++.h>
#include "hint.h"

#pragma GCC optimize "-O3"

#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol) {
    std::vector<int> f = a, s = b;

    if (f.size() > s.size()) {
        std::swap(f, s);
    }

    std::vector<bool> hint(f.size(), false);
    int pos = 0;
    for (int i = 0; i < (int)f.size() && pos < sol.size(); i++) {
        if (f[i] == sol[pos]) {
            hint[i] = true;
            pos++;
        }
    }

    return hint;
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint) {
    std::vector<int> f = a, s = b;

    if (f.size() > s.size()) {
        std::swap(f, s);
    }

    std::vector<int> sol;
    for (int i = 0; i < f.size(); i++) {
        if (hint[i]) {
            sol.emplace_back(f[i]);
        }
    }

    return sol;
}
