#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int n;
vector<pair<int, int>> orders;

void read() {
    cin >> n;

    orders.resize(n);
    for (auto &order : orders) {
        cin >> order.first >> order.second;
    }
}

void solve() {
    sort(orders.begin(), orders.end());

    int answer = 0;
    vector<bool> taken(n, false);
    for (int i = 0; i < n; i++) {
        if (taken[i]) {
            continue;
        }

        answer++;
        taken[i] = true;
        pair<int, int> last = orders[i];
        for (int j = i + 1; j < n; j++) {
            if (taken[j]) {
                continue;
            }

            if (abs(last.first - orders[j].first) == 1 && abs(last.second - orders[j].second) == 1) {
                taken[j] = true;
                last = orders[j];
                continue;
            }

            if (last.second == orders[j].second) {
                taken[j] = true;
                last = orders[j];
                continue;
            }
        }
    }

    cout << answer << endl;
}

int main() {
    setIO();

    read();

    solve();
}
