#include "hint.h"

std::vector<bool> genHint(const std::vector<int>& a,
                          const std::vector<int>& b,
                          const std::vector<int>& sol) {
    std::vector<bool> res;
    res.reserve(15 * sol.size());

    for (auto i = 0; i < sol.size(); ++i) {
        auto val = sol[i];
        for (auto i = 0; i < 15; ++i) {
            res.push_back(val & 1);
            val >>= 1;
        }
    }

    return res;
}

std::vector<int> solve(const std::vector<int>& a,
                       const std::vector<int>& b,
                       const std::vector<bool>& hint) {
    std::vector<int> res;
    res.reserve(hint.size() / 15);

    for (auto i = 0; i < hint.size(); i += 15) {
        auto curr = 0;
        for (auto j = i + 14; j >= i; --j) {
            curr <<= 1;
            curr |= hint[j];
        }

        res.push_back(curr);
    }

    return res;
}
