#include "hint.h"
#include <iostream>
using namespace std;
vector<bool>  genHint(const vector<int>&  a,  const vector<int>&  b, const vector<int>& sol) {
    vector <bool> ans;
    int ind;
    if (a.size()>10000 || b.size()>10000) {
        ind=0;
        if (a.size()<b.size()) {
            for (auto i:a) {
                if (ind<sol.size() && sol[ind]==i) {
                    ans.push_back(1);
                    ind++;
                } else ans.push_back(0);
            }
        } else {
            for (auto i:b) {
                if (ind<sol.size() && sol[ind]==i) {
                    ans.push_back(1);
                    ind++;
                } else ans.push_back(0);
            }
        }
    } else {
        int k=sol.size();
        while (k>0) {
            ans.push_back(k%2);
            k/=2;
        }
    }
    return ans;
}
const int MAXN=1e4+10;
short dp[MAXN][MAXN][2];
vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint) {
    vector <int> ans;
    if (a.size()>10000 || b.size()>10000) {
        if (a.size()<b.size()) {
            for (int i=0;i<a.size();i++) {
                if (hint[i]==1) ans.push_back(a[i]);
            }
        } else {
            for (int i=0;i<b.size();i++) {
                if (hint[i]==1) ans.push_back(b[i]);
            }
        }
    } else {
        int num=0;
        for (int i=hint.size()-1;i>=0;i--) num=num*2+hint[i];
        for (int i=1;i<=a.size();i++) {
            dp[i][0][0]=0;
            dp[i][0][1]=-2;
        }
         for (int i=1;i<=b.size();i++) {
            dp[0][i][0]=0;
            dp[0][i][1]=-2;
        }
        for (int i=1;i<=a.size();i++) {
            for (int j=1;j<=b.size();j++) {
                dp[i][j][0]=dp[i-1][j][0];
                dp[i][j][1]=1;
                if (dp[i][j][0]<dp[i][j-1][0]) {
                    dp[i][j][0]=dp[i][j-1][0];
                    dp[i][j][1]=-1;
                }
                if (b[j-1]==a[i-1]) {
                    if (dp[i][j][0]<dp[i-1][j-1][0]+1) {
                        dp[i][j][0]=dp[i-1][j-1][0]+1;
                        dp[i][j][1]=2;
                    }
                }
            }
        }
        int br1, br2;
        br1=a.size(); br2=b.size();
        while (true) {
            if (dp[br1][br2][0]==0) break;
            if (dp[br1][br2][1]==-1) br2--;
            else if (dp[br1][br2][1]==1) br1--;
            else if (dp[br1][br2][1]==2) {
                ans.push_back(a[br1-1]);
                br1--; br2--;
            }
        }
        if (ans.size()!=num) cout << 1/0 << endl;
        for (int i=0;i<ans.size()/2;i++) swap(ans[i],ans[ans.size()-i-1]);
    }
    return ans;
}
