#include <iostream>
#include <algorithm>
using namespace std;
const int MAXN=1e6+10;
struct House {
    int t, pl;
};
House p[MAXN];
int in[MAXN], out[MAXN];
bool cmp(House a, House b) {
    return a.t<b.t;
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    for (int i=1;i<=n;i++) cin >> p[i].t >> p[i].pl;
    sort(p+1,p+n+1,cmp);
    int diff;
    for (int i=1;i<=n;i++) {
        for (int j=i-1;j>=1;j--) {
            diff=p[i].pl-p[j].pl;
            if (diff<0) diff=-diff;
            if (diff<=p[i].t-p[i].pl) {
                in[i]++;
                out[j]++;
            }
        }
    }
    int s1, s2;
    s1=s2=0;
    for (int i=1;i<=n;i++) {
        if (out[i]==0) {
            ///cout << "out " << p[i].t << ' ' << p[i].pl << endl;
            s1++;
        }
        if (in[i]==0) {
            ///cout << "in " << p[i].t << ' ' << p[i].pl << endl;
            s2++;
        }
    }
    cout << max(s1,s2) << endl;
    return 0;
}
