#include <iostream>
#include "hint.h"

using namespace std;

vector<bool> genHint(const vector<int>& a, const vector<int>& b,
                          const vector<int>& sol) {
    vector<bool> hint;
    if (a.size() > b.size()) return hint;
    int iA = 0;
    int iSol = 0;

    bool generator;

    while (iSol != sol.size()) {
        if (a[iA] == sol[iSol]) {
            iSol++;
            generator = true;
        } else {
            generator = false;
        }

        hint.push_back(generator);
        iA++;
    }

    return hint;
 }

 vector<int> solve(const vector<int>& a, const vector<int>& b,
                        const vector<bool>& hint) {
    vector<int> sol;

    int calcSize = 0;
    for (auto it: hint) {
        if (it == true)
            calcSize++;
    }

    for (int i = 0; i < b.size(); i++) {
        if (hint[i] == 1) {
            sol.push_back(a[i]);
            if (sol.size() == calcSize)
                break;
        }
    }

    return sol;
}
