#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int N, S, C;
    cin >> N >> S >> C;

    int time = 0;
    vector<int> road;

    vector<int> cells;
    for (int i = 1; i <= N; i++)
        cells.push_back(i);

    string sequence = " ";
    for (int i = 0; i < S; i++)
        sequence += "s";
    for (int i = 0; i < C; i++)
        sequence += "c";

    for (int i = 0; i < sequence.size(); i++) {
        if (sequence[i] == 's') {
            road.push_back(cells.front());
            time++;

            if (cells.size() == 1)
                break;

            cells.erase(cells.begin());
            if (cells.size() != 1)
                cells.erase(cells.begin());
        } else {
            road.push_back(cells[cells.size() / 2]);
            time++;

            if (cells.size() == 1)
                break;

            cells.pop_back();
            if (cells.size() != 1)
                cells.erase(cells.begin());
        }

        if (i == sequence.size() - 1)
            i = 0;
    }

    cout << time << endl;
    for (int i = 0; i < time; i++) {
        cout << road[i] << ' ';
    }
    cout << endl;

    return 0;
}
