#include <iostream>
#include <vector>
using namespace std;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int N, S, C, time;
    cin >> N >> S >> C;

    if (S == 0 && C == 1) {
        time = N / 2 + 1;
        cout << time << '\n';
        for (int i = 0; i < time; i++) {
            cout << time << ' ';
        }
    }

    if (S == 1 && C == 0) {
        if (N == 2) {
            cout << "2\n1 2\n";
            return 0;
        }
        if (N == 3) {
            cout << "2\n1 3\n";
            return 0;
        }
        if (N == 4) {
            cout << "3\n1 3 4\n";
            return 0;
        }
        if (N == 5) {
            cout << "3\n3 5 1\n";
            return 0;
        }
        time = 0;
        int limit = 2147483647;
        vector<int> road;
        for (int i = 0, leftbound = N / 2 + 1, rightbound = N / 2 + 1; i < limit; i++) {
            if (i == 0) {
                time++;
                road.push_back(leftbound);
                leftbound -= 2;
                rightbound += 2;
            } else {
                if (leftbound >= 1) {
                    time++;
                    road.push_back(leftbound);
                    leftbound --;
                    if (leftbound > 1)
                        leftbound--;

                    if(rightbound < N)
                        rightbound++;
                }
                if (rightbound <= N) {
                    time++;
                    road.push_back(rightbound);
                    rightbound ++;
                    if(rightbound < N)
                        rightbound++;
                    if (leftbound > 1)
                        leftbound--;
                }
                if(leftbound < 1 && rightbound > N)
                    limit = i;
            }
        }
        cout << time << '\n';
        for (int i = 0; i < time; i++) {
            cout << road[i] << ' ';
        }
    }

    if (S == 1 && C == 1) {
        if (N == 2) {
            cout << "2\n1 2\n";
            return 0;
        }
        bool scared = true;
        time = 0;
        int limit = 2147483647;
        vector<int> road;
        for (int i = 0, x = 1, lowbound = 1, highbound = N; i < limit; i++) {
            time++;
            if (scared) {
                road.push_back(x);
                lowbound += 2;
                if (highbound < N)
                    highbound++;
                if (lowbound > N)
                    break;
                scared = false;
            } else {
                road.push_back((lowbound + highbound) / 2);
                lowbound++;
                highbound--;
                if (lowbound > N || highbound < 1)
                    break;
                if (lowbound >= highbound) {
                    x = highbound;
                    limit = i + 2;
                } else {
                    x = lowbound;
                }
                scared = true;
            }
        }
        cout << time << '\n';
        for (int i = 0; i < time; i++) {
            cout << road[i] << ' ';
        }
    }

    cout << '\n';
    return 0;
}
