#include <bits/stdc++.h>

using namespace std;

#define all(v) v.begin(), v.end()

const int N = 10000;
bitset<N> g[N];
int mt1[N];
int mt2[N];
bitset<N> used;

inline bool go(const pair<int, int> &A, const pair<int, int> &B) {
    return B.first - A.first >= abs(A.second - B.second);
}

bool dfs(int v) {
    if (used[v])
        return 0;
    used[v] = 1;
    for (int u = g[v]._Find_first(); u < N; u = g[v]._Find_next(u)) {
        if (mt2[u] == -1 || dfs(mt2[u])) {
            mt1[v] = u;
            mt2[u] = v;
            return 1;
        }
    }
    return 0;
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n;
    cin >> n;
    if (n <= 10000) {
        vector<pair<int, int> > a(n);
        for (int i = 0; i < n; ++i) {
            cin >> a[i].first >> a[i].second;
        }
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                if (j == i)
                    continue;
                if (go(a[i], a[j]))
                    g[i][j] = 1;
            }
        }
        /**for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                if (g[i][j])
                    cout << i + 1 << ' ' << j + 1 << endl;
            }
        }**/
        fill(mt1, mt1 + n, -1);
        fill(mt2, mt2 + n, -1);
        int M = 0;
        bool run = 1;
        while (run) {
            used.reset();
            run = 0;
            for (int v = 0; v < n; ++v) {
                if (mt1[v] == -1 && !used[v]) {
                    if (dfs(v)) {
                        run = 1;
                        ++M;
                    }
                }
            }
        }
        cout << n - M;
        return 0;
    }
    return 0;
}
