#include <bits/stdc++.h>

using namespace std;

#define all(v) v.begin(), v.end()

const int N = 10000;
vector<short> g[N];
int mt1[N];
int mt2[N];
int used[N];
int timer = 0;

inline bool go(const pair<int, int> &A, const pair<int, int> &B) {
    return B.first - A.first >= abs(A.second - B.second);
}

bool dfs(int v) {
    if (used[v] == timer)
        return 0;
    used[v] = timer;
    for (int u : g[v]) {
        if (mt2[u] == -1 || dfs(mt2[u])) {
            mt1[v] = u;
            mt2[u] = v;
            return 1;
        }
    }
    return 0;
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n;
    cin >> n;
    if (n <= 10000) {
        vector<pair<int, int> > a(n);
        for (int i = 0; i < n; ++i) {
            cin >> a[i].first >> a[i].second;
        }
        sort(all(a));
        vector<int> cnt(n, 0);
        for (int i = 0; i < n; ++i) {
            for (int j = i + 1; j < n; ++j) {
                if (go(a[i], a[j]))
                    ++cnt[i];
            }
        }
        for (int i = 0; i < n; ++i) {
            g[i].resize(cnt[i]);
            cnt[i] = 0;
        }
        for (int i = 0; i < n; ++i) {
            for (int j = i + 1; j < n; ++j) {
                if (go(a[i], a[j]))
                    g[i][cnt[i]++] = j;
            }
        }
        /**for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                if (g[i][j])
                    cout << i + 1 << ' ' << j + 1 << endl;
            }
        }**/
        fill(mt1, mt1 + n, -1);
        fill(mt2, mt2 + n, -1);
        int M = 0;
        bool run = 1;
        while (run) {
            ///used.reset();
            ++timer;
            run = 0;
            for (int v = 0; v < n; ++v) {
                if (mt1[v] == -1 && used[v] != timer) {
                    if (dfs(v)) {
                        run = 1;
                        ++M;
                    }
                }
            }
        }
        cout << n - M;
        return 0;
    }
    return 0;
}
