#include<bits/stdc++.h>
//#include "hint.h"

#define ll long long
#define f first
#define s second
#define pb push_back

using namespace std;

int e = 18;
ll gr_sz = 1000 / e;

ll unbit(vector<bool> a) {
ll now = 0;
for(int j = 0; j < 18; j++) {
now += (a[j] << j);
}
return now;
}

vector<bool> bits(ll x) {
vector<bool> now;
for(int j = 0; j < 18; j++) {
now.pb((x >> j) & 1);
}
return now;
}
vector<bool> genHint(const vector<int>& a, const vector<int>& b,
 const vector<int>& sol) {
 	  gr_sz = a.size() * b.size()  * e / 100000000 + 1;
      vector<pair<int, int>> ans;
      ll i = 0, j = 0;
      for(auto to: sol) {
		  while(a[i] != to) i++;
		  while(b[j] != to) j++;
		  ans.pb({i, j});
		  i++; j++;
      }
      vector<ll> a2(a.size(), 0);
      for(auto to: ans) {
        a2[to.f] = to.s;
      }
      for(int j = 1; j < a.size(); j++) {
            a2[j] = max(a2[j], a2[j - 1]);
      }
      vector<bool> a3;
      ll st = 0;
      while(st < a.size()) {
            ll x = a2[min((ll)a.size() - 1,  st + gr_sz - 1)];
            vector<bool> e = bits(x);
            for(auto to: e) a3.pb(to);
            st += gr_sz;
      }
      return a3;
 };


vector<int> find_ma(vector<int> a, vector<int> b) {
    bool pr[a.size() + 1][b.size() + 1];
    bool pr2[a.size() + 1][b.size() + 1];
    int ans[2][b.size() + 1];
    for(int j = 0; j <= a.size(); j++)
	for(int q = 0; q <= b.size(); q++) {
            ans[1][q] = 0; ans[0][q] = 0;
            pr[j][q] = 0; pr2[j][q] = 0;
	}
    for(int j = 1; j <= a.size(); j++) {
	for(int q = 0; q <= b.size(); q++) {
        ans[0][q] = ans[1][q];
        ans[1][q] = 0;
	}
	for(int q = 1; q <= b.size(); q++) {
        ans[1][q] = ans[1][q - 1];
        if(ans[0][q] > ans[1][q]) ans[1][q] = ans[0][q], pr2[j][q] = 1;
        int x = ans[0][q - 1] + (a[j - 1] == b[q - 1]);
        if(ans[1][q] < x) ans[1][q] = x, pr[j][q] = 1;
        else pr[j][q] = 0;
	}
    }
    vector<int> now;
    ll n = a.size(), m = b.size();
    while(n && m) {
        bool f = pr[n][m];
        if(f) {n--, m--; if(a[n] == b[m])now.pb(a[n]); }
        else if(pr2[n][m]) n--;
                 else m--;
    }
    reverse(now.begin(), now.end());
    return now;

}
 std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b,
 const std::vector<bool>& hint) {
 	  gr_sz = a.size() * b.size()  * e / 100000000 + 1;
      ll st = 0, pr = 0, st3 = 0;
      vector<int> ans;
      while(st < a.size()) {
           vector<int> a2, b2;
           vector<bool> bt;
           for(int i = 0; i < e; i++) {
                 bt.pb(hint[i + st3]);
           }
           st3 += e;
           int nowb = unbit(bt);
           for(int j = st; j < min((ll)a.size(), st + gr_sz); j++) {
              a2.pb(a[j]);
           }
           for(int j = pr; j <= nowb; j++) {
              b2.pb(b[j]);
           }
           if(a2.size() && b2.size()) {
			vector<int> anc = find_ma(a2, b2);
           for(auto to: anc) ans.pb(to); }
           pr = nowb + 1;
           st += gr_sz;
           }
         return ans;
      }
/*
int main() {
cin.tie(0);
cout.tie(0);
ios_base::sync_with_stdio(0);

#ifdef LOCAL
freopen("input.txt", "r", stdin);
freopen("output.txt", "w", stdout);
#endif

ll n, m, q;
cin >> n >> m >> q;
vector<int> a, b, c;
while(n--) {
	ll x;
	cin >> x;
	a.pb(x);
}

while(m--) {
	ll x;
	cin >> x;
	b.pb(x);
}

while(q--) {
	ll x;
	cin >> x;
	c.pb(x);
}

vector<bool> x = genHint(a, b, c);
vector<int> ans = solve(a, b, x);
for(auto to: ans) {
	cout << to << ' ';
}
}*/
