#include <bits/stdc++.h>
//#include <hint.h>

#define ibase ios_base::sync_with_stdio(0); cin.tie(0);
#define fi first
#define se second

using namespace std;
using ll = long long;

vector <bool> genHint(const vector <int>& a, const vector <int>& b, const vector <int>& sol){
    int n = a.size(), m = b.size(), k = sol.size();
    if(n <= m){
        vector <bool> hint(n, 0);
        int j = 0;
        for(int i = 0; i < n; ++i){
            if(j < k and a[i] == sol[j]){
                hint[i] = 1;
                ++j;
            }
            else{
                hint[i] = 0;
            }
        }
        return hint;
    }
    else{
        vector <bool> hint(m, 0);
        int j = 0;
        for(int i = 0; i < m; ++i){
            if(j < k and b[i] == sol[j]){
                hint[i] = 1;
                ++j;
            }
            else{
                hint[i] = 0;
            }
        }
        return hint;
    }
}

vector <int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint){
    int n = a.size(), m = b.size();
    vector <int> sol;
    if(n <= m){
        for(int i = 0; i < n; ++i){
            if(hint[i]){
                sol.push_back(a[i]);
            }
        }
    }
    else{
        for(int i = 0; i < m; ++i){
            if(hint[i]){
                sol.push_back(b[i]);
            }
        }
    }
    return sol;
}

