#include <bits/stdc++.h>
//#include <hint.h>

#define ibase ios_base::sync_with_stdio(0); cin.tie(0);
#define fi first
#define se second

using namespace std;
using ll = long long;

int const inf = 1e4 + 1;

vector <int> stup(vector <int>& a, vector <int>& b){
    int n = a.size(), m = b.size();
    int dp[n][m];
    for(int x = 0; x < n; ++x){
        for(int y = 0; y < m; ++y){
            dp[x][y] = 0;
            if(a[x] == b[y]){
                dp[x][y] = 1 + ((x - 1 >= 0 and y - 1 >= 0) ? dp[x - 1][y - 1] : 0);
            }
            if(x - 1 >= 0){
                dp[x][y] = max(dp[x][y], dp[x - 1][y]);
            }
            if(y - 1 >= 0){
                dp[x][y] = max(dp[x][y], dp[x][y - 1]);
            }
        }
    }
    vector <int> ans;
    int x = n - 1, y = m - 1;
    while(x >= 0 and y >= 0){
        if(!dp[x][y]){ break;}
        if(x - 1 >= 0 and dp[x][y] == dp[x - 1][y]){
            --x;
        }
        else if(y - 1 >= 0 and dp[x][y] == dp[x][y - 1]){
            --y;
        }
        else{
            ans.push_back(b[y]);
            --x;
            --y;
        }
    }
    reverse(ans.begin(), ans.end());
    return ans;
}

int gsq(int x){
    return sqrt(x) + 1;
}

vector <bool> gig(int x, int bit){
    vector <bool> b(bit, 0);
    for(int i = 0; i < bit; ++i){
        if(x & (1 << i)){
            b[i] = 1;
        }
    }
    return b;
}

vector <bool> genHint(const vector <int>& a, const vector <int>& b, const vector <int>& sol){
    int n = a.size(), m = b.size(), k = sol.size();
    if(max(n, m) < inf){
        return vector <bool>(0);
    }
    int sq = gsq(n);
    vector <int> diff;
    int j = 0, bi = 0;
    for(int i = 0; i < sq; ++i){
        int last = -1, _bi = bi - 1;
        for(int _i = i * sq; _i < min(n, (i + 1) * sq); ++_i){
            if(j < k and sol[j] == a[_i]){
                while(b[bi] != sol[j]){
                    ++bi;
                }
                last = bi;
                ++bi;
                ++j;
            }
        }
        diff.push_back(max(0, last - _bi));
    }
    int bit = 0;
    for(int i = 0; i < sq; ++i){
        int g = 1, _bit = 1;
        while(g < diff[i]){
            g *= 2;
            _bit++;
        }
        bit = max(bit, _bit);
    }
    vector <bool> hint(5, 0);
    vector <bool> _num = gig(bit, 5);
    for(int l = 0; l < 5; ++l){
        hint[l] = _num[l];
    }
    for(int i = 0; i < sq; ++i){
        vector <bool> num = gig(diff[i], bit);
        if(diff[i] == 0){
            hint.push_back(0);
        }
        else{
            hint.push_back(1);
            for(int l = 0; l < bit; ++l){
                hint.push_back(num[l]);
            }
        }
    }
    return hint;
}

vector <int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint){
    int n = a.size(), m = b.size();
    if(hint.size() == 0){
        vector <int> _a = a, _b = b;
        vector <int> sol = stup(_a, _b);
        return sol;
    }
    vector <int> sol;
    int j = -1, sq = gsq(n);
    int bit = 0;
    for(int i = 0; i < 5; ++i){
        if(hint[i]){
            bit += (1 << i);
        }
    }
    int id = 5;
    for(int i = 0; i < sq; ++i){
        int last = 0;
        if(!hint[id]){
            ++id;
            continue;
        }

        for(int _i = 0; _i < bit; ++_i){
            if(hint[id + 1 + _i]){
                last += (1 << _i);
            }
        }
        id += bit + 1;
        last += j;
        ++j;
        int N = min(sq, n - sq*i);
        int len = last - j + 1, dp[N][len];
        for(int x = 0; x < N; ++x){
            for(int y = 0; y < len; ++y){
                dp[x][y] = 0;
                if(a[i * sq + x] == b[j + y]){
                    dp[x][y] = 1 + ((x - 1 >= 0 and y - 1 >= 0) ? dp[x - 1][y - 1] : 0);
                }
                if(x - 1 >= 0){
                    dp[x][y] = max(dp[x][y], dp[x - 1][y]);
                }
                if(y - 1 >= 0){
                    dp[x][y] = max(dp[x][y], dp[x][y - 1]);
                }
            }
        }
        vector <int> ans;
        int x = N - 1, y = len - 1;
        while(x >= 0 and y >= 0){
            if(!dp[x][y]){ break;}
            if(x - 1 >= 0 and dp[x][y] == dp[x - 1][y]){
                --x;
            }
            else if(y - 1 >= 0 and dp[x][y] == dp[x][y - 1]){
                --y;
            }
            else{
                ans.push_back(b[j + y]);
                --x;
                --y;
            }
        }
        reverse(ans.begin(), ans.end());
        for(auto w : ans){
            sol.push_back(w);
        }
        j = last;
    }
    return sol;
}

mt19937 rnd(time(0));

void gg(){
    while(1){
        int n = 5 + rnd()%10, m = 5 + rnd()%10;
        vector <int> a(n), b(m);
        for(int i = 0; i < n; ++i){
            a[i] = rnd()%15;
        }
        for(int i = 0; i < m; ++i){
            b[i] = rnd()%15;
        }
        for(auto w : a){
            cout << w << ' ';
        }
        cout << endl;
        for(auto w : b){
            cout << w << ' ';
        }
        cout << endl;
        vector <int> sol = stup(a, b);
        vector <bool> hint = genHint(a, b, sol);
        vector <int> _sol = solve(a, b, hint);
        for(auto w : sol){
            cout << w << ' ';
        }
        cout << endl;
        for(auto w : _sol){
            cout << w << ' ';
        }
        cout << endl;
        cout << endl;
        if(sol != _sol){
            break;
        }
    }
}

void test(){
    int n, m, k;
    cin >> n >> m >> k;
    vector <int> a(n), b(m), sol(k);
    for(int i = 0; i < n; ++i){
        cin >> a[i];
    }
    for(int i = 0; i < m; ++i){
        cin >> b[i];
    }
    for(int i = 0; i < k; ++i){
        cin >> sol[i];
    }
    vector <bool> hint = genHint(a, b, sol);
    vector <int> _sol = solve(a, b, hint);
    for(auto w : _sol){
        cout << w << ' ';
    }
}

/*
signed main(){
    //test();
    gg();
}
*/


/**
7 5 4
1 2 1 3 1 2 1
1 3 1 2 2
1 3 1 2

7 7 5
1 2 1 3 1 2 4
1 3 1 2 2 3 4
1 3 1 2 4

7 7 5
3 2 1 3 1 2 4
2 3 1 2 2 3 4
2 3 1 2 4

11 8 3
10 7 4 5 9 10 9 8 13 0 4
5 0 11 3 5 0 10 4
5 10 4
**/

