#include "hint.h"

#include <iostream>
#include <vector>

static int n, m, k;
static std::vector<int> a, b, sol, maybeSol;
static std::vector<bool> hint;

int main()
{
    
    std::cin >> n >> m;

    a.resize(n);
    b.resize(m);

    for (int& num : a)
    {
        std::cin >> num;
    }

    for (int& num : b)
    {
        std::cin >> num;
    }

    std::cin >> k;

    sol.resize(k);

    for (int& num : sol)
    {
        std::cin >> num;
    }
    
    hint = genHint(a, b, sol);
    maybeSol = solve(a, b, hint);
    
    std::cout << "hint size: " << hint.size() << std::endl;
    std::cout << "my sol size: " << maybeSol.size() << std::endl;
 
    for (int i = 0; i < (int)maybeSol.size(); ++i)
    {
        if (i > 0) std::cout << " ";
        std::cout << maybeSol[i];
    }
    std::cout << std::endl;
    
    return 0;
}


/*

8 7
1 3 5 4 2 2 6 3
4 3 2 1 6 2 3
4
3 2 6 3



1 1
1
1
1
1

1 1
1
2
0


3 3
2 3 1
3 1 2
2
3 1

*/
