#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <queue>

#define upmin(a, b) a = min(a, b)
#define upmax(a, b) a = max(a, b)
#define pr(x) cout << x << endl
#define wpr(x) cout << #x << ": " << x << endl
#define spr(x) cout << x << " "
#define wprv(x) cout << #x << ": " << endl; for(auto it : x) cout << it << " "; cout << endl;
#define wprvv(x) cout << #x << ": " << endl; for(auto it : x) { for(auto it2 : it) cout << it2 << " "; cout << endl;}
#define rep(i, s, e) for(ll i = s; i < e; i++)



using namespace std;

using ll = long long;
using vll = vector<ll>;
using vvll = vector<vll>;
using vb = vector<bool>;
using vvb = vector<vb>;
using pll = pair<ll, ll>;
using vpll = vector<pll>;
using vvpll = vector<vpll>;

ll n, s, c;

void solve_s()
{
	vll res;
	/*
	for (ll i = 1; i <= 2 * n / 3; i += 2) {
		res.push_back(i);
	}
	*/
	ll st = n / 3;
	ll en = 2 * n / 3;
	if (n % 3 == 2) st++;
	for (ll i = 0; st + i <= en - i; i++) {
		
		res.push_back(st + i);
		if(st + i != en - i) res.push_back(en - i);
	}
	res.push_back(1);
	res.push_back(n);
	pr(res.size());
	rep(i, 0, res.size()) {
		spr(res[i]);
	}
	pr("");
}

void solve_c()
{
	ll len = n / 2;
	pr(len+1);
	rep(i, 0, len+1) {
		spr(len+1);
	}
	pr("");
}

/*

we wanna bring them down.
To do so, when we are at c we will enter "1",
and when we are at s we will enter "n".
Works after ~(n+2) tries.

*/
void solve_gen()
{
	pr(n);
	rep(i, 0, n-(ll)1) {
		if (i % (s + c) < s) { // scared
			spr(n);
		}
		else { // curious
			spr("1");
		}
	}
	pr("1");
}

void solve()
{
	cin >> n >> s >> c;
	if (s == 0) c = 1;
	if (c == 0) s = 1;

	if (s == 1 && c == 0) {
		solve_s();
	}
	else if(s == 0 && c == 1) {
		solve_c();
	}
	else {
		solve_gen();
	}
}



int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	solve();
}

/*

8 1 0
9 1 0
13 1 0

*/