#include <bits/stdc++.h>
#include "hint.h"

using namespace std;

std::vector<int> CalculateSizes (const std::vector<int>& a) {
    std::vector <int> Sizes_A;
    for (int i = 0; i < 35; ++ i )
        Sizes_A.push_back(a.size() / 35);
    for (int i = 0; i < a.size()%35; ++ i )
        Sizes_A[i] ++;

    return Sizes_A;
}

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol) {
    std::vector <int> poz_a, poz_b, Sizes_A;
    std::vector <bool> ans;

    int j = 0, i = 0;

    for (auto it : sol) {
        while (i < a.size() && a[i] != it) ++ i;
        while (j < b.size() && b[j] != it) ++ j;

        poz_a.push_back(i);
        poz_b.push_back(j);
    }

    j = 0;
    Sizes_A = CalculateSizes(a);

    int ind_A = 0;
    int Last_Poz = 0;
    for (int i = 0; i < 35; ++ i ) {
        Last_Poz += Sizes_A[i];
        while (ind_A < poz_a.size() && poz_a[ind_A] < Last_Poz) ++ ind_A;

        int val = (ind_A == 0 ? 0 : poz_b[ind_A-1]+1);

        for (int j = 17; j >= 0; -- j ) {
            if ((val&(1<<j))) ans.push_back(1);
            else ans.push_back(0);
        }

        if (ind_A == poz_a.size()) break;
    }

    return ans;
}

vector <int> dp[6300];

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint) {
    std::vector<int> Sizes_A = CalculateSizes(a);
    std::vector<int> sol;

    int First_PozA = 0;
    int First_PozB = 0;
    int ind = 0;
    for (auto sz : Sizes_A) {
        int Last_PozA = First_PozA + sz - 1;
        int Last_PozB = 0;

        for (int i = ind; i < ind+18; ++ i ) {
            Last_PozB *= 2;
            Last_PozB += hint[i];
        }
        ind += 18;

        if (sz == 0) break;

        int ind_a = 0, ind_b = 0;
        int Max = 0;
        for (int j = First_PozB; j < Last_PozB; ++ j ) {
            if (dp[1].size() <= j - First_PozB + 1) dp[1].push_back(0);
            dp[1][j - First_PozB + 1] = (a[First_PozA] == b[j] ? 1 : 0);

            if (dp[1][j-First_PozB+1] > Max) {
                Max = dp[1][j-First_PozB+1];
                ind_a = 1;
                ind_b = j - First_PozB+1;
            }
        }

        for (int i = First_PozA+1; i <= Last_PozA; ++ i ) {
            for (int j = First_PozB; j < Last_PozB; ++ j ) {
                if (dp[i-First_PozA+1].size() <= j - First_PozB + 1) dp[i-First_PozA+1].push_back(0);
                dp[i-First_PozA+1][j-First_PozB+1] = max(dp[i-First_PozA][j-First_PozB+1], dp[i-First_PozA+1][j-First_PozB]);
                if (a[i] == b[j]) dp[i-First_PozA+1][j-First_PozB+1] = max(dp[i-First_PozA+1][j-First_PozB+1], 1 + dp[i-First_PozA][j - First_PozB]);

                if (dp[i-First_PozA+1][j-First_PozB+1] > Max){
                    Max = dp[i-First_PozA+1][j-First_PozB+1];
                    ind_a = i - First_PozA + 1;
                    ind_b = j - First_PozB + 1;
                }
            }
        }

        std::vector<int> aux;
        for (int i = ind_a; i >= 1; -- i ) {
            for (int j = ind_b; j >= 1; -- j )
                if (dp[i][j] == Max) {
                    aux.push_back(b[j+First_PozB-1]);
                    ind_b = j-1;
                    -- Max;
                    break;
                }

            if (Max == 0) break;
        }

        reverse(aux.begin(), aux.end());

        for (int i = 0; i < aux.size(); ++ i )
            sol.push_back(aux[i]);
        First_PozA = Last_PozA + 1;
        First_PozB = Last_PozB;
    }

    return sol;
}

/*
6 5
1 3 2 5 6 4
2 5 4 3 6
3
2 5 6
*/
