#include <bits/stdc++.h>

using namespace std;

constexpr int NMAX = 1e6 + 5;
typedef pair <int, int> PII;

int N;
PII V[NMAX];
set <PII> Trucks[NMAX];

int modul (int x) {
    if (x < 0) return -x;

    return x;
}

void Read () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N;

    for (int i = 1; i <= N; ++ i ) {
        cin >> V[i].first >> V[i].second;
        swap(V[i].first, V[i].second);
    }

    sort(V+1, V+N+1);
}

void Solve () {
    int cnt_trucks = 0;

    for (int i = 1; i <= N; ++ i ) {
        bool ok = 0;
        int timp = V[i].second;
        int loc = V[i].first;
        for (int j = 1; j <= cnt_trucks; ++ j ) {
            PII aux;
            aux.first = timp;
            aux.second = loc;
            set <PII> :: iterator it = upper_bound(Trucks[j].begin(), Trucks[j].end(), aux);

            if (it == Trucks[j].begin()) {
                PII primul = *it;

                if (modul(primul.first - timp) >= modul(primul.second - loc)) {
                    Trucks[j].insert({timp, loc});
                    ok = 1;
                    break;
                }
                continue;
            }


            if (it == Trucks[j].end()) {
                it = prev(it);

                PII ultimul = *it;
                if (modul(ultimul.first - timp) >= modul(ultimul.second - loc)) {
                    Trucks[j].insert({timp, loc});
                    ok = 1;
                    break;
                }
                continue;
            }

            set <PII> :: iterator bef = prev(it);
            PII primul = *bef;
            PII ultimul = *it;

            if (modul(primul.first - timp) >= modul(primul.second - loc) && modul(ultimul.first - timp) >= modul(ultimul.second - loc)) {
                Trucks[j].insert({timp, loc});
                ok = 1;
                break;
            }
        }

        if (!ok) {
            ++ cnt_trucks;
            Trucks[cnt_trucks].insert({V[i].second, V[i].first});
        }
    }

    cout << cnt_trucks << '\n';
}

int main () {
    Read();
    Solve();

    return 0;
}
