#include <iostream>
#include <cstdio>
#include <cstring>
#include <map>
#include <vector>

bool HasParent [ 20'005 ] ;
std::vector<int> adj [ 20'005 ] ;

int T [ 20'005 ] ;
int H [ 20'005 ] ;

int main ( void ) {
	int N ;
	scanf ( " %d" , &N ) ;
	for ( int i = 1 ; i <= N ; i++ ) {
		scanf ( " %d %d" , &T [ i ] , &H [ i ] ) ;
	}
	for ( int i = 1 ; i <= N ; i++ ) {
		for ( int j = 1 ; j <= N ; j++ ) {
			if ( i == j ) continue ;
			if ( ( T [ j ] - T [ i ] ) >= abs ( H [ j ] - H [ i ] ) ) {
				// printf ( "%d can replace %d\n" , i , j ) ;
				adj [ i ].push_back ( j ) ;
				HasParent [ j ] = true;
			}
		}
	}
	int ans = 0 ;
	for ( int i = 1 ; i <= N ; i++ )
		if ( HasParent [ i ] == false )
			ans++;
	printf ( "%d\n" , ans ) ;
	return 0 ;
}
