#include "hint.h"

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define pb push_back
#define f first
#define s second

std::vector<bool> genHint(const std::vector<int> &a, const std::vector<int> &b,
                          const std::vector<int> &sol) {
    int l = 0, r = sol.size() + 1;
    while (r > l + 1) {
        int kolvo = (r + l) / 2;
        bool bl = 1;
        int it_a = 0, it_b = 0;
        for (int j = 0; j < kolvo; j++) {
            while (a[it_a] != sol[j])
                it_a++;
            while (b[it_b] != sol[j])
                it_b++;
            it_a++;
            it_b++;
        }
        if (ll(it_a) * ll(it_b) < ll(1e7))
            l = kolvo;
        else
            r = kolvo;
    }
    int it_a = 0, it_b = 0;
    for (int j = 0; j < l; j++) {
        while (a[it_a] != sol[j])
            it_a++;
        while (b[it_b] != sol[j])
            it_b++;
        it_a++;
        it_b++;
    }
    vector<bool> ans;
    for (int j = 0; j < 18; j++) {
        if (it_a & (1 << j))
            ans.pb(true);
        else
            ans.pb(false);
    }
    for (int j = 0; j < 18; j++) {
        if (it_b & (1 << j))
            ans.pb(true);
        else
            ans.pb(false);
    }
    for (int i = l; i < sol.size(); i++) {
        for (int j = 0; j < 18; j++) {
            if (sol[i] & (1 << j))
                ans.pb(true);
            else
                ans.pb(false);
        }
    }
    return ans;
}

std::vector<int> solve(const std::vector<int> &a, const std::vector<int> &b,
                       const std::vector<bool> &hint) {
    int sz_a = 0, sz_b = 0;
    for (int i = 0; i < 18; i++)
        sz_a += int(hint[i]) * (1 << i);
    for (int i = 18; i < 36; i++)
        sz_b += int(hint[i]) * (1 << (i - 18));
    vector<int> add_ans;
    for (int i = 36; i < int(hint.size()); i += 18) {
        int val = 0;
        for (int j = 0; j < 18; j++) {
            val += int(hint[i + j]) * (1 << j);
        }
        add_ans.pb(val);
    }
    if (!sz_a || !sz_b)
        return add_ans;
    pair<int, char> dp[sz_a + 1][sz_b + 1];
    for (int i = 0; i <= sz_a; i++) {
        for (int j = 0; j <= sz_b; j++)
            dp[i][j] = {0, '#'};
    }
    for (int i = 0; i <= sz_a; i++) {
        for (int j = 0; j <= sz_b; j++) {
            if (!i && !j)
                continue;
            if (!i) {
                dp[i][j] = {dp[i][j - 1].f, '2'};
            } else if (!j) {
                dp[i][j] = {dp[i - 1][j].f, '1'};
            } else {
                if (a[i - 1] == b[j - 1]) {
                    if (dp[i - 1][j - 1].f + 1 > max(dp[i][j - 1].f, dp[i - 1][j].f)) {
                        dp[i][j] = {dp[i - 1][j - 1].f + 1, '0'};
                    } else {
                        if (dp[i][j - 1].f > dp[i - 1][j].f) {
                            dp[i][j] = {dp[i][j - 1].f, '2'};
                        } else {
                            dp[i][j] = {dp[i - 1][j].f, '1'};
                        }
                    }
                } else {
                    if (dp[i][j - 1].f > dp[i - 1][j].f) {
                        dp[i][j] = {dp[i][j - 1].f, '2'};
                    } else {
                        dp[i][j] = {dp[i - 1][j].f, '1'};
                    }
                }
            }
        }
    }
    vector<int> answer;
    while (sz_a || sz_b) {
        if (dp[sz_a][sz_b].s == '0'){
            answer.pb(a[sz_a - 1]);
            sz_a--;
            sz_b--;
        }else if (dp[sz_a][sz_b].s == '1'){
            sz_a--;
        }else{
            sz_b--;
        }
    }
    reverse(answer.begin(), answer.end());
    for (auto u : add_ans)
        answer.pb(u);
    return answer;
}