#include "hint.h"

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define pb push_back
#define f first
#define s second

const int N = 2500, LG = 12;

std::vector<bool> genHint(const std::vector<int> &a, const std::vector<int> &b,
                          const std::vector<int> &sol) {
    vector<int> as, bs;
    int it_a = 0, it_b = 0;
    for (auto u: sol) {
        while (a[it_a] != u)
            it_a++;
        as.pb(it_a);
        it_a++;
    }
    for (auto u: sol) {
        while (b[it_b] != u)
            it_b++;
        bs.pb(it_b);
        it_b++;
    }
    int last_a = 0, last_b = 0;
    int i = 0;
    vector<bool> ans;
    while (i != int(sol.size())) {
        int l = 0, r = int(sol.size()) - i + 1;
        while (r > l + 1) {
            int mid = (r + l) / 2;
            if ((as[mid - 1 + i] - last_a) + 1 <= N && (bs[mid - 1 + i] - last_b) + 1 <= N) {
                l = mid;
            } else {
                r = mid;
            }
        }
        int sz_a, sz_b;
        if (l == 0) {
            sz_a = min(N, as[i] - last_a);
            sz_b = min(N, bs[i] - last_b);
        } else {
            sz_a = as[l - 1 + i] - last_a + 1;
            sz_b = bs[l - 1 + i] - last_b + 1;
        }
        i += l;
        last_a += sz_a;
        last_b += sz_b;
        if (!l)
            ans.pb(true);
        else
            ans.pb(false);
        for (int j = 0; j < LG; j++) {
            if ((1 << j) & sz_a)
                ans.pb(true);
            else
                ans.pb(false);
        }
        for (int j = 0; j < LG; j++) {
            if ((1 << j) & sz_b)
                ans.pb(true);
            else
                ans.pb(false);
        }
    }
    return ans;
}

int dp[N + 10][N + 10];

std::vector<int> solve(const std::vector<int> &a, const std::vector<int> &b,
                       const std::vector<bool> &hint) {
    vector<int> sz_a, sz_b;
    vector<bool> skip;
    for (int i = 0; i < int(hint.size()); i += LG * 2 + 1) {
        skip.pb(hint[i]);
        int to_a = 0, to_b = 0;
        for (int j = 0; j < LG; j++) {
            to_a += int(hint[j + i + 1]) * (1 << j);
        }
        for (int j = 0; j < LG; j++) {
            to_b += int(hint[j + i + LG + 1]) * (1 << j);
        }
        sz_a.pb(to_a);
        sz_b.pb(to_b);
    }
    int last_a = 0, last_b = 0;
    vector<int> ans, now;
    for (int k = 0; k < int(sz_a.size()); k++) {
        if (!skip[k]) {
            dp[0][0] = 0;
            for (int i = 0; i <= sz_a[k]; i++) {
                for (int j = 0; j <= sz_b[k]; j++) {
                    if (i == 0 && j == 0)
                        continue;
                    if (j == 0)
                        dp[i][j] = dp[i - 1][j];
                    else if (i == 0)
                        dp[i][j] = dp[i][j - 1];
                    else {
                        dp[i][j] = max(dp[i][j - 1], dp[i - 1][j]);
                        if (a[i - 1 + last_a] == b[j - 1 + last_b])
                            dp[i][j] = max(dp[i][j], dp[i - 1][j - 1] + 1);
                    }
                }
            }
            int it_a = sz_a[k], it_b = sz_b[k];
            while (it_a || it_b) {
                if (!it_a) {
                    it_b--;
                } else if (!it_b) {
                    it_a--;
                } else {
                    if (a[it_a - 1 + last_a] == b[it_b - 1 + last_b] && dp[it_a][it_b] - 1 == dp[it_a - 1][it_b - 1]) {
                        now.pb(a[it_a - 1 + last_a]);
                        it_a--;
                        it_b--;
                    } else {
                        if (dp[it_a][it_b] == dp[it_a - 1][it_b])
                            it_a--;
                        else
                            it_b--;
                    }
                }
            }
            for (int j = now.size() - 1; j >= 0; j--) {
                ans.pb(now[j]);
            }
        }
        last_a += sz_a[k];
        last_b += sz_b[k];
        now.clear();
    }
    return ans;
}