#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ldb;

bool cmp(pair<int, int> a, pair<int, int> b) {
    int sa = a.first + a.second;
    int sb = b.first + b.second;
    if (sa != sb) {
        return sa < sb;
    }
    return a.first < b.first;
}

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> arr(n);
    for (int i = 0; i < n; i++) {
        cin >> arr[i].first >> arr[i].second;
    }
    sort(arr.begin(), arr.end(), cmp);
    int ans = 0;
    while (!arr.empty()) {
        ans++;
        vector<pair<int, int>> arr2;
        pair<int, int> last = arr[0];
        for (int i = 1; i < (int) arr.size(); i++) {
            if (abs(last.first - arr[i].first) >= abs(last.second - arr[i].second)) {
                last = arr[i];
            } else {
                arr2.push_back(arr[i]);
            }
        }
        arr = arr2;
    }
    cout << ans << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    while (t--) {
        solve();
    }
}
