#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ldb;

bool cmp(pair<int, int> a, pair<int, int> b) {
    int sa = a.first + a.second;
    int sb = b.first + b.second;
    if (sa != sb) {
        return sa < sb;
    }
    return a.first < b.first;
}

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> arr(n);
    for (int i = 0; i < n; i++) {
        cin >> arr[i].first >> arr[i].second;
    }
    sort(arr.begin(), arr.end(), cmp);
    multiset<int> s;
    s.insert(arr[0].second - arr[0].first);
    for (int i = 1; i < n; i++) {
        int val = arr[i].second - arr[i].first;
        auto it = s.lower_bound(val);
        if (it == s.end()) {
            s.insert(val);
        } else {
            s.erase(it);
            s.insert(val);
        }
    }
    cout << s.size() << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    while (t--) {
        solve();
    }
}
