#ifndef LOCAL
#pragma GCC optimize("Ofast,unroll-loops,fast-math,inline,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx,popcnt")
#endif
#include <bits/stdc++.h>
using namespace std;

#define endl '\n'

typedef long long ll;
typedef long double ldb;

void check(int n, int s, int c, vector<int> ans) {
    vector<int> pos;
    pos.resize(n);
    iota(pos.begin(), pos.end(), 1);
    int cur_time = 0;
    for (int el : ans) {
        auto it = lower_bound(pos.begin(), pos.end(), el);
        if (it != pos.end() && *it == el) {
            pos.erase(it);
        } else {
            //assert(false);
        }
        for (int &x : pos) {
            if (cur_time % (s + c) < s) {
                if (x < el) {
                    if (x > 1)
                        x--;
                } else if (x < n) {
                    x++;
                }
            } else {
                if (x < el) {
                    x++;
                } else {
                    x--;
                }
            }
        }
        cur_time++;
        pos.erase(unique(pos.begin(), pos.end()), pos.end());
    }
    assert(pos.empty());
}


int n, s, c;
vector<int> calc(int cur_pos) {
    vector<int> ans;
    int cur_time = 0;
    ans.push_back(cur_pos);
    deque<int> left;
    for (int i = 1; i < cur_pos; i++) {
        left.push_back(i);
    }
    int addLeft=0;
    int max_pos = n;
    int nxt_pos = n;
    if (s == 0) {
        nxt_pos = n - 1;
    }
    if (cur_pos == n) {
        nxt_pos = -1;
    }
    while (cur_pos < nxt_pos || (cur_pos == nxt_pos && nxt_pos < max_pos)) {
        if (cur_time % (s + c) >= s) {
            max_pos--;
            addLeft++;
            if (left.empty() || left.back() != cur_pos - addLeft)
                left.push_back(cur_pos - addLeft);
            cur_pos++;
        } else {
            addLeft--;
            if (!left.empty() && left[0] + addLeft == 0) {
                left.pop_front();
                if (left.empty() || left.front() + addLeft != 1) {
                    left.push_front(1 - addLeft);
                }
            }
            cur_pos += 2;
            max_pos++;
            max_pos = min(max_pos, n);
            cur_pos = min(cur_pos, n);
        }
        cur_time++;
        ans.push_back(cur_pos);
        if (cur_pos == max_pos)
            break;
        if (cur_time % (s + c) >= s) {
            nxt_pos = max_pos - 1;
        } else {
            nxt_pos = min(max_pos + 1, n);
        }
    }
    if ((cur_time) % (s + c) < s) {
        addLeft--;
        if (!left.empty() && left[0] + addLeft == 0) {
            left.pop_front();
            if (left.empty() || left.front() + addLeft != 1) {
                left.push_front(1 - addLeft);
            }
        }
    } else {
        addLeft++;
        if (!left.empty() && left.back() + addLeft == n + 1) {
            left.pop_back();
            if (left.empty() || left.back() + addLeft != n) {
                left.push_back(n - addLeft);
            }
        }
    }
    while (!left.empty()) {
        int el = left.front();
        left.pop_front();
        int val = min(n, el + addLeft); 
        ans.push_back(val);
        if (val == n) {
            break;
        }
        cur_time++;
        if ((cur_time) % (s + c) < s) {
            addLeft++;
            if (!left.empty() && left.back() + addLeft == n + 1) {
                left.pop_back();
                if (left.empty() || left.back() + addLeft != n) {
                    left.push_back(n - addLeft);
                }
            }
        } else {
            addLeft--;
            if (!left.empty() && left[0] + addLeft == 0) {
                left.pop_front();
                if (left.empty() || left.front() + addLeft != 1) {
                    left.push_front(1 - addLeft);
                }
            }
        }
    }
#ifdef LOCAL
    cout << ans.size() << endl;
    for (int el : ans) {
        cout << el << " ";
    }
    cout << endl;
    cout.flush();
    check(n, s, c, ans);
    ldb t = (ldb) n * (s + c) / (s + 2 * max(s, c)) + 3 * max(s, c);
    int k = (int) ans.size();
    cout << "Result: ";
    if (k > 2 * n) {
        cout << 0 << endl;
    } else if (k <= t) {
        cout << 1 << endl;
    } else {
        cout << 0.3 * t * t / k / k << endl;
    }
    cout << "Need: " << t << endl;
#endif
    return ans;
}

vector<int> calc2() {
    int l = 1;
    int r = n;
    int cnt = n;
    int cur_time = 0;
    vector<int> ans;
    while (cnt > 0) {
        if (cur_time % (s + c) < s) {
            ans.push_back(l);
            l += 2;
            if (l - 1 == r)
                l--;
            r++;
            r = min(r, n);
            cnt = r - l + 1;
        } else if (l == r) {
            ans.push_back(l);
            break;
        } else {
            ans.push_back(l + 1);
            l++;
            r--;
            r = max(r, l);
            cnt = r - l + 1;
        }
        cur_time++;
    }
#ifdef LOCAL
    cout << ans.size() << endl;
    for (int el : ans) {
        cout << el << " ";
    }
    cout << endl;
    cout.flush();
    check(n, s, c, ans);
    ldb t = (ldb) n * (s + c) / (s + 2 * max(s, c)) + 3 * max(s, c);
    int k = (int) ans.size();
    cout << "Result: ";
    if (k > 2 * n) {
        cout << 0 << endl;
    } else if (k <= t) {
        cout << 1 << endl;
    } else {
        cout << 0.3 * t * t / k / k << endl;
    }
    cout << "Need: " << t << endl;
#endif
    return ans;
}

vector<int> calc3() {
    int l = 1;
    int r = n;
    int cnt = n;
    int cur_time = 0;
    vector<int> ans;
    while (cnt > 0) {
        if (cur_time % (s + c) < s) {
            ans.push_back(l);
            l += 2;
            if (l == n + 1)
                l--;
            r++;
            r = min(r, n);
            cnt = r - l + 1;
        } else if (l == r) {
            ans.push_back(l);
            break;
        } else {
            ans.push_back(r);
            l++;
            r = max(r, l);
            cnt = r - l + 1;
        }
        cur_time++;
    }
#ifdef LOCAL
    cout << ans.size() << endl;
    for (int el : ans) {
        cout << el << " ";
    }
    cout << endl;
    cout.flush();
    check(n, s, c, ans);
    ldb t = (ldb) n * (s + c) / (s + 2 * max(s, c)) + 3 * max(s, c);
    int k = (int) ans.size();
    cout << "Result: ";
    if (k > 2 * n) {
        cout << 0 << endl;
    } else if (k <= t) {
        cout << 1 << endl;
    } else {
        cout << 0.3 * t * t / k / k << endl;
    }
    cout << "Need: " << t << endl;
#endif
    return ans;
}

vector<int> calc4() {
    int l = 1;
    int r = n;
    int cnt = n;
    int cur_time = 0;
    vector<int> ans;
    while (cnt > 0) {
        if (cur_time % (s + c) < s) {
            ans.push_back(l);
            l += 2;
            if (l == n + 1)
                l--;
            r++;
            r = min(r, n);
            cnt = r - l + 1;
        } else if (l == r) {
            ans.push_back(l);
            break;
        } else {
            ans.push_back(r - 1);
            l++;
            r--;
            l = min(l, r);
            cnt = r - l + 1;
        }
        cur_time++;
    }
#ifdef LOCAL
    cout << ans.size() << endl;
    for (int el : ans) {
        cout << el << " ";
    }
    cout << endl;
    cout.flush();
    check(n, s, c, ans);
    ldb t = (ldb) n * (s + c) / (s + 2 * max(s, c)) + 3 * max(s, c);
    int k = (int) ans.size();
    cout << "Result: ";
    if (k > 2 * n) {
        cout << 0 << endl;
    } else if (k <= t) {
        cout << 1 << endl;
    } else {
        cout << 0.3 * t * t / k / k << endl;
    }
    cout << "Need: " << t << endl;
#endif
    return ans;
}


vector<int> calc5(int start) {
    if (s <= c) {
        return vector<int>(n,-1);
    }
    int l1 = 1;
    int r1 = start - 1;
    int l = start;
    int r = n;
    int cnt = r - l + 1;
    int cur_time = 0;
    vector<int> ans;
    while (cnt > 0) {
        if (cur_time % (s + c) < s) {
            l1--;
            r1--;
            l1 = max(l1, 1);
            r1 = max(r1, l1);
            ans.push_back(l);
            l += 2;
            if (l == n + 1)
                l--;
            r++;
            r = min(r, n);
            cnt = r - l + 1;
        } else if (l == r) {
            l1++;
            r1++;
            ans.push_back(l);
            cur_time++;
            break;
        } else {
            l1++;
            r1++;
            ans.push_back(r - 1);
            l++;
            r--;
            l = min(l, r);
            cnt = r - l + 1;
        }
        cur_time++;
    }
    l = l1;
    r = r1;
    cnt = r - l + 1;
    while (cnt > 0) {
        if (cur_time % (s + c) < s) {
            ans.push_back(r);
            r -= 2;
            if (r == l - 1) {
                r++;
            }
            l--;
            l = max(l, 1);
            cnt = r - l + 1;
        } else if (l == r) {
            ans.push_back(l);
            break;
        } else {
            ans.push_back(r - 1);
            l++;
            r--;
            l = min(l, r);
            cnt = r - l + 1;
        }
        cur_time++;
    }
#ifdef LOCAL
    cout << ans.size() << endl;
    for (int el : ans) {
        cout << el << " ";
    }
    cout << endl;
    cout.flush();
    check(n, s, c, ans);
    ldb t = (ldb) n * (s + c) / (s + 2 * max(s, c)) + 3 * max(s, c);
    int k = (int) ans.size();
    cout << "Result: ";
    if (k > 2 * n) {
        cout << 0 << endl;
    } else if (k <= t) {
        cout << 1 << endl;
    } else {
        cout << 0.3 * t * t / k / k << endl;
    }
    cout << "Need: " << t << endl;
#endif
    return ans;
}

void solve() {
    cin >> n >> s >> c;
    vector<vector<int>> anss;
    anss.push_back(calc(1));
    anss.push_back(calc((n + 2) / 3));
    anss.push_back(calc((2 * n + 2) / 3));
    anss.push_back(calc(n));
    anss.push_back(calc2());
    anss.push_back(calc3());
    anss.push_back(calc4());
    anss.push_back(calc5(min(n, max(1, n / 2))));
    anss.push_back(calc5(min(n, max(1, (n + 2) / 3))));
    anss.push_back(calc5(min(n, max(1, (n + 2) / 4))));
    anss.push_back(calc5(min(n, max(1, (n + 2) / 5))));
    anss.push_back(calc5(min(n, max(1, (n + 2) / 6))));
    anss.push_back(calc5(min(n, max(1, (n + 2) / 7))));
    size_t min_sz = ULONG_MAX;
    for (int i = 0; i < (int) anss.size(); i++) {
        min_sz = min(min_sz, anss[i].size());
    }
    vector<int> ans;
    for (auto &el : anss) {
        if (el.size() == min_sz) {
            ans = el;
            break;
        }
    }
    cout << ans.size() << endl;
    for (int el : ans) {
        cout << el << " ";
    }
    cout << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    while (t--) {
        solve();
    }
}
