#include <algorithm>
#include <iostream>
#include <cstring>
#include <iomanip>
#include <bitset>
#include <math.h>
#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <stack>
#include <map>

#define pii pair<long long, long long>
#define ll long long
#define MOD (int)1e9 + 7

using namespace std;

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	int n, s, c;
	cin >> n >> s >> c;
	if (s == 0) {
		vector<int> out;
		for (int i = 0; i < n / 2 + 2; i++)
			out.push_back(n / 2);

		cout << out.size() << endl;
		for (int i = 0; i < n - 1; i++) {
			cout << out[i] << " ";
		}
		cout << out[out.size() - 1] << endl;

		return 0;
	}
	if (c == 0) {
		vector<int> out;
		int passed = 0;
		for (int i = n / 2; i <= n; i += 2) {
			out.push_back(i);
			passed++;
		}
		if (out[out.size() - 1] != n)
		{
			out.push_back(n);
			passed++;
		}

		for (int i = n / 2 - passed - 1; i >= 1; i -= 2) {
			out.push_back(i);
		}

		if (out[out.size() - 1] != 1)
			out.push_back(1);

		cout << out.size() << endl;
		for (int i = 0; i < out.size() - 1; i++) {
			cout << out[i] << " ";
		}
		cout << out[out.size() - 1] << endl;
		return 0;
	}

	int l = 1, time = 0;
	vector<int> out;
	while (time < n - 1) {
		
		int rem = time % (s + c);

		if (rem < s) 
			out.push_back(1);
		else
			out.push_back(n);
		time++;
	}

	out.push_back(n);

	cout << out.size() << endl;
	for (int i = 0; i < n - 1; i++) {
		cout << out[i] << " ";
	}
	cout << out[out.size() - 1] << endl;
}