#include <algorithm>
#include <iostream>
#include <cstring>
#include <iomanip>
#include <bitset>
#include <math.h>
#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <stack>
#include <map>
#define pii pair<long long, long long>
#define ll long long
#define MOD (int)1e9 + 7
using namespace std;
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n, s, c;
    cin >> n >> s >> c;
    if (s == 0) {
        vector<int> out;
        for (int i = 0; i < n / 2 + 2; i++)
            out.push_back(n / 2);
        cout << out.size() << endl;
        for (int i = 0; i < out.size() - 1; i++) {
            cout << out[i] << " ";
        }
        cout << out[out.size() - 1] << endl;
        return 0;
    }
    if (c == 0) {
        vector<int> out;
        bool turn = true;
        int l = n / 3 + 1, r = 2 * n / 3;
        for (; l <= r;) {
            if (turn) {
                out.push_back(l);
                turn = false;
                l++;
            }
            else {
                out.push_back(r);
                turn = true;
                r--;
            }
        }
        out.push_back(1);
        out.push_back(n);
        cout << out.size() << endl;
        for (int i = 0; i < out.size() - 1; i++) {
            cout << out[i] << " ";
        }
        cout << out[out.size() - 1] << endl;
        return 0;
    }
    int l = 1, r = n, time = 0;
    vector<int> out;
    while (time < n - 1 && l <= r) {
        int rem = time % (s + c);
        if (rem < s)
        {
            out.push_back(l);
            l += 2;
            r++;
            if (r > n)
                r = n;
        }
        else
        {
            int place = r - (c - 1);
            for (int j = 0; j < c; j++)
            {
                out.push_back(place);
                l++;
            }
            r = place - (c - 1);
        }
        time++;
    }
    out.push_back(n);
    cout << out.size() << endl;
    for (int i = 0; i < out.size(); i++) {
        cout << out[i] << " ";
    }
    cout << out[out.size() - 1] << endl;
}