#include <vector>

using namespace std;

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol) {
    vector<bool> ans;
    for(int i = 0,j = 0;i < b.size() && j < sol.size(); ++i) {
        if(b[i] == sol[j]) {
            ans.push_back(1);
            ++j;
        } else {
            ans.push_back(0);
        }
    }
    while(ans.size() && !ans.back()) ans.pop_back();
    return ans;
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint) {
    vector<int> ans;
    for(int i = 0;i < hint.size(); ++i) {
        if(hint[i]) {
            ans.push_back(b[i]);
        }
    }
    return ans;
}

