#include <bits/stdc++.h>>
#include "hint.h"

using namespace std;

/**
vector<int> dumb(vector<int>a,vector<int>b){
  int n=a.size(),m=b.size();
  assert(n*m<=(int)1e8);
  vector<vector<int>>dp(n+1,vector<int>(m+1,0));
  vector<vector<int>>par(n+1,vector<int>(m+1,0));
  for (int i=1;i<=n;i++){
    for (int j=1;j<=m;j++){
      if (a[i-1]==b[j-1]){
        dp[i][j]=1+dp[i-1][j-1];
        par[i][j]=1;
      }else{
        if (dp[i-1][j]>dp[i][j-1]){
          dp[i][j]=dp[i-1][j];
          par[i][j]=2;
        }else{
          dp[i][j]=dp[i][j-1];
          par[i][j]=3;
        }
      }
    }
  }
  vector<int>sol;
  int i=n,j=m;
  while (i&&j){
    if (par[i][j]==1){
      sol.push_back(a[i-1]);
      i--;
      j--;
    }else{
      if (par[i][j]==2){
        i--;
      }else{
        assert(par[i][j]==3);
        j--;
      }
    }
  }
  assert((int)sol.size()==dp[n][m]);
  reverse(sol.begin(),sol.end());
  return sol;
}**/

const int INF=(int)1e9;

vector<int>app(vector<int>a){
  vector<int>sol={0};
  for (auto &x:a){
    sol.push_back(x);
  }
  return sol;
}

vector<int> otherdumb(vector<int>a,vector<int>b){ /// use this when |a| is small
  int n=a.size(),m=b.size();
  a=app(a);
  b=app(b);
  /// n is small
  vector<vector<int>> dp(n+1,vector<int>(n+1,INF)); ///dp[len][pos] = min pos in B so that the solution is valid
  vector<vector<int>> par(n+1,vector<int>(n+1,INF)); ///par[len][pos]

  /// len=0
  for (int i=0;i<=n;i++){
    dp[0][i]=0;
  }

  /// len>=1
  int mxlen=0;
  for (int len=0;len<n;len++){
    /// propag?
    for (int i=1;i<n;i++){
      if (dp[len][i]==INF)continue;
      int curpos=dp[len][i];
      if (curpos<dp[len][i+1]){
        dp[len][i+1]=curpos;
        par[len][i+1]=1;
      }
      int nxt=-1;
      for (int j=curpos+1;j<=m;j++){
        if (b[j]==a[i+1]){
          nxt=j;
          break;
        }
      }
      if (nxt!=-1){
        if (nxt<dp[len+1][i+1]){
          dp[len+1][i+1]=nxt;
          par[len+1][i+1]=2;
        }
      }
    }
    for (int i=1;i<=n;i++){
      if (dp[len][i]!=INF){
        mxlen=len;
        break;
      }
    }
    if (mxlen!=len)break;
  }
  int i=-1;
  for (int ind=1;ind<=n;ind++){
    if (dp[mxlen][ind]!=INF){
      i=ind;
      break;
    }
  }
  assert(i!=-1);
  int len=mxlen;
  vector<int>sol;

  while (len){
    assert(i>=1);
    if (par[len][i]==1){
      i--;
    }else{
      assert(par[len][i]==2);
      sol.push_back(a[i]);
      len--;
      i--;
    }
  }

  reverse(sol.begin(),sol.end());

  assert((int)sol.size()==mxlen);
  return sol;
}

vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol){
 // int n=(int)a.size();
  vector<bool> kek;
  return kek;
  int n=a.size(),pt=0;
  for (int i=0;i<n;i++){
    if (pt<(int)sol.size()&&a[i]==sol[pt]){
      kek.push_back(1);
      pt++;
    }else{
      kek.push_back(0);
    }
  }
  return kek;
}

vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint){
 // assert((int)hint.size()==(int)a.size());
  return otherdumb(a,b);
  vector<int>sol;
  for (int i=0;i<a.size();i++){
    if (hint[i])sol.push_back(a[i]);
  }
  return sol;
}
