#include <bits/stdc++.h>>
#include "hint.h"

using namespace std;



const int INF=(int)1e9;

vector<int>app(vector<int>a){
  vector<int>sol={0};
  for (auto &x:a){
    sol.push_back(x);
  }
  return sol;
}


void print(vector<int>a){
  cout<<" ---> ";
  for (auto &x:a){
    cout<<x<<" ";
  }
  cout<<"\n";
}

vector<int> otherdumb(vector<int>a,vector<int>b,int mx){ /// use this when |a| is small
  if (a.empty()||b.empty()){
    return {};
  }
  int n=a.size(),m=b.size();
  a=app(a);
  b=app(b);
  /// n is small
  vector<vector<int>> dp(n+1,vector<int>(n+1,INF)); ///dp[len][pos] = min pos in B so that the solution is valid
  vector<vector<int>> par(n+1,vector<int>(n+1,INF)); ///par[len][pos]

  vector<vector<int>>where(mx+1);

  for (int i=1;i<=m;i++){
    where[b[i]].push_back(i);
  }

  /// len=0
  dp[0][0]=0;

  /// len>=1
  int mxlen=0;
  for (int len=0;len<n;len++){
    for (int i=0;i<n;i++){
    /// propag?
      if (dp[len][i]==INF)continue;
      int curpos=dp[len][i];
      if (curpos<dp[len][i+1]){
        dp[len][i+1]=curpos;
        par[len][i+1]=1;
      }
      if (where[a[i+1]].empty())continue;
      if (curpos+1>where[a[i+1]].back())continue;
      int low=0,high=(int)where[a[i+1]].size()-1,nxt=-1;
      while (low<=high){
        int mid=(low+high)/2;
        if (where[a[i+1]][mid]>=curpos+1){
          nxt=where[a[i+1]][mid];
          high=mid-1;
        }else{
          low=mid+1;
        }
      }
      if (nxt<dp[len+1][i+1]){
        dp[len+1][i+1]=nxt;
        par[len+1][i+1]=2;
      }

    }
    for (int i=1;i<=n;i++){
      if (dp[len+1][i]!=INF){
        mxlen=len+1;
        break;
      }
    }
    if (mxlen!=len+1)break;
  }
  int i=-1;
  for (int ind=1;ind<=n;ind++){
    if (dp[mxlen][ind]!=INF){
      i=ind;
      break;
    }
  }
  assert(i!=-1);
  int len=mxlen;
  vector<int>sol;

  while (len){
    assert(i>=1);
    if (par[len][i]==1){
      i--;
    }else{
      assert(par[len][i]==2);
      sol.push_back(a[i]);
      len--;
      i--;
    }
  }

  reverse(sol.begin(),sol.end());

  assert((int)sol.size()==mxlen);
  return sol;
}

int getlog(int x){
  if (x<=1)return 0;
  return 1+getlog(x/2);
}


vector<bool> gen(vector<int>a,vector<int>b,vector<int>sol,int k){
  if ((int)b.size()<(int)a.size())swap(a,b);
  int n=(int)a.size(),m=(int)b.size();
  int sz=max(n,m)+2;
  vector<int>bucket(sz+1);
  vector<int>first(sz+1),last(sz+1);

  for (int i=0;i<=sz;i++){
    bucket[i]=i/k;
    last[bucket[i]]=i;
  }
  for (int i=sz;i>=0;i--){
    first[bucket[i]]=i;
  }

  int lg=getlog(sz);

  vector<pair<int,int>> prs((int)sol.size());

  {
    int j=0;
    for (int i=0;i<n;i++){
      if (j<(int)sol.size()&&a[i]==sol[j]){
        prs[j].first=i;
        j++;
      }
    }
  //  cout<<" : "<<j<<" ves "<<(int)sol.size()<<"\n";
    assert(j==(int)sol.size());
  }

  {
    int j=0;
    for (int i=0;i<m;i++){
      if (j<(int)sol.size()&&b[i]==sol[j]){
        prs[j].second=i;
        j++;
      }
    }
   // cout<<" : "<<j<<" ves "<<(int)sol.size()<<"\n";;
    assert(j==(int)sol.size());
  }

  int pt=0;

  vector<bool> hint;


  for (int b=bucket[0];b<=bucket[n-1];b++){
    int l=first[b];
    int r=last[b];
    while (pt<(int)prs.size()&&prs[pt].first<l){
      pt++;
    }
    if (pt<(int)prs.size()&&prs[pt].first<=r){
      //cout<<"aici\n";
      assert(prs[pt].first>=l);
      for (int bit=0;bit<=lg;bit++){
        if ((prs[pt].first+1)&(1<<bit))hint.push_back(1);
        else hint.push_back(0);
      }
      assert((1<<(lg+1))>prs[pt].first+1);
      for (int bit=0;bit<=lg;bit++){
        if ((prs[pt].second+1)&(1<<bit))hint.push_back(1);
        else hint.push_back(0);
      }
      assert((1<<(lg+1))>prs[pt].second+1);
    //  cout<<prs[pt].first+1<<" "<<prs[pt].second+1<<"\n";
    }else{
      for (int bit=0;bit<=lg;bit++){
        hint.push_back(0);
      }
      for (int bit=0;bit<=lg;bit++){
        hint.push_back(0);
      }
    //  cout<<"0 0\n";
    }
  }
  //cout<<"\n";

  return hint;
}

vector<int> read(vector<int>a,vector<int>b,vector<bool> hint,int k){
  if ((int)b.size()<(int)a.size())swap(a,b);
  /**{
    vector<int>x={1};
    vector<int>y={};
    cout<<otherdumb(x,y,10).size()<<"\n";
    exit(0);
  }**/
  int n=(int)a.size(),m=(int)b.size();
  int sz=max(n,m)+2;
  vector<int>bucket(sz+1);
  vector<int>first(sz+1),last(sz+1);

  for (int i=0;i<=sz;i++){
    bucket[i]=i/k;
    last[bucket[i]]=i;
  }
  for (int i=sz;i>=0;i--){
    first[bucket[i]]=i;
  }

  int lg=getlog(sz);

  int pt=0;


  vector<pair<int,int>>semiprs;

 // cout<<lg<<"\n";

  for (int b=bucket[0];b<=bucket[n-1];b++){
    int x=0,y=0;
    for (int bit=0;bit<=lg;bit++){
      assert(pt<(int)hint.size());
      if (hint[pt])x+=(1<<bit);
      pt++;
    }
    for (int bit=0;bit<=lg;bit++){
      assert(pt<(int)hint.size());
      if (hint[pt])y+=(1<<bit);
      pt++;
    }


   // cout<<" = "<<x<<" and "<<y<<"\n";

    x--;
    y--;



    if(x==-1)assert(y==-1);
    if(y==-1)assert(x==-1);
    semiprs.push_back({x,y});
  }
  //cout<<"\n\n";
  assert(bucket[0]==0);
  vector<int> nxt((int)semiprs.size());
  for (int i=(int)nxt.size()-1;i>=0;i--){
    if (i==(int)nxt.size()-1){
      nxt[i]=m-1;
    }else{
      if (semiprs[i+1].second!=-1){
        nxt[i]=semiprs[i+1].second-1;
      }else{
        nxt[i]=nxt[i+1];
      }
    }
  }
  vector<int>sol;
  for (int i=0;i<(int)semiprs.size();i++){
    int x=semiprs[i].first,y=semiprs[i].second;
    if (x==-1)continue;


    sol.push_back(a[x]);


    int l1=x+1,r1=min(n-1,last[i]);
    int l2=y+1,r2=nxt[i];



    vector<int>ff,ss;
    for (int i=l1;i<=r1;i++)ff.push_back(a[i]);
    for (int i=l2;i<=r2;i++)ss.push_back(b[i]);
    vector<int>kek=otherdumb(ff,ss,sz);

    //cout<<"aici : "<<i<<" out of "<<(int)semiprs.size()<<" : "<<(int)ff.size()<<" ves "<<(int)ss.size()<<"\n";

    for (auto &it:kek){
      sol.push_back(it);
    }
  }
  return sol;
}

const int K=750;

vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol){
  //cout<<" = "<<(int)sol.size()<<"\n";
  vector<bool> v0=gen(a,b,sol,K);
  //vector<bool> v1=gen(a,b,sol,2);
  //vector<bool> v2=gen(a,b,sol,3);
  //vector<bool> v3=gen(a,b,sol,4);

  return v0;
}

vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint){
  return read(a,b,hint,K);
}
