#include <bits/stdc++.h>>
#include "hint.h"

using namespace std;



const int INF=(int)1e9;

vector<int>app(vector<int>a){
  vector<int>sol={0};
  for (auto &x:a){
    sol.push_back(x);
  }
  return sol;
}


void print(vector<int>a){
  cout<<" ---> ";
  for (auto &x:a){
    cout<<x<<" ";
  }
  cout<<"\n";
}

vector<int> otherdumb(vector<int>a,vector<int>b,int mx){ /// use this when |a| is small
  if (a.empty()||b.empty()){
    return {};
  }
  int n=a.size(),m=b.size();
  a=app(a);
  b=app(b);
  /// n is small
  vector<vector<int>> dp(n+1,vector<int>(n+1,INF)); ///dp[len][pos] = min pos in B so that the solution is valid
  vector<vector<int>> par(n+1,vector<int>(n+1,INF)); ///par[len][pos]

  vector<vector<int>>where(mx+1);

  for (int i=1;i<=m;i++){
    where[b[i]].push_back(i);
  }

  /// len=0
  dp[0][0]=0;

  /// len>=1
  int mxlen=0;
  for (int len=0;len<n;len++){
    for (int i=0;i<n;i++){
    /// propag?
      if (dp[len][i]==INF)continue;
      int curpos=dp[len][i];
      if (curpos<dp[len][i+1]){
        dp[len][i+1]=curpos;
        par[len][i+1]=1;
      }
      if (where[a[i+1]].empty())continue;
      if (curpos+1>where[a[i+1]].back())continue;
      int low=0,high=(int)where[a[i+1]].size()-1,nxt=-1;
      while (low<=high){
        int mid=(low+high)/2;
        if (where[a[i+1]][mid]>=curpos+1){
          nxt=where[a[i+1]][mid];
          high=mid-1;
        }else{
          low=mid+1;
        }
      }
      if (nxt<dp[len+1][i+1]){
        dp[len+1][i+1]=nxt;
        par[len+1][i+1]=2;
      }

    }
    for (int i=1;i<=n;i++){
      if (dp[len+1][i]!=INF){
        mxlen=len+1;
        break;
      }
    }
    if (mxlen!=len+1)break;
  }
  int i=-1;
  for (int ind=1;ind<=n;ind++){
    if (dp[mxlen][ind]!=INF){
      i=ind;
      break;
    }
  }
  assert(i!=-1);
  int len=mxlen;
  vector<int>sol;

  while (len){
    assert(i>=1);
    if (par[len][i]==1){
      i--;
    }else{
      assert(par[len][i]==2);
      sol.push_back(a[i]);
      len--;
      i--;
    }
  }

  reverse(sol.begin(),sol.end());

  assert((int)sol.size()==mxlen);
  return sol;
}

int getlog(int x){
  if (x<=1)return 0;
  return 1+getlog(x/2);
}


vector<bool> gen(vector<int>a,vector<int>b,vector<int>sol,int k){
  if ((int)b.size()<(int)a.size())swap(a,b);
  int n=(int)a.size();

  int lg=getlog(n);


  vector<int> all;

  int j=0;
  for (int i=0;i<n;i++){
    if (j<(int)sol.size()&&a[i]==sol[j]){
      all.push_back(i);
      j++;
    }
  }
  assert(j==(int)sol.size());

  vector<bool> hint;
  sol=all;
  for (int i=0;i<(int)sol.size();i++){
    if (i%k==0){
      for (int bit=0;bit<=lg;bit++){
        if (sol[i]&(1<<bit))hint.push_back(1);
        else hint.push_back(0);
      }
    }
  }

  return hint;
}

vector<int> read(vector<int>a,vector<int>b,vector<bool> hintbool,int k){
  if ((int)b.size()<(int)a.size())swap(a,b);
  int n=(int)a.size(),m=(int)b.size();

  int lg=getlog(n);

  int pt=0;

  vector<int>guys;
  while (pt<(int)hintbool.size()){
    int cur=0;
    for (int bit=0;bit<=lg;bit++){
      assert(pt<(int)hintbool.size());
      if (hintbool[pt])cur+=(1<<bit);
      pt++;
    }
    guys.push_back(cur+1);
  }
  assert(pt==(int)hintbool.size());

  a=app(a);
  b=app(b);

  //vector<vector<int>> dp(n+1,vector<int>(n+1,INF)); ///dp[len][pos] = min pos in B so that the solution is valid
  //vector<vector<int>> par(n+1,vector<int>(n+1,INF)); ///par[len][pos]


  for (int j=0;j<(int)guys.size();j++){
    int l=guys[j];
    int r;
    if (j==(int)guys.size()-1){
      r=n-1;
    }else{
      r=guys[j+1]-1;
    }
  }



  vector<int>sol;
  for (auto &i:guys){
    sol.push_back(a[i]);
  }

  return sol;
  print(guys);
  exit(0);

  return sol;
}

const int K=2;

vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol){
  //cout<<" = "<<(int)sol.size()<<"\n";
  vector<bool> v0=gen(a,b,sol,K);
  //vector<bool> v1=gen(a,b,sol,2);
  //vector<bool> v2=gen(a,b,sol,3);
  //vector<bool> v3=gen(a,b,sol,4);

  return v0;
}

vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint){
  return read(a,b,hint,K);
}
