#include "hint.h"

// #include <iostream>
// #include <vector>

// static int n, m, k;
// static std::vector<int> a, b, sol, maybeSol;
// static std::vector<bool> hint;


std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol) {
    std::vector<bool> ans(a.size(), 0);
    int cur_pointer = 0;
    // sol.push_back(-INT_MAX);
    for (int i = 0; i < a.size(); i++) {
        if (cur_pointer >= sol.size()) continue;
        if (sol[cur_pointer] == a[i]) {
            ans[i] = 1;
            cur_pointer++;
        }
    }
    // sol.pop_back();
    return ans;
}
std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint) {
    std::vector<int> rez;
    for (int i = 0; i < hint.size(); i++) {
        if (hint[i]) {
            rez.push_back(a[i]);
        }
    }
    return rez;
}


// int main()
// {
//     std::cin >> n >> m;

//     a.resize(n);
//     b.resize(m);

//     for (int& num : a)
//     {
//         std::cin >> num;
//     }

//     for (int& num : b)
//     {
//         std::cin >> num;
//     }

//     std::cin >> k;

//     sol.resize(k);

//     for (int& num : sol)
//     {
//         std::cin >> num;
//     }

//     hint = genHint(a, b, sol);
//     for (auto i : hint) {
//         std::cout << i << ' ';
//     }
//     std::cout << "\n";
//     maybeSol = solve(a, b, hint);

//     std::cout << hint.size() << std::endl;
//     std::cout << maybeSol.size() << std::endl;

//     for (int i = 0; i < (int) maybeSol.size(); ++i)
//     {
//         if (i > 0) std::cout << " ";
//         std::cout << maybeSol[i];
//     }
//     std::cout << std::endl;

//     return 0;
// }
