#include <vector>
#include "hint.h"

using namespace std;

const int N = 16;
vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol) {
    vector<bool> hint;
    for (int i = 0; i < (int)sol.size(); i++) {
        for (int bit = 0; bit < N; bit++) {
            hint.push_back(1 & (sol[i] >> bit));
        }
    }
    return hint;
}
vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint) {
    vector<int> sol;
    int ans = 0;
    for (int i = 0; i < (int)hint.size(); i++) {
        if (i % N == 0)ans = 0;
        if (hint[i])
            ans += (1 << (i % N));
        if (i % N == N - 1)sol.push_back(ans);
    }
    return sol;
}
