#include <bits/stdc++.h>

using namespace std;

int n;
int t[10101], h[10101];
vector<int> g[10101];
int ans = 0;
int In[10101];

bool used[10101];
int mt[10101];
bool has[10101];
bool dfs(int v) {
    if (used[v])return false;
    used[v] = true;
    for (auto to : g[v]) {
        if (mt[to] == -1 || dfs(mt[to])) {
            mt[to] = v;
            return true;
        }
    }
    return false;
}
vector<int> go;
void crBFS() {
    queue<int> nw;
    for (int i = 1; i <= n; i++) {
        if (In[i] == 0) {
            go.push_back(i);
            nw.push(i);
            used[i] = true;
        }
    }
    while (!nw.empty()) {
        int v = nw.front();
        nw.pop();
        for (auto to : g[v]) {
            if (used[to])continue;
            nw.push(to);
            go.push_back(to);
            used[to] = true;
        }
    }
    for (int i = 1; i <= n; i++)used[i] = false;
}
int color[10101];
int MT[10101];
void dfsGood(int v) {
    if (v == -1)return;
    color[v] = true;
    dfsGood(MT[v]);
}
void dfsReverse(int v) {
    if (v == -1)return;
    color[v] = true;
    dfsReverse(mt[v]);
}
int main() {
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    cin >> n;
    for (int i = 1; i <= n; i++) {
        cin >> t[i] >> h[i];
    }
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            if (i == j)continue;
            if (t[j] - t[i] >= 0 && abs(h[j] - h[i]) <= t[j] - t[i]) {
                g[i].push_back(j);
                In[j]++;
            }
        }
    }
    crBFS();
    for (int i = 1; i <= n; i++) {
        mt[i] = -1;
        MT[i] = -1;
    }
    for (int v = 1; v <= n; v++) {
        for (auto to : g[v]) {
            if (mt[to] == -1) {
                mt[to] = v;
                has[v] = true;
                break;
            }
        }
    }
    for (int i = 0; i < (int)go.size(); i++) {
        if (has[go[i]])continue;
        for (int j = 1; j <= n; j++)used[j] = false;
        dfs(go[i]);
    }
    for (int i = 1; i <= n; i++) {
        if (mt[i] != -1)
            MT[mt[i]] = i;
    }
    for (int i = 1; i <= n; i++) {
        if (color[i])continue;
        dfsGood(i);
        dfsReverse(i);
        ans++;
    }
    cout << ans;
}
