#include "hint.h"
#include <bits/stdc++.h>
using namespace std;
#define pb push_back
const int N = 1e4 + 10;
std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol) {
	vector <bool> ans;
	int n = (int)a.size(),m = (int)b.size();
	if(n < m) {
		for(int i = 0;i < n;i++) {
			ans.pb(0);
		}
		int R = 0;
		for(int i = 0;i < n;i++) {
			if(R < sol.size() && sol[R] == a[i]) {
				ans[i] = 1;
				R++;
			}
		}
	}else {
		for(int i = 0;i < m;i++)ans.pb(0);
		int R = 0;
		for(int i = 0;i < m;i++) {
			if(R < sol.size() && sol[R] == b[i]) {
				ans[i] = 1;
				R++;
			}
		}
	}
	return ans;
}
std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint) {
	vector <int> ans;
	int n = (int)a.size(),m = (int)b.size();
	if(n < m) {
		for(int i = 0;i < n;i++) {
			if(hint[i])ans.pb(a[i]);
		}
	}else {
		for(int i = 0;i < m;i++) {
			if(hint[i])ans.pb(b[i]);
		}
	}
	return ans;
}