#include "hint.h"
#include <bits/stdc++.h>
using namespace std;
#define pb push_back
#define pii pair <int,int>
#define f first
#define s second
#define mp make_pair
const int N = 1e4 + 10;
std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol) {
	vector <bool> ans;
	int n = (int)a.size(),m = (int)b.size();
	if(n < m) {
		for(int i = 0;i < n;i++) {
			ans.pb(0);
		}
		int R = 0;
		for(int i = 0;i < n;i++) {
			if(R < sol.size() && sol[R] == a[i]) {
				ans[i] = 1;
				R++;
			}
		}
	}else {
		for(int i = 0;i < m;i++)ans.pb(0);
		int R = 0;
		for(int i = 0;i < m;i++) {
			if(R < sol.size() && sol[R] == b[i]) {
				ans[i] = 1;
				R++;
			}
		}
	}
	vector <bool> Van;
	Van.pb(1);
	if(n < N && m < N)return Van;
	return ans;
}
short dp[2][N];
pair <short,short> pr[N][N];
bitset <N> u[N];
std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint) {
	vector <int> ans;
	int n = (int)a.size(),m = (int)b.size();
	if(n < N && m < N) {
		int p = 1;
		for(int i = 0;i < n;i++) {
			for(int j = 0;j < m;++j) {
				if(a[i] == b[j]) {
					if(j == 0 || i == 0)dp[p][j] = 1;
					else dp[p][j] = dp[p ^ 1][j - 1] + 1;
					pr[i][j] = mp(i - 1,j - 1);
					u[i][j] = 1;
				}
				if(j > 0 && dp[p][j - 1] > dp[p][j]) {
					dp[p][j] = dp[p][j - 1];
					pr[i][j] = mp(i,j - 1);
					u[i][j] = 0;
				}
				if(i > 0 && dp[p ^ 1][j] > dp[p][j]) {
					dp[p][j] = dp[p ^ 1][j];
					pr[i][j] = mp(i - 1,j);
					u[i][j] = 0;
				}
			}
			p ^= 1;
		}
		pair <short,short> mx = mp(0,0);
		for(int i = 0;i < m;i++) {
			mx = max(mx,mp(dp[p][i],(short)i));
		}
		//cout << mx.f << endl;
		pii vv = mp(n - 1,mx.s);
		vector <int> ans;
		while(vv.f >= 0 && vv.s >= 0) {
			//cout << vv.f << " " << vv.s << endl;
			if(u[vv.f][vv.s]) {
				ans.pb(a[vv.f]);
			}
			vv = pr[vv.f][vv.s];
		}
		reverse(ans.begin(),ans.end());
		return ans;
	}
	if(n < m) {
		for(int i = 0;i < n;i++) {
			if(hint[i])ans.pb(a[i]);
		}
	}else {
		for(int i = 0;i < m;i++) {
			if(hint[i])ans.pb(b[i]);
		}
	}
	return ans;
}