#include <bits/stdc++.h>
#include "hint.h"
using namespace std;
#define MAXN 200005

int dp[2000][2000];
pair<int,int> p[2000][2000];

void push_num(int num,vector<bool>& res){
    for(int i=0;i<=17;i++,num>>=1){
        res.push_back((num&1)?true:false);
    }
}

int pull_num(int& pos,vector<bool> res){
    int a=1;
    int ans=0;
    for(int i=0;i<=17;i++,pos++,a<<=1){
        ans+=a*((int)res[pos]);
    }
    return ans;
}

vector<bool> genHint(const vector<int>& a,const vector<int>& b,const vector<int>& sol){
    //first find the positions on arrays of the lcs
    vector<pair<int,int>> pos_lcs;//(posa,posb)
    int ptra=0;
    int ptrb=0;
    int K=sol.size();
    for(int num:sol){
        while(ptra<a.size()-1&&a[ptra]!=num) ptra++;
        while(ptrb<b.size()-1&&b[ptrb]!=num) ptrb++;
        pos_lcs.push_back({ptra,ptrb});
        ptra++;
        ptrb++;
    }
    int k=1000;
    vector<pair<pair<int,int>,pair<int,int>>> se;//((starta,enda),(startb,endb))
    int cnt=0;
    int sa=pos_lcs[0].first,sb=pos_lcs[0].second;
    for(int i=0;i<sol.size();i++){
        pair<int,int> p=pos_lcs[i];
        cnt++;
        if(i==sol.size()-1){
            se.push_back({{sa,p.first},{sb,p.second}});
            continue;
        }
        if(pos_lcs[i+1].first-sa>k||pos_lcs[i+1].second-sb>k||cnt+1>k){
            cnt=0;
            se.push_back({{sa,p.first},{sb,p.second}});
            sa=pos_lcs[i+1].first;
            sb=pos_lcs[i+1].second;
        }
    }
    vector<bool> res;
    //bits have exponents 0 to 17
    for(auto p:se){
        push_num(p.first.first,res);
        push_num(p.first.second,res);
        push_num(p.second.first,res);
        push_num(p.second.second,res);
    }
    return res;
}

vector<int> solve(const vector<int>& a,const vector<int>& b,const vector<bool>& hint){
    vector<int> ans;
    int pos=0;
    while(pos<hint.size()){
        int sa,ea,sb,eb;
        sa=pull_num(pos,hint);
        ea=pull_num(pos,hint);
        sb=pull_num(pos,hint);
        eb=pull_num(pos,hint);
        //lcs
        for(int i=0;i<=ea-sa+1;i++){
            dp[i][0]=0;
            p[i][0]={-1,-1};
        }
        for(int i=0;i<=eb-sb+1;i++){
            dp[0][i]=0;
            p[0][i]={-1,-1};
        }
        for(int i=1;i<=ea-sa+1;i++){
            for(int j=1;j<=eb-sb+1;j++){
                if(a[sa+i-1]==b[sb+j-1]){
                    dp[i][j]=dp[i-1][j-1]+1;
                    p[i][j]={i-1,j-1};
                }else{
                    if(dp[i-1][j]>dp[i][j-1]){
                        dp[i][j]=dp[i-1][j];
                        p[i][j]={i-1,j};
                    }else{
                        dp[i][j]=dp[i][j-1];
                        p[i][j]={i,j-1};
                    }
                }
            }
        }
        vector<int> res;
        pair<int,int> curr={ea-sa+1,eb-sb+1};
        while(p[curr.first][curr.second].first!=-1||p[curr.first][curr.second].second!=-1){
            if(p[curr.first][curr.second].first==curr.first-1&&p[curr.first][curr.second].second==curr.second-1){
                //new letter
                res.push_back(a[sa+curr.first-1]);
            }
            curr=p[curr.first][curr.second];
        }
        reverse(res.begin(),res.end());
        for(int x:res){
            ans.push_back(x);
        }
    }
    return ans;
}