#include <bits/stdc++.h>
#include "hint.h"

using namespace std;

#define pb push_back
#define fr first
#define sc second

vector <bool> emp;

void engrave(int cor_a, int cor_b, bool ok) ///Encrypting Function (Likely Works)
{
    emp.pb(ok);
    for (int i=17; i>=0; i--)
    {
        int act = ((1<<i)&cor_a);
        bool bit = 0;
        if (act > 0)
        {
            bit = 1;
        }
        emp.pb(bit);
    }
    for (int i=17; i>=0; i--)
    {
        int act = ((1<<i)&cor_b);
        bool bit = 0;
        if (act > 0)
        {
            bit = 1;
        }
        emp.pb(bit);
    }
}

vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& sol)
{
     int MAXDIST1 = 2000;
     int MAXDIST2 = 700;
     int j = 0;
     int c = sol.size();
     pair<int,int> cor[c];
     for (int i=0; i<a.size() and j<c; i++)
     {
         if (a[i] == sol[j])
         {
             cor[j].fr = i;
             j++;
         }
     }
     j = 0;
     for (int i=0; i<b.size() and j<c; i++) ///Find the locations of subsequence elements (Works)
     {
         if (b[i] == sol[j])
         {
             cor[j].sc = i;
             j++;
         }
     }

     pair <int, int> last = cor[0];
     int lcor = 0;
     engrave(last.fr, last.sc, 0);
     for (int i =0; i<c; i++)
     {
         if ((cor[i].fr - last.fr > MAXDIST1 )or (cor[i].sc - last.sc > MAXDIST2) )
         {
             if (i== lcor + 1)
             {
                 engrave(cor[i].fr, cor[i].sc, 0);
                 lcor = i;
                 last = cor[i];
             }
             else if (i==lcor + 2)
             {
                 engrave(cor[i-1].fr, cor[i-1].sc, 0);
                 lcor = i-1;
                 last = cor[i-1];
             }
             else
             {
                 engrave(cor[i-1].fr, cor[i-1].sc, 1);
                 lcor = i-1;
                 last = cor[i-1];
             }
         }
         else if (i==c-1)
         {
             engrave(cor[i].fr, cor[i].sc, 1);
         }
     }
     return emp;
}

vector <bool> code;

pair<int, int> decipher(int start)
{
    pair<int,int> ans = {0, 0};
    for (int i=17; i>=0; i--)
    {
        if (code[start])
        {
            ans.fr = ans.fr | (1<<i);
        }
        start ++;
    }
    for (int i=17; i>=0; i--)
    {
        if (code[start])
        {
            ans.sc = ans.sc | (1<<i);
        }
        start ++;
    }
    return ans;
}

int dp[2001][701];
vector <int> A;
vector <int> B;

int start_a, start_b;

int rec(int i, int j)
{
    if (i==0 or j==0)
    {
        return 0;
    }
    if (dp[i][j] != -1)
    {
        return dp[i][j];
    }
    if (A[i+start_a] == B[j+start_b])
    {
        dp[i][j] = (rec(i-1,j-1) + 1);
    }
    else
    {
        dp[i][j] = max (rec(i-1, j), rec(i, j-1));
    }
    return dp[i][j];
}

 vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint)
{
     int n = a.size();
     int m = b.size();
     A = a;
     B = b;

     code = hint;

     vector <int> sol;

     start_a = 0;
     start_b = 0;

     for (int i=0; i<hint.size(); i+=37)
     {
         bool check = hint[i];
         pair<int,int> coor = decipher(i+1);

         if (check)
         {
             int it_a = (coor.fr - start_a-1);
             int it_b = (coor.sc - start_b-1);
             for (int g=1; g<=it_a; g++)
             {
                 for (int t=1; t<=it_b; t++)
                 {
                     dp[g][t] = -1;
                 }
             }
             rec(it_a, it_b);
             stack <int> temp;
             while (1)
             {
                 if (A[it_a+start_a] == B[it_b+start_b])
                 {
                     temp.push(A[it_a + start_a]);
                     it_a --;
                     it_b --;
                     if (it_a == 0 or it_b ==0)
                     {
                         break;
                     }
                     continue;
                 }
                 if (dp[it_a-1][it_b] == dp[it_a][it_b])
                 {
                     it_a --;
                 }
                 else
                 {
                     it_b --;
                 }
                 if (it_a == 0 or it_b ==0)
                 {
                     break;
                 }
             }
             while (!temp.empty())
             {
                 sol.pb(temp.top());
                 temp.pop();
             }
         }
         sol.pb(A[coor.fr]);
         start_a = coor.fr;
         start_b = coor.sc;
     }
     return sol;
}

/*

5 5
12 2 0 4 3
2 0 4 3 9
4
2 0 4 3

6 7
4 0 2 5 2 4
6 7 0 1 2 1 2
3
0 2 2

*/
