#include "hint.h"
#include <iostream>
#include <vector>
#include <stack>

using namespace std; 

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol){
    return vector<bool>(); 
}

vector<int> seg_solve(int s_a, int e_a, int s_b, int e_b, const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint){
int a_s = e_a - s_a + 1, b_s = e_b - s_b + 1; 
    vector<vector<int>> dp(a_s+1, vector<int>(b_s+1, 0)); 
    for (int sum = 2; sum <= a_s + b_s; ++sum){
        for (int i = 1; i <= min(sum, a_s); ++i){
            int j = sum - i; 
            if (j > b_s || j < 1) continue; 
            dp[i][j] = max(dp[i][j-1], dp[i-1][j]); 
            if (a[s_a + i -1] == b[s_b + j -1]) dp[i][j] = max(dp[i][j], dp[i-1][j-1] + 1);  
        }
    }
    int i = a_s, j = b_s; 
    stack<int> st; 
    while (i > 0 && j > 0){
        if (dp[i][j] == dp[i][j-1]){
            j--;
            continue; 
        }
        if (dp[i][j] == dp[i-1][j]){
            i--; 
            continue; 
        }
        st.push(a[i-1]);   
        i--, j--; 
    }

    vector<int> res;
    while (!st.empty()){
        res.push_back(st.top()); st.pop(); 
    }
    return res; 
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint){
    return seg_solve(0, a.size()-1, 0, b.size()-1, a, b, hint); 
}
