#include <bits/stdc++.h>
#include "hint.h"

#define pb push_back

using namespace std;

int Mx;
inline void get_mx(int len) {
    Mx = 0; while ((1 << Mx) <= len) ++Mx;
}

vector < bool > get(vector < bool > s) {
    vector < bool > res;
    s.pb(0), reverse(s.begin(), s.end());
    s.pb(0), reverse(s.begin(), s.end());
    for (int i = 1; i < s.size(); ++i) {
        if (s[i - 1] != s[i]) {
            int idx = i - 1;
            if (!s[i]) --idx;
            for (int bit = 0; bit < Mx; ++bit) 
                res.pb((idx >> bit) & 1);
        }
    }
    return res;
}

vector<bool> genHint(const vector<int>& a, const std::vector<int>& b, const vector<int>& sol) {
	vector < bool > ans, ansa, ansb;
 	int pt = -1, n = a.size(), m = b.size(), k = sol.size();
 	get_mx(max(n, m)); 
 	for (int i = 0; i < n; ++i) 
        if (pt + 1 < k && sol[pt + 1] == a[i]) ansa.pb(true), ++pt;
    	    else ansa.pb(false);		

    for (int i = 0; i < m; ++i) 
    	if (pt + 1 < k && sol[pt + 1] == b[i]) ansb.pb(true), ++pt;
    		else ansb.pb(false);		
    
    vector < bool > ansA = get(ansa);
    vector < bool > ansB = get(ansb);
    if (ansA.size() <= ansB.size()) {
        if (ansA.size() + 1 <= min(n, m)) {
           for (int i = 0; i < ansA.size(); ++i) ans.pb(ansA[i]); 
           ans.pb(0);
           ans.pb(1);
        }
            else {
            if (n <= m) 
                for (int i = 0; i < ansa.size(); ++i) ans.pb(ansa[i]);
                    else 
                for (int i = 0; i < ansb.size(); ++i) ans.pb(ansb[i]);
            ans.pb(0);        
        }
    }
        else {
        if (ansB.size() + 1 <= min(n, m)) {
            for (int i = 0; i < ansB.size(); ++i) ans.pb(ansB[i]); 
            ans.pb(1);
            ans.pb(1);
        }
            else {
            if (n <= m) 
                for (int i = 0; i < ansa.size(); ++i) ans.pb(ansa[i]);
                    else 
                for (int i = 0; i < ansb.size(); ++i) ans.pb(ansb[i]);
            ans.pb(0);        
        }
    }
	return ans;
}

vector<int> solve(const vector<int>& a, const std::vector<int>& b, const vector<bool>& hint) {
	vector < int > ans;
	int n = a.size(), m = b.size(), k = hint.size();
	get_mx(max(n, m));
	if (hint.back()) {
	    bool t = hint[k - 2];
	    for (int i = 0; i + Mx - 1 < k; i += Mx) {
	       int X = 0;
	       for (int j = 0; j < Mx; ++j) 
	           X += (1 << j) * hint[i + j];
	           
	       if (!t)
	        ans.pb(a[X]);
	            else
	        ans.pb(b[X]);
	    }    
	}
	    else {
	    for (int i = 0; i + 1 < hint.size(); ++i) 
	        if (hint[i] && n <= m) ans.pb(a[i]);
	            else
	        if (hint[i] && n > m) ans.pb(b[i]);
	}
	return ans;
} 
 
/*
main () {
    
}
*/
