#include <bits/stdc++.h>

using namespace std;

vector<pair<int, int>> v;

multiset<pair<int, int>> trucks;
// <a, b> represents a truck that at time t can be between [a - t ... b + t]

int main() {
    int n; cin >> n;
    v.resize(n);
    for(auto &e : v)
        cin >> e.first >> e.second;

    sort(v.begin(), v.end());

    for(int i = 0; i < n; i++) {
        int left = v[i].second + v[i].first;
        int right = v[i].second - v[i].first;

        // looking for a <= left, b >= right in <a, b>

        for(auto it = trucks.begin(); it != trucks.end(); ++it) {
            auto t = *it;
            if(t.first <= left && t.second >= right) {
                trucks.erase(it);
                break;
            }
        }

        trucks.insert({left, right});
    }

    cout << trucks.size() << endl;
    return 0;
}
