#include <bits/stdc++.h>
using namespace std;
const int NMAX = 1e4;
vector<pair<int, int>> v;
vector<int> g[NMAX];
vector<int> rev_g[NMAX];
int nr_sons[NMAX];
int is_lant[NMAX];

void create_lant(int node) {
    if(node == -1) return;
    is_lant[node] = 1;
    int best_son = -1;

    for(auto vec : g[node]) {
        if(best_son == -1) {
            if(is_lant[vec] == 0) {
                best_son = vec;
            }
        }
        else {
            if(nr_sons[best_son] < nr_sons[vec] && is_lant[vec] == 0)
                best_son = vec;
        }
    }

    create_lant(best_son);
}

int main() {
    int n; cin >> n;
    v.resize(n);
    for(auto &e : v)
        cin >> e.first >> e.second;
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < n; j++) {
            if(i == j) continue;
            if(v[i].first < v[j].first) {
                if(v[j].first - v[i].first >= max(v[i].second - v[j].second, v[j].second - v[i].second)) {
                    g[i].push_back(j);
                    rev_g[j].push_back(i);
                    nr_sons[i] += 1;
                }
            }
        }
    }

    int ans = 0;
    for(int i = 0; i < n; i++) {
        if(is_lant[i] == 0) {
            bool start = 1;
            for(auto e : rev_g[i])
                if(is_lant[e] == 0)
                    start = 0;

            if(start) {
                ans += 1;
                create_lant(i);
            }
        }
    }

    cout << ans << endl;
    return 0;
}
