#include <iostream>
#include <vector>
using namespace std;

#define add push_back

vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& sol) {
	vector<bool> s;
	int j = 0;
	if (a.size() > b.size()) {
		for (int i = 0; i < b.size(); i++) {
			if (j < sol.size() && sol[j] == b[i]) {
				s.add(true);
				j++;
			}
			if (j < sol.size() && sol[j] != b[i]) {
				s.add(false);
			}
		}
	}
	else {
		for (int i = 0; i < a.size(); i++) {
			if (j < sol.size() && sol[j] == a[i]) {
				s.add(true);
				j++;
			}
			if (j < sol.size() && sol[j] != a[i]) {
				s.add(false);
			}
		}
	}
	return s;
}

vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint) {
	vector<int> s;
	int j = 0;
	if (a.size() > b.size()) {
		for (int i = 0; i < b.size(); i++) {
			if (i < hint.size() && hint[i]) s.add(b[i]);
		}
	}
	else {
		for (int i = 0; i < a.size(); i++) {
			if (i < hint.size() && hint[i]) s.add(a[i]);
		}
	}
	return s;
}