#include <iostream>
#include <vector>
#include <cmath>

using namespace std;
const int RADNMAX = 500;
const  int NMAX = 10000;

vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& sol)
{
  /*  bool hintA[RADNMAX], hintB[RADNMAX];
    int rada, radb, lena, lenb, i, j, k, nra, nrb, pa, pb;
    lena = a.size();
    lenb = b.size();
    nra = rada = sqrt(lena);
    if (rada * rada != lena)
        nra++;
    nrb = radb = sqrt(radb)
    if (radb * radb != lenb)
        nrb++;
    pa = pb = 0;
    j = k = i = 0;*/
    vector<bool> hint;
    hint.push_back(1);
    return hint;


}
vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint)
{
    int dp[NMAX + 1][NMAX + 1];
    int len1 = a.size(), len2 = b.size(), i, j;
    for (i = 0; i < len1; i++)
        for (j = 0; j < len2; j++)
        {
            if (a[i] == b[j])
                dp[i][j] = dp[i - 1][j - 1] + 1;
            else
                dp[i][j] = max(dp[i - 1][j], dp[i][j - 1]);
        }
    vector<int> sol;
    i = len1, j = len2;
    while (i > 0 && j > 0)
    {
        if (a[i] == b[j])
            sol.push_back(a[i]);
        else
        {
            if (dp[i - 1][j] == dp[i][j])
                i--;
            else
                j--;
        }
    }
    int len = sol.size();
    for (i = 0; i < len / 2; i++)
        swap(sol[i], sol[len - i - 1]);

}
