#include "hint.h"

#include <iostream>
#include <vector>

using namespace std;

static int n, m, k;
static vector<int> a, b, sol, maybeSol;
static vector<bool> hint;

int main()
{
    cin >> n >> m;

    a.resize(n);
    b.resize(m);

    for (int& num : a)
    {
        cin >> num;
    }

    for (int& num : b)
    {
        cin >> num;
    }

    cin >> k;

    sol.resize(k);

    for (int& num : sol)
    {
        cin >> num;
    }

    hint = genHint(a, b, sol);
    maybeSol = solve(a, b, hint);

    cout << hint.size() << endl;
    cout << maybeSol.size() << endl;

    for (int i = 0; i < (int) maybeSol.size(); ++i)
    {
        if (i > 0) cout << " ";
        cout << maybeSol[i];
    }
    cout << endl;

    return 0;
}
