#include <bits/stdc++.h>
#include "hint.h"
#define all(s) s.begin(), s.end()
using namespace std;

vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& sol){
    vector<bool>hint;
    hint.push_back(0);
    return hint;
}

int dp[50005][50005];

vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint){
    int n = a.size(), m = b.size();
    for(int i=1;i<=n;i++){
        for(int j=1;j<=m;j++){
            dp[i][j] = max(dp[i-1][j], dp[i][j-1]);
            if(a[i-1] == b[j-1] && dp[i-1][j-1] + 1 > dp[i][j]){
                dp[i][j] = dp[i - 1][j - 1] + 1;
            }
        }
    }
    int i=n, j=m;
    vector<int>ans;
    while(i >= 1 && j >= 1){
        if(dp[i][j] > dp[i-1][j-1] && a[i-1] == b[j-1]){
            ans.push_back(a[i-1]);
            i--;
            j--;
        }
        else if(dp[i][j] == dp[i-1][j]) i--;
        else if(dp[i][j] == dp[i][j-1]) j--;
        else{
            i--;
            j--;
        }
    }
    reverse(all(ans));
    return ans;
 }


 /**
 6 6
 1 2 1 2 1 2
 3 1 3 1 3 1
 3
 1 1 1


 */
