#include <bits/stdc++.h>

typedef long long ll;

#define MS(x,y) memset((x), (y), sizeof((x)))
#define pb push_back
#define MN 1000000000

using namespace std;

ll n;
pair<ll,ll> deliv[1001];
vector<ll> pat[1001],pat2[1001];
vector<ll> red;
bool vis[1001];
ll left_of[1001],right_of[1001];

void dfs1 (ll pos) {
    if (vis[pos]) return;

    vis[pos] = true;

    for (auto it:pat2[pos]) dfs1(it);
}

bool find_match(ll pos) {
    if (vis[pos]) return false;

    vis[pos] = true;

    for (auto it:pat[pos]) {
        if (left_of[it] == -1) {
            right_of[pos] = it;
            left_of[it] = pos;
            vis[pos] = false;

            return true;
        }
    }

    for (auto it:pat[pos]) {
        if (find_match(left_of[it])) {
            right_of[pos] = it;
            left_of[it] = pos;
            vis[pos] = false;

            return true;
        }
    }

    vis[pos] = false;

    return false;
}

int main() {
    #ifdef LOCAL_DEBUG
        fstream cin("in.txt");
    #endif

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    MS(left_of,-1);
    MS(right_of,-1);

    cin>>n;

    for (ll i = 0; i<n; i++) cin>>deliv[i].first>>deliv[i].second;
    sort(deliv, deliv+n);

    for (ll i = 0; i<n; i++) {
        for (ll j = i+1; j<n; j++) {
            if (deliv[j].first-deliv[i].first >= abs(deliv[j].second-deliv[i].second)) pat[i].pb(j);
        }
    }

    MS(vis,0);
    for (ll i = 0; i<n; i++) find_match(i);

    for (ll i = 0; i<n; i++) if (right_of[i] != -1) pat2[i].pb(right_of[i]);

    MS(vis,0);
    ll res = 0;

    for (ll i = 0; i<n; i++) {
        if (vis[i]) continue;

        res++;
        dfs1(i);
    }

    cout<<res<<endl;
}
