﻿// delivery.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
typedef vector<bool> vb;
typedef vector<int> vi;
typedef pair<int, int> pii;
typedef vector<pii> vp;
const int inf = 1e9;

//ll?
int lis(vi a) {
    int ans = 0;
    int n = a.size();
    vi d(n+1, inf);
    d[0] = -inf;
    for (int i = 0; i < n; i++) {
        int ind = upper_bound(d.begin(), d.end(), a[i]) - d.begin();
        if (d[ind - 1] < a[i] && a[i] < d[ind]) {
            d[ind] = a[i];
            ans = max(ans, ind);
        }
    }
    return ans;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n; cin >> n;
    vp q(n);
    for (int i = 0; i < n; i++) {
        int a, b; cin >> a >> b;
        q[i] = { a, b };
    }
    sort(q.begin(), q.end());
    vi a;
    int t = q[0].first;
    a.push_back(t);
    for (int i = 1; i < q.size(); i++) {
        a.push_back(-1*(q[i].first - (abs(q[i].second - t))));
    }
    int ans = lis(a);
    cout << ans << endl;
    return 0;
}


