﻿// delivery.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
typedef vector<bool> vb;
typedef vector<int> vi;
typedef pair<int, int> pii;
typedef vector<pii> vp;
const int inf = 1e9;

/*int lis(vi a) {
    int ans = 0;
    int n = a.size();
    vi d(n+1, inf);
    d[0] = -inf;
    for (int i = 0; i < n; i++) {
        int ind = upper_bound(d.begin(), d.end(), a[i]) - d.begin();
        if (d[ind - 1] < a[i] && a[i] < d[ind]) {
            d[ind] = a[i];
            ans = max(ans, ind);
        }
    }
    return ans;
}*/

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n; cin >> n;
    vp q(n);
    for (int i = 0; i < n; i++) {
        int a, b; cin >> a >> b;
        q[i] = { a, b };
    }
    sort(q.begin(), q.end());
    /*vi a;
    int t = q[0].first;
    a.push_back(-t);
    for (int i = 1; i < q.size(); i++) {
        a.push_back(-1*(q[i].first - (abs(q[i].second - t))));
    }
    int ans = lis(a);
    cout << ans << endl;
    */
    int cnt = 0;
    vb used(n);
    for (int i = 0; i < n; i++) {
        if (used[i])
            continue;
        cnt++;
        vp dp(n, { 0, -1 });
        for (int j = n - 2; j >= i; j--) {
            if (used[j])
                continue;
            for (int k = j+1; k < n; k++) {
                if (used[k] || (q[k].first < (q[j].first + (abs(q[j].second - q[k].second)))))
                    continue;
                if (dp[k].first + 1 > dp[j].first)
                    dp[j] = { dp[k].first + 1, k };
            }
        }
        int cur = i;
        while (cur != -1) {
            used[cur] = 1;
            cur = dp[cur].second;
        }
    }
    cout << cnt << endl;
    return 0;
}


