#include "hint.h"
#pragma GCC optimize("Ofast")
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define pii pair < int, int > 
#define sz(x) (int)x.size()
#include <bits/stdc++.h>
#define ld long double
#define ll long long 
#define _ << ' ' << 
#define int short

using namespace std;
using namespace __gnu_pbds;

template <typename T>
using ordered_set = tree <T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

mt19937 gen(chrono::system_clock::now().time_since_epoch().count());

static int n, m, k;
static std::vector<int> a, b, sol, maybeSol;
static std::vector<bool> hint;

const int N = 10005;

int dp[N][N];

vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& sol) {
	vector < bool > ret;
    return ret;
}

vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint) {
    vector < int > ans;
    int n = sz(a), m = sz(b);
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= m; j++) {
			dp[i][j] = max(dp[i - 1][j], dp[i][j - 1]);
			if (a[i - 1] == b[j - 1] && dp[i][j] < dp[i - 1][j - 1] + 1) {
				dp[i][j] = dp[i - 1][j - 1] + 1;
			}
		}
	}
	
	int x = n, y = m;
	while (x && y && dp[x][y]) {
		while (y > 1 && dp[x][y - 1] == dp[x][y]) y--;
		while (x > 1 && dp[x - 1][y] == dp[x][y]) x--;
		if (dp[x][y] == dp[x - 1][y - 1] + 1) {
			ans.push_back(a[x - 1]);
			x--; y--;
		}
	}
	reverse(ans.begin(), ans.end());
	return ans;
}

