#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define pii pair < int, int > 
#define sz(x) (int)x.size()
#include <bits/stdc++.h>
#define ld long double
#define ll long long 
#define _ << ' ' << 

using namespace std;
using namespace __gnu_pbds;

template <typename T>
using ordered_set = tree <T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

mt19937 gen(chrono::system_clock::now().time_since_epoch().count());

int n;

vector < pii > v;

bool check(int x) {
	vector < bool > used(n, false);
	for (int j = 1; j <= x; j++) {
		pii p = {-1, -1};
		for (int i = 0; i < n; i++) {
			if (!used[i]) {
				if (p.first == -1 || abs(v[i].second - p.second) <= abs(v[i].first - p.first)) {
					used[i] = true;
					p = v[i];
				}
			}
		}
	}
	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			return false;
		}
	}
	return true;
}

int32_t main() {
	#ifdef LOCAL 
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif // LOCAL
	
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	
	cin >> n;
	v.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> v[i].first >> v[i].second;
	}
	sort(v.begin(), v.end());
					
	int ans = 1;
	int l = 1, r = n;
	while (l <= r) {
		int mid = (l + r) / 2;
		if (check(mid)) {
			ans = mid; 
			r = mid - 1;
		}
		else {
			l = mid + 1;
		}
	}
	
	cout << ans << '\n';
	return 0;
}
