#include "hint.h"
#include <bits/stdc++.h>
using namespace std;

using ll = long long;

std::vector<bool> genHint(const std::vector<int>& _a, const std::vector<int>& _b, const std::vector<int>& sol){
    return {0};
}

const int N = 10000;

short dp[N+5][N+5];

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint){
    int n = a.size(), m = b.size();
    for(int i=1; i<=n; i++){
        for(int j=1; j<=m; j++){
            if(a[i-1] == b[j-1]) dp[i][j] = max(int(dp[i][j]), dp[i-1][j-1] + 1);
            dp[i][j] = max(dp[i][j], dp[i-1][j]);
            dp[i][j] = max(dp[i][j], dp[i][j-1]);
            //cout << i << " " << j << " i " << dp[i][j] << endl;
        }
    }
    stack <int> s;
    int i = n, j = m;
    while(i || j){
        //cout << i << " i " << j << endl;
        if(i && dp[i-1][j] == dp[i][j]){
            i--;
        }
        else if(j && dp[i][j-1] == dp[i][j]){
            j--;
        }
        else{
            s.push(a[i-1]);
            i--;
            j--;
        }
    }
    vector <int> soln;
    while(s.size()){
        soln.push_back(s.top());
        s.pop();
    }
    return soln;
}

/*
6 6
2 5 1 2 3 4
5 2 4 3 0 1
3
5 2 4
*/
