#include "hint.h"
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define x first
#define y second
using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
typedef pair<ll, ll> pll;
typedef tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update> yree;

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol){
    ll n =a.size();
    vector<ll> in, out;
    ll ti = 0;
    for(ll i = 0;i<a.size();i++){
        if(ti==sol.size() || sol[ti]!=a[i]) out.push_back(i);
        else in.push_back(i), ti++;
    }
    vector<bool> bts;
    if(in.size()<=out.size()){
        if(in.empty()){
            bts.resize(1);
            bts[0]=0;
            return bts;
        }
        bts.resize(in.back()+2);
        fill(bts.begin(), bts.end(), 0);
        for(ll i = 0;i<in.size();i++) bts[1+in[i]]=1;
    }else{
        if(out.empty()){
            bts.resize(1);
            bts[0]=1;
            return bts;
        }
        bts.resize(out.back()+2);
        fill(bts.begin(), bts.end(), 0);
        bts[0]=1;
        for(ll i = 0;i<out.size();i++) bts[1+out[i]]=1;
    }
    return bts;
}


std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint){
    vector<int> res;
    if(hint[0]==0){
        for(ll i = 1;i<hint.size();i++) if(hint[i]) res.push_back(a[i-1]);
    }else{
        for(ll i = 0;i<a.size();i++) if(i+1>=hint.size() || !hint[i+1]) res.push_back(a[i]);
    }
    return res;
}
