#include "hint.h"

#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& s) {
	vector<bool> h;
	int ln = log2(min(a.size(), b.size()) - 1) + 1;
	for (int i = 0; i < s.size(); i++) {
		for (int j = ln - 1; j >= 0; j--) {
			h.push_back(s[i] & (1 << j));
		}
	}
	return h;
}

vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& h) {
	vector<int> s;
	int ln = log2(min(a.size(), b.size()) - 1) + 1;
	for (int i = 0; i * ln < h.size(); i++) {
		s.push_back(0);
		for (int j = 0; j < ln; j++) {
			s[i] *= 2;
			s[i] += h[i * ln + j];
		}
	}
	return s;
}

/*
3 3
1 3 2
3 1 2
2
1 2
*/