#include "hint.h"
#include <bits/stdc++.h>
using namespace std;
#define LL long long
#define LD long double
#define INF (1<<30L)

const int maxN = 10005;
int dp[maxN][maxN] = {};

vector <bool> genHint( const vector <int> &A, const vector <int> &B, const vector <int> &S ){
    vector <bool> rv;
    return rv;
}

vector <int> solve( const vector <int> &A, const vector <int> &B, const vector <bool> &H ){

    vector <int> rv;
    int N = A.size(), M = B.size();

    for( int i = 0 ; i <= N ; i++ ) for( int j = 0 ; j <= M ; j++ ){
        if( !i || !j ){ dp[i][j] = 0; continue; } 
        dp[i][j] = max( dp[i][j], dp[i-1][j] );
        dp[i][j] = max( dp[i][j], dp[i][j-1] );
        if( A[i-1] == B[j-1] ) dp[i][j] = max( dp[i][j], dp[i-1][j-1]+1 );
    }

    // cout << "LCS: " << dp[N][M] << endl;
    // for( int i = 0 ; i <= N ; i++ ){
    //     for( int j = 0 ; j <= M ; j++ ){
    //         cout << dp[i][j] << ' ';
    //     } cout << endl;
    // } cout << endl;

    int i = N, j = M;
    while( dp[i][j] ){

        if( i && j ){ if( dp[i-1][j-1]+1 == dp[i][j] ){
            rv.push_back( A[i-1] );
            i--; j--;
        } }else if( i ){
            if( dp[i-1][j] == dp[i][j] ){ i--; }
        }else if( j ){
            if( dp[i][j-1] == dp[i][j] ){ j--; }
        }else return rv;

    }

    reverse( rv.begin(), rv.end() );

    return rv;

} 