#include <bits/stdc++.h>
using namespace std;
#define LL long long
#define LD long double
#define INF (1<<30L)

int N, S, C;

void strategy1();
void strategy2();

int main(){ ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    cin >> N >> S >> C;

    if( S == 0 && C == 1 ) strategy1();
    else if( S == 1 && C == 0 ) strategy2();
    else cout << 0 << endl;

}

void strategy1(){ // Keep checking the same cell in the middle in the hopes that the rabbit eventually visits

    int mid = (N+1)/2;
    cout << mid+1 << endl;
    for( int i = 0 ; i <= mid ; i++ ) cout << mid << ' '; cout << endl; 

}

void strategy2(){ // Chase the rabbit away into one of the corners

    int mid = (N+1)/2;
    vector <int> moves;
    moves.push_back(mid);
    int L = mid-2, R = mid+3;
    while( L >= 1 || R <= N ){
        if( L >= 1 ){ moves.push_back(L); L -= 3; }
        if( R <= N ){ moves.push_back(R); R += 3; }
    }

    cout << moves.size() << endl;
    for( int m : moves ) cout << m << ' '; cout << endl;

}