#include <iostream>
#include <vector>
#include <string>
#include <iomanip>
#include <set>
#include <map>
#include <algorithm>
#include <deque>
#include <cmath>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <tuple>

using namespace std;
typedef long long ll;
#define int long long

int n;
pair <int, int> a[1000010];

vector <int> g[1000010];

int from[1000010];
int used[1000010];
int C = 1;
int ans = 0;

bool dfs(int u)
{
	if (used[u] == C) return false;
	used[u] = C;

	for (auto v : g[u])
	{
		if (!from[v])
		{
			from[v] = u;
			return true;
		}
	}

	for (auto v : g[u])
	{
		if (dfs(from[v]))
		{
			from[v] = u;
			return true;
		}
	}
	return false;
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n;
	for (int i = 1; i <= n; ++i)
	{
		cin >> a[i].first >> a[i].second;
	}

	sort(a + 1, a + 1 + n);

	for (int i = 1; i <= n; ++i)
	{
		vector <int> ls, eq, gr;
		for (int j = 1; j <= n; ++j) if (i != j)
		{
			if (a[j].first - a[i].first >= abs(a[i].second - a[j].second))
			{/*
				if (a[j].second < a[i].second)
				{
					ls.push_back(j);
				}
				else if (a[j].second == a[i].second)
				{
					eq.push_back(j);
				}
				else
				{
					gr.push_back(j);
				}*/
				g[i].push_back(j);
			}
		}

		//if (ls.size())
		//{
		//	auto got = *min_element(ls.begin(), ls.end(), [&](int u, int v) { return a[u].first < a[v].first; });
		//	g[i].push_back(got);
		//}
		////for (auto j : ls) g[i].push_back(j);
		//if (eq.size())
		//{
		//	auto got = *min_element(eq.begin(), eq.end(), [&](int u, int v) { return a[u].first < a[v].first; });
		//	g[i].push_back(got);
		//}
		///*
		//if (gr.size())
		//{
		//	auto got = *min_element(gr.begin(), gr.end(), [&](int u, int v) { return a[u].second != a[v].second ? a[u].second < a[v].second : a[u].first < a[v].first; });
		//	g[i].push_back(got);
		//}*/
		//for (auto j : gr) g[i].push_back(j);
	}

	for (int i = 1; i <= n; ++i)
	{
		++C;
		ans += dfs(i);
	}

	cout << n - ans;
	return 0;
}