#include <bits/stdc++.h>
using namespace std;

#define x first
#define y second
#define all(x) begin(x), end(x)
#define sz(x) ((int) (x).size())
using ll = long long;
using ld = long double;

const int N = 1e6 + 10;

pair<int, int> a[N];

vector<int> g[N];
int with1[N], with2[N], used[N], used_ver = 15;

bool dfs(int u) {
	if (used[u] == used_ver) {
		return false;
	}
	used[u] = used_ver;
	for (int v : g[u]) {
		if (with2[v] == -1 || dfs(with2[v])) {
			with2[v] = u;
			with1[u] = v;
			return true;
		}
	}
	return false;
}

signed main() {
	cin.tie(0)->sync_with_stdio(0);
	int n;
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> a[i].x >> a[i].y;
		a[i] = {a[i].x + a[i].y, a[i].x - a[i].y};
	}
	sort(a, a + n);
	int ans = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			if (a[j].x >= a[i].x && a[j].y >= a[i].y) {
				g[i].push_back(j);
			}
		}
	}
	bool run = true;
	fill(all(with1), -1);
	fill(all(with2), -1);
	while (run) {
		run = false;
		++used_ver;
		for (int i = 0; i < n; ++i) {
			if (used[i] != used_ver && with1[i] == -1 && dfs(i)) {
				++ans;
				run = true;
			}
		}
	}
	cout << n - ans;
}