#include <bits/stdc++.h>
using namespace std;

#define x first
#define y second
#define all(x) begin(x), end(x)
#define sz(x) ((int) (x).size())
using ll = long long;
using ld = long double;

int n, s, c;
vector<int> ans;

void normalize(int &l, int &r) {
	r = clamp(r, 0, n - 1);
	l = clamp(l, 0, n - 1);
	l = min(l, r);
}

signed main() {
	cin.tie(0)->sync_with_stdio(0);
	cin >> n >> s >> c;
	if (s > c) {
		int lef0 = 0, rig0 = n / 2, lef1 = n / 2 + 1, rig1 = n - 1;
		while (lef0 != rig0 || lef1 != rig1) {
			if (sz(ans) % (s + c) < s) {
				if (rig0 - lef0 > rig1 - lef1) {
					ans.push_back(rig0);
					rig0 -= 2;
					--lef0;
					++lef1;
					++rig1;
				} else {
					ans.push_back(lef1);
					lef1 += 2;
					++rig1;
					--lef0;
					--rig0;
				}
			} else {
				ans.push_back(0);
				--rig0;
				--lef0;
				--rig1;
				--lef1;
			}
			normalize(lef1, rig1);
			normalize(lef0, rig0);
		}
		if (sz(ans) % (s + c) < s) {
			ans.push_back(lef0);
			ans.push_back(lef1);
		} else {
			ans.push_back(lef0);
			ans.push_back(lef1 - 1);
		}
	} else {
		int lef = 0, rig = n - 1;
		while (lef != rig) {
			if (sz(ans) % (s + c) < s) {
				ans.push_back(lef);
				lef += 2;
				++rig;
				rig = min(rig, n - 1);
				lef = min(lef, rig);
			} else {
				int whom = (lef + rig) / 2;
				if (lef < whom) {
					++lef;
				}
				if (rig > whom) {
					--rig;
				}
				ans.push_back(whom);
			}
		}
		ans.push_back(lef);
	}
	cout << sz(ans) << "\n";
	for (int u : ans) {
		cout << u + 1 << " ";
	}
	cout << "\n";
}