#pragma GCC Optimize("O3")
#include <bits/stdc++.h>
using namespace std;

const int numsz = 11;
const int SQRT = 1527;
void addnum(vector<bool> &V,int num){
    for(int bit = numsz-1;bit>=0;--bit){
        V.push_back((num&(1<<bit))!=0);
    }
}
std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b,
const std::vector<int>& sol){
    vector<bool> ret;
    int ptr1 = 0,ptr2 = 0;
    int cptr = 0;
    vector<int> a_ind,b_ind;

    for(int i = 0;i<a.size();++i){
        if (a_ind.size()<sol.size() && a[i]==sol[a_ind.size()])
            a_ind.push_back(i);
    }
    for(int i = 0;i<b.size();++i){
        if (b_ind.size()<sol.size() && b[i]==sol[b_ind.size()])
            b_ind.push_back(i);
    }
    a_ind.push_back(a.size());
    b_ind.push_back(b.size());
   // for(int to:a_ind)
   //    cout<<to<<' ';
   // cout<<endl;
    cptr = -1;
    while(cptr+1<int(sol.size())){
        int cnt = cptr;
        for(int i = cptr+1;i<sol.size();++i){
            if (a_ind[i]-ptr1>=SQRT || b_ind[i]-ptr2>=SQRT){
                cnt = i-1;
                break;
            }
            cnt = i;
        }
        int b1 = min(ptr1+SQRT,int(a.size())),b2 = min(ptr2+SQRT,int(b.size()));
        int r1 = min(ptr1+SQRT,a_ind[cnt+1]);
        int r2 = min(ptr2+SQRT,b_ind[cnt+1]);
       // cout<<ptr1<<' '<<ptr2<<' '<<r1<<' '<<r2<<' '<<cptr<<' '<<a_ind[cnt+1]<<' '<<b_ind[cnt+1]<<endl;
        if (r2<b2){
            int pos = r2;

            ret.push_back(0);
            ret.push_back(1);
            addnum(ret,pos-ptr2);
            ptr1+=SQRT;
            ptr2 = pos;
            cptr=cnt;
        }
        else if (r1<b1){
            int pos = r1;
            ret.push_back(0);
            ret.push_back(0);
            addnum(ret,pos-ptr1);
            ptr1 = pos;
            ptr2+=SQRT;
            cptr=cnt;
        }
        else{
            ret.push_back(1);
            //ret.push_back(1);
            ptr1+=SQRT;
            ptr2+=SQRT;
            cptr=cnt;
        }
        //cout<<lcnt<<' '<<rcnt<<' '<<ptr1<<' '<<ptr2<<endl;
    }
    return ret;
}
int getnum(vector<bool> &V,int pos){
    int ret = 0;
    for(int i = pos;i<pos+numsz;++i)
        ret = ret*2+V[i];
    return ret;
}
int dp[2][SQRT+20];
char P[SQRT+20][SQRT+20];
std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b,
const std::vector<bool>& hi){
    vector<int> c;
    vector<bool> hint = hi;
    int ptrl = 0,ptrr = 0;
    int hptr = 0;
    //for(int to:hint)
    //    cout<<to;
    //cout<<endl;

    while(hptr<hint.size()){
        int r1 = 0,r2 = 0;
        if (hint[hptr]==1){
            r1 = min(int(a.size()),ptrl+SQRT);
            r2 = min(int(b.size()),ptrr+SQRT);
            hptr++;
        }
        else{
            if (hint[hptr+1]==0){
                r1 = ptrl+getnum(hint,hptr+2);
                r2 = min(int(b.size()),ptrr+SQRT);
            }
            else{
                r2 = ptrr+getnum(hint,hptr+2);
                r1 = min(int(a.size()),ptrl+SQRT);
            }
            hptr+=2+numsz;
        }
        //cout<<r1<<' '<<r2<<endl;
        if (ptrl==r1 || ptrr==r2){
            ptrl = r1;
            ptrr = r2;
            continue;
        }

        P[0][0] = 0;
        for(int i = 0;i+ptrl<r1;++i){
            for(int j = 0;j+ptrr<r2;++j){
                dp[1][j] = 0;
                P[i][j] = 0;
                if (j>0)
                    dp[1][j] = max(dp[1][j],dp[1][j-1]);
                if (dp[1][j]<dp[0][j]){
                    dp[1][j] = dp[0][j];
                    P[i][j] = 1;
                }
                if (a[i+ptrl]==b[j+ptrr]){
                  //  cout<<ptrl<<' '<<ptrr<<' '<<dp[1][j]<<endl;
                    if (j>0 && dp[1][j]<dp[0][j-1]+1){
                        dp[1][j] = dp[0][j-1]+1;
                        P[i][j] = 2;
                    }
                    else if (dp[1][j]<1){
                        dp[1][j] = 1;
                        P[i][j] = 2;
                    }
                }

            }
            for(int j = 0;j+ptrr<r2;++j){
                dp[0][j] = dp[1][j];
            }
        }
        pair<int,int> state;
        int res = 0;
        for(int j = 0;j+ptrr<r2;++j){
            if (res<dp[0][j]){
                res = dp[0][j];
                state = {r1-ptrl-1,j};
            }
        }
        //cout<<"//////////////"<<endl;

        vector<int> to_add;
        while(state.first>=0 && state.second>=0){
         //  cout<<state.first+ptrl<<' '<<state.second+ptrr<<endl;

            if (P[state.first][state.second]==0)
                --state.second;
            else if (P[state.first][state.second]==1)
                --state.first;
            else{
               // cout<<a[state.first+ptrl]<<endl;
                to_add.push_back(a[state.first+ptrl]);
                --state.first;
                --state.second;
            }
        }
        reverse(to_add.begin(),to_add.end());
        for(int to:to_add)
            c.push_back(to);
        for(int j = 0;j+ptrr<r2;++j){
            dp[0][j] = dp[1][j] = 0;
        }
        ptrl = r1;
        ptrr = r2;
       // cout<<dp[0][3]<<' '<<res<<' '<<int(P[1][1])<<endl;
       //cout<<int(P[0][0])<<endl;

    }
    return c;
}
