#include "hint.h"
#include <bits/stdc++.h>
#ifndef DEBUG
#define endl '\n'
#endif
using namespace std;
using ll = int;
using vi = vector<short>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vvi = vector<vi>;
using vvii = vector<vii>;
using vsi = vector<set<ll>>;
using vb = vector<bool>;
template<class X, class Y>
istream& operator>>(istream& s, pair<X, Y>& p) {
  s >> p.first >> p.second;
  return s;
}
template<class T>
istream& operator>>(istream& s, vector<T>& v) {
  for (int i = 0; i < v.size(); ++i) {
    s >> v[i];
  }
  return s;
}
template<class T>
ostream& operator<<(ostream& s, const vector<T>& v) {
  for (auto e: v) {
    s << e << ' ';
  }
  return s;
}
//auto solve() -> void;
//
//int main() {
//  ios_base::sync_with_stdio(false);
//  cin.tie(nullptr);
//  cout.setf(ios::fixed);
//  cout.precision(20);
//
//  solve();
//}
//auto solve() -> void {
//
//}
// -----

const size_t LIMIT = 10'000;

std::vector<bool> genHint(const std::vector<int>& a1, const std::vector<int>& b1,
                          const std::vector<int>& sol) {
  auto a = a1;
  auto b = b1;
  vector<bool> hint;

  if (a == b) return hint;
  if (a.size() == b.size()) {
    ll i = 0;
    while (a[i] == b[i]) ++i;
    for (int j = 0; j < 17; ++j) {
      hint.push_back((bool) (a[i] & (1 << j)));
    }
  }

  for (int i = 0, j = 0; i < a.size() and j < sol.size(); ++i, ++j) {
    while (a[i] != sol[j]) {
      hint.push_back(false);
      ++i;
    }
    hint.push_back(true);
  }

  return hint;
}
std::vector<int> solve(const std::vector<int>& a1, const std::vector<int>& b1,
                       const std::vector<bool>& hint) {
  auto a = a1;
  auto b = b1;
  vector<int> res;

  ll offset = 0;
  if (a == b) return a;
  if (a.size() == b.size()) {
    offset = 17;
    ll i = 0;
    while (a[i] == b[i]) ++i;
    ll q = 0;
    for (int j = 0; j < 17; ++j) {
      q += ((int) hint[j]) << j;
    }
    if (b[i] == q) a.swap(b);
//    assert(a[i] == q);
  }
  if (a.size() + offset != hint.size()) a.swap(b);

//  assert(a.size() == hint.size());
  for (int i = offset; i < hint.size(); ++i) {
    if (hint[i]) res.push_back(a[i - offset]);
  }

  return res;
}