#include <bits/stdc++.h>
#ifndef DEBUG
#define endl '\n'
#endif
using namespace std;
using ll = long long;
using vi = vector<ll>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vvi = vector<vi>;
using vvii = vector<vii>;
using vsi = vector<set<ll>>;
using vb = vector<bool>;
template<class X, class Y>
istream& operator>>(istream& s, pair<X, Y>& p) {
  s >> p.first >> p.second;
  return s;
}
template<class T>
istream& operator>>(istream& s, vector<T>& v) {
  for (int i = 0; i < v.size(); ++i) {
    s >> v[i];
  }
  return s;
}
template<class T>
ostream& operator<<(ostream& s, const vector<T>& v) {
  for (auto e: v) {
    s << e << ' ';
  }
  return s;
}
auto solve() -> void;

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.setf(ios::fixed);
  cout.precision(20);

  solve();
}

// ----


auto solve() -> void {
  ll n, s, c;
  cin >> n >> s >> c;

  if (s == 0 or c == 0) {
    cout << n / 2 + 3 << endl;
    cout << vi(n / 2 + 3, n / 2 + 1);
  } else {

    mt19937 rnd = mt19937((random_device()) ());
    vi acts;

    for (int i = 1; i + 3 <= n; i += 2) {
      acts.push_back(i);
      acts.push_back(i + (rnd() % 3 + 1));
    }
    acts.push_back(n);
    acts.push_back(1);

//    for (int x = 1; x <= n; x += 5) {
////      ll orig = (ll) rnd() % n + 1;
//      ll orig = x;
//      ll cur = orig;
//      ll counter = 1;
//      for (auto p: acts) {
//        bool scared = counter <= s;
//        if (scared) {
//          if (cur < p and cur > 1) --cur;
//          else if (p < cur and cur < n) ++cur;
//          else {} // ???
//        } else {
//          if (cur < p and cur < n) ++cur;
//          else if (p < cur and cur > 1) --cur;
//          else {} // ???
//        }
//
//        counter %= (s + c);
//        ++counter;
//      }
//      acts.push_back(cur);
//    }
//    while (acts.size() < n) {
//      acts.push_back((ll) rnd());
//    }
    cout << acts.size() << endl;
    cout << acts << endl;

#ifdef DEBUG
//    cout << "CHECKING" << endl;
    ll n_nf = 0;
    for (int orig = 1; orig <= n; orig++) {
      bool ok = false;
      ll cur = orig;
      ll counter = 1;
      for (auto p: acts) {
        if (p == cur) {
//          cout << "FOUND" << endl;
          ok = true;
          break;
        } else {
          bool scared = counter <= s;
          if (scared) {
            if (cur < p and cur > 1) --cur;
            else if (p < cur and cur < n) ++cur;
          } else {
            if (cur < p and cur < n) ++cur;
            else if (p < cur and cur > 1) --cur;
          }
        }

        counter %= (s + c);
        counter++;
      }
      if (!ok) {
        cout << "NOT FOUND: " << orig << endl;
        ++n_nf;
//        abort();
      }
    }
    cerr << n_nf << "/" << n << " not found" << endl;
    if (n_nf > 0) {
//      abort();
    }
#endif
  }
}
