#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}

#define int long long

const int N = 1e4 + 100;

int n, s, c, l, r;
vector<int> ans1, ans2;

bool good(vector<int> e) {
    bool can[n], ncan[N];
    fill(can, can + n, true);
    for (int i = 0; i < e.size(); i++) {
        int p = e[i] - 1;
        fill(ncan, ncan + n, false);
        can[p] = false;
        if (i % (s + c) < s) {
            for (int j = 0; j < n; j++) {
                if (can[j] && j < p && j) {
                    ncan[j - 1] = true;
                }
                if (can[j] && j > p && j + 1 < n) {
                    ncan[j + 1] = true;
                }
            }
        } else {
            for (int j = 0; j < n; j++) {
                if (can[j] && j < p) {
                    ncan[j + 1] = true;
                }
                if (can[j] && j > p) {
                    ncan[j - 1] = true;
                }
            }
        }
        for (int j = 0; j < n; j++) {
            can[j] = ncan[j];
        }
    }
    for (int i = 0; i < n; i++) {
        if (can[i]) return false;
    }
    return true;
}

void solve() {
    cin >> n >> s >> c;
    l = 1;
    r = n;
    while (l <= r) {
        if (l == r) {
            ans1.push_back(l);
            break;
        }
        int e = ans1.size();
        if (e % (s + c) < s) {
            ans1.push_back(l);
            l = min(l + 2, n);
            r = min(r + 1, n);
        } else {
            ans1.push_back(l + 1);
            if (l + 1 == r) {
                l = l + 1;
            } else {
                l = min(l + 1, n);
                r = max(r - 1, 1ll);
            }
        }
    }
    if (n > 2 && s > c) {
        int m = n / 2;
        ans2.push_back(m);
        int u = max(1ll, m - 2);
        while (u > 0) {
            if (u == 1) {
                ans2.push_back(u);
                break;
            }
            int e = ans2.size();
            if (e % (s + c) < s) {
                ans2.push_back(u);
                u = max(1ll, u - 2);
            } else {
                ans2.push_back(1);
                u--;
            }
        }
        l = min(n, m + 1);
        r = n;
        for (int i = 0; i < ans2.size(); i++) {
            if (i % (s + c) < s) {
                l = min(l + 1, n);
                r = min(r + 1, n);
            } else {
                l = max(l - 1, 1ll);
                r = max(r - 1, 1ll);
            }
        }
        while (l <= r) {
            if (l == r) {
                ans2.push_back(l);
                break;
            }
            int e = ans2.size();
            if (e % (s + c) < s) {
                ans2.push_back(l);
                l = min(l + 2, n);
                r = min(r + 1, n);
            } else {
                ans2.push_back(r);
                l++;
            }
        }
    }
    int T = n * (s + c) / (s + 2 * max(s, c)) + 3 * max(s, c);
    cout << T << endl;
    if (ans1.size() < ans2.size() || ans2.empty()) {
//        if (!good(ans1)) cout << "WA" << endl;
        cout << ans1.size() << '\n';
        for (int x: ans1) {
            cout << x << " ";
        }
    } else {
//        if (!good(ans2)) cout << "WA" << endl;
        cout << ans2.size() << '\n';
        for (int x: ans2) {
            cout << x << " ";
        }
    }
}
