#include "hint.h"
#include <bits/stdc++.h>

using namespace std;

const int NMAX = 1e4 + 1;
int dp[NMAX][NMAX];

int A[NMAX], B[NMAX];
vector < int > ans;

vector < bool > genHint (const vector < int > &a, const vector < int > &b, const vector < int > &sol)
{
    vector < bool > ans;

    ans.push_back(0);

    return ans;
}

int my_max (int a, int b)
{
    return ((a > b) ? a : b);
}

void Reconstruct (int i, int j)
{
    if(i < 1 || j < 1)
        return;

    if(A[i] == B[j])
    {
        ans.push_back(A[i]);

        Reconstruct(i - 1, j - 1);

        return;
    }

    if(dp[i - 1][j] > dp[i][j - 1])
        Reconstruct(i - 1, j);
    else Reconstruct(i, j - 1);

    return;
}

vector < int > solve (const vector < int > &a, const vector < int > &b, const vector < bool > &hint)
{
    int N = (int)a.size();
    int M = (int)b.size();

    for(int i = 1; i <= N; ++i)
        A[i] = a[i - 1];
    for(int i = 1; i <= M; ++i)
        B[i] = b[i - 1];

    for(int i = 1; i <= N; ++i)
        for(int j = 1; j <= M; ++j)
            if(a[i - 1] == b[j - 1])
                dp[i][j] = dp[i - 1][j - 1] + 1;
            else dp[i][j] = my_max(dp[i - 1][j], dp[i][j - 1]);

    Reconstruct(N, M);

    reverse(ans.begin(), ans.end());

    return ans;
}
