#include <iostream>
#include <algorithm>

using namespace std;

typedef pair < int, int > PII;

const int NMAX = 1e3 + 1;

int N;
PII V[NMAX];

bool Sel[NMAX];

static inline void Read ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N;

    for(int i = 1; i <= N; ++i)
        cin >> V[i].first >> V[i].second;

    return;
}

static inline int my_abs (int X)
{
    if(X < 0)
        return -X;

    return X;
}

int main()
{
    Read();

    sort(V + 1, V + N + 1);

    int ans = 0;

    for(int i = 1; i <= N; ++i)
        if(!Sel[i])
        {
            ++ans;

            int last = i;

            for(int j = (i + 1); j <= N; ++j)
                if(!Sel[j])
                    if(V[j].first - V[last].first >= my_abs(V[j].second - V[last].second))
                        Sel[j] = 1, last = j;
        }

    cout << ans << '\n';

    return 0;
}
