#include <iostream>
#include <vector>

using namespace std;

int N, S, C;

static inline void Read ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N >> S >> C;

    return;
}

int main()
{
    Read();

    if(S == 0 && C == 1)
    {
        int Ops = ((N >> 1) + 2);
        cout << Ops << '\n';
        for(int i = 1; i <= Ops; ++i)
        {
            cout << (N >> 1);
            if(i < Ops)
                cout << ' ';
        }
        cout << '\n';
    }
    else if(S == 1 && C == 0)
    {
        vector < int > steps;

        int left = (N / 3) + 1;
        int right = (2 * N / 3);

        while(left <= right)
        {
            if(left == right)
            {
                steps.push_back(left);

                break;
            }

            steps.push_back(left);
            steps.push_back(right);

            ++left, --right;
        }

        steps.push_back(1), steps.push_back(N);

        cout << (int)steps.size() << '\n';

        for(auto it : steps)
            cout << it << ' ';

        cout << '\n';
    }
    else
    {
        vector < int > steps;

        int left = 1, right = N;

        while(left <= N / 3 || right >= (2 * N / 3))
        {
            if(left <= N / 3)
                steps.push_back(left);

            if(right >= (2 * N / 3))
                steps.push_back(right);

            ++left, --right;
        }

        steps.push_back(N / 3), steps.push_back(N);

        cout << (int)steps.size() << '\n';

        for(auto it : steps)
            cout << it << ' ';

        cout << '\n';
    }

    return 0;
}
