#include <cstdio>
#include <vector>
#include <algorithm>

const int N = 10005;
std::pair<short, std::pair<short, short> > d[N][N];

std::vector<bool> genHint(const std::vector<int> &a, const std::vector<int> &b, const std::vector<int> &sol)
{
    return std::vector<bool>(228, 1);
}

std::vector<int> solve(const std::vector<int> &a, const std::vector<int> &b, const std::vector<bool> &hint)
{
    for (short i = 1; i <= (int)a.size(); ++i) for (short j = 1; j <= (int)b.size(); ++j) {
        d[i][j] = std::max(std::max(d[i - 1][j], d[i][j - 1]), a[i - 1] == b[j - 1] ? std::make_pair(short(d[i - 1][j - 1].first + 1), std::make_pair(short(i - 1), short(j - 1))) : std::make_pair(short(-1), std::make_pair(short(-1), short(-1))));
    }
    std::vector<int> sol;
    int i = a.size(), j = b.size();
    while (i && j && d[i][j].first) {
        std::pair<int, int> k = d[i][j].second;
        sol.push_back(a[k.first]);
        i = k.first;
        j = k.second;
    }
    std::reverse(sol.begin(), sol.end());
    return sol;
}

/*
5 10
1 3 1 4 5
7 6 3 4 1 3 1 2 2 5
4
1 3 1 5
*/
