#include<bits/stdc++.h>
using namespace std;
typedef long long ll;

void dfs(ll k, vector<vector<bool>> dp, vector<bool> &visited){
	if(visited[k]){
		return;
	}
	visited[k]=true;
	for(ll i=0; i<dp[k].size(); i++){
		if(dp[k][i]){
			dfs(i, dp, visited);
		}
	}
}

int main(){
	
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	
	ll n, i, maxi=0, s=0, maxin1, maxin2, j;
	cin>>n;
	
	vector<pair<ll, ll>> v;
	
	for(i=0; i<n; i++){
		ll t, h;
		cin>>t>>h;
		h--;
		v.push_back({t, h});
	}
	
	sort(v.begin(), v.end());
	
	vector<vector<bool>> dp(n, vector<bool> (n, 0));
	
	vector<ll> in(n, 0);
	
	for(j=1; j<n; j++){
		for(i=0; i<j; i++){
			if(v[i].first>v[j].first && v[i].first-v[j].first>=abs(v[i].second-v[j].second)){
				dp[j][i]=true;
				in[i]++;
			}
		}
	}
	
	//node=query
	//in is the answer of from how many nodes can we go directly(with only 1 edge) to the given node
	//out is the answer of to how many nodes can we go directly from the given node
	//how many tree "lines" are in this graph
	//saying "lines" I mean a tree with exactly 1 leaf, each parent has 1 child
	
	//to solve this problem I will use dfs and for each edge
	//if we will use this make minimum of number of cars that we will use
	
}
