#include "hint.h"

using namespace std;

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol)
{
    vector<bool> res(a.size());
    for (int i = 0, j = 0; i < a.size() && j < sol.size(); ++i)
    {
        if (a[i] == sol[j])
        {
            res[i] = true;
            ++j;
        }
    }
    return res;
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint)
{
    vector<int> sol;
    for (int i = 0; i < a.size(); ++i) if (hint[i]) sol.push_back(a[i]);
    return sol;
}