#include "hint.h"
#include <iostream>

using namespace std;

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol)
{
    vector<int> dod = a;
    if (a.size() > b.size())
    {
        dod = b;
    }
    vector<bool> res(dod.size());
    for (int i = 0, j = 0; i < dod.size() && j < sol.size(); ++i)
    {
        if (dod[i] == sol[j])
        {
            res[i] = true;
            ++j;
        }
    }
    return res;
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint)
{
    vector<int> sol;
    vector<int> dod = a;
    if (hint.size() < a.size()) dod = b;
    //for (bool i : hint) cout << i << ' ';
    for (int i = 0; i < dod.size(); ++i) if (hint[i]) sol.push_back(dod[i]);
    return sol;
}

/*
5 4
1 2 3 4 7
1 3 7 2
3
1 3 7
 */