#include <bits/stdc++.h>
//#include "Lgrader.cpp"
#include "hint.h"
#define sz(x) (int)x.size()
#define pb push_back
#define all(x) (x).begin(), (x).end()
using namespace std;

const int N = 2e5 + 500;
const int SQ = 500;
vector <int> ps[N];

vector <bool> genHint(const vector <int> &a, const vector <int> &b, const vector <int> &sol) {
    vector <bool> ret;
    int n = sz(sol);
    for (int i = 0; i < 20; i++) {
        if (n & (1 << i)) {
            ret.pb(1);
        } else {
            ret.pb(0);
        }
    }
    while (sz(ret) && ret.back() == 0) {
        ret.pop_back();
    }
    if (a[0] == 0) {
        ret = ret;
     }
     if (b[0] == 0) {
        ret = ret;
     }
    return ret;
}

int to_int(const vector <bool> &hint) {
    int ret = 0;
    for (int i = 0; i < sz(hint); i++) {
        ret += hint[i] * (1 << i);
    }
    return ret;
}

vector <int> solve(const vector <int> &A, const vector <int> &B, const vector <bool> &hint) {
     vector <int> ret;
     vector <int> a = A, b = B;
     int len = to_int(hint);
     int n = sz(a);
     int m = sz(b);
     if (len == 0) {
        return {};
     }
     if (len > SQ) {
        int rz = N / SQ;
        vector <vector <int> > f(n + 3, vector <int> (2 * rz + 5, -1e9));
        vector <vector <int> > pr(n + 3, vector <int> (2 * rz + 5, -2));
        f[0][rz] = 0;
        pr[0][rz] = 0;
        int ans = 0, ri, rJ;
        for (int i = 0; i <= n; i++) {
            for (int J = 2 * rz, j = i + rz; j >= i - rz; j--, J--) {
                if (j < 0) {
                    continue;
                }
                if (j > m) {
                    continue;
                }
                if (pr[i][J] == -2) {
                    continue;
                }
                if (f[i][J] > ans) {
                    ans = f[i][J];
                    ri = i;
                    rJ = J;
                }
                if (i < n && j < m && a[i] == b[j]) {
                    if (f[i + 1][J] < f[i][J] + 1) {
                        f[i + 1][J] = f[i][J] + 1;
                        pr[i + 1][J] = 0;
                    }
                }
                if (f[i + 1][J + 1] < f[i][J]) {
                    f[i + 1][J + 1] = f[i][J];
                    pr[i + 1][J + 1] = -1;
                }
                if (J - 1 >= 0 && f[i][J - 1] < f[i][J]) {
                    f[i][J - 1] = f[i][J];
                    pr[i][J - 1] = 1;
                }
            }
        }
        while (ri > 0) {
            if (!pr[ri][rJ]) {
                ret.pb(a[ri - 1]);
            }
            if (pr[ri][rJ] != 1) {
                ri--;
            }
            rJ -= pr[ri][rJ];
        }
        reverse(all(ret));
        return ret;
     } else {
        vector <vector <int> > f(n + 5, vector <int> (SQ + 5, 1e9));
        vector <vector <int> > pr(n + 5, vector <int> (SQ + 5, 1e9));
        for (int i = 0; i < m; i++) {
            ps[b[i]].pb(i);
        }
        f[0][0] = -1;
        pr[0][0] = -1;
        int ans = 0, ri;
        for (int i = 0; i <= n; i++) {
            int k = 0;
            for (int j = 0; j <= SQ; j++) {
                if (pr[i][j] == 1e9) {
                    continue;
                }
                if (j > ans) {
                    ans = j;
                    ri = i;
                }
                if (i < n) {
                    while (k < sz(ps[a[i]]) && ps[a[i]][k] < f[i][j]) {
                        k++;
                    }
                    if (f[i + 1][j] > f[i][j]) {
                        f[i + 1][j] = f[i][j];
                        pr[i + 1][j] = pr[i][j];
                    }
                    if (k == sz(ps[a[i]])) {
                        continue;
                    }
                    if (f[i + 1][j + 1] > ps[a[i]][k]) {
                        f[i + 1][j + 1] = ps[a[i]][k];
                        pr[i + 1][j + 1] = i;
                    }
                }
            }
        }
        while (ri >= 0) {
            if (pr[ri][ans] >= 0) {
                ret.pb(a[pr[ri][ans]]);
            }
            ri = pr[ri][ans];
            ans--;
        }
        reverse(all(ret));
        return ret;
     }
}
