#include <bits/stdc++.h>
#define pb push_back
#define sz(x) (int)x.size()
using namespace std;

int n, s, c;

bool check(vector <int> ans) {
    for (int start = 1; start <= n; start++) {
        int pos = start;
        int par = 0;
        int cnt = 0;
        bool gd = 0;
        for (int j = 0; j < sz(ans) && !gd; j++) {
            if (ans[j] == pos) {
                gd = 1;
            }
            if (!par) {
                if (pos < ans[j]) {
                    pos = max(1, pos - 1);
                } else {
                    pos = min(n, pos + 1);
                }
            } else {
                pos += (pos < ans[j]) ? 1 : -1;
            }

            cnt++;
            if (!par) {
                if (cnt == s) {
                    par ^= 1;
                    cnt = 0;
                }
            } else {
                if (cnt == c) {
                    par ^= 1;
                    cnt = 0;
                }
            }
        }
        if (!gd) {
            return 0;
        }
    }
    return 1;
}
vector <int> ans;

void print() {
//    assert(check(ans));
    cout << sz(ans) << endl;
    for (auto x : ans) {
        cout << x << " ";
    }
    exit(0);
}

void solve() {
    int md = n / (2 * (s + c)) + s;
    for (int i = 0; i < s; i++) {
        ans.pb(md);
    }
    int l = md + s;
    int r = n;
    int L = 1, R = md - s;

    while (R >= 1 || l <= r) {
        if (R >= L) {
            for (int i = 0; i < c; i++) {
                ans.pb(max(1, R - c + 1));
            }
            R = R - c + 1;
            L = L + c;
            l -= c; r -= c;
        } else {
            for (int i = 0; i < c; i++) {
                ans.pb(min(n, l));
            }
            r -= c;
        }
        if (l <= r) {
            for (int i = 0; i < s; i++) {
                ans.pb(l);
            }
            l += s;
            r += s; r = min(n, r);
            R -= s;
            L -= s; L = max(1, L);
        } else {
            for (int i = 0; i < s; i++) {
                ans.pb(max(1, R));
            }
            R -= s;
        }
    }
    print();
}

int main()
{
    cin >> n >> s >> c;
//    int T = n * (s + c) / (s + max(s, c) * 2) + 3 * max(s, c);
//    cout << T << endl;
    if (s == 0) {
        int l = 2;
        int r = n;
        while (l <= r) {
            ans.pb(l);
            l++;
            r--;
        }
        ans.pb(l);
        ans.pb(l);
        ans.pb(l);
        print();
    }
    if (c == 1 && s == 1) {
        int l = 1;
        int r = n;
        while (l <= n) {
            for (int a = 0; a < s; a++) {
                ans.pb(l);
            }
            for (int b = 0; b < c; b++) {
                ans.pb(r);
            }
            l = l + s + c + 1;
        }
        ans.pb(n);
        print();
    }
    if (c == 0) {
        int md = (1 + n) >> 1;
        int l = md - s - 1;
        int r = md + s + 1;
        ans.pb(md);
        while (l >= 1 || r <= n) {
            if (l >= 1) {
                ans.pb(l);
                l = l - s - 1;
                r++;
            }
            if (r <= n) {
                ans.pb(r);
                l--;
                r = r + s + 1;
            }
        }
        ans.pb(1);
        ans.pb(n);
        print();
    }

    if (s > n) {
        cout << n << endl;
        for (int i = 0; i < n - 1; i++) {
            cout << "1 ";
        }
        cout << n;
        return 0;
    }
    if (c > n) {
        cout << n << endl;
        for (int i = 0; i < s; i++) {
            cout << "1 ";
        }
        for (int i = 0; i < n - s; i++) {
            cout << n << " ";
        }
        return 0;
    }

    solve();
    print();
}
