#include <bits/stdc++.h>
#include "hint.h"
using namespace std;

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol){

    vector <bool> v;

    int n = a.size(), m = b.size(),k = sol.size(), i = 0, j = 0;

    while (i < n && j < k){
        if (a[i] == sol[j]){
            //v[i] = 1;

            for (int bit=0;bit<=16;bit++){
                if (i & (1<<bit))
                    v.push_back(true);
                else v.push_back(false);
            }

            i++, j++;
        } else i++;
    }


    return v;
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint){

    int n = a.size(),m = b.size(),i;

    vector <int> sol;

    int k = hint.size();
    for (i=0;i<k;i+=17){
        int val = 0;
        for (int bit=0;bit<=16 && i + bit < k;bit++)
            if (hint[i+bit] == true)
                val += (1<<bit);

        sol.push_back(a[val]);
    }

    return sol;
}