#include <bits/stdc++.h>
#include "hint.h"

using namespace std;
typedef long long ll;

const int S=2000;
bool dp[S+1][S+1];

vector<bool> genHint(const vector<int> &a,const vector<int> &b,const vector<int> &sol)
{
    int n=a.size();
    int m=b.size();
    int x=0,y=0;
    vector<bool> hint;
    auto add=[&](int t,int sz)
    {
        while(sz--)
        {
            hint.push_back(t&1);
            t/=2;
        }
    };
    vector<int> one;
    for(int t:sol)
    {
        while(a[x]!=t) x++;
        one.push_back(x++);
    }
    vector<int> two;
    for(int t:sol)
    {
        while(b[y]!=t) y++;
        two.push_back(y++);
    }
    x=0;
    int len=sol.size();
    while(x<len)
    {
        y=x;
        while(y+1<len&&max(one[y+1]-one[x]+1,two[y+1]-two[x]+1)<=S) y++;
        add(one[x],18);
        add(two[x],18);
        x=y+1;
    }
    return hint;
}

vector<int> lcs(vector<int> a,vector<int> b)
{
    int n=a.size();
    int m=b.size();
    vector<int> now(m+1,0);
    for(int i=1;i<=n;i++)
    {
        vector<int> nxt(m+1,0);
        for(int j=1;j<=m;j++)
        {
            nxt[j]=max(nxt[j-1],now[j]);
            dp[i][j]=(nxt[j]==nxt[j-1]);
            if(a[i-1]==b[j-1]) nxt[j]=now[j-1]+1;
        }
        now=nxt;
    }
    vector<int> c;
    int i=n,j=m;
    while(max(i,j)>0)
    {
        if(a[i-1]==b[j-1])
        {
            c.push_back(a[i-1]);
            i--; j--;
        }
        else if(!dp[i][j]) i--;
        else j--;
    }
    reverse(c.begin(),c.end());
    return c;
}

vector<int> solve(const vector<int> &a,const vector<int> &b,const vector<bool> &hint)
{
    int n=a.size();
    int m=b.size();
    int idx=0;
    auto get_r=[&](int sz)->int
    {
        int r=0;
        for(int i=0;i<sz;i++) r+=((1<<i)*hint[idx++]);
        return r;
    };
    int sz=hint.size();
    vector<int> breakers;
    while(idx<sz) breakers.push_back(get_r(18));
    breakers.push_back(n);
    breakers.push_back(m);
    int len=breakers.size();
    vector<int> res;
    for(int i=0;i+3<len;i+=2)
    {
        int x=breakers[i];
        int y=breakers[i+1];
        int limx=breakers[i+2];
        int limy=breakers[i+3];
        vector<int> one;
        for(int i=x;i<min(limx,x+S);i++) one.push_back(a[i]);
        vector<int> two;
        for(int i=y;i<min(limy,y+S);i++) two.push_back(b[i]);
        vector<int> t=lcs(one,two);
        for(int e:t) res.push_back(e);
    }
    return res;
}

//int main()
//{
//    ios::sync_with_stdio(0);
//    cin.tie(0);
//    
//    return 0;
//}
