#include <bits/stdc++.h>
#include "hint.h"
#pragma GCC optimize ("Ofast","unroll-all-loops")

using namespace std;
typedef long long ll;

const int S=3000;
//bool dp[S+1][S+1];

vector<bool> genHint(const vector<int> &a,const vector<int> &b,const vector<int> &sol)
{
    int n=a.size();
    int m=b.size();
    int x=0,y=0;
    vector<bool> hint;
    const int sz=18;
    int prv=0;
    auto mv=[&](int c,int d){hint.push_back(c);hint.push_back(d);};
    auto add=[&](int t)
    {
        int p=-1;
        for(int i=0;i<sz;i++) if((prv&(1<<i))!=(t&(1<<i))) p=i;
        for(int i=0;i<=p;i++) mv(0,1);
        for(int i=p;i>=0;i--)
        {
            int c=((t>>i)&1);
            mv(c,c);
        }
        mv(1,0);
        prv=t;
    };
    vector<int> one;
    for(int t:sol)
    {
        while(x<n&&a[x]!=t) x++;
        one.push_back(x++);
    }
    vector<int> two;
    for(int t:sol)
    {
        while(y<m&&b[y]!=t) y++;
        two.push_back(y++);
    }
    x=0;
    int len=sol.size();
    vector<int> ta,tb;
    while(x<len)
    {
        y=x;
        while(y+1<len&&max(one[y+1]-one[x]+1,two[y+1]-two[x]+1)<=S) y++;
        ta.push_back(one[x]);
        tb.push_back(two[x]);
        x=y+1;
    }
    for(int t:ta) add(t);
    for(int t:tb) add(t);
    return hint;
}

vector<int> lcs(vector<int> &a,vector<int> &b)
{
    int n=a.size();
    int m=b.size();
    vector<int> now(m+1,0);
    bool dp[n+1][m+1];
    for(int i=1;i<=n;i++)
    {
        vector<int> nxt(m+1,0);
        for(int j=1;j<=m;j++)
        {
            nxt[j]=max(nxt[j-1],now[j]);
            dp[i][j]=(nxt[j]==nxt[j-1]);
            if(a[i-1]==b[j-1]) nxt[j]=now[j-1]+1;
        }
        now=nxt;
    }
    vector<int> c;
    int i=n,j=m;
    while(min(i,j)>0)
    {
        if(a[i-1]==b[j-1])
        {
            c.push_back(a[i-1]);
            i--; j--;
        }
        else if(!dp[i][j]) i--;
        else j--;
    }
    reverse(c.begin(),c.end());
    return c;
}

vector<int> solve(const vector<int> &a,const vector<int> &b,const vector<bool> &hint)
{
    int n=a.size();
    int m=b.size();
    int now=0;
    vector<int> tmp;
    for(int i=0;i<(int)hint.size();i+=2)
    {
        int x=hint[i];
        int y=hint[i+1];
        if(x==0&&y==0) now=2*now;
        if(x==1&&y==1) now=2*now+1;
        if(x==0&&y==1) now/=2;
        if(x==1&&y==0) tmp.push_back(now);
    }
    vector<int> breakers;
    int ta=0,tb=(int)tmp.size()/2;
    while(ta<(int)tmp.size()/2)
    {
        breakers.push_back(tmp[ta++]);
        breakers.push_back(tmp[tb++]);
    }
    breakers.push_back(n);
    breakers.push_back(m);
    int len=breakers.size();
    vector<int> res;
    for(int i=0;i+3<len;i+=2)
    {
        int x=breakers[i];
        int y=breakers[i+1];
        int limx=breakers[i+2];
        int limy=breakers[i+3];
        vector<int> one;
        for(int j=x;j<min(limx,x+S);j++) one.push_back(a[j]);
        vector<int> two;
        for(int j=y;j<min(limy,y+S);j++) two.push_back(b[j]);
        vector<int> t=lcs(one,two);
        for(int e:t) res.push_back(e);
    }
    return res;
}

//int main()
//{
//    ios::sync_with_stdio(0);
//    cin.tie(0);
//    mt19937 gen(chrono::steady_clock::now().time_since_epoch().count());
//    auto rng=[&](int l,int r)->int{return uniform_int_distribution<int>(l,r)(gen);};
//    while(1)
//    {
//        int n=rng(1,10);
//        int m=rng(1,10);
//        vector<int> a(n);
//        for(int i=0;i<n;i++) a[i]=rng(1,min(n,m));
//        vector<int> b(m);
//        for(int i=0;i<m;i++) b[i]=rng(1,min(n,m));
//        vector<int> opt=lcs(a,b);
//        int len=opt.size();
//        vector<bool> hint=genHint(a,b,opt);
//        vector<int> res=solve(a,b,hint);
//        bool ok=1;
//        int x=0;
//        for(int t:res)
//        {
//            while(x<n&&a[x]!=t) x++;
//            ok&=(x<n);
//            x++;
//        }
//        int y=0;
//        for(int t:res)
//        {
//            while(y<m&&b[y]!=t) y++;
//            ok&=(y<m);
//            y++;
//        }
//        ok&=(len==(int)res.size());
//        if(ok) cout << "OK" << endl;
//        else
//        {
//            cout << n << " " << m << "\n";
//            for(int i=0;i<n;i++) cout << a[i] << " \n"[i==n-1];
//            for(int i=0;i<m;i++) cout << b[i] << " \n"[i==m-1];
//            cout << "opt: ";
//            for(int i=0;i<len;i++) cout << opt[i] << " \n"[i==len-1];
//            cout << "res: ";
//            int rsz=res.size();
//            for(int i=0;i<rsz;i++) cout << res[i] << " \n"[i==rsz-1];
//            break;
//        }
//    }
//    return 0;
//}
