#include <bits/stdc++.h>
#include "hint.h"
using namespace std;
int n, i, pointerLeft;

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol) {
  pointerLeft = 0;
  n = (int)a.size();
  vector<bool> hint(n, false);
  for (i=0; i < n && pointerLeft < (int)sol.size(); ++i) {
    if (a[i] == sol[pointerLeft]) {
      ++pointerLeft;
      hint[i] = true;
    }
  }
  return hint;
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint) {
  vector<int> ans;
  n = (int)a.size();
  
  for (i=0; i < n; ++i) {
    if (hint[i]) ans.push_back(a[i]);
  }
  
  return ans;
}
