#include <bits/stdc++.h>
#include "hint.h"
using namespace std;
int n, m, i, pointerLeft;

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol) {
  pointerLeft = 0;
  vector<bool> hint;
  if ((int)a.size() <= (int)b.size()) {
    n = (int)a.size();
    hint.resize(n+1);
    hint[0] = false;
    for (i=0; i < n && pointerLeft < (int)sol.size(); ++i) {
      if (a[i] == sol[pointerLeft]) {
        ++pointerLeft;
        hint[i+1] = true;
      }

      else {
        hint[i+1] = false;
      }
    }
  }

  else {
    m = (int)b.size();
    hint.resize(m+1);
    hint[0] = true;
    for (i=0; i < m && pointerLeft < (int)sol.size(); ++i) {
      if (b[i] == sol[pointerLeft]) {
        ++pointerLeft;
        hint[i+1] = true;
      }
      else {
        hint[i+1] = false;
      }
    }
  }

  return hint;
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint) {
  vector<int> ans;

  if (hint[0]) {
    m = (int)b.size();

    for (i=0; i < m; ++i) {
      if (hint[i+1]) ans.push_back(b[i]);
    }
  }

  else {
    n = (int)a.size();

    for (i=0; i < n; ++i) {
      if (hint[i+1]) ans.push_back(a[i]);
    }
  }

  return ans;
}
