#include<bits/stdc++.h>
using namespace std;
vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint) {
	int n = (int)a.size(), m = (int)b.size();
	vector<vector<int>> dp(n, vector<int>(m));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			if (a[i] == b[j]) {
				if (i == 0 || j == 0) {
					dp[i][j] = 1;
				} else {
					dp[i][j] = dp[i - 1][j - 1] + 1;
				}
			}
			if (i > 0) {
				dp[i][j] = max(dp[i][j], dp[i - 1][j]);
			}
			if (j > 0) {
				dp[i][j] = max(dp[i][j], dp[i][j - 1]);
			}
		}
	}
	vector<int> answer;
	int i = n - 1, j = m - 1;
	while (i >= 0 && j >= 0) {
		if (a[i] == b[j]) {
			answer.push_back(a[i]);
			--i, --j;
		} else if (i > 0 && dp[i][j] == dp[i - 1][j]) {
			--i;
		} else if (j > 0 && dp[i][j] == dp[i][j - 1]) {
			--j;
		} else {
			break;
		}
	}
	reverse(answer.begin(), answer.end());
	return answer;
}
int main() {
	int n, m; cin >> n >> m;
	vector<int> a(n), b(m);
	for (int &i : a) {
		cin >> i;
	}
	for (int &i : b) {
		cin >> i;
	}
	for (int i : solve(a, b, {})) {
		cout << i << ' ';
	}
	return 0;
	// int n, s, c;
	// cin >> n >> s >> c;
	// int sum = c + s;
	// int diff = c - s;
	// if (diff > 0 && 2 * diff > sum) {
	// 	int cnt = (n + 1) / 2 * sum / diff + 1;
	// 	cout << cnt << '\n';
	// 	for (int i = 0; i < cnt; ++i) cout << n / 2 << ' ';
	// 	return 0;
	// }
	// vector<int> ans;
	// int pos = 1;
	// ans.push_back(pos);
	// for (int i = 0; i < n - 1 && pos <= n; ++i) {
	// 	if (i % (s + c) < s) {
	// 		pos += 2;
	// 	}
	// 	ans.push_back(pos);
	// }
	// ans.pop_back();
	// cout << ans.size() << endl;
	// for (int i : ans) cout << i << ' ';
}