#include <bits/stdc++.h>
#include "hint.h"
using namespace std;
vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& sol) {
	vector<bool> hint;
	for (int i = 0, j = 0; j < (int)sol.size() && i < (int)a.size(); ++i) {
		if (a[i] == sol[j]) {
			hint.push_back(true);
			++j;
		} else {
			hint.push_back(false);
		}
	}
	auto toBinary = [&](int x) -> vector<bool> {
		vector<bool> bits;
		for (int bit = 9; bit >= 0; --bit) {
			bits.push_back(x >> bit & 1);
		}
		return bits;
	};
	int cnt = 1;
	vector<bool> better_hint;
	for (int i = 1; i < (int)hint.size(); ++i) {
		if (hint[i] != hint[i - 1]) {
			better_hint.push_back(hint[i]);
			for (bool b : toBinary(cnt)) {
				better_hint.push_back(b);
			}
			cnt = 0;
		}
		++cnt;
	}
	if (cnt > 0) {
		better_hint.push_back(hint.back());
		for (bool b : toBinary(cnt)) {
			better_hint.push_back(b);
		}
	}
	return better_hint;
}
vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint) {
	vector<int> answer;
	vector<bool> realHint;
	auto getNumber = [&](int x) -> int {
		int num = 0;
		for (int i = x; i < x + 10; ++i) {
			num = num << 1 | hint[x];
		}
		return num;
	};
	for (int i = 0; i < (int)hint.size(); ++i) {
		int num = getNumber(i + 1);
		for (int rep = 0; rep < num; ++rep) {
			realHint.push_back(hint[i]);
		}
		i += 10;
	}
	for (int i = 0; i < (int)realHint.size(); ++i) {
		if (realHint[i] == true) {
			answer.push_back(a[i]);
		}
	}
	return answer;
}