#include <bits/stdc++.h>
#include "hint.h"

#define pb push_back
#define pii pair <int, int>
#define f first
#define s second



using namespace std;

const int P = 17;
std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b,
                          const std::vector<int>& sol)
{


    int n = (int)a.size();
    int m = (int)b.size();
    if (n <= 10000 && m <= 10000)
        return {};

    int k = P * (int)sol.size() + 1;
    if (n <= m && k >= n + 1)
    {
        vector < bool > ok(n);

        for (int i = 0; i < n; i++)
            ok[i] = 0;
        int l = 0;
        for (int i = 0; i < n; i++)
        {
            if (l < (int)sol.size() && a[i] == sol[l])
            {
                ok[i] = 1;
                l++;
            }
        }

        ok.pb(0);

        return ok;
    }
    else if (m <= n && k >= m + 1)
    {


        vector < bool > ok(m);
        for (int i = 0; i < m; i++)
            ok[i] = 0;
        int l = 0;
        for (int i = 0; i < m; i++)
        {
            if (l < (int)sol.size() && b[i] == sol[l])
            {
                ok[i] = 1;
                l++;
            }
        }

        ok.pb(0);
        return ok;
    }
    vector < bool > ok;

    int l = 0;
    for (int i = 0; i < n; i++)
    {
        if (l < (int)sol.size() && a[i] == sol[l])
        {
            for (int c = 0; c < P; c++)
                ok.pb((i >> c) & 1);
            l++;
        }
    }

    ok.pb(1);

    return ok;



}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint)
{
    vector < int > c;
    int n = (int)a.size();
    int m = (int)b.size();

    if (n <= 10000 && m <= 10000)
    {
        int dp[n + 1][m + 1];
        pair < bool, bool > pred[n + 1][m + 1];
        for (int i = 0; i <= n; i++)
            for (int j = 0; j <= m; j++)
            {
                dp[i][j] = 0;
                pred[i][j] = {0, 0};
            }

        for (int i = 1; i <= n; i++)
            for (int j = 1; j <= m; j++)
            {
                if (a[i - 1] == b[j - 1] && dp[i][j] < dp[i - 1][j - 1] + 1)
                {
                    dp[i][j] = dp[i - 1][j - 1] + 1;
                    pred[i][j] = {1, 1};
                }

                if (dp[i][j] < dp[i - 1][j])
                {
                    dp[i][j] = dp[i - 1][j];
                    pred[i][j] = {1, 0};
                }
                if (dp[i][j] < dp[i][j - 1])
                {
                    dp[i][j] = dp[i][j - 1];
                    pred[i][j] = {0, 1};
                }
            }

        vector < int > c;
        while (n > 0 && m > 0)
        {
            int x = pred[n][m].f;
            int y = pred[n][m].s;
            if (x == 0 && y == 0)
                break;
            if (x + y == 2)
            {
                n--;
                m--;
                c.pb(a[n]);
            }
            else
            {
                n -= x;
                m -= y;
            }
        }


        reverse(c.begin(), c.end());

        return c;
    }


    int fl = hint.back();

    if (n <= m && fl == 0)
    {
        for (int i = 0; i < n; i++)
        {
            if (hint[i] == 1)
                c.pb(a[i]);
        }
    }
    else if (m <= n && fl == 0)
    {
        for (int i = 0; i < m; i++)
        {
            if (hint[i] == 1)
                c.pb(b[i]);
        }
    }

    if (fl == 0)
        return c;

    for (int i = 0; i + P < (int)hint.size(); i += P)
    {
        int in = 0;
        for (int c = 0; c < P; c++)
        {
            if (hint[i + c] == 1)
                in += (1ll << c);
        }

        c.pb(a[in]);
    }
    return c;
}
