#include <bits/stdc++.h>

//#pragma GCC optimize ("Ofast", "O3", "-O3", "fast-math")

using namespace std;

#define int long long
#define pii pair<int, int>
#define null NULL

const int inf = 2e9;
const int mod = 1e9 + 7;

int n, l, r;
vector<int> ans;

int clamp(int a, int mn, int mx) {
    return max(mn, min(a, mx));
}

int add(int a, int x) {
    return clamp(a + x, 0, n - 1);
}

void check(int x, bool scary = false) {
    if (scary) {
        l = min(add(l, -1), max(0ll, x - 2));
        r = max(add(r, 1), min(n - 1, x + 2));
    } else {
        if (x < l) l--, r--;
        else if (x > r) l++, r++;
        else l++, r--;
    }
    ans.push_back(x + 1);
}

signed main() {
    int s, c;
    cin >> n >> s >> c;
    l = n / 2;
    r = n / 2;
    bool inLeft = true, inRight = true;
    bool scary = true;
    int timer = s;

    while (inLeft || inRight) {
        if (l == 0 && inLeft) {
            inLeft = false;
            check(0, scary);
            if (l == n - 1)
                inRight = false;
        } else if (r == n - 1 && inRight) {
            inRight = false;
            check(n - 1, scary);
            if (r == 0)
                inLeft = false;
        } else {
            if (scary) {
                if (inLeft)
                    check(l, scary);
                else
                    check(r, scary);

            } else {
                if (l + 1 <= n - r && inLeft) check(0);
                else check(n - 1);
            }
        }
        timer--;
        if (timer <= 0)
            timer = (scary ? c : s), scary = !scary;
    }

    cout << ans.size() << endl;
    for (auto x: ans)
        cout << x << " ";
}