#include <bits/stdc++.h>
using namespace std;

#define INF 1000000009
#define int long long

unordered_map<int, int> mp;
vector<pair<int, int>> v;
int nrp;

pair<int, int> query(int l, int r){
	int mini=INF, poz=-1;
	for(auto it:mp){
		if(l<=it.first&&it.first<=r&&v[it.second].second<mini){
			mini=v[it.second].second;
			poz=it.first;
		}
	}
	return {mini, poz};
}

void solve(int l, int r, int lh, int rh){
	//cout<<l<<" "<<r<<" "<<lh<<" "<<rh<<"\n";
	if((r-1)<(l+1)||(r-1)<=1||(l+1)>=1e9) return;
	int mini, poz;
	tie(mini, poz) = query(max(l+1, 1ll), min((int)1e9,r-1));
	//cout<<mini<<" "<<poz<<"**"<<endl;
	if(mini==INF||poz==-1) return;
	if((abs(lh-mini)<=abs(l-poz))&&(abs(rh-mini)<=abs(r-poz))){
		nrp++;
		int x=mp[poz];
		v[x].second=INF;
		if(((x+1)<v.size())&&(v[x+1].first==v[x].first)){
			mp[poz]++;
		}
		solve(l, poz, lh, mini);
		solve(poz, r, mini, rh);
	}
}

int32_t main(){
	int n;
	cin>>n;
	v.resize(n+1);
	for(int i=1;i<=n;++i){
		cin>>v[i].first>>v[i].second;
	}
	sort(v.begin()+1, v.end());
	for(int i=1;i<=n;++i){
		if(v[i].first!=v[i-1].first) mp[v[i].first]=i;	
	}
	int sol=0;
	while(nrp<n){
		sol++;
		solve(-1e9, 2e9, 0, 0);
	}
	cout<<sol<<"\n";
	return 0;
}



