#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N_MAX = 1000000;
const int XY_MAX = 1000000000;

struct Point {
    int x, y;
};

bool operator < (const Point &a, const Point &b) {
    if (a.x != b.x) {
        return a.x < b.x;
    }
    return a.y > b.y;
}

int N;

Point Q[N_MAX + 2];

int dp[N_MAX + 2];

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> N;
    for (int i = 1; i <= N; i++) {
        cin >> Q[i].x >> Q[i].y;
        Q[i] = Point{Q[i].y - Q[i].x, Q[i].y + Q[i].x};
    }

    sort(Q + 1, Q + N + 1);

    int answer = 0;
    for (int i = 1; i <= N; i++) {
        dp[i] = 1;
        for (int j = 1; j < i; j++) {
            if (Q[j].y < Q[i].y) {
                dp[i] = max(dp[i], dp[j] + 1);
            }
        }
        answer = max(answer, dp[i]);
    }

    cout << answer << "\n";

    return 0;
}
