#include <bits/stdc++.h>

using namespace std;

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	int n;
	cin >> n;
	vector<int> h(n), t(n);
	for (int i = 0; i < n; ++i) {
		cin >> h[i] >> t[i];
	}

	vector<int> a(n), b(n);
	for (int i = 0; i < n; ++i) {
		a[i] = h[i] + t[i];
		b[i] = h[i] - t[i];
	}
	
	vector<int> ord(n);
	for (int i = 0; i < n; ++i) {
		ord[i] = i;
	}
	sort(ord.begin(), ord.end(), [&](const int &i, const int &j) {
		return a[i] < a[j] || (a[i] == a[j] && b[i] > b[j]);
	});

	vector<int> dp = {-(int)2e9};
	for (int i = 0; i < n; ++i) {
		int l = 0, r = dp.size();
		while (r - l > 1) {
			int m = (l + r) / 2;
			if (dp[m] < b[ord[i]]) {
				l = m;
			} else {
				r = m;
			}
		}
		if (l == (int)dp.size() - 1) {
			dp.push_back(b[ord[i]]);
		} else {
			dp[r] = b[ord[i]];
		}
	}
	cout << (int)dp.size() - 1 << "\n";
	return 0;
}
