#include <iostream>
#include <vector>
#include <set>
#include <cmath>
#include <algorithm>
#include <map>

using namespace std;

typedef long long ll;

int main(){
    
    int n;
    cin >> n;
    vector <ll> h(n);
    vector <ll> t(n);
    
    for (int i = 0; i < n; i++)
        cin >> t[i] >> h[i];
    
    map <ll, ll> mapa1;
    map <ll, ll> mapa2;
    
    for (int i = 0; i < n; i++)
        mapa1[t[i]] = h[i], mapa2[h[i]] = t[i];
    
    sort(t.begin(), t.end());
    
    ll l = 1, r = n;
    while (l < r){
        
        ll mid = (l+r)/2;
        
        vector <pair <ll, ll> > kraj(mid, {-1,-1});
        
        bool moguce = true;
        
        for (int  i = 0; i < n; i++){
            
            ll trent = t[i], trenp = mapa1[trent];
            bool nasao = false;
            for (int j = 0; j < mid; j++)
                if (kraj[j].first == -1 || trent - kraj[j].first >= trenp - kraj[j].second){
                    kraj[j].first = trent, kraj[j].second = trenp;
                    nasao = true;
                    break;
                }
            if (!nasao){
                moguce = false;
                break;
            }
            
        }
        
        if (!moguce)
            l = mid + 1;
        else
            r = mid;
        
        
    }
    
    cout << l;
    
}
