#include <iostream>
#include <vector>
#include <set>
#include <cmath>
#include <algorithm>
#include <map>

using namespace std;

typedef long long ll;

int main(){
    
    int n;
    cin >> n;
    vector <ll> h(n);
    vector <ll> t(n);
    
    for (int i = 0; i < n; i++)
        cin >> t[i] >> h[i];
    
    map <ll, ll> mapa1;
    map <ll, ll> mapa2;
    
    for (int i = 0; i < n; i++)
        mapa1[t[i]] = h[i], mapa2[h[i]] = t[i];
    
    sort(t.begin(), t.end());
    
    vector <ll> novi(n);
    for (int i = 0; i < n; i++)
        novi[i] = t[i] - mapa1[t[i]];
    
    vector <ll> nizovi(n, -100000000000);
    for (int i = 0; i < n; i++){
        
        ll tren = novi[i];
        ll l = 0, r = n - 1;
        while (l < r){
            
            ll mid = (l+r+1)/2;
            if (nizovi[mid] <= tren)
                l = mid;
            else
                r = mid - 1;
    
        }
        nizovi[l] = tren;
        
    }
    
    ll broj = n;
    for (int i = 0; i < n; i++)
        if (nizovi[i] == -100000000000)
            broj--;
    
    cout << broj;
        
    
}
