#include <iostream>
#include <vector>
#include <set>
#include <cmath>
#include <algorithm>
#include <utility>
#include <map>

using namespace std;

typedef long long ll;

int main(){
    
    int n;
    cin >> n;
    vector <ll> h(n);
    vector <ll> t(n);
    
    for (int i = 0; i < n; i++)
        cin >> t[i] >> h[i];
    
    vector <pair<ll,ll> > parovi(n);
    for (int i = 0; i < n; i++)
        parovi[i].first = t[i], parovi[i].second = h[i];
    
    sort(parovi.begin(), parovi.end());
    
    vector <ll> novi(n);
    for (int i = 0; i < n; i++)
        novi[i] = parovi[i].first - parovi[i].second;
    
    vector <ll> nizovi(n, -100000000000);
    for (int i = 0; i < n; i++){
        
        ll tren = novi[i];
        ll l = 0, r = n - 1;
        while (l < r){
            
            ll mid = (l+r+1)/2;
            if (nizovi[mid] <= tren)
                l = mid;
            else
                r = mid - 1;
    
        }
        nizovi[l] = tren;
        
    }
    
    ll broj = n;
    for (int i = 0; i < n; i++)
        if (nizovi[i] == -100000000000)
            broj--;
    
    cout << broj;
        
    
}
