#include "hint.h"

#include <vector>
using namespace std;

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol) {
	int n = a.size();
	int m = b.size();
	int pt = 0;
	vector<bool> ans(n + m);
	for (int i = 0; i < n + m; i++) {
		if (pt < n && sol[i] == a[pt])
			pt++, ans[i] = true;
	}
	return ans;
}


std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint) {
	int n = a.size();
	int m = b.size();
	vector<int> ans;
	int pt = 0;
	int pt2 = 0;
	for (int i = 0; i < n; i++)
		if (hint[i])
			ans.emplace_back(a[pt]), pt++;
		else
			ans.emplace_back(b[pt2]), pt2++;
	return ans;
}