#include "hint.h"

#include <vector>
using namespace std;

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol) {
	int n = a.size();
	int m = b.size();
	int d = sol.size();
	int pt = 0;
	vector<bool> ans(20 * d);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < 20; j++)
			ans[i * 20 + j] = !!(sol[i] & (1 << j));
	}
	return ans;
}


std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint) {
	int c = hint.size() / 20;
	vector<int> ans(c);
	for (int i = 0; i < hint.size(); i+=20) {
		for (int j = 0; j < 20; j++)
			if (hint[i + j])
				ans[i / 20] += (1 << j);
	}
	return ans;
}