#include "hint.h"

#include <vector>
using namespace std;

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol) {
	int d = sol.size();
	int pt = 0;
	vector<bool> ans(15 * d);
	for (int i = 0; i < d; i++) {
		for (int j = 0; j < 15; j++)
			ans[i * 15 + j] = !!(sol[i] & (1 << j));
	}
	return ans;
}


std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint) {
	int c = hint.size() / 15;
	vector<int> ans(c);
	for (int i = 0; i < hint.size(); i += 15) {
		for (int j = 0; j < 15; j++)
			if (hint[i + j]	)
				ans[i / 15] += (1 << j);
	}
	return ans;
}