#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define pii pair<int,int>
#define all(x) x.begin(), x.end()

const int max_n = 1e4 + 100;

int backs[max_n];
vector<int> gr[max_n];
int used[max_n];
int timer = 1;
bool marked[2][max_n];

bool try_khun(int v) {
	if (used[v] == timer)
		return false;
	used[v] = timer;
	for (int to : gr[v]) {
		if (backs[to] == -1) {
			backs[to] = v;
			marked[0][v] = true;
			return true;
		}
	}
	for (int to : gr[v]) {
		if (try_khun(backs[v])) {
			backs[to] = v;
			marked[0][v] = true;
			return true;
		}
	}
	return false;
}

void solve(int v) {
	if (used[v] == timer)
		return;
	used[v] = timer;
	marked[0][v] = true;
	for (int to : gr[v]) {
		if (backs[v] != -1) {
			solve(backs[v]);
			marked[1][to] = true;
		}
	}
}

signed main() {
	cin.tie(), cout.tie(), ios_base::sync_with_stdio(false);
	int n;
	cin >> n;
	vector<pii> a(n);
	for (int i = 0; i < n; i++)
		cin >> a[i].first >> a[i].second;
	fill(backs, backs + n, -1);
	sort(all(a));
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			if (abs(a[i].first - a[j].first) >= abs(a[i].second - a[j].second)) {
				gr[i].emplace_back(j);
				//cout << i << " " << j << '\n';
			}
		}
	}
	for (int i = 0; i < n; i++) {
		if (try_khun(i))
			timer++;
	}
	timer++;
	for (int i = 0; i < n; i++) {
		if (marked[0][i])
			solve(i);
	}
	// for (int i = 0; i < n; i++) {
	// 	cout << backs[i] << '\n';
	// }
	int cnt = 0;
	for (int i = 0; i < n; i++)
		if (backs[i] == -1)
			cnt++;
	cout << cnt << '\n';
}