#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define pii pair<int,int>
#define all(x) x.begin(), x.end()

const int max_n = 1e4 + 100;

vector<int> gr[max_n];
vector<int> gr2[max_n];
vector<int> gr3[max_n];
int col[max_n];


void dfs(int v, int cl) {
	col[v] = cl;
	for (int to : gr3[v])
		if (col[to] == -1)
			dfs(to, cl);
}

signed main() {
    cin.tie(), cout.tie(), ios_base::sync_with_stdio(false);
    int n;
    cin >> n;
    vector<pii> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i].first >> a[i].second;
    sort(all(a));
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (a[j].first - a[i].first >= abs(a[i].second - a[j].second)) {
                gr[i].emplace_back(j);
            	gr2[j].emplace_back(i);
            	gr3[i].emplace_back(j);
            	gr3[j].emplace_back(i);
            	//cout << i << " " << j << '\n';
            }
        }
    }
    fill(col, col + n, -1);
    for (int i = 0; i < n; i++)
    	if (col[i] == -1)
    		dfs(i, i);
    vector<int> mem(n);
    vector<int> mem2(n);
    for (int i = 0; i < n; i++) {
    	if (gr[i].size() == 0)
    		mem[col[i]]++;
    	else if(gr2[i].size() == 0)
    		mem2[col[i]]++;
    	//cout << mem[col[i]] << '\n';
    }
    int ans = 0;
    for (int i = 0; i < n; i++) {
    	ans += max(mem[i], mem2[i]);
    }
    cout << ans << '\n';
}