#include <vector>
#include <iomanip>
#include <iostream>
#include <algorithm>

using namespace std;

int main() {
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

  int n, s, c;
  cin >> n >> s >> c;
  int r = n - 1;
  vector<int> ans1;
  int cur = 0;
  while (r >= 0) {
    if (cur % (s + c) < s) {
      ans1.emplace_back(r);
      r -= 2;
      if (r == -1)
        ++r;
    } else {
      ans1.emplace_back(0);
      r -= 1;
    }
    ++cur;
  }
  vector<int> ans2;
  cur = 0;
  int l = 0;
  r = n - 1;
  while (l <= r) {
    if (cur % (s + c) < s) {
      ans2.emplace_back(r);
      if (r == 1)
        --r;
      else
        r -= 2;
      l = max(l - 1, 0);
    } else {
      if (l + 1 == r) {
        ans2.emplace_back(l);
        --r;
      } else {
        ans2.emplace_back((l + r) / 2);
        ++l;
        --r;
      }
    }
    ++cur;
  }
  if (ans2.size() < ans1.size())
    swap(ans2, ans1);
  cout << ans1.size() << '\n';
  for (int x : ans1)
    cout << x + 1 << '\n';
  return 0;
}