#include "bits/stdc++.h"
//#include "hint.h"

using namespace std;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
#define sz(a)(int)a.size()
#define all(a)a.begin(),a.end()

//#define int long long
vector<bool> genHint(const vector<int> &a, const vector<int> &b, const vector<int> &sol) {
    int n = sz(a);
    int m = sz(b);
    if (max(n, m) <= 1e4)
        return {};
    vector<bool> res(min(n, m));
    if (n <= m) {
        int pnta = 0, pntsol = 0;
        while (pnta < n && pntsol < sz(sol)) {
            if (a[pnta] == sol[pntsol]) {
                res[pnta] = true;
                ++pntsol;
            }
            ++pnta;
        }
    } else {
        int pnta = 0, pntsol = 0;
        while (pnta < m && pntsol < sz(sol)) {
            if (b[pnta] == sol[pntsol]) {
                res[pnta] = true;
                ++pntsol;
            }
            ++pnta;
        }
    }
    return res;
};

vector<int> solve(const vector<int> &a, const vector<int> &b, const vector<bool> &hint) {
    int n = sz(a);
    int m = sz(b);
    vector<int> ans;
    if (!hint.empty()) {
        if (n <= m) {
            for (int i = 0; i < sz(hint); ++i)
                if (hint[i])
                    ans.push_back(a[i]);
        } else {
            for (int i = 0; i < sz(hint); ++i)
                if (hint[i])
                    ans.push_back(b[i]);
        }
    } else {
        vector<vector<int>> dp(n + 1, vector<int>(m + 1));
        for (int i = 1; i <= n; ++i)
            for (int j = 1; j <= m; ++j) {
                if (a[i - 1] == b[j - 1])
                    dp[i][j] = dp[i - 1][j - 1] + 1;
                else
                    dp[i][j] = max(dp[i - 1][j], dp[i][j - 1]);
//                cout<<i<<" "<<j<<" "<<dp[i][j]<<endl;
            }
        int i = n;
        int j = m;
        while (i > 0 && j > 0) {
            if (a[i - 1] == b[j - 1]) {
                --i, --j;
                ans.push_back(a[i]);
            } else {
                if (dp[i][j] == dp[i - 1][j])
                    --i;
                else
                    --j;
            }
        }
        reverse(all(ans));
    }
    return ans;
}
//void solve() {
//   cout<<pow((640.0/100000.0),0.3);
//}
//
//signed main() {
//    ios_base::sync_with_stdio(0), cin.tie(0);
//    solve();
//    return 0;
//}