#include "bits/stdc++.h"
//#include "hint.h"
using namespace std;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,avx")
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("O3")
#define sz(a)(int)a.size()
#define all(a)a.begin(),a.end()
//#define int long long
int B = 1330;
int C = 18;

int getPOW2(int x) {
    int y = 0;
    while ((1 << y) < x)
        ++y;
    return y;
}

vector<int> get(int x, int len) {
    int y = getPOW2(len);
    vector<int> res;
    for (int i = 0; i < y; ++i) {
        res.push_back(x & 1);
        x >>= 1;
    }
    return res;
}

int back(vector<int> &a) {
    int x = 0;
    for (int i = 0; i < sz(a); ++i)
        x += (1 << i) * a[i];
    return x;
}

vector<bool> genHint(const vector<int> &a, const vector<int> &b, const vector<int> &sol) {
    vector<bool> res;
    int n = sz(a);
    int m = sz(b);
    int k = sz(sol);
    int p1 = 0, p2 = 0;
    vector<bool> used(n);
    while (p1 < n && p2 < k) {
        if (a[p1] == sol[p2]) {
            used[p1] = true;
            ++p2;
        }
        ++p1;
    }
    vector<bool> T(m);
    p1 = 0;
    p2 = 0;
    while (p1 < m && p2 < k) {
        if (b[p1] == sol[p2]) {
            T[p1] = true;
            ++p2;
        }
        ++p1;
    }
    int last = 0;
    for (int i = 0;; ++i) {
        p1 = i * B;
        if (n <= p1)
            break;
        int cnt = 0;
        for (int j = p1; j < min(n, p1 + B); ++j)
            cnt += used[j];
        int rem = last;
        while (cnt) {
            cnt -= T[last];
            ++last;
        }
        int X = last - rem;
        vector<int> f = get(X, m - rem);
        for (int &j : f)
            res.push_back(j);
    }
    return res;
};

vector<int> RES(vector<int> &a, vector<int> &b) {
    int n = sz(a);
    int m = sz(b);
    vector<vector<int>> dp(n + 1, vector<int>(m + 1));
    for (int i = 1; i <= n; ++i)
        for (int j = 1; j <= m; ++j) {
            if (a[i - 1] == b[j - 1])
                dp[i][j] = dp[i - 1][j - 1] + 1;
            else
                dp[i][j] = max(dp[i - 1][j], dp[i][j - 1]);
        }
    vector<int> ans;
    int i = n;
    int j = m;
    while (i > 0 && j > 0) {
        if (a[i - 1] == b[j - 1]) {
            --i, --j;
            ans.push_back(a[i]);
        } else {
            if (dp[i][j] == dp[i - 1][j])
                --i;
            else
                --j;
        }
    }
    reverse(all(ans));
    return ans;
}

vector<int> solve(const vector<int> &a, const vector<int> &b, const vector<bool> &hint) {
    int n = sz(a);
    int m = sz(b);
    vector<int> ans;
    int p1 = 0;
    int last = 0;
    int p2 = 0;
    for (int i = 0;; ++i) {
        p1 = i * B;
        if (n <= p1)
            break;
        vector<int> A;
        for (int j = p1; j < min(n, p1 + B); ++j)
            A.push_back(a[j]);
        vector<int> h;
        int y = getPOW2(m - last);
        for (int j = p2; j < p2 + y; ++j)
            h.push_back(hint[j]);
        int LAST = last + back(h);
        p2 += y;
        vector<int> BB;
        for (int j = last; j < min(m, LAST); ++j)
            BB.push_back(b[j]);
        vector<int> f = RES(A, BB);
        for (int &j : f)
            ans.push_back(j);
        last = LAST;
    }
    return ans;
}