#include "bits/stdc++.h"

using namespace std;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
#define sz(a)(int)a.size()
#define all(a)a.begin(),a.end()
#define int long long

const int MAXN = 1e6;
vector<vector<int>> g(MAXN);
int T = 1;
vector<int> used(MAXN, 0);
vector<int> pr(MAXN, -1);

int kuhn(int v) {
    if (used[v] == T)
        return 0;
    used[v] = T;
    for (auto w:g[v]) {
        if (pr[w] == -1 || kuhn(pr[w])) {
            pr[w] = v;
            return 1;
        }
    }
    return 0;
}

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i].first >> a[i].second;
    sort(all(a));
    for (int i = 0; i < n; ++i)
        for (int j = i + 1; j < n; ++j) {
            if (abs(a[i].second - a[j].second) <= a[j].first - a[i].first)
                g[i].push_back(j);
        }
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        T++;
        cnt += kuhn(i);
    }
    cout << n - cnt;
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    solve();
    return 0;
}