#include "bits/stdc++.h"

using namespace std;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
#pragma GCC optimize("Ofast")
#pragma GCC optimize("O3")
#define sz(a)(int)a.size()
#define all(a)a.begin(),a.end()
//#define int long long
const int MAXN = 1e4;
vector<set<int>> g(MAXN);
vector<unordered_set<int>> can(MAXN);
int T = 1;
vector<int> used(MAXN, 0);
vector<int> pr(MAXN, -1);

inline int kuhn(int v) {
    if (used[v] == T)
        return 0;
    used[v] = T;
    int k = -1;
    for (auto w:g[v])
        if (pr[w] == -1)
            k = w;
    if (k != -1) {
        pr[k] = v;
        return 1;
    }
    for (auto w:g[v]) {
        if (pr[w] == -1 || kuhn(pr[w])) {
            pr[w] = v;
            return 1;
        }
    }
    return 0;
}

void dfs(int i, int j) {
    if (can[i].find(j) != can[i].end())
        return;
    can[i].insert(j);
    for (auto w:g[j])
        dfs(i, w);

}

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i].first >> a[i].second;
    sort(all(a));
    for (int i = 0; i < n; ++i) {
        can[i].insert(i);
        for (int j = i + 1; j < n; ++j) {
            if (can[i].find(j) == can[i].end() && abs(a[i].second - a[j].second) <= a[j].first - a[i].first) {
                dfs(i, j);
                g[i].insert(j);
            }
        }
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            ++ans;
            int v = i;
            used[v] = 1;
            while (!g[v].empty()) {
                int w = *g[v].begin();
                used[w] = 1;
                g[v].erase(w);
                v = w;
            }
        }
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    solve();
    return 0;
}