#include <bits/stdc++.h>
#include "hint.h"
//#define int long long
using namespace std;

std::vector<bool> genHint(const std::vector<int> &a, const std::vector<int> &b, const std::vector<int> &sol) {
    vector<bool> Ans;
    if (a.size() > b.size()) {
        int pos = 0;
        Ans.resize(b.size());
        for (int i = 0; i < b.size(); i++) {
            if (pos == sol.size()) {
                Ans[i] = 0;
                continue;
            }
            if (b[i] == sol[pos]) {
                Ans[i] = 1;
                pos++;
            } else
                Ans[i] = 0;
        }
    }else{
        Ans.resize(a.size());
        int pos = 0;
        for (int i = 0; i < a.size(); i++) {
            if (pos == sol.size()) {
                Ans[i] = 0;
                continue;
            }
            if (a[i] == sol[pos]) {
                Ans[i] = 1;
                pos++;
            } else
                Ans[i] = 0;
        }
    }

    vector<bool> ans, ans2;
    int pos = 0;
    for(int i = 0; i < a.size(); i++){
        if(pos < sol.size() && a[i] == sol[pos]){
            bitset<18> B(i);
            for(int j = 0; j < 18; j++)
                ans.push_back(B[j]);
            pos++;
        }else{
            bitset<18> B(i);
            for(int j = 0; j < 18; j++)
                ans2.push_back(B[j]);
        }
    }
    if(min(ans.size(), ans2.size()) > Ans.size())
    return Ans;
    if(ans2.size() < ans.size())
    return ans2;

    return ans;
}
std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b,const std::vector<bool>& hint){
    if(hint.size() != min(a.size(), b.size())) {
        vector<int> ans, ans2;
        bitset<(int) 2e5> u;
        u.reset();
        for (int i = 0; i < hint.size(); i += 18) {
            bitset<18> B;
            for (int j = 0; j < 18; j++)
                B[j] = hint[i + j];
            u[B.to_ullong()] = 1;
            ans.push_back(a[B.to_ullong()]);
        }
        for(int i = 0; i < a.size(); i++)
            if(!u[i]) ans2.push_back(a[i]);
        int pos = 0;
        for(int i = 0; i < b.size(); i++){
            if(pos < ans.size() && b[i] == ans[pos])
                pos++;
        }
        if(pos == ans.size())
        return ans;
        return ans2;
    }else{
        vector<int> ans;
        if(a.size() <= b.size()){
            for(int i = 0; i < a.size(); i++)
                if(hint[i])
                    ans.push_back(a[i]);
        }else{
            for(int i = 0; i < b.size(); i++)
                if(hint[i])
                    ans.push_back(b[i]);
        }
        return ans;
    }
}