#include <bits/stdc++.h>
#include "hint.h"
//#define int long long
using namespace std;

std::vector<bool> genHint(const std::vector<int> &a, const std::vector<int> &b, const std::vector<int> &sol) {
    vector<int> A, B;
    set<int> sa; set<int> sb;
    for(int i = 0; i < a.size(); i++)
        sa.insert(a[i]);
    for(int i = 0; i < b.size(); i++)
        sb.insert(b[i]);
    for(int i = 0; i < a.size(); i++)
        if(sb.count(a[i]))
            A.push_back(a[i]);
    for(int i = 0; i < b.size(); i++)
        if(sa.count(b[i]))
            B.push_back(b[i]);

    if (A.size() > B.size())
        swap(A, B);
    vector<bool> Hint(A.size());
    int pos = 0;
    for (int i = 0; i < A.size(); i++) {
        if (pos < sol.size() && A[i] == sol[pos]) {
            Hint[i] = 1;
            pos++;
        } else Hint[i] = 0;
    }
    return Hint;
}

std::vector<int> solve(const std::vector<int> &a, const std::vector<int> &b, const std::vector<bool> &hint) {
    vector<int> A, B;
    set<int> sa; set<int> sb;
    for(int i = 0; i < a.size(); i++)
        sa.insert(a[i]);
    for(int i = 0; i < b.size(); i++)
        sb.insert(b[i]);
    for(int i = 0; i < a.size(); i++)
        if(sb.count(a[i]))
            A.push_back(a[i]);
    for(int i = 0; i < b.size(); i++)
        if(sa.count(b[i]))
            B.push_back(b[i]);

    if (A.size() > B.size())
        swap(A, B);
    vector<int> ans;
    for (int i = 0; i < A.size(); i++)
        if (hint[i])
            ans.push_back(A[i]);
    return ans;
}