#include <bits/stdc++.h>
#include "hint.h"

#define fr(i, a, b) for(int i = (a); i <= (b); ++i)
#define rf(i, a, b) for(int i = (a); i >= (b); --i)
#define fe(x, y) for(auto& x : y)

#define fi first
#define se second
#define pb push_back
#define mt make_tuple
#define mp make_pair

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define pw(x) (1LL << (x))

using namespace std;

mt19937_64 rng(chrono::system_clock::now().time_since_epoch().count());

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template<typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order
#define ook order_of_key

template<typename T>
bool umn(T& a, T b) { return (a > b ? (a = b, 1) : 0); }
template<typename T>
bool umx(T& a, T b) { return (a < b ? (a = b, 1) : 0); }

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
template<typename T>
using ve = vector<T>;

const int N = 200005;
const int R = 447;
//const int R = 7;

int dp[R][N];
char par[R][N];

ve<int> solve(const ve<int>& a, const ve<int>& b) {
    if(sz(a) == 0 || sz(b) == 0) return ve<int>(0);

//    assert(sz(a) <= R);
//    cout << "a: ";
//    fe(x, a) cout << x << " ";
//    cout << "\n";
//    cout << "b: ";
//    fe(x, b) cout << x << " ";
//    cout << "\n" << flush;

    fr(i, 0, sz(a)) {
        fr(j, 0, sz(b)) {
            dp[i][j] = -1e9;
            par[i][j] = -1;
        }
    }
    dp[0][0] = 0;
    fr(i, 0, sz(a)) {
        fr(j, 0, sz(b)) {
            if(i + 1 <= sz(a)) {
                if(umx(dp[i + 1][j], dp[i][j])) {
                    par[i + 1][j] = 0;
                }
            }
            if(j + 1 <= sz(b)) {
                if(umx(dp[i][j + 1], dp[i][j])) {
                    par[i][j + 1] = 1;
                }
            }
            if(i + 1 <= sz(a) && j + 1 <= sz(b) && a[i] == b[j]) {
                if(umx(dp[i + 1][j + 1], dp[i][j] + 1)) {
                    par[i + 1][j + 1] = 2;
                }
            }
        }
    }
//    cout << "dp:\n";
//    fr(i, 0, sz(a)) {
//        fr(j, 0, sz(b)) {
//            cout << dp[i][j] << " ";
//        }
//        cout << "\n";
//    }
//    cout << "\n";
//
//    cout << "par:\n";
//    fr(i, 0, sz(a)) {
//        fr(j, 0, sz(b)) {
//            cout << int(par[i][j]) << " ";
//        }
//        cout << "\n";
//    }
//    cout << "\n";
//

    int x = sz(a);
    int y = sz(b);
    ve<int> ans;

    int moves = dp[x][y];
//    cout << dp[x][y] << "\n";

    while(1) {
        if(sz(ans) == moves) break;
//        cout << "go " << x << " " << y << "\n" << flush;
//        cout << int(par[x][y]) << "\n" << flush;

        if(par[x][y] == 0) {
            x--;
            continue;
        }
        if(par[x][y] == 1) {
            y--;
            continue;
        }
        if(par[x][y] == 2) {
            x--;
            y--;
            ans.pb(a[x]);
            continue;
        }
    }
    reverse(all(ans));
    return ans;
}

ve<bool> genHint(const ve<int>& a, const ve<int>& b, const ve<int>& sol) {
    return ve<bool>(0);
    int ptr1 = 0;
    int ptr2 = 0;

    ve<int> r((sz(a) + R - 1) / R);
    ve<bool> have((sz(a) + R - 1) / R);

    fr(i, 0, sz(sol) - 1) {
        while(a[ptr1] != sol[i]) ptr1++;
        while(b[ptr2] != sol[i]) ptr2++;
        umx(r[ptr1 / R], ptr2);
        have[ptr1 / R] = 1;
    }

//    cout << "r: ";
//    fe(cur, r) cout << cur << " ";
//    cout << "\n";

    ve<bool> hint;
    fr(i, 0, sz(r) - 1) {
        if(!have[i]) r[i] = 200001;
        ve<int> add;
        rf(j, 17, 0) {
            if(r[i] & pw(j)) {
                add.pb(1);
            } else {
                add.pb(0);
            }
        }
        fe(x, add) hint.pb(x);
    }
    return hint;
}

ve<int> solve(const ve<int>& a, const ve<int>& b, const ve<bool>& hint) {
    return solve(a, b);
    ve<int> r;
    for(int i = 0; i < sz(hint); i += 18) {
        int res = 0;
        fr(j, i, i + 17) {
            res = res * 2 + hint[j];
        }
        r.pb(res);
    }

//    cout << "r: ";
//    fe(cur, r) cout << cur << " ";
//    cout << "\n";
//    cout << "r: ";
//    fe(cur, r) cout << cur << " ";
//    cout << "\n";
    ve<int> ans;
    int last = -1;
    for(int i = 0; i < sz(a); i += R) {
        if(r[i / R] == 200001) continue;

        ve<int> A;
        fr(j, i, min(i + R - 1, sz(a) - 1)) {
            A.pb(a[j]);
        }
        ve<int> B;
        fr(j, last + 1, r[i / R]) {
            B.pb(b[j]);
        }
        umx(last, r[i / R]);

//        cout << "A: ";
//        fe(x, A) cout << x << " ";
//        cout << "\n";
//        cout << "B: ";
//        fe(x, B) cout << x << " ";
//        cout << "\n\n";

        ve<int> add = solve(A, B);
        fe(cur, add) ans.pb(cur);
    }
    return ans;
}

/*
5 3
1 2 3 2 3
3 2 1
2
3 2
*/

