#include <bits/stdc++.h>
#define fr(i, n, m) for(int i = (n); i < (m); i++)
#define pb push_back
#define st first
#define nd second
#define pq priority_queue
#define all(x) begin(x), end(x)

using namespace std;
typedef long long ll;
typedef pair<int,int> pii;

const int mxn = 2e5;
const int k = 350;
int link[mxn];

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol){
	int n = a.size();
	int m = b.size();
	int lcs = sol.size();
	
	int p = 0;
	vector<int> apos;
	fr(i, 0, n){
		if(p >= lcs) break;
		if(a[i] == sol[p]){
			++p;
			apos.pb(i);
		}
	}
	
	p = 0;
	vector<int> bpos;
	fr(i, 0, m){
		if(p >= lcs) break;
		if(b[i] == sol[p]){
			++p;
			bpos.pb(i);
		}
	}
	
	vector<int> akpos;
	vector<int> bkpos;
	fr(i, 0, lcs){
		akpos.pb(apos[i]/k + 1);
		bkpos.pb(bpos[i]/k + 1);
	}
	int mxbk = 0;
	fr(i, 0, lcs){
		link[bkpos[i]] = max(link[bkpos[i]], akpos[i]);
		mxbk = max(mxbk, bkpos[i]);
	}
	vector<bool> h;
	fr(i, 1, mxbk+1){
		int x = link[i];
		for(int j = 8; j >= 0; j --){
			if(x&(1<<j)){
				h.pb(true);
			}
			else{
				h.pb(false);
			}
		}
	}
	
	return h;
}



vector<int> A;
vector<int> B;
int N, M;

int la, ra, lb, rb;

int dp[mxn][500];
int me[mxn][500];

int f(int x, int y){
	if(x < la || y < lb) return 0;
	
	if(dp[x-la][y-lb] != -1) return dp[x-la][y-lb];
	
	int ans1 = f(x-1, y);
	int ans2 = f(x, y-1);
	int ans3 = f(x-1, y-1) + (int)(A[x] == B[y]);
	
	int mx = max({ans1, ans2, ans3});
	dp[x-la][y-lb] = mx;
	if(ans1 == mx) me[x-la][y-lb] = 0;
	else if(ans2 == mx) me[x-la][y-lb] = 1;
	else me[x-la][y-lb] = 2;

	return mx;
}
vector<int> add;
void reconstruct(int x, int y){
	if(x < la || y < lb) return;
	
	if(me[x-la][y-lb] == 0){
		reconstruct(x-1, y);
	}
	else if(me[x-la][y-lb] == 1){
		reconstruct(x, y-1);
	}
	else{
		reconstruct(x-1, y-1);
		add.pb(x);
	}
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint){
	N = (int)a.size();
	M = (int)b.size();
	A = a;
	B = b;
	if(min(N, M) < 500){
		if(N < 500){
			swap(A, B);
			swap(N, M);
		}
		la = 0, lb = 0;
		ra = N-1, rb = M-1;
		memset(dp, -1, sizeof(dp));
		f(ra, rb);
		reconstruct(ra, rb);
	
	}
	else{
		int hlen = (int)hint.size();
		
		vector<int> v;
		int bit;
		fr(i, 0, hlen){
			if(i % 9 == 0){
				v.pb(0);
				bit = 8;
			}
			if(hint[i]){
				v.back() |= (1<<bit);
			}
			--bit;
		}
		int bblocks = (int)v.size();
		
		int pr = 0;
		
		fr(i, 0, bblocks){
			if(v[i] == 0) continue;
			
			lb = i*k;
			rb = (i+1)*k - 1;
			
			la = pr;
			ra = v[i]*k - 1;
			
			fr(x, 0, ra-la+1){
				fr(y, 0, rb-lb+1){
					dp[x][y] = -1;
				} 
			}
			f(ra, rb);
			reconstruct(ra, rb);
			/*if(add.empty()){
				cout<<"ERROR"<<endl;
				continue;
			}*/
			pr = add.back() + 1;
		}
	
	}
	vector<int> ans = add;
	fr(i, 0, (int)ans.size()){
		ans[i] = A[add[i]];
	}
	
	
	
	
	return ans;
}
/*
int main(){
	int n, m, l;
	cin >> n;
	vector<int> a(n);
	fr(i, 0, n) cin >> a[i];
	cin >> m;
	vector<int> b(m);
	fr(i, 0, m) cin >> b[i];
	cin >> l;
	vector<int> sol(l);
	
	fr(i, 0, l) cin >> sol[i];
	
	vector<bool> hint = genHint(a, b, sol);
	sol = solve(a, b, hint);
	for(auto u : sol) cout<<u<<' ';
	cout<<endl;
	

}
10
0 1 2 3 4 5 6 7 8 9
10
10 1 10 4 6 10 10 7 8 9
6
1 4 6 7 8 9
*/
