#include "hint.h"
#include <iostream>
#include <vector>

using namespace std;

vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol)
{
	vector<bool> ans;
	int l = 0;
	if (a.size() <= b.size())
	{
		ans.resize(a.size() + 1);
		for (int i = 0; i < sol.size(); ++i)
		{
			while (a[l] != sol[i]) ++l;
			ans[l] = 1;
			++l;
		}
	}
	else
	{
		ans.resize(b.size() + 1);
		ans[ans.size() - 1] = 1;
		for (int i = 0; i < sol.size(); ++i)
		{
			while (b[l] != sol[i]) ++l;
			ans[l] = 1;
			++l;
		}
	}
	return ans;
}

vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint)
{
	vector<int> res;
	if (hint[hint.size() - 1] == 0)
	{
		for (int i = 0; i < hint.size() - 1; ++i)
		{
			if (hint[i] == 1) res.push_back(a[i]);
		}
	}
	else
	{
		for (int i = 0; i < hint.size() - 1; ++i)
		{
			if (hint[i] == 1) res.push_back(b[i]);
		}
	}
	return res;
}



