#include <iostream>
#include <set>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

struct postime
{
    int pos;
    int time;

    bool operator<(postime b)
    {
        return (abs(pos - b.pos) + time < b.time);
    }
};
bool operator<(postime a, postime b)
{
    //cout << "compare " << endl;
    //cout << a.pos << " " << a.time << endl;
    //cout << b.pos << " " << b.time << endl;
    //cout << "result " << (abs(a.pos - b.pos) + a.time > b.time) << endl;
    return ((abs(a.pos - b.pos) + a.time) > b.time);
}
multiset<postime> trucks;
vector<pair<int, int> /**/> houses;
int main()
{
    int n;
    cin >> n;
    for (int i = 0; i < n; i++)
    {
        pair<int, int> a;
        cin >> a.first >> a.second;
        houses.push_back(a);
    }
    sort(houses.begin(), houses.end());
    for (int i = 0; i < n; i++)
    {
        postime a;
        //cout << houses[i].first << " " << houses[i].second << endl;
        a.time = houses[i].first;
        a.pos = houses[i].second;
        multiset<postime>::iterator tr = trucks.lower_bound(a);
        if (tr == trucks.end())
        {
            trucks.insert(a);
            //cout << "new truck" << endl;
        }
        else
        {
            //cout << "found rout" << endl;
            //cout << "from rout element " << tr->time << " " << tr->pos << endl;
            trucks.erase(tr);
            trucks.insert(a);
        }
    }
    cout << trucks.size() - 1 << endl;
}