#include <iostream>
#include <vector>
#include <cmath>
using namespace std;
const int N = 1e4 + 5;
int t[N], x[N], col[N];
bool used[N][N];
vector<int> gr[N];
void dfs(int nod) {
  col[nod] = 1;
  while (used[nod][col[nod]])
    ++col[nod];
  for (auto vec : gr[nod]) {
    if (col[vec] > 0) continue;
    used[vec][col[nod]] = true;
    dfs(vec);
  }
}
int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr), cout.tie(nullptr);
  int n;
  cin >> n;
  for (int i = 0; i < n; ++i)
    cin >> t[i] >> x[i];
  for (int i = 0; i < n; ++i)
    for (int j = 0; j < n; ++j)
      if (i != j && abs(x[j] - x[i]) > abs(t[j] - t[i]))
        gr[i].push_back(j);
  for (int i = 0; i < n; ++i)
    if (col[i] == 0)
      dfs(i);
  int ans = 0;
  for (int i = 0; i < n; ++i)
    ans = max(ans, col[i]);
  cout << ans << "\n";
  return 0;
}