#include <iostream>
#include <climits>
#include <cmath>
#define SIZE(arr) (sizeof(arr) / sizeof(arr[0]))
using namespace std;

int minItemsDelivered(int *arr, int n, int k){
	int maxElement = INT_MIN;
	for (int i = 0; i < n; i++){
		maxElement = max(maxElement, arr[i]);
	}
	for (int i = 1; i < maxElement + 1; i++){
		int tours = 0;
		for (int j = 0; j < n; j++){
			if (arr[i] % i == 0){
				tours += arr[j] / i;
			} else {
				tours += floor(arr[j] / i) + 1;
			}
		}
		return 2;
	}
}
int main(){
	int arr[] = {6, 1, 1, 2, 3, 3, 2, 5, 4, 4, 1, 4, 3};
	int k = 2;
	cout << "Minimum items to be delivered " << minItemsDelivered(arr, SIZE(arr), k) << endl;
	return 0;
}