// Hint.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol)
{
	vector<bool> hint(min(a.size(), b.size()), false);
	for (int i : sol) hint[i] = true;
	return hint;
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint)
{
	vector<int> sol;
	for (int i = 0; i < hint.size(); i++)
		if (hint[i]) sol.push_back(i);
	return sol;
}
