// Hint.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol)
{
    int j = 0;
    //if (a.size() < b.size()) swap(a, b);
    if (b.size() < a.size())
    {
        vector<bool> hint(b.size(), false);
        for (int i : sol)
        {
            while (b[j] != i) j++;
            hint[j] = true;
            j++;
        }
        return hint;
    }
    else
    {
        vector<bool> hint(a.size(), false);
        for (int i : sol)
        {
            while (a[j] != i) j++;
            hint[j] = true;
            j++;
        }
        return hint;
    }

}


vector<int> lis(vector<int>& nums)
{
    vector<vector<int>> seq;
    for (int i : nums)
    {
        if (seq.empty())
        {
            seq.push_back(vector<int>(1));
            seq[0][0] = i;
            continue;
        }
        if (seq.back().back() < i)
        {
            seq.push_back(seq.back());
            seq.back().push_back(i);
        }
        int l = 0, r = seq.size(), m, a;
        while (l <= r)
        {
            m = (l + r) / 2;
            if (seq[m].back() >= i)
            {
                a = m; r = m - 1;
            }
            else l = m + 1;
        }
        if (a == 0) seq[0][0] = i;
        else
        {
            for (int j = 0; j < seq[a - 1].size(); j++) seq[a][j] = seq[a - 1][j];
            seq[a].pop_back(); seq[a].push_back(i);
        }
    }
    return seq.back();
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint)
{
    vector<int> sol;
    vector<int> c;
    for (int i : a)
    {
        for (int j = b.size() - 1; j >= 0; j--) 
            if (b[j] == i) c.push_back(j);
    }
    return lis(c);
}