#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <stack>

using namespace std;

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol)
{
    vector<bool> hint;
    return hint;
}


void lis(vector<int>& nums, vector<int>& sol)
{
    vector<pair<int, int>> seq;
    vector<int> last(nums.size(), -1);
    for (int i = 0; i < nums.size(); i++)
    {
        if (seq.empty())
        {
            seq.push_back({ nums[i], i });
            continue;
        }
        if (seq.back().first < nums[i])
        {
            last[i] = seq.back().second;
            seq.push_back({ nums[i], i });
        }
        int l = 0, r = seq.size(), m, a;
        while (l <= r)
        {
            m = (l + r) / 2;
            if (seq[m].first >= nums[i])
            {
                a = m; r = m - 1;
            }
            else l = m + 1;
        }
        if (a == 0) seq[0] = { nums[i], i };
        else
        {
            last[i] = seq[a - 1].second;
            seq[a] = { nums[i], i };
        }
    }
    stack<int> s;
    int curr = seq.back().second;
    while (curr != -1)
    {
        s.push(nums[curr]);
        curr = last[curr];
    }
    while (!s.empty())
    {
        sol.push_back(s.top()); s.pop();
    }
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint)
{
    vector<int> sol;
    vector<int> c;
    for (int i : a)
    {
        for (int j = b.size() - 1; j >= 0; j--)
            if (b[j] == i) c.push_back(j);
    }
    lis(c, sol);
    return sol;
}