#include "bits/stdc++.h"
#include "hint.h"


using namespace std;

#define len(v) (int)(v).size()

using ll = int_fast64_t;

vector<bool> genHint(const vector<int> &a, const vector<int> &b, const vector<int> &sol){
    vector<bool> hint;
    if(len(a) <= len(b)){
        hint.push_back(false);
        int p = 0;
        for (int i : sol) {
            while(a[p] != i)
                ++p, hint.push_back(false);
            hint.push_back(true);
            ++p;
        }
    }else{
        hint.push_back(true);
        int p = 0;
        for (int i : sol) {
            while(b[p] != i)
                ++p, hint.push_back(false);
            hint.push_back(true);
            ++p;
        }
    }
    return hint;
}

vector<int> solve(const vector<int> &a, const vector<int> &b, const vector<bool> &hint){
    vector<int> ans;
    if(!hint[0]){
        for (int i = 1; i < len(hint); ++i) {
            if(hint[i])
                ans.push_back(a[i-1]);
        }
    }else{
        for (int i = 1; i < len(hint); ++i) {
            if(hint[i])
                ans.push_back(b[i-1]);
        }
    }
    return ans;
}