//#include "hint.h"
#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define pb push_back
#define all(a) a.begin(),a.end()
#define sz(a) (int)a.size()
std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol){
    int n = a.size(), m = b.size(), k = sol.size();
    if(n * m <= (int)1e8 || sol.size() <= 1)return {};
    int j = 0;
    vector<bool> h;
    if(n <= m){
        for(int i = 0;i < n; ++i){
            if(j < k && a[i] == sol[j]){
                h.pb(1);
                ++j;
            }else h.pb(0);
        }
    }else{
        for(int i = 0;i < m; ++i){
            if(j < k && b[i] == sol[j]){
                h.pb(1);
                ++j;
            }else h.pb(0);
        }
    }
    return h;
}
std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint){
    int n = a.size(), m = b.size(), k = hint.size();
    if(n * m <= (int)1e8){
        vector<vector<int>> dp(n + 1, vector<int>(m + 1, 0));
        for(int i = 1;i <= n; ++i){
            for(int j = 1;j <= m; ++j){
                dp[i][j] = max(dp[i - 1][j], dp[i][j - 1]);
                if(a[i - 1] == b[j - 1])dp[i][j] = max(dp[i][j], dp[i - 1][j - 1] + 1);
            }
        }
        int A = n, B = m;
        vector<int> answer;
        while(A >= 1 && B >= 1){
            if(a[A - 1] == b[B - 1]){
                answer.pb(a[A - 1]);
                --A,--B;
            }else if(dp[A - 1][B] >= dp[A][B - 1]){
                --A;
            }else --B;
        }
        if(answer.size())reverse(all(answer));
        return answer;
    }else if(!sz(hint)){
            vector<int> cnt((int)2e5 + 10, 0);
            for(int i = 0;i < n; ++i)cnt[a[i]]++;
            for(int i = 0;i < m; ++i){
                if(cnt[b[i]]){
                    return {b[i]};
                }
            }
            return {};
        }
    vector<int> ans;
    if(n == k){
        for(int i = 0;i < n; ++i){
            if(hint[i] == 1)ans.pb(a[i]);
        }
    }else{
        for(int i = 0;i < m; ++i){
            if(hint[i] == 1)ans.pb(b[i]);
        }
    }
    return ans;
}
/*
int main()
{
    int n, m, k;
    std::cin >> n >> m;
    vector<int>a, b, sol, maybeSol;
    vector<bool> hint;
    a.resize(n);
    b.resize(m);
    for (int& num : a)
    {
        std::cin >> num;
    }
    for (int& num : b)
    {
        std::cin >> num;
    }
    std::cin >> k;
    sol.resize(k);
    for (int& num : sol)
    {
        std::cin >> num;
    }
    hint = genHint(a, b, sol);
    maybeSol = solve(a, b, hint);
    std::cout << hint.size() << std::endl;
    std::cout << maybeSol.size() << std::endl;
    for (int i = 0; i < (int) maybeSol.size(); ++i)
    {
        if (i > 0) std::cout << " ";
        std::cout << maybeSol[i];
    }
    std::cout << std::endl;
    return 0;
}
*/
