#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define fi first
#define se second
#define all(x) (x).begin(),(x).end()
using namespace std;

const int N = 1e4 + 5;

vector <int> gr[N];
int mt[N], used[N];

inline bool kuhn(int v) {
    if (used[v]) return 0;
    used[v] = 1;

    for (auto to : gr[v]) {
        if (mt[to] == -1) {
            mt[to] = v;
            return 1;
        }
    }
    for (auto to : gr[v]) {
        if (mt[to] != -1 && kuhn(mt[to])) {
            mt[to] = v;
            return 1;
        }
    }
    return 0;
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    int n;
    cin >> n;
    vector <pair<int, int>> a(n);
    for (auto &[t, x] : a) cin >> t >> x;

    sort(all(a));
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (abs(a[j].se - a[i].se) <= a[j].fi - a[i].fi) {
                gr[i].push_back(j);
            }
        }
    }

//    for (auto [t, x] : a) cout << t << " " << x << '\n';
//    for (int i = 1; i <= n; ++i) {
//        cout << i << ": ";
//        for (auto u : gr[i - 1]) cout << u + 1 << " ";
//        cout << '\n';
//    }
//    cout << '\n';

    for (int i = 0; i < n; ++i) mt[i] = -1;

    int ans = 0;
    for (int i = 0; i < n; ++i) kuhn(i);
    for (int i = 0; i < n; ++i) ans += (mt[i] == -1);

//    for (int i = 0; i < n; ++i) {
//        cout << i + 1 << " : " << mt[i] + 1 << '\n';
//    }

    cout << ans;
}
