#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define fi first
#define se second
#define all(x) (x).begin(),(x).end()
using namespace std;
const int N = 1e4 + 5;
vector <int> gr[N], g[N];
int mt[N], used[N], in[N], out[N];

inline void dfs(int v, int &a, int &b) {
    used[v] = 1;
    a += !in[v], b += !out[v];

    for (auto to : g[v]) {
        if (used[to]) continue;
        dfs(to, a, b);
    }
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int n;
    cin >> n;
    vector <pair<int, int>> a(n);
    for (auto &[t, x] : a) cin >> t >> x;

    sort(all(a));
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (abs(a[j].se - a[i].se) <= a[j].fi - a[i].fi) {
                gr[i].push_back(j);
                ++in[i], ++out[j];

                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        if (used[i]) continue;
        int a = 0, b = 0;
        dfs(i, a, b);

        ans += max(a, b);
    }
    cout << ans;
}
