#include <bits/stdc++.h>
#include "hint.h"

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double
#define ll long long
#define ckmin(x, y) x = min(x, y)
#define ckmax(x, y) x = max(x, y)

using namespace std;

vector<bool> genHint(const vector<int> &a, const vector<int> &b, const vector<int> &sol) {
    vector<bool> hint;
    if (a.size() < b.size()) {
        hint.resize((int) a.size());
        int p = 0;
        for (int i = 0; i < (int) a.size(); ++i) {
            if (p < (int) sol.size() && a[i] == sol[p]) {
                hint[i] = true;
                p++;
            }
        }
    } else {
        hint.resize((int) b.size());
        int p = 0;
        for (int i = 0; i < (int) b.size(); ++i) {
            if (p < (int) sol.size() && b[i] == sol[p]) {
                hint[i] = true;
                p++;
            }
        }
    }
    return hint;
}

vector<int> solve(const vector<int> &a, const vector<int> &b, const vector<bool> &hint) {
    if (a.size() < b.size()) {
       vector<int> res;
       for(int i = 0 ;i < (int)a.size(); ++i){
           if(hint[i])res.push_back(a[i]);
       }
       return res;
    }else{
        vector<int> res;
        for(int i = 0; i < (int)b.size(); ++i){
            if(hint[i])res.push_back(b[i]);
        }
        return res;
    }
}