#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double
#define ll long long
#define ckmin(x, y) x = min(x, y)
#define ckmax(x, y) x = max(x, y)

using namespace std;

int n;
vector<pair<int, int>> t;
vector<vector<int>> g;
vector<int> p;
vector<vector<int>> G;
vector<int> used;
int timer = 0;

bool kuhn(int v) {
    if (used[v] == timer)return false;
    used[v] = timer;
    for(int u : g[v]){
        if(p[u] == -1){
            p[u] = v;
            return true;
        }
    }
    for(int u : g[v]){
        if(kuhn(p[u])){
            p[u] = v;
            return true;
        }
    } 
    return false;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    t.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> t[i].first >> t[i].second;
    }
    g.resize(n);
    sort(all(t));
    int e = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (t[j].first - t[i].first >= abs(t[j].second - t[i].second)) {
                g[i].push_back(j);
                e++;
            }
        }
    }
    p.resize(n, -1);
    used.assign(n, -1);

    for (int i = 0; i < n; ++i) {
        kuhn(i);
        timer++;
    }
    int pairing = 0;
    for (int i = 0; i < n; ++i) {
        if (p[i] != -1)pairing++;
    }
    cout << n - pairing;
}