#include <bits/stdc++.h>
using namespace std;
const int maxn = 10001;
vector <int> ad [maxn];
vector <int> dad [maxn];
bitset <maxn> del;
int nodes;

void dfs (int u) {
    //cout << u << " ";
    for (auto j: ad[u]) {
        if (!del[j]) {
            dfs(j);
            break;
        }
    }
    del[u] = 1;
    nodes--;
}

int main() {
    int n;
    cin >> n;
    nodes = n;
    vector <pair <int, int> > a (n);
    vector <int> in (n);
    vector <int> out (n);
    for (int i = 0; i < n; i++){
        cin >> a[i].first >> a[i].second;
    }
    sort(a.begin(), a.end());
    for (int i = 0; i < n; i++){
        for (int j = i + 1; j < n; j++) {
            if (abs(a[i].second - a[j].second) <= abs(a[i].first - a[j].first)) {
                ad[i].push_back(j);
                dad[j].push_back(i);
            }
        }
    }
    queue <int> q;
    for (int i = 0; i < n; i++){
        if (!in[i]) q.push(i);
    }
    int rs = 0;
    while (nodes) {
        rs++;
        int start = -1;
        for (int i = 0; i < n; i++){
            bool f = 0;
            bool ch = 0;
            for (auto j: dad[i]) {
                if (!del[i]) {
                    f = 1;
                }
            }
            for (auto j: ad[i]) {
                if (!del[j]) ch = 1;
            }
            if (!f && ch) {
                start = i;
                break;
            }
        }
        dfs(start);
        //cout << "\n";

    }
    cout << rs;
    /*for (int i = 0; i < n; i++) {
        cout << a[i].first << "," << a[i].second << ": ";
        for (auto j: ad[i]) {
            cout << a[j].first << "," << a[j].second << " ";
        }
        cout << "\n";
    }*/
}
