#include <bits/stdc++.h>

using namespace std;

const int NMAX = 1e6;

struct ura {int t, h;};

ura v[NMAX];
int viz[NMAX];

bool cmp (ura a, ura b) {
    return a.t < b.t;
}

int modul (int a, int b) {
    if (a > b)
        return a - b;
    return b - a;
}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int n;

    cin >> n;
    for (int i = 1; i <= n; i++) {
        cin >> v[i].t >> v[i].h;
    }

    sort(v + 1, v + n + 1, cmp);

    int truck = 0;
    int nrviz = 0;
    while (nrviz < n) {
        truck++;
        int i = 1;
        while (viz[i])
            i++;
        viz[i] = truck;
        nrviz++;
        int t1 = v[i].t;
        int poz1 = v[i].h;
        for (i++; i <= n; i++) {
            while (i <= n && viz[i])
                i++;

            if (i <= n && v[i].t - t1 >= modul(poz1, v[i].h)) {
                viz[i] = truck;
                nrviz++;
                t1 = v[i].t;
                poz1 = v[i].h;
            }
        }
    }

    cout << truck;

/*
    cout << "\n";
    for (int i = 1; i <= n; i++)
        cout << viz[i] << " ";
*/
    return 0;
}
