#include "hint.h"

#include <bits/stdc++.h>

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol) {
    if(a.size() < 100000) {
        std::vector<bool> res;
        int i = 0;

        for(auto c : sol) {
            while(a[i] != c) {
                res.push_back(0);
                i++;
            }
            res.push_back(1);
            i++;
        }

        return res;
    } else {
        std::vector<bool> res;
        for(auto x : sol) {
            for(int i = 0; i < 18; i++)
                res.push_back(x & (1 << i));
        }
        return res;
    }

}
std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint) {
    if(a.size() < 100000) {
        std::vector<int> res;
        for(int i = 0; i < hint.size(); i++) {
            if(hint[i]) res.push_back(a[i]);
        }
        return res;
    } else {
        std::vector<int> res;
        for(int i = 0; i < hint.size(); i += 18) {
            int r = 0;
            for(int j = i; j < i + 18; j++)
                r |= hint[j] << (j - i);
            res.push_back(r);
        }
        return res;
    }
}
