#include <bits/stdc++.h>
#include "hint.h"

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

using namespace std;

typedef long long ll;

using vi = vector<int>;
const int LG = 20;
const int K = 1000;

vector<bool> genHint(const vi& a, const vi& b, const vi& sol) {
    vi A, B;
    {
        int i = 0;
        for(auto &x : sol) {
            while(a[i] != x) i++;
            A.push_back(i++);
        }
    }
    {
        int i = 0;
        for(auto &x : sol) {
            while(b[i] != x) i++;
            B.push_back(i++);
        }
    }
    A.push_back((int)a.size());
    B.push_back((int)b.size());
    vector<int> res;
    int u = 0;
    int D = ((int)a.size() + K - 1) / K;
    for(int c = 0; c * D < (int)a.size(); ++c) {
        int l = c * D;
        int r = min(l + D - 1, (int)a.size() - 1);
        while(A[u] <= r) u++;
        res.push_back(B[u]);
        //cout << u << '\n';
    }
    //cout << "\n";
    vector<bool> ans;
    auto add = [&] (int x) {
        rep(i, LG) {
            if ((1 << i) & x) {
                ans.push_back(true);
            } else {
                ans.push_back(false);
            }
        }
    };
    for(auto &e : res) {
        add(e);
    }
    return ans;
}

vi solve(const vi& a, const vi& b, const vector<bool>& hint) {
    vi res;
    int cur = 0;
    auto read = [&] () {
        int x = 0;
        rep(i, LG) {
            if (hint[cur]) {
                x |= (1 << i);
            }
            cur++;
        }
        return x;
    };
    while(cur < (int)hint.size()) {
        res.push_back(read());
    }
    assert(cur == (int)hint.size());
    int D = ((int)a.size() + K - 1) / K;
    vector<int> ans;
    auto solve = [&] (int l1, int r1, int l2, int r2) {
        if (l1 > r1 || l2 > r2) return;
        int n = r1 - l1 + 1;
        int m = r2 - l2 + 1;
        vector<vector<int>> dp(n + 1, vector<int> (m + 1, 0));
        vector<vector<int>> pred(n + 1, vector<int> (m + 1, -1));
        rep(i, n + 1) {
            rep(j, m + 1) {
                if (i < n && j < m && a[l1 + i] == b[l2 + j] && dp[i + 1][j + 1] < dp[i][j] + 1) {
                    dp[i + 1][j + 1] = dp[i][j] + 1;
                    pred[i + 1][j + 1] = 0;
                }
                if (i < n && dp[i + 1][j] < dp[i][j]) {
                    dp[i + 1][j] = dp[i][j];
                    pred[i + 1][j] = 1;
                }
                if (j < m && dp[i][j + 1] < dp[i][j]) {
                    dp[i][j + 1] = dp[i][j];
                    pred[i][j + 1] = 2;
                }
            }
        }
        vi cur;
        while(pred[n][m] != -1) {
            if (pred[n][m] == 0) {
                cur.push_back(a[l1 + n - 1]);
                n--;
                m--;
            } else if (pred[n][m] == 1) {
                n--;
            } else {
                m--;
            }
        }
        reverse(all(cur));
        for(auto &x : cur) ans.push_back(x);
    };

    vector<int> have;
    rep(i, (int)res.size()) {
        int l1 = i * D;
        int r1 = min(l1 + D - 1, (int)a.size() - 1);
        int l2 = 0;
        if (i != 0) l2 = res[i - 1];
        int r2 = res[i] - 1;
        solve(l1, r1, l2, r2);
        //cout << res[i] << ' ' << ans.size() << '\n';
    }
    //cout << '\n';
    return ans;
}
