#include <bits/stdc++.h>
#include "hint.h"
#define pb push_back
using namespace std;

vector<bool> binary(int x, int b) {
	vector<bool> ans;
	while (x) {
		ans.pb(x % 2);
		x /= 2;
	}
	
	while(ans.size() != b) {
		ans.pb(0);
	}
	
	return ans;
}

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b,
 const std::vector<int>& sol) {
    int a_sz = a.size(), b_sz = b.size(), i = 0;
    vector<bool> hint;
    int bits = (max(a.size(), b.size()) <= 10000) ? 14 : 17;
    int bits_sz = bits * (int)sol.size();
   	while (bits_sz == a_sz || bits_sz == b_sz) ++bits_sz;
    if (bits_sz < min(a_sz, b_sz)) {
		for (auto x : sol) {
			vector<bool> f = binary(x, bits);
			for (auto x : f) {
				hint.pb(x);
			}
		}
		
		return hint;    
    }
    
   	hint.resize(min(a_sz, b_sz));
    if (a_sz <= b_sz) {
    	for (auto x : sol) {
    		while (a[i] != x) ++i;
    		hint[i++] = true;
    	}
    } else {
    	for (auto x : sol) {
    		while (b[i] != x) ++i;
    		hint[i++] = true;
    	}
    }
    
    return hint;
}
std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b,
 const std::vector<bool>& hint) {
    int a_sz = a.size();
    int b_sz = b.size();
    int h_sz = hint.size();
    int bits = (max(a.size(), b.size()) <= 10000) ? 14 : 17;
    
    vector<int> ans;
    if (h_sz == a_sz) {
	    for (int i = 0; i < a_sz; ++i) {
	        if (hint[i]) {
	            ans.pb(a[i]);
	        }
	    }    	
    } else if (h_sz == b_sz) {
	    for (int i = 0; i < b_sz; ++i) {
	        if (hint[i]) {
	            ans.pb(b[i]);
	        }
	    }     	
    } else {
    	for (int i = 0; i + bits - 1 < hint.size(); i += bits) {
    		int v = 0, pw = 1;
    		for (int j = 0; j < bits; ++j) {
    			v += pw * hint[i + j];
				pw *= 2;
    		}
    		
    		ans.pb(v);
    	}
    }
    
    return ans;
}