#include <bits/stdc++.h>
#include "hint.h"
#define pb push_back
using namespace std;
std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b,
 const std::vector<int>& sol) {
     if (max(a.size(), b.size()) <= 10000) {
         return {};
     }
     
    int a_sz = a.size();
    vector<bool> hint(a_sz);
    int i = 0;
    for (auto x : sol) {
        while (a[i] != x) ++i;
        hint[i] = true;
        ++i;
    }
while(!hint.empty() && hint.back() == false) hint.pop_back();
    
    return hint;
}
const int N = 10001;
int dp[N][N], par[N][N];
std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b,
 const std::vector<bool>& hint) {
    int a_sz = a.size();
    int b_sz = b.size();
    
    vector<int> ans;
    if (max(a_sz, b_sz) <= 10000) {
        for (int i = 0; i <= a_sz; ++i) {
            for (int j = 0; j <= b_sz; ++j) {
                if (i != a_sz && dp[i + 1][j] < dp[i][j]) {
                    dp[i + 1][j] = dp[i][j];
                    par[i + 1][j] = (i << 14) ^ j;
                }
                
                if (j != b_sz && dp[i][j + 1] < dp[i][j]) {
                    dp[i][j + 1] = dp[i][j];
                    par[i][j + 1] = (i << 14) ^ j;
                }
                
                if (i != a_sz && j != b_sz && a[i] == b[j] && dp[i + 1][j + 1] < dp[i][j] + 1) {
                    dp[i + 1][j + 1] = dp[i][j] + 1;
                    par[i + 1][j + 1] = (i << 14) ^ j;
                }
            }
        }
        
        int i = a_sz, j = b_sz;
        while (i != 0 && j != 0) {
            int x = par[i][j];
            int pi = (x >> 14), pj = (x & ((1 << 14) - 1));
            if (i == pi + 1 && j == pj + 1) {
                ans.pb(a[pi]);
            }
            
            i = pi, j = pj;
        }
        
        reverse(ans.begin(), ans.end());
    } else {    
        for (int i = 0; i < a_sz; ++i) {
            if (i < hint.size() && hint[i]) {
                ans.pb(a[i]);
            }
        }
    }
    
    return ans;
}