#include<bits/stdc++.h>
#include "hint.h"
#define p pair<int, int>
#define endl '\n'
const long long INF = 100000000001;

using namespace std;

vector<int> get(const vector<int>& a, const vector<int>& s, const vector<int>& sol) {
    int n = a.size(), m = s.size();
    int d[m+1], d1[m+1];
    bool parent[n+1][m+1];
    fill(d, d+m+1, 0), fill(d1, d1+m+1, 0);
    for (int q = 1; q <= n; q++) {
        for (int q1 = 1; q1 <= m; q1++) {
            if (a[q-1] == s[q1-1]) {
                d1[q1] = d[q1-1]+1;
            } else {
                d1[q1] = max(d[q1], d1[q1-1]), parent[q][q1] = (d[q1] < d1[q1-1]);
            }
        }
        for (int q1 = 0; q1 <= m; q1++) {
            d[q1] = d1[q1], d1[q1] = 0;
        }
    }
    vector<int> ans;
    int x = n, y = m;
    while (x > 0 && y > 0) {
        if (a[x-1] == s[y-1]) {
            ans.push_back(a[x-1]);
            x--, y--;
        } else if (!parent[x][y]) {
            x--;
        } else {
            y--;
        }
    }
    reverse(ans.begin(), ans.end());
    return ans;
}

vector<bool> genHint(const vector<int>& a, const vector<int>& s, const vector<int>& sol) {
    int n = a.size(), m = s.size();
    vector<bool> hint(n, false);
    int q1 = 0;
    for (int q = 0; q < n; q++) {
        if (q1 < sol.size() && sol[q1] == a[q]) {
            hint[q] = true, q1++;
        }
    }
    return hint;
}

vector<int> solve(const vector<int>& a, const vector<int>& s, const vector<bool>& hint) {
    int n = a.size();
    vector<int> ans;
    for (int q = 0; q < n; q++) {
        if (hint[q]) {
            ans.push_back(a[q]);
        }
    }
    return ans;
}
