#include<bits/stdc++.h>
#include "hint.h"
#define p pair<int, int>
#define endl '\n'
const long long INF = 100000000001;

using namespace std;

vector<bool> hint;
int len = 18;

vector<bool> code(int x) {
    vector<bool> who;
    for (int q1 = 0; q1 < len; q1++) {
        who.push_back(x & 1);
        x >>= 1;
    }
    reverse(who.begin(), who.end());
    for (bool q : who) {
        hint.push_back(q);
    }
    return who;
}

int decode(int start) {
    int x = 0;
    for (int q1 = 0; q1 < len; q1++) {
        x <<= 1;
        x |= hint[start+q1];
    }
    return x;
}

vector<bool> genHint(const vector<int>& a, const vector<int>& s, const vector<int>& ans) {
    int k = ans.size(), C = 0;
    vector<p> pos;
    int q1 = 0, q2 = 0;
    for (int q = 0; q < k; q++) {
        while (a[q1] != ans[q]) {
            q1++;
        }
        while (s[q2] != ans[q]) {
            q2++;
        }
        pos.push_back({q1++, q2++});
    }
    q1 = 0;
    for (int q = 0; q <= k; q++) {
        if (q == k || pos[q].first+pos[q].second > pos[q1].first+pos[q1].second+C) {
            code(pos[q1].first), code(pos[q1].second);
            code(pos[q-1].first), code(pos[q-1].second);
            q1 = q;
        }
    }
    return hint;
}

vector<int> get_ans(const vector<int>& a, const vector<int>& s) {
    int n = a.size(), m = s.size();
    int d[m+1], d1[m+1];
    bool parent[n+1][m+1];
    fill(d, d+m+1, 0), fill(d1, d1+m+1, 0);
    for (int q = 1; q <= n; q++) {
        for (int q1 = 1; q1 <= m; q1++) {
            if (a[q-1] == s[q1-1]) {
                d1[q1] = d[q1-1]+1;
            } else {
                d1[q1] = max(d[q1], d1[q1-1]), parent[q][q1] = (d[q1] < d1[q1-1]);
            }
        }
        for (int q1 = 0; q1 <= m; q1++) {
            d[q1] = d1[q1], d1[q1] = 0;
        }
    }
    vector<int> ans;
    int x = n, y = m;
    while (x > 0 && y > 0) {
        if (a[x-1] == s[y-1]) {
            ans.push_back(a[x-1]);
            x--, y--;
        } else if (!parent[x][y]) {
            x--;
        } else {
            y--;
        }
    }
    reverse(ans.begin(), ans.end());
    return ans;
}


vector<int> solve(const vector<int>& a, const vector<int>& s, const vector<bool>& hint1) {
    hint = hint1;
    vector<pair<p, p>> blocks;
    for (int q = 0; q < hint.size(); q += len*4) {
        blocks.push_back({{decode(q), decode(q+len)}, {decode(q+2*len), decode(q+3*len)}});
    }
    vector<int> ans;
    for (pair<p, p> q : blocks) {
        vector<int> a1, s1;
        /*for (int q1 = q.first.first; q1 <= q.second.first; q1++) {
            a1.push_back(a[q1]);
        }
        for (int q1 = q.first.second; q1 <= q.second.second; q1++) {
            s1.push_back(s[q1]);
        }*/
        ans.push_back(a[q.first.first]);
        /*for (int q1 : get_ans(a1, s1)) {
            ans.push_back(q1);
        }*/
    }
    return ans;
}
