#include<bits/stdc++.h>
#include "hint.h"
#define p pair<int, int>
#define endl '\n'
const long long INF = 100000000001;

using namespace std;

vector<bool> hint;
int len = 18, C = 5503;

vector<bool> code(long long x, int len_now) {
    vector<bool> who;
    for (int q1 = 0; q1 < len_now; q1++) {
        who.push_back(x & 1);
        x >>= 1;
    }
    reverse(who.begin(), who.end());
    for (bool q : who) {
        hint.push_back(q);
    }
    return who;
}

long long decode(int start, int len_now) {
    long long x = 0;
    for (int q1 = 0; q1 < len_now; q1++) {
        x <<= 1;
        x |= hint[start+q1];
    }
    return x;
}

vector<bool> genHint(const vector<int>& a, const vector<int>& s, const vector<int>& ans) {
    int n = a.size(), m = s.size(), k = ans.size();
    vector<p> pos;
    int q1 = 0, q2 = 0;
    for (int q = 0; q < k; q++) {
        while (a[q1] != ans[q]) {
            q1++;
        }
        while (s[q2] != ans[q]) {
            q2++;
        }
        pos.push_back({q1++, q2++});
    }
    q1 = 0;
    int wasx = 0, wasy = 0;
    for (int q = 0; q <= k; q++) {
        if (q == k || pos[q].first+pos[q].second > pos[q1].first+pos[q1].second+C) {
            int logx = ceil(log2(n-wasx)), logy = ceil(log2(m-wasy));
            code(pos[q1].first-wasx, logx), code(pos[q1].second-wasy, logy);
            wasx = pos[q1].first, wasy = pos[q1].second, q1 = q;
        }
    }
    return hint;
}

vector<int> get_ans(const vector<int>& a, const vector<int>& s) {
    int n = a.size(), m = s.size();
    int d[m+1], d1[m+1];
    bool parent[n+1][m+1];
    fill(d, d+m+1, 0), fill(d1, d1+m+1, 0);
    for (int q = 1; q <= n; q++) {
        for (int q1 = 1; q1 <= m; q1++) {
            if (a[q-1] == s[q1-1]) {
                d1[q1] = d[q1-1]+1;
            } else {
                d1[q1] = max(d[q1], d1[q1-1]), parent[q][q1] = (d[q1] < d1[q1-1]);
            }
        }
        for (int q1 = 0; q1 <= m; q1++) {
            d[q1] = d1[q1], d1[q1] = 0;
        }
    }
    vector<int> ans;
    int x = n, y = m;
    while (x > 0 && y > 0) {
        if (a[x-1] == s[y-1]) {
            ans.push_back(a[x-1]);
            x--, y--;
        } else if (!parent[x][y]) {
            x--;
        } else {
            y--;
        }
    }
    reverse(ans.begin(), ans.end());
    return ans;
}

vector<int> solve(const vector<int>& a, const vector<int>& s, const vector<bool>& hint1) {
    int n = a.size(), m = s.size();
    hint = hint1;
    vector<p> blocks;
    int wasx = 0, wasy = 0, q4 = 0;
    while (q4 < hint.size()) {
        int logx = ceil(log2(n-wasx)), logy = ceil(log2(m-wasy));
        blocks.push_back({decode(q4, logx), decode(q4+logx, logy)});
        wasx += blocks.back().first, wasy += blocks.back().second, q4 += logx+logy;
        blocks.back() = {wasx, wasy};
    }
    vector<int> ans;
    for (int q3 = 0; q3 < blocks.size(); q3++) {
        p q = blocks[q3], q2 = (q3+1 == blocks.size() ? p(n, m) : blocks[q3+1]);
        vector<int> a1, s1;
        int w = min(q.first+C, q2.first-1);
        for (int q1 = q.first; q1 <= w; q1++) {
            a1.push_back(a[q1]);
        }
        w = min(q.second+C, q2.second-1);
        for (int q1 = q.second; q1 <= w; q1++) {
            s1.push_back(s[q1]);
        }
        for (int q1 : get_ans(a1, s1)) {
            ans.push_back(q1);
        }
    }
    return ans;
}
