#include "hint.h"

#include <bits/stdc++.h>

using namespace std;


vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& sol) {
	vector<bool> hint;
	for(int x: sol) {
		for(int j = 0; j < 18; j++) {
			hint.push_back((x >> j) & 1);
		}
	}
	return hint;
}


vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint) {
	vector<int> sol;
	for(int i = 0; i < hint.size(); i += 18) {
		int x = 0;
		for(int j = 0; j < 18; j++) {
			x |= ((int)hint[i + j]) << j;
		}
		sol.push_back(x);
	}
	return sol;
}
