#include "hint.h"
#include <bits/stdc++.h>
typedef long long ll;
using namespace std;
const int K=1;
vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol){
    if (sol.empty()) return {};
    vector<int>indA,indB;
    int j=0;
    for (int x:sol){
        while (a[j]!=x) j++;
        indA.push_back(j++);
    }
    j=0;
    for (int x:sol){
        while (b[j]!=x) j++;
        indB.push_back(j++);
    }
    vector<pair<int,int> >need;
    for (int i=0;i<sol.size();i+=K){
        need.push_back({indA[i],indB[i]});
    }
    if (((int)sol.size()-1)%K){
        need.push_back({indA[(int)sol.size()-1],indB[(int)sol.size()-1]});
    }
    vector<bool>ans;
    for (auto cur:need){
        for (int i=0;i<20;i++){
            if (cur.first&(1<<i)) ans.push_back(true);
            else ans.push_back(false);
        }
        for (int i=0;i<20;i++){
            if (cur.second&(1<<i)) ans.push_back(true);
            else ans.push_back(false);
        }
    }
    return ans;
}
const int N=200010;
int A[N],B[N];
vector<int>g[N];
int dp[K+2][N];
vector<int>get(int la,int ra,int lb,int rb){
    if (la>ra || lb>rb) return {};
//    return {};
    la++;
    ra++;
    lb++;
    rb++;
//    cout<<la<<" "<<lb<<" "<<ra<<" "<<rb<<endl;
    for (int i=la;i<=ra;i++){
        dp[1][i]=*lower_bound(g[A[i]].begin(),g[A[i]].end(),lb);
//        cout<<"OK "<<dp[1][i]<<endl;
        if (i>la) dp[1][i]=min(dp[1][i],dp[1][i-1]);
    }
    for (int i=2;i<=K;i++){
        for (int j=la;j<=ra;j++){
            dp[i][j]=rb+1;
            if (j>la) dp[i][j]=dp[i][j-1];
            if (j>la && dp[i-1][j-1]<rb){
                int nxt=*upper_bound(g[A[j]].begin(),g[A[j]].end(),dp[i-1][j-1]);
                if (nxt<dp[i][j]){
                    dp[i][j]=nxt;
                }
            }
//            if (dp[i][j]<=rb) cout<<i<<" "<<j<<" "<<dp[i][j]<<endl;
        }
    }
    for (int i=K;i>=1;i--){
        for (int j=la;j<=ra;j++){
            if (dp[i][j]<=rb){
//                cout<<"AAAAAAAAA "<<i<<endl;
                int x=i,y=j;
                vector<int>ans;
                while (x>0){
                    if (y>la && dp[x][y]==dp[x][y-1]) y--;
                    else ans.push_back(y--),x--;
                }
                reverse(ans.begin(),ans.end());
                return ans;
            }
        }
    }
    return {};

}
vector<int> solve(const std::vector<int>& aa, const std::vector<int>& bb, const std::vector<bool>& hint){
    if (hint.empty()) return {};
    vector<pair<int,int> >need;
    int ind=0;
    for (int it=0;it<(int)hint.size()/40;it++){
        int x=0,y=0;
        for (int i=0;i<20;i++){
            if (hint[ind++]) x^=(1<<i);
        }
        for (int i=0;i<20;i++){
            if (hint[ind++]) y^=(1<<i);
        }
        need.push_back({x,y});
    }
    int n=aa.size();
    int m=bb.size();
    for (int i=0;i<n;i++){
        A[i+1]=aa[i];
    }
    for (int i=0;i<m;i++){
        B[i+1]=bb[i];
    }
    for (int i=1;i<=m;i++) g[B[i]].push_back(i);
    for (int i=0;i<n;i++) g[i].push_back(m+1);
//    for (auto cur:need) cout<<cur.first<<" "<<cur.second<<endl;
    vector<int>ans;
    ans.push_back(aa[need[0].first]);
    for (int i=1;i<need.size();i++){
        auto cur=get(need[i-1].first+1,need[i].first-1,need[i-1].second+1,need[i].second-1);
        cur.push_back(need[i].first+1);
        for (int x:cur) ans.push_back(aa[x-1]);
    }
    return ans;
}
