#include "hint.h"
#include <bits/stdc++.h>

using namespace std;
#define forn(j, i, n) for(int i = j; i <= n; ++i)
#define FOR(j, i, n) for(int i = j; i < n; ++i)
#define pb push_back
#define f first
#define s second

const int maxn = 2e5+100;

#define pii pair <int, int>

int block = 640;
int L[maxn], R[maxn], blboun[maxn];
int dp[650][maxn];
pii pred[650][maxn];

std::vector <bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol)
{
	int uk = 0;
	int ukb = 0;
	int ukbl = 0;
	vector <bool> ret;
	FOR(0, i, a.size())
	{
		if(sol[uk] == a[i])
		{
			while(b[ukb] != sol[uk])
			{
				ukb++;
			}
			blboun[i / block] = ukb / block;
			ukb++;
			uk++;
		}
	}
	FOR(0, i, a.size())
	{
		if(i != 0 && i / block == (i - 1) / block) continue;
		ret.pb(0);
		forn((i > 0 ? blboun[(i - 1) / block] + 1 : 0), j, blboun[i / block])
		{
			ret.pb(1);
		}
	}
	return ret;
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint)
{
	int uk = 0;
	vector <int> ret;
	FOR(0, i, a.size())
	{
		if(i > 0 && i / block == (i - 1) / block) continue;
		int bn = i / block;
		if(bn > 0)
			L[bn] = R[bn - 1] + 1;
		else
			L[bn] = 0;
		uk++;
		R[bn] = L[bn] - 1;
		while(hint[uk] == 1)
		{
			R[bn] += block;
			uk++;
		}
		R[bn] = min(R[bn], (int)b.size() - 1);
		if(L[bn] > R[bn]) continue;
		forn(i, x, min(i + block - 1, (int)a.size()))
		{
			forn(L[bn], y, R[bn])
			{
				int px = x - i + 1;
				int py = y - L[bn] + 1;
				if(dp[px-1][py] > dp[px][py-1])
					pred[px][py] = {px-1, py};
				else
					pred[px][py] = {px, py-1};
				dp[px][py] = max(dp[px-1][py], dp[px][py-1]);
				if(a[x] == b[y])
				{
					if(dp[px][py] < dp[px-1][py-1])
					{
						pred[px][py] = {px-1,py-1};
						dp[px][py] = dp[px-1][py-1];
					}
				}
			}
		}
		pii pos = {min(i + block - 1, (int)a.size()) - i + 1, R[bn] - L[bn] + 1};
		while(pos.f > 0 && pos.s > 0)
		{
			if(pred[pos.f][pos.s].f == pos.f - 1 && 
			pred[pos.f][pos.s].s == pos.s - 1)
			{
				ret.pb(a[pos.f+i-1]);
			}
			pos = pred[pos.f][pos.s];
		}
	}
	return ret;
}