#include "hint.h"
#include <bits/stdc++.h>

using namespace std;
#define forn(j, i, n) for(int i = j; i <= n; ++i)
#define FOR(j, i, n) for(int i = j; i < n; ++i)
#define pb push_back
#define f first
#define s second
#define all(v) v.begin(), v.end()

const int maxn = 2e5+100;

#define pii pair <int, int>

int block = 640;
int l[maxn], r[maxn], blboun[maxn];

std::vector <bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol)
{
	int uk = 0;
	int ukb = 0;
	int ukbl = 0;
	vector <bool> ret;
	FOR(0, i, a.size()) blboun[i / block] = -1;
	FOR(0, i, a.size())
	{
		if(uk < sol.size() && sol[uk] == a[i])
		{
			while(b[ukb] != sol[uk])
			{
				ukb++;
			}
			blboun[i / block] = ukb / block;
			ukb++;
			uk++;
		}
	}
	FOR(0, i, b.size())
	{
		int bn = i / block;
		l[bn] = 1000000000;
		r[bn] = -1000000000;
	}
	FOR(0, i, a.size())
	{
		if(i != 0 && i / block == (i - 1) / block) continue;
		int bn = i / block;
		if(blboun[bn] != -1)
		{
			l[blboun[bn]] = min(l[blboun[bn]], bn);
			r[blboun[bn]] = max(r[blboun[bn]], bn);
		}
	}
	FOR(0, i, b.size())
	{
		if(i != 0 && i / block == (i - 1) / block) continue;
		int bn = i / block;
		if(l[bn] <= r[bn])
		{
			forn(l[bn], j, r[bn]) blboun[j] = bn;
		}
	}
	int last = -1;
/*	FOR(0, i, a.size())
	{
		if(i != 0 && i / block == (i - 1) / block) continue;
		cout << blboun[i / block] << " ";
	}
	cout << endl;
*/	FOR(0, i, a.size())
	{
		if(i != 0 && i / block == (i - 1) / block) continue;
		int bn = i / block;
		if(blboun[bn] == -1)
		{
			ret.pb(0);
			continue;
		}
		forn(bn, B, (a.size() - 1) / block)
		{
			if(blboun[B] != blboun[bn]) break;
//			cout << "push 0 " << bn << " " << blboun[bn] << endl;
			ret.pb(0);
			i = (B + 1) * block - 1;
		}
		forn(last + 1, j, blboun[bn])
		{
//			cout << "push 1 " << bn << " " << last << " " << blboun[bn] << endl;
			ret.pb(1);
		}
		last = blboun[bn];
	}
	while(last < (b.size() - 1) / block)
	{
		last++;
		ret.pb(1);
	}
	return ret;
}

vector <int> calcdp(const std::vector<int>& a, const std::vector<int>& b, int L, int R, int X, int Y)
{
	if(L > R || X > Y) return {};
	vector <vector <int> > dp;
	vector <vector <pii> > pred;
	dp.assign(R - L + 4, {});
	pred.assign(R - L + 4, {});
	forn(0, i, R - L + 2)
	{
		dp[i].assign(Y - X + 4, 0);
		pred[i].assign(Y - X + 4, {0, 0});
	}
	forn(L, i, R)
	{
		forn(X, j, Y)
		{
			int px = i - L + 1;
			int py = j - X + 1;
			if(dp[px][py-1] > dp[px-1][py])
				pred[px][py] = {px, py-1};
			else
				pred[px][py] = {px-1, py};
			dp[px][py] = max(dp[px][py-1], dp[px-1][py]);
			if(a[i] == b[j])
			{
				if(dp[px][px] < dp[px-1][py-1] + 1)
				{
					pred[px][py] = {px-1, py-1};
					dp[px][py] = dp[px-1][py-1] + 1;
				}
			}
		}
	}
	pii pos = {R-L+1, Y-X+1};
	vector <int> ret;
	while(pos.f > 0 && pos.s > 0)
	{
		if(pred[pos.f][pos.s].f == pos.f - 1 &&
		   pred[pos.f][pos.s].s == pos.s - 1)
		{
			ret.pb(a[pos.f+L-1]);
		}
		pos = pred[pos.f][pos.s];
	}
	reverse(all(ret));
	return ret;
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint)
{
	int uka = 0;
	int ukb = 0;
	vector <int> ret;
	FOR(0, i, hint.size())
	{
		int cnt0 = 1;
		int cnt1 = 1;
		while(i + 1 < hint.size() && hint[i + 1] == 0)
		{
			cnt0++;
			i++;
		}
		++i;
		while(i + 1 < hint.size() && hint[i + 1] == 1)
		{
			cnt1++;
			i++;
		}
		vector <int> temp1 = calcdp(a, b, uka, min((int)a.size()-1, uka+block*cnt0-1), min((int)b.size()-1, ukb+block*(cnt1-1)), min((int)b.size()-1, ukb+block*cnt1-1));
		vector <int> temp2 = calcdp(a, b, min((int)a.size()-1, uka+block*(cnt0-1)), min((int)a.size()-1, uka+block*cnt0-1), ukb, min((int)b.size()-1, ukb+block*cnt1-1));
/*		cout << "c " << cnt0 << " " << cnt1 << " " 
		<< uka << " " << min((int)a.size()-1, uka+block*cnt0-1) << " " << ukb << " " << min(ukb+block-1, (int)b.size()-1) << "\n" << 
		uka << " " << min((int)a.size()-1, uka+block-1) << " " << ukb << " " << min((int)b.size()-1, ukb+block*cnt1-1) << "\n";
		for(auto j : temp1) cout << j << " ";
		cout << endl;
		for(auto j : temp2) cout << j << " ";
		cout << endl;
*/		if(temp1.size() > temp2.size()) for(auto j : temp1) ret.pb(j);
		else for(auto j : temp2) ret.pb(j);
		uka += cnt0 * block;
		ukb += cnt1 * block;
	}
	return ret;
}
