#include <iostream>
#include "vector"
#include "algorithm"
#include "cmath"
#include "map"
#include "hint.h"
//#include "Lgrader.cpp"
using namespace std;
#define all(x) (x).begin(), (x).end()
int K = 17;
int readnum(vector<bool> &nums, int ind) {
    ind *= K;
    int res = 0;
    for (int i = 0; i < K; ++i) {
        res += nums[ind + i] * (1 << i);
    }
    return res;
}
void writenum(vector<bool> &nums, int res) {
    for (int i = 0; i < K; ++i) {
        nums.push_back(res % 2);
        res /= 2;
    }
}
vector<int> obsh(vector<int> a, vector<int> b) {
    int n = a.size(), m = b.size();
    vector<vector<int>> dp(n + 1, vector<int>(m + 1));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i] == b[j]) {
                dp[i + 1][j + 1] = max(dp[i][j] + 1, dp[i + 1][j + 1]);
            }
            dp[i + 1][j] = max(dp[i][j], dp[i + 1][j]);
            dp[i][j + 1] = max(dp[i][j], dp[i][j + 1]);
        }
    }
    vector<int> res;
    while (n != 0 and m != 0) {
        if (dp[n-1][m] == dp[n][m]) {
            n--;
        } else if (dp[n][m-1] == dp[n][m]) {
            m--;
        } else {
            res.push_back(a[n-1]);
            n--;m--;
        }
    }
    reverse(all(res));
    return res;
}
vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& sol) {
    return {};
}
vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint) {
    return obsh(a, b);
}
