#include <iostream>
#include "vector"
#include "algorithm"
#include "cmath"
#include "map"
#include "hint.h"
//#include "Lgrader.cpp"
using namespace std;
#define all(x) (x).begin(), (x).end()
int K = 18;
int HELP = 77;
int readnum(vector<bool> &nums, int ind) {
    ind *= K;
    int res = 0;
    for (int i = 0; i < K; ++i) {
        res += nums[ind + i] * (1 << i);
    }
    return res;
}
void writenum(vector<bool> &nums, int res) {
    for (int i = 0; i < K; ++i) {
        nums.push_back(res % 2);
        res /= 2;
    }
}
void upd(short &a, short b) {
    a = max(a, b);
}
vector<int> obsh(vector<int> a, vector<int> b) {
    int n = a.size(), m = b.size();
    vector<vector<short>> dp(n + 2, vector<short>(m + 2));
    for (int i = 0; i <= n; ++i) {
        if (i != n) {
            for (int j = 0; j < m; ++j) {
                upd(dp[i][j + 1], dp[i][j]);
                upd(dp[i + 1][j], dp[i][j]);
                if (a[i] == b[j]) {
                    upd(dp[i + 1][j + 1], dp[i][j] + 1);
                }
            }
            upd(dp[i + 1][m], dp[i][m]);
        } else {
            for (int j = 0; j <= m; ++j) {
                upd(dp[i][j + 1], dp[i][j]);
                upd(dp[i + 1][j], dp[i][j]);
            }
        }
    }
    vector<int> res;
    while (n != 0 and m != 0) {
        if (dp[n-1][m] == dp[n][m]) {
            n--;
        } else if (dp[n][m-1] == dp[n][m]) {
            m--;
        } else {
            res.push_back(a[n-1]);
            n--;m--;
        }
    }
    reverse(all(res));
    return res;
}
vector<int> getind(vector<int> a, vector<int> sol) {
    vector<int> aind(sol.size());
    int indik = 0;
    for (int i = 0; i < a.size(); ++i) {
        if (a[i] == sol[indik]) {
            aind[indik] = i;
            indik++;
            if (indik == sol.size())
                return aind;
        }
    }
    return aind;
}
vector<int> getapos(int n) {
    vector<int> a(HELP + 1);
    for (int i = 0; i < HELP + 1; ++i) {
        a[i] = n * i / HELP;
    }
    return a;
}
vector<int> readbpos(vector<bool> hp) {
    vector<int> b(HELP + 1);
    b[0] = 0;
    for (int i = 1; i < HELP + 1; ++i) {
        b[i] = readnum(hp, i - 1);
    }
    return b;
}
bool opa = 1;
vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& sol) {
    if (opa) {
        opa = 0;
        return genHint(b, a, sol);
    }
    vector<int> aind = getind(a, sol);
    vector<int> bind = getind(b, sol);
    vector<int> del(HELP);
    vector<int> ap = getapos(a.size());
    vector<int> bp(HELP + 1);
    int indik = 0;
    for (int i = 1; i <= HELP; ++i) {
        while (indik != bind.size() and aind[indik] < ap[i]) {
            indik++;
        }
        if (indik == bind.size())
            bp[i] = b.size();
        else
            bp[i] = bind[indik];
    }
    vector<bool> hlp;
    for (int i = 0; i < HELP; ++i) {
        writenum(hlp, bp[i + 1]);
    }
    return hlp;
}
vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint) {
    if (opa) {
        opa = 0;
        return solve(b, a, hint);
    }
    //vector<bool> chk;
    //writenum(chk, 1e5);
    //cerr << readnum(chk, 0);
    vector<int> ap = getapos(a.size()), bp = readbpos(hint);
    vector<int> ans;
    for (int i = 0; i + 1 < ap.size(); ++i) {
        //cerr << ap[i] << ' ' << bp[i] << endl;
        vector<int> tempa;
        vector<int> tempb;
        for (int j = ap[i]; j < ap[i + 1]; ++j) {
            tempa.push_back(a[j]);
        }
        for (int j = bp[i]; j < bp[i + 1]; ++j) {
            tempb.push_back(b[j]);
        }
        for (auto t : obsh(tempa, tempb))
            ans.push_back(t);
    }
    //cerr << ap.back() << ' ' << bp.back() << endl;
    return ans;
}