#include "hint.h"
#include <bits/stdc++.h>

using namespace std;

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol) {
    vector<bool> ans(min(a.size(), b.size()));
    int j = 0;
    for(int i = 0; j < sol.size() && i < min(a.size(), b.size()); i++) {
        if(a.size() < b.size()) {
            if(a[i] == sol[j]) ans[i] = 1, j++;
        }
        else {
            if(b[i] == sol[j]) ans[i] = 1, j++;
        }
    }
    return ans;
}

std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint) {
    vector<int> ans;
    for(int i = 0; i < hint.size(); i++) {
        if(!hint[i]) continue;
        if(a.size() < b.size()) {
            ans.push_back(a[i]);
        }
        else {
            ans.push_back(b[i]);
        }
    }

    return ans;
}
