#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <random>
#include <cassert>
#include <array>
#include <deque>
#include <map>
#include <set>


using namespace std;


#define ll long long
#define ld long double
#define flt double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back
#define emb emplace_back


vector<vector<int>> dp;


inline void mxmz(int& a, int b) {
    if (a < b) {
        a = b;
    }
}


void get_mx_cmn(const vector<int> &a, const vector<int> &b, int l1, int r1, int l2, int r2, vector<int> &res) {
    int n = r1 - l1;
    int m = r2 - l2;
    dp.assign(n + 1, vector<int>(m + 1, 0));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i + l1] == b[j + l2]) {
                dp[i + 1][j + 1] = dp[i][j] + 1;
            }
            mxmz(dp[i + 1][j + 1], dp[i][j + 1]);
            mxmz(dp[i + 1][j + 1], dp[i + 1][j]);
        }
    }
    int i = n - 1;
    int j = m - 1;
    int lstsz = res.size();
    while (dp[i + 1][j + 1] != 0) {
        if (a[i + l1] == b[j + l2] && dp[i + 1][j + 1] == dp[i][j] + 1) {
            res.push_back(a[i + l1]);
            i -= 1;
            j -= 1;
        } else if (dp[i + 1][j + 1] == dp[i + 1][j]) {
            j -= 1;
        } else if (dp[i + 1][j + 1] == dp[i][j + 1]) {
            i -= 1;
        } else {
            assert(0);
        }
    }
    reverse(res.begin() + lstsz, res.end());
}


std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol) {
    vector<bool> res;

    return res;
}



std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint) {
    vector<int> res;
    int n = a.size();
    int m = b.size();
    get_mx_cmn(a, b, 0, n, 0, m, res);
    return res;
}


/*
4 5
1 4 6 7
4 0 5 7 6
0
*/