#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <random>
#include <cassert>
#include <array>
#include <deque>
#include <map>
#include <set>


using namespace std;


#define ll long long
#define ld long double
#define flt double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back
#define emb emplace_back


mt19937 rnd(1312341);


int n, s, c;

vector<int> a;


int get_bst1(vector<int>& mx) {
    mx.clear();
    int mxx = -1;
    for (int i = 0; i < n; ++i) {
        int x = a[i];
        if (i < n - 2) {
            x += (a[n - 2] && a[n - 1]);
        }
        if (i > 1) {
            x += (a[0] && a[1]);
        }
        if (x > mxx) {
            mxx = x;
            mx.clear();
        }
        if (x == mxx) {
            mx.push_back(i);
        }
    }
    return mxx;
}



int get_bst2(vector<int>& mx) {
    mx.clear();
    int mxx = -1;
    for (int i = 0; i < n; ++i) {
        int x = a[i];
        if (i + 1 < n && i - 1 >= 0) {
            x += (a[i - 1] && a[i + 1]);
        }
        if (x > mxx) {
            mxx = x;
            mx.clear();
        }
        if (x == mxx) {
            mx.push_back(i);
        }
    }
    return mxx;
}


void apply1(int i) {
    a[i] = 0;
    for (int j = 1; j < i; ++j) {
        if (a[j]) {
            a[j - 1] = 1;
        }
        a[j] = 0;
    }
    for (int j = n - 2; j > i; --j) {
        if (a[j]) {
            a[j + 1] = 1;
        }
        a[j] = 0;
    }
}


void apply2(int i) {
    a[i] = 0;
    for (int j = i - 1; j >= 0; --j) {
        if (a[j]) {
            a[j + 1] = 1;
        }
        a[j] = 0;
    }
    for (int j = i + 1; j < n; ++j) {
        if (a[j]) {
            a[j - 1] = 1;
        }
        a[j] = 0;
    }
}


void solve(vector<int> &res) {
    res.clear();
    a.assign(n, 1);
    int f = n;
    vector<int> mx;
    for(int i = 0; f > 0; ++i) {
        int x = i % (s + c);
        if (x < s) {
            int k = get_bst1(mx);
            int v = mx[rnd() % (int)(mx.size())];
            apply1(v);
            res.push_back(v);
            f -= k;
        } else {
            int k = get_bst2(mx);
            int v = mx[rnd() % (int)(mx.size())];
            apply2(v);
            res.push_back(v);
            f -= k;
        }
    }
}


int32_t main() {
    cin >> n >> s >> c;
    vector<int> res;
    if (s == 0) {
        for (int i = 0; i < (n + 2) / 2; ++i) {
            res.push_back(n / 2);
        }
    } 
    else{
        solve(res);
    }
    cout << res.size() << "\n";
    for (int i = 0; i < res.size(); ++i) {
        cout << res[i] + 1 << " ";
    }
    cout << "\n";
    return 0;
}