#include <bits/stdc++.h>
using namespace std;
int k = 0;
vector <vector <int>> g, r_g;
vector <int> top_sort, used;
void dfs(int v) {
    used[v] = true;
    for (auto& u : g[v]) {
        if (!used[u]) {
            dfs(u);
        }
    }
    top_sort.push_back(v);
}
void DFS(int v) {
    used[v] = true;
    for (auto& u : g[v]) {
        if (g[u].empty() && !used[u]) {
            used[u] = true;
            k++;
        }
        DFS(u);
    }
}
signed main() {
    int n;
    cin >> n;
    g.resize(n);
    r_g.resize(n);
    used.resize(n, false);
    pair <int, int> a[n];
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i == j) {
                continue;
            }
            if (a[i].first + abs(a[i].second - a[j].second) <= a[j].first) {
                g[i].push_back(j);
                r_g[j].push_back(i);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i);
        }
    }
    used.assign(n, false);
    reverse(top_sort.begin(), top_sort.end());
    for (auto& v : top_sort) {
        if (!used[v]) {
            if (g[v].empty()) {
                k++;
            }
            else {
                DFS(v);
            }
        }
    }
    cout << k;
    return 0;
}