#include <iostream>
#include <vector>
using namespace std;

void in_h(vector<bool> &h, int tmp, int sz)
{
    int br = 0;
    while(tmp > 0)
    {
        h.push_back(tmp&1);
//        cout<<(tmp&1);
        tmp >>= 1;
        br++;
    }
    while(br < sz)
    {
        h.push_back(0);
        br++;
    }
//    cout<<endl;
}
std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol)
{
    vector<bool> h;
    for(auto x: sol)
    {
        in_h(h,x,18);
    }
    return h;
}
std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint)
{
    vector<int> res;
    for(int i=0; i<hint.size(); i+=18)
    {
        int tmp = 0;
        for(int j=17; j>=0; j--)
        {
            tmp <<= 1;
            tmp += hint[i+j];
        }
        res.push_back(tmp);
    }
    return res;
}

static int n, m, k;
static std::vector<int> a, b, sol, maybeSol;
static std::vector<bool> hint;
int main()
{
    std::cin >> n >> m;

    a.resize(n);
    b.resize(m);

    for (int& num : a)
    {
        std::cin >> num;
    }

    for (int& num : b)
    {
        std::cin >> num;
    }

    std::cin >> k;

    sol.resize(k);

    for (int& num : sol)
    {
        std::cin >> num;
    }

    hint = genHint(a, b, sol);
    maybeSol = solve(a, b, hint);

    std::cout << hint.size() << std::endl;
    std::cout << maybeSol.size() << std::endl;

    for (int i = 0; i < (int) maybeSol.size(); ++i)
    {
        if (i > 0) std::cout << " ";
        std::cout << maybeSol[i];
    }
    std::cout << std::endl;

    return 0;
}
/**
6 5
1 5 4 3 2 10
6 3 7 10 2
2
3 2
*/

