#include <iostream>
#include <vector>
using namespace std;

void in_h(vector<bool> &h, int tmp, int sz)
{
    int br = 0;
    while(tmp > 0)
    {
        h.push_back(tmp&1);
//        cout<<(tmp&1);
        tmp >>= 1;
        br++;
    }
    while(br < sz)
    {
        h.push_back(0);
        br++;
    }
//    cout<<endl;
}
std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol)
{
    vector<bool> h;
    if(min(a.size(),b.size()) == sol.size())
    {
        h.push_back(1);
    }
    else h.push_back(0);
    vector< pair<int,int> > compress;
    compress.push_back({sol[0],1});
    int sz = 1;
    for(int i=1; i<sol.size(); i++)
    {
        if(sol[i] == compress[sz-1].first)
        {
            compress[sz-1].second++;
        }
        else
        {
            compress.push_back({sol[i],1});
        }
    }
    int largest_len = 0;
    int largest_num = 0;
    for(auto x: compress)
    {
        largest_len = max(largest_len, x.second);
        largest_num = max(largest_num, x.first);
    }
    int len_c = 0;
    int len_n = 0;
    while(largest_len > 0)
    {
        largest_len >>= 1;
        len_c++;
    }
    while(largest_num > 0)
    {
        largest_num >>= 1;
        len_n++;
    }
    int tmp = len_c;
    in_h(h, tmp, 18);
    tmp = len_n;
    in_h(h, tmp, 18);
    for(auto x: compress)
    {
        in_h(h,x.second,len_c);
        in_h(h,x.first,len_n);
    }
    return h;
}
std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint)
{
//    if(hint[0] == 1)
//    {
//        if(a.size() > b.size()) return b;
//        else return a;
//    }
//    else
    {
        vector<int> res;
        int len_f = 0;
        int len_s = 0;
        for(int i=18; i>=1; i--)
        {
            len_f <<= 1;
            len_f += hint[i];
        }
        for(int i=36; i>=19; i--)
        {
            len_s <<= 1;
            len_s += hint[i];
        }
        int one_num = len_f+len_s;
        for(int i=37; i<hint.size(); i+=one_num)
        {
            int tmp_num = 0;
            int tmp_occ = 0;
            for(int j=len_f-1; j>=0; j--)
            {
                tmp_occ <<= 1;
                tmp_occ += hint[i+j];
            }
            for(int j=len_s-1; j>=0; j--)
            {
                tmp_num <<= 1;
                tmp_num += hint[i+j+len_f];
            }
            for(int j=0; j<tmp_occ; j++)
            {
                res.push_back(tmp_num);
            }
        }
        return res;
    }

}

static int n, m, k;
static std::vector<int> a, b, sol, maybeSol;
static std::vector<bool> hint;
int main()
{
    std::cin >> n >> m;

    a.resize(n);
    b.resize(m);

    for (int& num : a)
    {
        std::cin >> num;
    }

    for (int& num : b)
    {
        std::cin >> num;
    }

    std::cin >> k;

    sol.resize(k);

    for (int& num : sol)
    {
        std::cin >> num;
    }

    hint = genHint(a, b, sol);
    maybeSol = solve(a, b, hint);

    std::cout << hint.size() << std::endl;
    std::cout << maybeSol.size() << std::endl;

    for (int i = 0; i < (int) maybeSol.size(); ++i)
    {
        if (i > 0) std::cout << " ";
        std::cout << maybeSol[i];
    }
    std::cout << std::endl;

    return 0;
}
/**
6 5
1 5 4 3 2 10
6 3 7 10 2
10
3 3 3 2 2 5 1 2 2 2
*/
