#include <bits/stdc++.h>
#include "hint.h"
using namespace std;

vector <bool> genHint (const vector <int> &a, const vector <int> &b, const vector <int> &sol){
    vector <bool> hint;
    for (int i : sol) hint.push_back (0);
    return hint;
}

const int maxn = 10004;
short dp [maxn][maxn];
char par [maxn][maxn];

vector <int> solve (const vector <int> &a, const vector <int> &b, const vector <bool> &hint){

    int na = a.size (), nb = b.size ();
    for (int j = 0; j < nb; j ++){
        if (a [0] == b [j]) dp [0][j] = 1, par [0][j] = '0';
        else par [0][j] = '2';
    }
    for (int i = 1; i < na; i ++){
        if (a [i] == b [0]) dp [i][0] = 1, par [i][0] = '0';
        else par [i][0] = '1';
        for (int j = 1; j < nb; j ++){
            if (a [i] == b [j]) dp [i][j] = dp [i - 1][j - 1] + 1, par [i][j] = '0';
            else{
                if (dp [i - 1][j] > dp [i][j - 1]) dp [i][j] = dp [i - 1][j], par [i][j] = '1';
                else dp [i][j] = dp [i][j - 1], par [i][j] = '2';
            }
        }
    }
    if (dp [na - 1][nb - 1] < hint.size ()) exit (-1);
    if (dp [na - 1][nb - 1] > hint.size ()) exit (1);
    vector <int> sol;
    int i = na - 1, j = nb - 1;
    while (i >= 0 && j >= 0){
        if (a [i] == b [j]) sol.push_back (a [i]);
        if (par [i][j] == '0') i --, j --;
        else if (par [i][j] == '1') i --;
        else j --;
    }
    reverse (sol.begin (), sol.end ());
    if (sol.size () < hint.size ()) exit (-2);
    if (sol.size () > hint.size ()) exit (2);
    return sol;

}