#include <bits/stdc++.h>
#define int long long
using namespace std;

const int maxn = 1e6;
int n;
pair <int, int> a [maxn];
// int edges [maxn][maxn];
bool vis [maxn];
int cnt = 0;
vector <vector <int> > v, w;
pair <int, int> pos [maxn];
/*
bool dfs (int i, int st){
    vis [i] = 1;
    curr_vis [i] = 1;
    for (int j = 0; j < n; j ++){
        if (!vis [j] && edges [i][j] == 1){
            if (j == st) cnt --;
            else if (curr_vis [j]) continue;
            else dfs (j, st);
            edges [i][j] = -1;
            edges [j][i] = 1;
            // curr_vis [i] = 0;
            return 1;
        }
    }
    for (int j = 0; j < n; j ++){
        if (edges [i][j] == 1){
            bool success = 0;
            if (j == st) cnt --, success = 1;
            else if (curr_vis [j]) continue;
            else success = dfs (j, st);
            if (success){
                edges [i][j] = -1;
                edges [j][i] = 1;
                // curr_vis [i] = 0;
                return 1;
            }
        }
    }
    // curr_vis [i] = 0;
    return 0;
}
*/

void dfs (int i){
    vis [i] = 1;
    int x = pos [i].first, y = a [i].second;
    if (pos [i].second < v [x].size () - 1) dfs (v [x][pos [i].second + 1]);
    else{
        for (int j = x + 1; j < v.size (); j ++){
            int k = lower_bound (w [j].begin (), w [j].end (), y) - w [j].begin ();
            if (k < v [j].size () && !vis [v [j][k]]){
                dfs (v [j][k]);
                return;
            }
        }
    }
}

signed main (){

    ios::sync_with_stdio (false);
    cin.tie (0);
/*
    cin >> n;
    for (int i = 0; i < n; i ++){
        cin >> a [i].first >> a [i].second;
    }
    sort (a, a + n);
    for (int i = 0; i < n; i ++){
        for (int j = i + 1; j < n; j ++){
            if (abs (a [i].second - a [j].second) <= a [j].first - a [i].first) edges [i][j] = 1, edges [j][i] = -1;
        }
    }
    for (int i = 0; i < n; i ++){
        if (!vis [i]){
            cnt ++;
            dfs (i, i);
            for (int j = 0; j < n; j ++) curr_vis [j] = 0;
        }
    }
    cout << cnt << '\n';*/

    cin >> n;
    for (int i = 0; i < n; i ++){
        int t, h;
        cin >> t >> h;
        a [i] = {t - h, t + h};
    }
    sort (a, a + n);
    v.push_back ({0});
    w.push_back ({a [0].second});
    pos [0] = {0, 0};
    for (int i = 1; i < n; i ++){
        if (a [i].first == a [i - 1].first) v.back ().push_back (i), w.back ().push_back (a [i].second);
        else v.push_back ({i}), w.push_back ({a [i].second});
        pos [i] = {v.size () - 1, v.back ().size () - 1};
    }
    for (int i = 0; i < n; i ++){
        if (vis [i]) continue;
        cnt ++;
        dfs (i);
    }
    cout << cnt << '\n';

}