#include<iostream>
#include<bits/stdc++.h>
using namespace std;

int const MAXN=100000;
int n, used[MAXN], maxpos, maxsum, used1[MAXN];
vector<int> v[MAXN];

struct point
{
    int t, h;
};
point a[MAXN];

bool cmp(point x, point y)
{
    if(x.t==y.t) return x.h<y.h;
    else return x.t<y.t;
}

void BFS(int i)
{
    used[i]=1;
    queue<int> q;
    q.push(i);
    while(!q.empty())
    {
        int w=q.front();
        q.pop();
        int sz=v[w].size();
        for(int j=0;j<sz;j++)
        {
            if(!used[v[w][j]])
            {
                used[v[w][j]]=used[w]+1;
                q.push(v[w][j]);
            }
        }
    }
}

void DFS(int i, int cnt)
{
    used[i]=cnt;
    if(cnt>maxsum)
    {
        maxsum=cnt;
        maxpos=i;
    }
    cnt++;
    int sz=v[i].size();
    for(int j=0;j<sz;j++)
    {
        if(!used[v[i][j]])
        {
            used[v[i][j]]=cnt;
            DFS(v[i][j],cnt);
            cnt--;
        }
    }
}

void read()
{
    int ans=0;
    cin>>n;
    for(int i=1;i<=n;i++)
    {
        cin>>a[i].t>>a[i].h;
    }
    sort(a+1,a+n+1,cmp);
    for(int i=1;i<n;i++)
    {
        for(int j=i+1;j<=n;j++)
        {
            if(a[j].t-a[i].t>=abs(a[i].h-a[j].h))
            {
                v[i].push_back(j);
            }
        }
    }
    int n1=n;
    while(n1>0)
    {
        for(int i=1;i<=n;i++)
        {
            if(used1[i]==0) DFS(i,1);
        }
        ans++;
        n1-=maxsum;
        int d=maxsum-1;
        for(int i=maxpos-1;i>=1;i--)
        {
            if(used[i]==d)
            {
                d--;
                used1[i]=1;
            }
        }
    }
    cout<<ans<<endl;
}

int main()
{
	read();
	return 0;
}
