#include <bits/stdc++.h>
#include "hint.h"
#define endl '\n'
#define MAXN 10003
using namespace std;
const int part_sz = 9;

vector<bool> convert(int x, int l)
{
    vector <bool> ans;
    while (x)
    {
        ans.push_back(x % 2);
        x /= 2;
    }

    vector <bool> ret;
    int sz = ans.size();

    if (sz < l)
    {
        for (int i = 0; i < l - sz; ++i)
        {
            ans.push_back(0);
        }
    }

    for (int i = l - 1; i >= 0; --i)
    {
        ret.push_back(ans[i]);
    }

    return ret;
}

int revert(vector <bool> b)
{
    int ret = 0;
    int sz = b.size();

    for (int i = 0; i < sz; ++i)
    {
        ret *= 2;
        ret += (b[i] ? 1 : 0);
    }

    return ret;
}

vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& sol)
{
    int n = a.size();
    int m = b.size();
    int sz = sol.size();
    vector <bool> ans;
    /*
    int max1 = -1;

    for (int i = 0; i < sz; ++i)
        max1 = max(max1, sol[i]);

    int part = ceil(log(max1) / log(2));
    */

    for (int i = 0; i < sz; ++i)
    {
        vector <bool> conv = convert(sol[i], part_sz);
        int conv_sz = conv.size();
        //cout << sol[i] << ": " << endl;

        for (int j = 0; j < conv_sz; ++j)
        {
            //cout << conv[j];
            ans.push_back(conv[j]);
        }
        //cout << endl;
    }

    return ans;
}


vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint)
{
    int sz = hint.size();
    vector <int> ans;

    for (int i = 0; i < sz; i += part_sz)
    {
        vector <bool> tmp;
        //cout << i << ": " << endl;
        for (int j = i; j < i + part_sz; ++j)
        {
            //cout << hint[j];
            tmp.push_back(hint[j]);
        }
        //cout << endl;
        int curr = revert(tmp);
        //cout << "reverted: " << curr << endl;
        ans.push_back(curr);
    }

    return ans;
}

/*
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);


    return 0;
}
*/
