#include <bits/stdc++.h>
#include "hint.h"
#define endl '\n'
#define MAXN 10003
using namespace std;

vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& sol)
{
    int n = a.size();
    int m = b.size();
    int sz = sol.size();

    vector <bool> ans_a;
    int idx = 0;
    for (int i = 0; i < n; ++i)
    {
        if (idx == sz)
            break;

        if (sol[idx] == a[i])
        {
            ans_a.push_back(1);
            ++idx;
        }
        else
            ans_a.push_back(0);
    }

    //return ans_a;

    vector <bool> ans_b;
    idx = 0;
    for (int i = 0; i < m; ++i)
    {
        if (idx == sz)
            break;

        if (sol[idx] == b[i])
        {
            ans_b.push_back(1);
            ++idx;
        }
        else
            ans_b.push_back(0);
    }

    if (ans_a.size() <= ans_b.size())
    {
        ans_a.push_back(0);
        return ans_a;
    }

    ans_b.push_back(1);
    return ans_b;
}


vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint)
{
    int sz = hint.size();
    bool check = hint[sz - 1];

    vector <int> ans;
    for (int i = 0; i < sz - 1; ++i)
    {
        if (hint[i])
        {
            int tmp = check ? b[i] : a[i];
            //int tmp = a[i];
            ans.push_back(tmp);
        }
    }

    return ans;
}

/*
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);


    return 0;
}
*/
