#include<iostream>
#include<vector>
#include<stack>
#include "hint.h"
using namespace std;

const int MAXN=1e4;

int dp[MAXN+1][MAXN+1];

vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& sol)
{
    vector<bool> res;

    return res;
}

vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint)
{
    stack<int> st;

    int n=a.size(), m=b.size();
    for(int i=0; i<=n; i++)
    {
        for(int j=0; j<=m; j++)
        {
            if(i==0 || j==0)
            {
                dp[i][j]=0;
                continue;
            }

            if(a[i-1]==b[j-1])
            {
                dp[i][j]=dp[i-1][j-1]+1;
            }
            else
            {
                dp[i][j]=max(dp[i-1][j], dp[i][j-1]);
            }
        }
    }

    int i=n, j=m;
    while(i>0 && j>0)
    {
        if(a[i-1]==b[j-1])
        {
            st.push(a[i-1]);
            i--, j--;
        }
        else if(dp[i-1][j]>dp[i][j-1])
        {
            i--;
        }
        else
        {
            j--;
        }
    }

    vector<int> res;

    while(!st.empty())
    {
        res.push_back(st.top());
        st.pop();
    }

    return res;
}
/*
5 6
1 2 9 3 3
1 9 9 7 8 3
3
1 9 3
*/


