#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#define endl '\n'

using namespace std;

const int maxn = 1e3 + 3; 

int n; 
pair <int, int> a[maxn];
void read()
{
	cin >> n;
	for (int i = 1; i <= n; i++)
	cin >> a[i].first >> a[i].second;
}

int deg[maxn];
vector <int> adj[maxn];
bool used[maxn];
void solve()
{
	sort (a + 1, a + n + 1);
	for (int i = 1; i <= n; i++)
	for (int j = i + 1; j <= n; j++)
	if (a[j].first - a[i].first >= abs(a[i].second - a[j].second))
	deg[j]++, adj[j].push_back(i);
	
	int ans = 0;
	for (;;)
	{
		vector <int> v;
		for (int i = 1; i <= n; i++)
		if (deg[i] == 0 && !used[i])
		v.push_back(i);
		
		if (v.empty())
		break;
		
		ans = max(ans, (int)v.size());
		for (auto i: v)
		{
			used[i] = true;
			for (auto j: adj[i])
			deg[j]--;
		}
	}
	
	//~ for (int i = 1; i <= n; i++)
	//~ cout << dist[i] << " " << i << endl;  
	
	cout << ans << endl; 
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	
	read();
	solve();
}
