#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include "hint.h"

#define fr first
#define sc second
#define pb push_back
#define ll long long
#define all(x) x.begin(), x.end()

using namespace std;
using namespace __gnu_pbds;

template<class T> using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<class T> using matrix = vector<vector<T>>;

vector<bool> genHint(const vector<int> &a, const vector<int> &b, const vector<int> &sol){
	return vector<bool>();
}

vector<int> solve(const vector<int> &A, const vector<int> &B, const vector<bool> &hint){
	auto a = A;
	auto b = B;
	reverse(all(a)); a.pb(0); reverse(all(a));
	reverse(all(b)); b.pb(0); reverse(all(b));
	matrix<pair<int, int>> dp(a.size() + 1, vector<pair<int, int>>(b.size() + 1));
	for(int i = 1; i < a.size(); i ++){
		for(int j = 1; j < b.size(); j ++){
			if(a[i] == b[j]){
				dp[i][j] = {dp[i - 1][j - 1].fr + 1, 1};
			}
			else{
				if(dp[i - 1][j].fr <= dp[i][j - 1].fr){
					dp[i][j] = {dp[i][j - 1].fr, 2};
				}
				else{
					dp[i][j] = {dp[i - 1][j].fr, 0};
				}
			}
		}
	}
	int i0 = a.size() - 1, j0 = b.size() - 1;
	vector<int> ret;
	while(i0 != 0 && j0 != 0){
		if(dp[i0][j0].sc == 0){
			-- i0;
		}
		else if(dp[i0][j0].sc == 2){
			-- j0;
		}
		else{
			ret.pb(a[i0]);
			-- i0; -- j0;
		}
	}
	reverse(all(ret));
	return ret;
}

/**

*/