#include <algorithm>
#include <iostream>
#include <utility>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 1000000;

bool used[MAXN + 5];
pair<int, int> d[MAXN + 5];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    cin >> n;

    for (int i = 1; i <= n; ++ i)
    {
        cin >> d[i].first >> d[i].second;
    }

    sort(d + 1, d + n + 1);

    vector<int> v;
    for (int i = 1; i <= n; ++ i)
    {
        v.push_back(d[i].first - d[i].second);
    }

    int p = 0;
    int ans = 0;
    vector<int> lis;
    while (p < n)
    {
        int i = 0;
        while (used[i]) i++;

        int cnt = 1;
        lis.clear();
        lis.push_back(i);
        i++;
        while (i < n)
        {
            if (v[i] < v[lis[0]]) lis[0] = i;
            else if (v[i] > v[lis.back()])
            {
                lis[cnt] = i;
                cnt++;
            }
            else
            {
                int l = -1, r = cnt;
                while (r - l > 1)
                {
                    int mid = (l + r) / 2;
                    if (v[lis[mid]] < v[i]) l = mid;
                    else r = mid;
                }
                lis[r] = i;
            }
            i++;
        }

        for (int i = 0; i < cnt; ++ i)
        {
            used[lis[i]] = true;
        }

        p += cnt;
        ans++;
    }

    cout << ans << endl;

    return 0;
}
