#include<iostream>
#include<vector>
#include<algorithm>
#include "hint.h"
using namespace std;
std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b, const std::vector<int>& sol)
{
    vector<bool> ans;
    int isol=0;
    if(a.size()<b.size())
    {
        ans.push_back(0);
        for(int i=0; i<a.size(); i++)
        {
            //cout<<sol[i]<<" "<<a[i]<<endl;
            if(isol<sol.size() && sol[isol]==a[i])
            {
                ans.push_back(1);
                isol++;
                //cout<<1;
            }
            else
            {
                ans.push_back(0);
                //cout<<0;
            }
        }
    }
    else
    {
        ans.push_back(1);
        for(int i=0; i<b.size(); i++)
        {
            //cout<<sol[i]<<" "<<a[i]<<endl;
            if(isol<sol.size() && sol[isol]==b[i])
            {
                ans.push_back(1);
                isol++;
                //cout<<1;
            }
            else
            {
                ans.push_back(0);
                //cout<<0;
            }
        }
    }
    while(ans[ans.size()-1]==0){
        ans.pop_back();
    }
    //cout<<endl;
    return ans;
}
int dp[10002][10002];
int dpos[10002][10002];
std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b, const std::vector<bool>& hint)
{
    vector<int> ans;
    if(a.size()<=100000 && b.size()<=100000){
        for(int i=0;i<=a.size();i++){
            for(int j=0;j<=b.size();j++){
                if(i==0 || j==0){
                    dp[i][j]=0;
                    dpos[i][j]=-1;
                }else{
                    if(dp[i-1][j]>dp[i][j-1]){
                        dp[i][j]=dp[i-1][j];
                        dpos[i][j]=dpos[i-1][j];
                    }else{
                        dp[i][j]=dp[i][j-1];
                        dpos[i][j]=dpos[i][j-1];
                    }
                    if(a[i-1]==b[j-1] && dp[i-1][j-1]+1>dp[i][j]){
                        dp[i][j]=dp[i-1][j-1]+1;
                        dpos[i][j]=i-1;
                    }
                }
            }
        }
        int p=dpos[a.size()][b.size()];
        //cout<<dp[a.size()][b.size()]<<endl;
        while(p!=-1){
            ans.push_back(a[p]);
            p=dpos[p][b.size()-1];
        }
        reverse(ans.begin(), ans.end());
        return ans;
    }

    if(hint[0]==0)
    {
        for(int i=1; i<hint.size(); i++)
        {
            if(hint[i])
            {
                ans.push_back(a[i-1]);
            }
        }
    }
    else
    {
        for(int i=1; i<hint.size(); i++)
        {
            if(hint[i])
            {
                ans.push_back(b[i-1]);
            }
        }
    }
    return ans;
}
