#include "hint.h"
#include <iostream>
#include <vector>

using namespace std;


bool check(const std::vector<int>& a,const std::vector<int>& sol,int k)
{
	int i=0;
	while(i<sol.size()&&a[i+k]==sol[i]) i++;
	
	if(i==sol.size()) return true;
	return false;
}

std::vector<bool> genHint(const std::vector<int>& a, const std::vector<int>& b,
 const std::vector<int>& sol)
 {
 	int idx;
 	for(int i=0;i<a.size();i++)
 	{
 		if(check(a,sol,i))
 		{
 			idx=i;
 			break;
		}
	}
	
	int i=0;
	std::vector<bool> hint;
	while(idx)
	{
		i++;
		hint.push_back(idx&1);
		idx>>=1;
	}
	for(i;i<32;i++)
		hint.push_back(false);
	
	idx=sol.size();
	while(idx)
	{
		i++;
		hint.push_back(idx&1);
		idx>>=1;
	}
	for(i;i<32;i++)
		hint.push_back(false);
	
	return hint;
}


std::vector<int> solve(const std::vector<int>& a, const std::vector<int>& b,
 const std::vector<bool>& hint)
 {
 	int idx=0,len=0;
 	for(int i=31;i>=0;i--)
 	{
 		idx<<=1;
 		idx+=hint[i];
	}
	
	for(int i=63;i>=32;i--)
 	{
 		len<<=1;
 		len+=hint[i];
	}
	
	cout<<idx<<" "<<len<<endl;
	
	std::vector<int> sol;
	for(int i=0;i<len;i++)
	{
		sol.push_back(a[idx+i]);
	}
	
	return sol;
 }