#include <iostream>
#include <vector>
#define ll long long
using namespace std;


vector<bool> genHint(const vector<int>& a, const vector<int>& b, const vector<int>& sol){
    ll br=0,i;
    vector<bool> hint;
    if(a.size()<b.size()){
        for(i=0;i<a.size();i++){
            if(hint.size()==a.size()){
                return hint;
            }
            if(sol[br]==a[i]){
                hint.push_back(true);
                br++;
            }else{
                hint.push_back(false);
            }
        }
        return hint;
    }else{
        for(i=0;i<b.size();i++){
            if(hint.size()==b.size()){
                return hint;
            }
            if(sol[br]==b[i]){
                hint.push_back(true);
                br++;
            }else{
                hint.push_back(false);
            }
        }
        return hint;
    }
}

vector<int> solve(const vector<int>& a, const vector<int>& b, const vector<bool>& hint){
    vector<int> ans;
    ll i;
    if(a.size()<b.size()){
        for(i=0;i<a.size();i++){
            if(hint[i]){
                ans.push_back(a[i]);
            }
        }
    }else{
        for(i=0;i<b.size();i++){
            if(hint[i]){
                ans.push_back(b[i]);
            }
        }
    }
    return ans;
}
/*
int main(){
    vector<int> a,b,s;
    int u,i,n,m,k;
    cin >> n >> m >> k;
    for(i=0;i<n;i++){
        cin >> u;
        a.push_back(u);
    }
    for(i=0;i<m;i++){
        cin >> u;
        b.push_back(u);
    }
    for(i=0;i<k;i++){
        cin >> u;
        s.push_back(u);
    }
    vector<int> resh=solve(a,b,genHint(a,b,s));
    for(i=0;i<resh.size();i++){
        cout << resh[i] << endl;
    }
}*/
