#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;
const int MAXN=1e6+10;
struct House {
    int t, pl;
};
House p[MAXN];
int in[MAXN], res[MAXN], cnt[MAXN];
vector <int> v[MAXN];
bool cmp(House a, House b) {
    return a.t<b.t;
}
int dfs(int x) {
    if (res[x]!=-1) return res[x];
    res[x]=0;
    for (auto i:v[x]) {
        res[x]=max(res[x],dfs(i)+1);
    }
    return res[x];
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    for (int i=1;i<=n;i++) cin >> p[i].t >> p[i].pl;
    sort(p+1,p+n+1,cmp);
    int diff;
    for (int i=1;i<=n;i++) {
        res[i]=-1;
        for (int j=i-1;j>=1;j--) {
            diff=p[i].pl-p[j].pl;
            if (diff<0) diff=-diff;
            if (diff<=p[i].t-p[i].pl) {
                v[i].push_back(j);
                in[i]++;
            }
        }
    }
    int maxin=0;
    for (int i=1;i<=n;i++) {
        if (in[i]==0) maxin=max(maxin,dfs(i));
    }
    for (int i=1;i<=n;i++) {
        if (in[i]==0) res[i]=maxin;
        cnt[res[i]]++;
    }
    int ans=1;
    for (int i=0;i<=maxin;i++) ans=max(ans,cnt[i]);
    cout << ans << endl;
    return 0;
}
