#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;
const int MAXN=1e6+10;
struct House {
    int t, pl;
};
struct Lev {
    int x, ind;
};
House p[MAXN];
Lev a[MAXN];
int out[MAXN], res[MAXN];
vector <int> v[MAXN];
bool cmp(House a, House b) {
    return a.t<b.t;
}
bool cmpRes(Lev a, Lev b) {
    return a.x<b.x;
}
int dfs(int x) {
    if (res[x]!=-1) return res[x];
    res[x]=0;
    for (auto i:v[x]) {
        res[x]=max(res[x],dfs(i)+1);
    }
    return res[x];
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    for (int i=1;i<=n;i++) cin >> p[i].t >> p[i].pl;
    sort(p+1,p+n+1,cmp);
    int diff;
    for (int i=1;i<=n;i++) {
        for (int j=i-1;j>=1;j--) {
            diff=p[i].pl-p[j].pl;
            if (diff<0) diff=-diff;
            if (diff<=p[i].t-p[i].pl) {
                v[j].push_back(i);
                out[i]++;
            }
        }
    }
    /**
    int m, x, y;
    cin >> m;
    for (int i=0;i<m;i++) {
        cin >> x >> y;
        v[y].push_back(x);
        out[x]++;
    }
    **/
    for (int i=1;i<=n;i++) res[i]=-1;
    for (int i=1;i<=n;i++) {
        a[i].x=dfs(i);
        a[i].ind=i;
    }
    sort(a+1,a+n+1,cmpRes);
    int ans=1, sum=0, last=1, cur=0;
    for (int i=1;i<=n;i++) {
        if (i>1 && a[i].x!=a[i-1].x) {
            ans=max(ans,i-last+sum-cur);
            last=i;
            cur=0;
        }
        if (out[a[i].ind]==0) {
            sum++;
            cur++;
        }
    }
    ans=max(ans,sum);
    cout << ans << endl;
    return 0;
}
/**
11 13
2 3
2 4
2 8
1 4
1 5
1 7
1 11
3 8
3 6
4 5
6 10
8 10
5 9

5 4
1 2
1 3
1 4
1 5
**/
