#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;
const int MAXN=1e6+10;
struct House {
    int t, pl;
};
struct Lev {
    int x, c, ind;
};
House p[MAXN];
Lev a[MAXN];
int out[MAXN], res[MAXN];
int comp[MAXN], br;
vector <int> v[MAXN], c[MAXN];
bool cmp(House a, House b) {
    return a.t<b.t;
}
bool cmpRes(Lev a, Lev b) {
    if (a.c!=b.c) return a.c<b.c;
    return a.x<b.x;
}
void find_comp(int x) {
    comp[x]=br;
    for (auto i:c[x]) {
        if (comp[i]) continue;
        find_comp(i);
    }
}
int dfs(int x) {
    if (res[x]!=-1) return res[x];
    res[x]=0;
    for (auto i:v[x]) {
        res[x]=max(res[x],dfs(i)+1);
    }
    return res[x];
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    for (int i=1;i<=n;i++) cin >> p[i].t >> p[i].pl;
    sort(p+1,p+n+1,cmp);
    int diff;
    for (int i=1;i<=n;i++) {
        for (int j=i-1;j>=1;j--) {
            diff=p[i].pl-p[j].pl;
            if (diff<0) diff=-diff;
            if (diff<=p[i].t-p[j].t) {
                v[i].push_back(j);
                c[i].push_back(j);
                c[j].push_back(i);
                out[j]++;
            }
        }
    }
    /**
    int m, x, y;
    cin >> m;
    for (int i=0;i<m;i++) {
        cin >> x >> y;
        v[y].push_back(x);
        c[y].push_back(x);
        c[x].push_back(y);
        out[x]++;
    }
    **/
    br=1;
    for (int i=1;i<=n;i++) {
        res[i]=-1;
        if (comp[i]!=0) continue;
        find_comp(i);
        br++;
    }
    for (int i=1;i<=n;i++) {
        a[i].x=dfs(i);
        a[i].c=comp[i];
        a[i].ind=i;
    }
    sort(a+1,a+n+1,cmpRes);
    int ans=0, sum=0, last=1, cur_sum=0, cur_ans=1, lastc=1;
    for (int i=1;i<=n;i++) {
        if (a[i].c!=lastc) {
            cur_ans=max(cur_ans,sum);
            ans+=cur_ans;
            lastc++;
            sum=cur_sum=0;
            cur_ans=1;
            last=i;
        }
        if (i>1 && a[i].c==a[i-1].c && a[i].x!=a[i-1].x) {
            ans=max(ans,i-last+sum-cur_sum);
            last=i;
            cur_sum=0;
        }
        if (out[a[i].ind]==0) {
            sum++;
            cur_sum++;
        }
    }
    cur_ans=max(cur_ans,sum);
    ans+=cur_ans;
    cout << ans << endl;
    return 0;
}
/**
14 16
1 2
1 3
2 4
2 5
3 6
4 7
5 7
6 7
8 9
8 10
8 11
9 12
10 12
11 13
12 14
12 14

5
1 3
2 2
3 3
3 4
6 5
**/
