#include<iostream>
#include<algorithm>
#include<vector>
#include<cmath>
using namespace std;

int broiDostavki;

struct DanniZaDostavkata{
    int vKoiMoment;
    int koqKashta;
};

DanniZaDostavkata dostavki[1000010];

bool koqEPoNapred(DanniZaDostavkata a, DanniZaDostavkata b){
    return a.vKoiMoment < b.vKoiMoment;
}

vector<int> sasedstvo[1000010];

int kolkoVlizatV[1000010];
bool aktivenliE[1000010];

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    cin>>broiDostavki;

    for(int i = 0; i < broiDostavki; i++){
        cin>>dostavki[i].vKoiMoment>>dostavki[i].koqKashta;
    }

    sort(dostavki, dostavki + broiDostavki, koqEPoNapred);

    for(int i = 0; i < broiDostavki; i++){
        aktivenliE[i] = true;

        for(int j = i + 1; j < broiDostavki; j++){
            if(dostavki[j].vKoiMoment > dostavki[i].vKoiMoment && abs(dostavki[j].koqKashta - dostavki[i].koqKashta) <= dostavki[j].vKoiMoment - dostavki[i].vKoiMoment){
                sasedstvo[i].push_back(j);
                kolkoVlizatV[j]++;
            }
        }
    }

    int broiOstanali = broiDostavki;

    int naiMnogotoNavednuj = 0;

    while(broiOstanali > 0){
        vector<int> vKoitoNeVliza;

        for(int i = 0; i < broiDostavki; i++){
            if(aktivenliE[i] == true && kolkoVlizatV[i] == 0){
                vKoitoNeVliza.push_back(i);
            }
        }

        naiMnogotoNavednuj = max(naiMnogotoNavednuj, (int)vKoitoNeVliza.size());
        broiOstanali -= (int)vKoitoNeVliza.size();

        for(int i = 0; i < (int)vKoitoNeVliza.size(); i++){

            int segashen = vKoitoNeVliza[i];

            aktivenliE[segashen] = false;

            for(int j = 0; j < (int)sasedstvo[segashen].size(); j++){
                kolkoVlizatV[sasedstvo[segashen][j]]--;
            }
        }
    }

    cout<<naiMnogotoNavednuj<<endl;

    return 0;
}
