#include<iostream>
#include<algorithm>
#include<vector>
#include<cmath>
using namespace std;

long long broiDostavki;

struct DanniZaDostavkata{
    long long vKoiMoment;
    long long koqKashta;
};

DanniZaDostavkata dostavki[1000010];

bool koqEPoNapred(DanniZaDostavkata a, DanniZaDostavkata b){
    return a.vKoiMoment < b.vKoiMoment;
}

vector<long long> sasedstvo[1000010];

long long kolkoVlizatV[1000010];
bool aktivenliE[1000010];

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    cin>>broiDostavki;

    for(long long i = 0; i < broiDostavki; i++){
        cin>>dostavki[i].vKoiMoment>>dostavki[i].koqKashta;
    }

    sort(dostavki, dostavki + broiDostavki, koqEPoNapred);

    for(long long i = 0; i < broiDostavki; i++){
        aktivenliE[i] = true;

        for(long long j = i + 1; j < broiDostavki; j++){
            if(dostavki[j].vKoiMoment > dostavki[i].vKoiMoment && abs(dostavki[j].koqKashta - dostavki[i].koqKashta) <= dostavki[j].vKoiMoment - dostavki[i].vKoiMoment){
                sasedstvo[i].push_back(j);
                kolkoVlizatV[j]++;
            }
        }
    }

    long long broiOstanali = broiDostavki;

    long long naiMnogotoNavednuj = 0;

    while(broiOstanali > 0){
        vector<long long> vKoitoNeVliza;

        for(long long i = 0; i < broiDostavki; i++){
            if(aktivenliE[i] == true && kolkoVlizatV[i] == 0){
                vKoitoNeVliza.push_back(i);
            }
        }

        naiMnogotoNavednuj = max(naiMnogotoNavednuj, (long long)vKoitoNeVliza.size());
        broiOstanali -= (long long)vKoitoNeVliza.size();

        for(long long i = 0; i < (long long)vKoitoNeVliza.size(); i++){

            long long segashen = vKoitoNeVliza[i];

            aktivenliE[segashen] = false;

            for(long long j = 0; j < (long long)sasedstvo[segashen].size(); j++){
                kolkoVlizatV[sasedstvo[segashen][j]]--;
                if(kolkoVlizatV[sasedstvo[segashen][j]] < 0){
                    cout<<sasedstvo[10000000]<<endl;
                }
            }
        }
    }

    cout<<naiMnogotoNavednuj<<endl;

    return 0;
}
