#include <iostream>
#include "hint.h"

using namespace std;

vector<bool> genHint(const vector<int>& a, const vector<int>& b,
                          const vector<int>& sol) {
    int iA = 0;
    int iB = 0;
    int iSol = 0;

    bool generator;
    vector<bool> hint;

    while (iB != b.size()) {
        if (b[iB] == sol[iSol]) {
            iSol++;
            generator = true;
        } else {
            generator = false;
        }

        hint.push_back(generator);
        iB++;
    }

    iSol = 0;

    while (iA != a.size()) {
        if (a[iA] == sol[iSol]) {
            iSol++;
            generator = true;
        } else {
            generator = false;
        }

        hint.push_back(generator);
        iA++;
    }

    return hint;
 }

 vector<int> solve(const vector<int>& a, const vector<int>& b,
                        const vector<bool>& hint) {
    vector<int> solA;
    vector<int> solB;

    for (int i = 0; i < b.size(); i++) {
        if (hint[i] == 1) {
            solB.push_back(b[i]);
        }
    }

    for (int i = 0; i < a.size(); i++) {
        if (hint[i + b.size()] == 1) {
            solA.push_back(a[i]);
        }
    }

    if (solA.size() > solB.size())
        return solB;
    else
        return solA;
}
